var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __commonJS = (cb, mod) => function __require() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __reExport = (target, module2, copyDefault, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && (copyDefault || key !== "default"))
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toESM = (module2, isNodeMode) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", !isNodeMode && module2 && module2.__esModule ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// node_modules/@cirru/parser.ts/lib/types.js
var require_types = __commonJS({
  "node_modules/@cirru/parser.ts/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.ELexControl = exports2.ELexState = void 0;
    var ELexState;
    (function(ELexState2) {
      ELexState2[ELexState2["space"] = 0] = "space";
      ELexState2[ELexState2["token"] = 1] = "token";
      ELexState2[ELexState2["escape"] = 2] = "escape";
      ELexState2[ELexState2["indent"] = 3] = "indent";
      ELexState2[ELexState2["string"] = 4] = "string";
    })(ELexState = exports2.ELexState || (exports2.ELexState = {}));
    var ELexControl;
    (function(ELexControl2) {
      ELexControl2[ELexControl2["open"] = -1e3] = "open";
      ELexControl2[ELexControl2["close"] = -2e3] = "close";
    })(ELexControl = exports2.ELexControl || (exports2.ELexControl = {}));
  }
});

// node_modules/@cirru/parser.ts/lib/tree.js
var require_tree = __commonJS({
  "node_modules/@cirru/parser.ts/lib/tree.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.resolveDollar = exports2.resolveComma = exports2.isOdd = exports2.isNumber = exports2.isString = exports2.notEmpty = exports2.isEmpty = exports2.isArray = exports2.pushToList = void 0;
    var pushToList = (acc, xs, ys, zs) => {
      let result = acc;
      xs.forEach((x) => {
        result.push(x);
      });
      if (ys != null) {
        ys.forEach((y) => {
          result.push(y);
        });
      }
      if (zs != null) {
        zs.forEach((y) => {
          result.push(y);
        });
      }
      return result;
    };
    exports2.pushToList = pushToList;
    exports2.isArray = Array.isArray;
    var isEmpty = (xs) => xs.length === 0;
    exports2.isEmpty = isEmpty;
    var notEmpty = (xs) => xs.length > 0;
    exports2.notEmpty = notEmpty;
    var isString = (x) => typeof x === "string";
    exports2.isString = isString;
    var isNumber = (x) => typeof x === "number";
    exports2.isNumber = isNumber;
    var isOdd = (x) => x % 2 === 1;
    exports2.isOdd = isOdd;
    var resolveComma = (xs) => {
      if ((0, exports2.isEmpty)(xs)) {
        return [];
      } else {
        return commaHelper(xs);
      }
    };
    exports2.resolveComma = resolveComma;
    var commaHelper = (intialAfter) => {
      let before = [];
      let after = intialAfter;
      let pointer = 0;
      while (true) {
        if (pointer >= after.length) {
          return before;
        }
        let cursor = after[pointer];
        if ((0, exports2.isArray)(cursor) && (0, exports2.notEmpty)(cursor)) {
          let head2 = cursor[0];
          if ((0, exports2.isArray)(head2)) {
            before.push((0, exports2.resolveComma)(cursor));
            pointer += 1;
          } else if (head2 === ",") {
            (0, exports2.pushToList)(before, (0, exports2.resolveComma)(cursor.slice(1)));
            pointer += 1;
          } else {
            before.push((0, exports2.resolveComma)(cursor));
            pointer += 1;
          }
        } else {
          before.push(cursor);
          pointer += 1;
        }
      }
    };
    var resolveDollar = (xs) => {
      if ((0, exports2.isEmpty)(xs)) {
        return [];
      } else {
        return dollarHelper(xs);
      }
    };
    exports2.resolveDollar = resolveDollar;
    var dollarHelper = (initialAfter) => {
      let before = [];
      let after = initialAfter;
      let pointer = 0;
      while (true) {
        if (pointer >= after.length) {
          return before;
        } else {
          let cursor = after[pointer];
          if ((0, exports2.isArray)(cursor)) {
            before.push((0, exports2.resolveDollar)(cursor));
            pointer += 1;
          } else if (cursor === "$") {
            before.push((0, exports2.resolveDollar)(after.slice(pointer + 1)));
            pointer = after.length;
          } else {
            before.push(cursor);
            pointer += 1;
          }
        }
      }
    };
  }
});

// node_modules/@cirru/parser.ts/lib/index.js
var require_lib = __commonJS({
  "node_modules/@cirru/parser.ts/lib/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.parse = void 0;
    var types_1 = require_types();
    var tree_1 = require_tree();
    var graspeExprs = (pullToken) => {
      let acc = [];
      let pointer = acc;
      let pointerStack = [];
      while (true) {
        let cursor = pullToken();
        switch (cursor) {
          case types_1.ELexControl.close:
            if (pointerStack.length === 0) {
              return pointer;
            }
            let collected = pointer;
            pointer = pointerStack.pop();
            pointer.push(collected);
            break;
          case types_1.ELexControl.open:
            pointerStack.push(pointer);
            pointer = [];
            break;
          case types_1.ELexControl.close:
            throw new Error("Unexpected close token");
          default:
            if ((0, tree_1.isString)(cursor)) {
              pointer.push(cursor);
              break;
            } else {
              console.log(JSON.stringify(cursor));
              throw new Error("Unknown cursor");
            }
        }
      }
    };
    var buildExprs = (pullToken) => {
      let acc = [];
      while (true) {
        let chunk = pullToken();
        if (chunk === types_1.ELexControl.open) {
          let expr = graspeExprs(pullToken);
          acc.push(expr);
          continue;
        } else if (chunk == null) {
          return acc;
        } else if (chunk === types_1.ELexControl.close) {
          throw new Error(`Unexpected ")"`);
        } else {
          throw new Error(`Unexpected chunk ${JSON.stringify(chunk)}`);
        }
      }
    };
    var parseIndentation = (buffer) => {
      let size = buffer.length;
      if ((0, tree_1.isOdd)(size)) {
        throw new Error(`Invalid indentation size ${size}`);
      }
      return size / 2;
    };
    var lex = (initialCode) => {
      let acc = [];
      let state = types_1.ELexState.indent;
      let buffer = "";
      let code = initialCode;
      let pointer = 0;
      while (true) {
        if (pointer >= code.length) {
          switch (state) {
            case types_1.ELexState.space:
              return acc;
            case types_1.ELexState.token:
              acc.push(buffer);
              return acc;
              break;
            case types_1.ELexState.escape:
              throw new Error("Should not be escape");
            case types_1.ELexState.indent:
              return acc;
            case types_1.ELexState.string:
              throw new Error("Should not be string");
            default:
              console.log(state);
              throw new Error("Unkown state");
          }
        } else {
          let c = code[pointer];
          pointer += 1;
          switch (state) {
            case types_1.ELexState.space:
              switch (c) {
                case " ":
                  [acc, state, buffer] = [acc, types_1.ELexState.space, ""];
                  break;
                case "\n":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, ""];
                  break;
                case "(":
                  acc.push(types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case ")":
                  acc.push(types_1.ELexControl.close);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case '"':
                  [acc, state, buffer] = [acc, types_1.ELexState.string, ""];
                  break;
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.token, c];
                  break;
              }
              break;
            case types_1.ELexState.token:
              switch (c) {
                case " ":
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case '"':
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.string, ""];
                  break;
                case "\n":
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.indent, ""];
                  break;
                case "(":
                  acc.push(buffer, types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case ")":
                  acc.push(buffer, types_1.ELexControl.close);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.token, `${buffer}${c}`];
                  break;
              }
              break;
            case types_1.ELexState.string:
              switch (c) {
                case '"':
                  acc.push(buffer);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                case "\\":
                  [acc, state, buffer] = [acc, types_1.ELexState.escape, buffer];
                  break;
                case "\n":
                  throw new Error("Expected newline in string");
                default:
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}${c}`];
                  break;
              }
              break;
            case types_1.ELexState.escape:
              switch (c) {
                case '"':
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}"`];
                  break;
                case "'":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}'`];
                  break;
                case "t":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}	`];
                  break;
                case "n":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}
`];
                  break;
                case "\\":
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}\\`];
                  break;
                case "u":
                  console.warn(`unicode escaping not supported yet, ${code.slice(pointer - 1, pointer + 10)}...`);
                  [acc, state, buffer] = [acc, types_1.ELexState.string, `${buffer}\\u`];
                  break;
                default:
                  throw new Error(`Unknown ${c} in escape`);
              }
              break;
            case types_1.ELexState.indent:
              switch (c) {
                case " ":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, `${buffer}${c}`];
                  break;
                case "\n":
                  [acc, state, buffer] = [acc, types_1.ELexState.indent, ""];
                  break;
                case '"':
                  acc.push(parseIndentation(buffer));
                  [state, buffer] = [types_1.ELexState.string, ""];
                  break;
                case "(":
                  acc.push(parseIndentation(buffer), types_1.ELexControl.open);
                  [state, buffer] = [types_1.ELexState.space, ""];
                  break;
                default:
                  acc.push(parseIndentation(buffer));
                  [state, buffer] = [types_1.ELexState.token, c];
                  break;
              }
              break;
            default:
              console.log("Unknown state:", c);
              return acc;
          }
        }
      }
      return acc;
    };
    var repeat = (times, x) => {
      let xs = [];
      for (let i = 1; i <= times; i++) {
        xs.push(x);
      }
      return xs;
    };
    var resolveIndentations = (initialTokens) => {
      let acc = [];
      let level = 0;
      let tokens = initialTokens;
      let pointer = 0;
      while (true) {
        if (pointer >= tokens.length) {
          if ((0, tree_1.isEmpty)(acc)) {
            return [];
          } else {
            acc.unshift(types_1.ELexControl.open);
            (0, tree_1.pushToList)(acc, repeat(level, types_1.ELexControl.close), [types_1.ELexControl.close]);
            return acc;
          }
        } else {
          let cursor = tokens[pointer];
          if (typeof cursor === "string") {
            acc.push(cursor);
            pointer += 1;
            [level] = [level];
          } else if (cursor === types_1.ELexControl.open || cursor === types_1.ELexControl.close) {
            acc.push(cursor);
            pointer += 1;
            [level] = [level];
          } else if (typeof cursor === "number") {
            if (cursor > level) {
              let delta = cursor - level;
              (0, tree_1.pushToList)(acc, repeat(delta, types_1.ELexControl.open));
              pointer += 1;
              [level] = [cursor];
            } else if (cursor < level) {
              let delta = level - cursor;
              (0, tree_1.pushToList)(acc, repeat(delta, types_1.ELexControl.close), [types_1.ELexControl.close, types_1.ELexControl.open]);
              pointer += 1;
              [level] = [cursor];
            } else {
              if ((0, tree_1.isEmpty)(acc)) {
                acc = [];
              } else {
                acc.push(types_1.ELexControl.close, types_1.ELexControl.open);
              }
              pointer += 1;
              [level] = [level];
            }
          } else {
            console.log(cursor);
            throw new Error("Unknown token");
          }
        }
      }
    };
    var parse2 = (code) => {
      let tokens = resolveIndentations(lex(code));
      let pointer = 0;
      let pullToken = () => {
        let c = tokens[pointer];
        pointer += 1;
        return c;
      };
      return (0, tree_1.resolveComma)((0, tree_1.resolveDollar)(buildExprs(pullToken)));
    };
    exports2.parse = parse2;
  }
});

// node_modules/@cirru/writer.ts/lib/types.js
var require_types2 = __commonJS({
  "node_modules/@cirru/writer.ts/lib/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isSimpleExpr = exports2.WriterNodeKind = void 0;
    var WriterNodeKind;
    (function(WriterNodeKind2) {
      WriterNodeKind2["writerKindNil"] = "nil";
      WriterNodeKind2["writerKindLeaf"] = "leaf";
      WriterNodeKind2["writerKindSimpleExpr"] = "simple";
      WriterNodeKind2["writerKindBoxedExpr"] = "boxed";
      WriterNodeKind2["writerKindExpr"] = "expr";
    })(WriterNodeKind = exports2.WriterNodeKind || (exports2.WriterNodeKind = {}));
    function isSimpleExpr(xs) {
      if (Array.isArray(xs)) {
        for (let x of xs) {
          if (typeof x !== "string") {
            return false;
          }
        }
        return true;
      } else {
        return false;
      }
    }
    exports2.isSimpleExpr = isSimpleExpr;
  }
});

// node_modules/@cirru/writer.ts/lib/str-util.js
var require_str_util = __commonJS({
  "node_modules/@cirru/writer.ts/lib/str-util.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isALetter = exports2.isADigit = void 0;
    function isADigit(c) {
      let n = c.charCodeAt(0);
      return n >= 48 && n <= 57;
    }
    exports2.isADigit = isADigit;
    function isALetter(c) {
      let n = c.charCodeAt(0);
      if (n >= 65 && n <= 90) {
        return true;
      }
      if (n >= 97 && n <= 122) {
        return true;
      }
      return false;
    }
    exports2.isALetter = isALetter;
  }
});

// node_modules/@cirru/writer.ts/lib/writer.js
var require_writer = __commonJS({
  "node_modules/@cirru/writer.ts/lib/writer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.writeCirruCode = void 0;
    var types_1 = require_types2();
    var str_util_1 = require_str_util();
    var allowedChars = "-~_@#$&%!?^*=+|\\/<>[]{}.,:;'";
    function isBoxed(xs) {
      if (Array.isArray(xs)) {
        for (let x of xs) {
          if (typeof x === "string") {
            return false;
          }
        }
        return true;
      } else {
        return false;
      }
    }
    function isSimpleChar(x) {
      return str_util_1.isADigit(x) || str_util_1.isALetter(x);
    }
    function isCharAllowed(x) {
      if (isSimpleChar(x)) {
        return true;
      }
      if (allowedChars.includes(x)) {
        return true;
      }
      return false;
    }
    var charClose = ")";
    var charOpen = "(";
    var charSpace = " ";
    function generateLeaf(xs) {
      if (Array.isArray(xs)) {
        if (xs.length === 0) {
          return "()";
        } else {
          throw new Error("Unexpect list in leaf");
        }
      } else {
        let allAllowed = true;
        for (let x of xs) {
          if (!isCharAllowed(x)) {
            allAllowed = false;
            break;
          }
        }
        if (allAllowed) {
          return xs;
        } else {
          return JSON.stringify(xs);
        }
      }
    }
    function generateInlineExpr(xs) {
      let result = charOpen;
      if (Array.isArray(xs)) {
        for (let idx = 0; idx < xs.length; idx++) {
          let x = xs[idx];
          if (idx > 0) {
            result = result + charSpace;
          }
          let childForm = typeof x === "string" ? generateLeaf(x) : generateInlineExpr(x);
          result = result + childForm;
        }
      } else {
        throw new Error("Unexpect token in gen list");
      }
      return result + charClose;
    }
    function renderSpaces(n) {
      let result = "";
      for (let i = 0; i < n; i++) {
        result = result + "  ";
      }
      return result;
    }
    function renderNewline(n) {
      return "\n" + renderSpaces(n);
    }
    function getNodeKind(cursor) {
      if (typeof cursor === "string") {
        return types_1.WriterNodeKind.writerKindLeaf;
      } else {
        if (cursor.length === 0) {
          return types_1.WriterNodeKind.writerKindLeaf;
        } else if (types_1.isSimpleExpr(cursor)) {
          return types_1.WriterNodeKind.writerKindSimpleExpr;
        } else if (isBoxed(cursor)) {
          return types_1.WriterNodeKind.writerKindBoxedExpr;
        } else {
          return types_1.WriterNodeKind.writerKindExpr;
        }
      }
    }
    function generateTree(xs, insistHead, options, baseLevel, inTail) {
      let prevKind = types_1.WriterNodeKind.writerKindNil;
      let bendedSize = 0;
      let level = baseLevel;
      let result = "";
      if (typeof xs === "string") {
        throw new Error("expects a list");
      }
      for (let idx = 0; idx < xs.length; idx++) {
        let cursor = xs[idx];
        let kind = getNodeKind(cursor);
        let nextLevel = level + 1;
        let childInsistHead = prevKind === types_1.WriterNodeKind.writerKindBoxedExpr || prevKind === types_1.WriterNodeKind.writerKindExpr;
        let atTail = idx != 0 && !inTail && prevKind === types_1.WriterNodeKind.writerKindLeaf && idx === xs.length - 1 && Array.isArray(cursor);
        let child;
        if (atTail) {
          if (typeof cursor === "string") {
            throw new Error("Expected list");
          }
          if (cursor.length === 0) {
            child = "$";
          } else {
            child = "$ " + generateTree(cursor, false, options, level, atTail);
          }
        } else if (kind === types_1.WriterNodeKind.writerKindLeaf) {
          child = generateLeaf(cursor);
        } else if (idx === 0 && insistHead) {
          child = generateInlineExpr(cursor);
        } else if (kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          if (prevKind === types_1.WriterNodeKind.writerKindLeaf) {
            child = generateInlineExpr(cursor);
          } else if (options.useInline && prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
            child = " " + generateInlineExpr(cursor);
          } else {
            child = renderNewline(nextLevel) + generateTree(cursor, childInsistHead, options, nextLevel, false);
          }
        } else if (kind === types_1.WriterNodeKind.writerKindExpr) {
          let content = generateTree(cursor, childInsistHead, options, nextLevel, false);
          if (content.startsWith("\n")) {
            child = content;
          } else {
            child = renderNewline(nextLevel) + content;
          }
        } else if (kind === types_1.WriterNodeKind.writerKindBoxedExpr) {
          let content = generateTree(cursor, childInsistHead, options, nextLevel, false);
          if (prevKind === types_1.WriterNodeKind.writerKindNil || prevKind === types_1.WriterNodeKind.writerKindLeaf || prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
            child = content;
          } else {
            child = renderNewline(nextLevel) + content;
          }
        } else {
          throw new Error("Unpected condition");
        }
        let bended = kind === types_1.WriterNodeKind.writerKindLeaf && (prevKind === types_1.WriterNodeKind.writerKindBoxedExpr || prevKind === types_1.WriterNodeKind.writerKindExpr);
        let chunk;
        if (atTail) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindLeaf && kind === types_1.WriterNodeKind.writerKindLeaf) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindLeaf && kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          chunk = " " + child;
        } else if (prevKind === types_1.WriterNodeKind.writerKindSimpleExpr && kind === types_1.WriterNodeKind.writerKindLeaf) {
          chunk = " " + child;
        } else if (bended) {
          chunk = renderNewline(nextLevel) + ", " + child;
        } else {
          chunk = child;
        }
        result = result + chunk;
        if (kind === types_1.WriterNodeKind.writerKindSimpleExpr) {
          if (idx === 0 && insistHead) {
            prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
          } else if (options.useInline) {
            if (prevKind === types_1.WriterNodeKind.writerKindLeaf || prevKind === types_1.WriterNodeKind.writerKindSimpleExpr) {
              prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
            } else {
              prevKind = types_1.WriterNodeKind.writerKindExpr;
            }
          } else {
            if (prevKind === types_1.WriterNodeKind.writerKindLeaf) {
              prevKind = types_1.WriterNodeKind.writerKindSimpleExpr;
            } else {
              prevKind = types_1.WriterNodeKind.writerKindExpr;
            }
          }
        } else {
          prevKind = kind;
        }
        if (bended) {
          bendedSize = bendedSize + 1;
          level = level + 1;
        }
      }
      return result;
    }
    function generateStatements(xs, options) {
      if (typeof xs === "string") {
        throw new Error("Unexpected item");
      }
      return xs.map((x) => {
        return "\n" + generateTree(x, true, options, 0, false) + "\n";
      }).join("");
    }
    function writeCirruCode3(xs, options = { useInline: false }) {
      return generateStatements(xs, options);
    }
    exports2.writeCirruCode = writeCirruCode3;
  }
});

// node_modules/color-name/index.js
var require_color_name = __commonJS({
  "node_modules/color-name/index.js"(exports2, module2) {
    "use strict";
    module2.exports = {
      "aliceblue": [240, 248, 255],
      "antiquewhite": [250, 235, 215],
      "aqua": [0, 255, 255],
      "aquamarine": [127, 255, 212],
      "azure": [240, 255, 255],
      "beige": [245, 245, 220],
      "bisque": [255, 228, 196],
      "black": [0, 0, 0],
      "blanchedalmond": [255, 235, 205],
      "blue": [0, 0, 255],
      "blueviolet": [138, 43, 226],
      "brown": [165, 42, 42],
      "burlywood": [222, 184, 135],
      "cadetblue": [95, 158, 160],
      "chartreuse": [127, 255, 0],
      "chocolate": [210, 105, 30],
      "coral": [255, 127, 80],
      "cornflowerblue": [100, 149, 237],
      "cornsilk": [255, 248, 220],
      "crimson": [220, 20, 60],
      "cyan": [0, 255, 255],
      "darkblue": [0, 0, 139],
      "darkcyan": [0, 139, 139],
      "darkgoldenrod": [184, 134, 11],
      "darkgray": [169, 169, 169],
      "darkgreen": [0, 100, 0],
      "darkgrey": [169, 169, 169],
      "darkkhaki": [189, 183, 107],
      "darkmagenta": [139, 0, 139],
      "darkolivegreen": [85, 107, 47],
      "darkorange": [255, 140, 0],
      "darkorchid": [153, 50, 204],
      "darkred": [139, 0, 0],
      "darksalmon": [233, 150, 122],
      "darkseagreen": [143, 188, 143],
      "darkslateblue": [72, 61, 139],
      "darkslategray": [47, 79, 79],
      "darkslategrey": [47, 79, 79],
      "darkturquoise": [0, 206, 209],
      "darkviolet": [148, 0, 211],
      "deeppink": [255, 20, 147],
      "deepskyblue": [0, 191, 255],
      "dimgray": [105, 105, 105],
      "dimgrey": [105, 105, 105],
      "dodgerblue": [30, 144, 255],
      "firebrick": [178, 34, 34],
      "floralwhite": [255, 250, 240],
      "forestgreen": [34, 139, 34],
      "fuchsia": [255, 0, 255],
      "gainsboro": [220, 220, 220],
      "ghostwhite": [248, 248, 255],
      "gold": [255, 215, 0],
      "goldenrod": [218, 165, 32],
      "gray": [128, 128, 128],
      "green": [0, 128, 0],
      "greenyellow": [173, 255, 47],
      "grey": [128, 128, 128],
      "honeydew": [240, 255, 240],
      "hotpink": [255, 105, 180],
      "indianred": [205, 92, 92],
      "indigo": [75, 0, 130],
      "ivory": [255, 255, 240],
      "khaki": [240, 230, 140],
      "lavender": [230, 230, 250],
      "lavenderblush": [255, 240, 245],
      "lawngreen": [124, 252, 0],
      "lemonchiffon": [255, 250, 205],
      "lightblue": [173, 216, 230],
      "lightcoral": [240, 128, 128],
      "lightcyan": [224, 255, 255],
      "lightgoldenrodyellow": [250, 250, 210],
      "lightgray": [211, 211, 211],
      "lightgreen": [144, 238, 144],
      "lightgrey": [211, 211, 211],
      "lightpink": [255, 182, 193],
      "lightsalmon": [255, 160, 122],
      "lightseagreen": [32, 178, 170],
      "lightskyblue": [135, 206, 250],
      "lightslategray": [119, 136, 153],
      "lightslategrey": [119, 136, 153],
      "lightsteelblue": [176, 196, 222],
      "lightyellow": [255, 255, 224],
      "lime": [0, 255, 0],
      "limegreen": [50, 205, 50],
      "linen": [250, 240, 230],
      "magenta": [255, 0, 255],
      "maroon": [128, 0, 0],
      "mediumaquamarine": [102, 205, 170],
      "mediumblue": [0, 0, 205],
      "mediumorchid": [186, 85, 211],
      "mediumpurple": [147, 112, 219],
      "mediumseagreen": [60, 179, 113],
      "mediumslateblue": [123, 104, 238],
      "mediumspringgreen": [0, 250, 154],
      "mediumturquoise": [72, 209, 204],
      "mediumvioletred": [199, 21, 133],
      "midnightblue": [25, 25, 112],
      "mintcream": [245, 255, 250],
      "mistyrose": [255, 228, 225],
      "moccasin": [255, 228, 181],
      "navajowhite": [255, 222, 173],
      "navy": [0, 0, 128],
      "oldlace": [253, 245, 230],
      "olive": [128, 128, 0],
      "olivedrab": [107, 142, 35],
      "orange": [255, 165, 0],
      "orangered": [255, 69, 0],
      "orchid": [218, 112, 214],
      "palegoldenrod": [238, 232, 170],
      "palegreen": [152, 251, 152],
      "paleturquoise": [175, 238, 238],
      "palevioletred": [219, 112, 147],
      "papayawhip": [255, 239, 213],
      "peachpuff": [255, 218, 185],
      "peru": [205, 133, 63],
      "pink": [255, 192, 203],
      "plum": [221, 160, 221],
      "powderblue": [176, 224, 230],
      "purple": [128, 0, 128],
      "rebeccapurple": [102, 51, 153],
      "red": [255, 0, 0],
      "rosybrown": [188, 143, 143],
      "royalblue": [65, 105, 225],
      "saddlebrown": [139, 69, 19],
      "salmon": [250, 128, 114],
      "sandybrown": [244, 164, 96],
      "seagreen": [46, 139, 87],
      "seashell": [255, 245, 238],
      "sienna": [160, 82, 45],
      "silver": [192, 192, 192],
      "skyblue": [135, 206, 235],
      "slateblue": [106, 90, 205],
      "slategray": [112, 128, 144],
      "slategrey": [112, 128, 144],
      "snow": [255, 250, 250],
      "springgreen": [0, 255, 127],
      "steelblue": [70, 130, 180],
      "tan": [210, 180, 140],
      "teal": [0, 128, 128],
      "thistle": [216, 191, 216],
      "tomato": [255, 99, 71],
      "turquoise": [64, 224, 208],
      "violet": [238, 130, 238],
      "wheat": [245, 222, 179],
      "white": [255, 255, 255],
      "whitesmoke": [245, 245, 245],
      "yellow": [255, 255, 0],
      "yellowgreen": [154, 205, 50]
    };
  }
});

// node_modules/color-convert/conversions.js
var require_conversions = __commonJS({
  "node_modules/color-convert/conversions.js"(exports2, module2) {
    var cssKeywords = require_color_name();
    var reverseKeywords = {};
    for (const key of Object.keys(cssKeywords)) {
      reverseKeywords[cssKeywords[key]] = key;
    }
    var convert = {
      rgb: { channels: 3, labels: "rgb" },
      hsl: { channels: 3, labels: "hsl" },
      hsv: { channels: 3, labels: "hsv" },
      hwb: { channels: 3, labels: "hwb" },
      cmyk: { channels: 4, labels: "cmyk" },
      xyz: { channels: 3, labels: "xyz" },
      lab: { channels: 3, labels: "lab" },
      lch: { channels: 3, labels: "lch" },
      hex: { channels: 1, labels: ["hex"] },
      keyword: { channels: 1, labels: ["keyword"] },
      ansi16: { channels: 1, labels: ["ansi16"] },
      ansi256: { channels: 1, labels: ["ansi256"] },
      hcg: { channels: 3, labels: ["h", "c", "g"] },
      apple: { channels: 3, labels: ["r16", "g16", "b16"] },
      gray: { channels: 1, labels: ["gray"] }
    };
    module2.exports = convert;
    for (const model of Object.keys(convert)) {
      if (!("channels" in convert[model])) {
        throw new Error("missing channels property: " + model);
      }
      if (!("labels" in convert[model])) {
        throw new Error("missing channel labels property: " + model);
      }
      if (convert[model].labels.length !== convert[model].channels) {
        throw new Error("channel and label counts mismatch: " + model);
      }
      const { channels, labels } = convert[model];
      delete convert[model].channels;
      delete convert[model].labels;
      Object.defineProperty(convert[model], "channels", { value: channels });
      Object.defineProperty(convert[model], "labels", { value: labels });
    }
    convert.rgb.hsl = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const min = Math.min(r, g, b);
      const max = Math.max(r, g, b);
      const delta = max - min;
      let h;
      let s;
      if (max === min) {
        h = 0;
      } else if (r === max) {
        h = (g - b) / delta;
      } else if (g === max) {
        h = 2 + (b - r) / delta;
      } else if (b === max) {
        h = 4 + (r - g) / delta;
      }
      h = Math.min(h * 60, 360);
      if (h < 0) {
        h += 360;
      }
      const l = (min + max) / 2;
      if (max === min) {
        s = 0;
      } else if (l <= 0.5) {
        s = delta / (max + min);
      } else {
        s = delta / (2 - max - min);
      }
      return [h, s * 100, l * 100];
    };
    convert.rgb.hsv = function(rgb) {
      let rdif;
      let gdif;
      let bdif;
      let h;
      let s;
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const v = Math.max(r, g, b);
      const diff = v - Math.min(r, g, b);
      const diffc = function(c) {
        return (v - c) / 6 / diff + 1 / 2;
      };
      if (diff === 0) {
        h = 0;
        s = 0;
      } else {
        s = diff / v;
        rdif = diffc(r);
        gdif = diffc(g);
        bdif = diffc(b);
        if (r === v) {
          h = bdif - gdif;
        } else if (g === v) {
          h = 1 / 3 + rdif - bdif;
        } else if (b === v) {
          h = 2 / 3 + gdif - rdif;
        }
        if (h < 0) {
          h += 1;
        } else if (h > 1) {
          h -= 1;
        }
      }
      return [
        h * 360,
        s * 100,
        v * 100
      ];
    };
    convert.rgb.hwb = function(rgb) {
      const r = rgb[0];
      const g = rgb[1];
      let b = rgb[2];
      const h = convert.rgb.hsl(rgb)[0];
      const w = 1 / 255 * Math.min(r, Math.min(g, b));
      b = 1 - 1 / 255 * Math.max(r, Math.max(g, b));
      return [h, w * 100, b * 100];
    };
    convert.rgb.cmyk = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const k = Math.min(1 - r, 1 - g, 1 - b);
      const c = (1 - r - k) / (1 - k) || 0;
      const m = (1 - g - k) / (1 - k) || 0;
      const y = (1 - b - k) / (1 - k) || 0;
      return [c * 100, m * 100, y * 100, k * 100];
    };
    function comparativeDistance(x, y) {
      return (x[0] - y[0]) ** 2 + (x[1] - y[1]) ** 2 + (x[2] - y[2]) ** 2;
    }
    convert.rgb.keyword = function(rgb) {
      const reversed = reverseKeywords[rgb];
      if (reversed) {
        return reversed;
      }
      let currentClosestDistance = Infinity;
      let currentClosestKeyword;
      for (const keyword of Object.keys(cssKeywords)) {
        const value = cssKeywords[keyword];
        const distance = comparativeDistance(rgb, value);
        if (distance < currentClosestDistance) {
          currentClosestDistance = distance;
          currentClosestKeyword = keyword;
        }
      }
      return currentClosestKeyword;
    };
    convert.keyword.rgb = function(keyword) {
      return cssKeywords[keyword];
    };
    convert.rgb.xyz = function(rgb) {
      let r = rgb[0] / 255;
      let g = rgb[1] / 255;
      let b = rgb[2] / 255;
      r = r > 0.04045 ? ((r + 0.055) / 1.055) ** 2.4 : r / 12.92;
      g = g > 0.04045 ? ((g + 0.055) / 1.055) ** 2.4 : g / 12.92;
      b = b > 0.04045 ? ((b + 0.055) / 1.055) ** 2.4 : b / 12.92;
      const x = r * 0.4124 + g * 0.3576 + b * 0.1805;
      const y = r * 0.2126 + g * 0.7152 + b * 0.0722;
      const z = r * 0.0193 + g * 0.1192 + b * 0.9505;
      return [x * 100, y * 100, z * 100];
    };
    convert.rgb.lab = function(rgb) {
      const xyz = convert.rgb.xyz(rgb);
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a2 = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a2, b];
    };
    convert.hsl.rgb = function(hsl2) {
      const h = hsl2[0] / 360;
      const s = hsl2[1] / 100;
      const l = hsl2[2] / 100;
      let t2;
      let t3;
      let val;
      if (s === 0) {
        val = l * 255;
        return [val, val, val];
      }
      if (l < 0.5) {
        t2 = l * (1 + s);
      } else {
        t2 = l + s - l * s;
      }
      const t1 = 2 * l - t2;
      const rgb = [0, 0, 0];
      for (let i = 0; i < 3; i++) {
        t3 = h + 1 / 3 * -(i - 1);
        if (t3 < 0) {
          t3++;
        }
        if (t3 > 1) {
          t3--;
        }
        if (6 * t3 < 1) {
          val = t1 + (t2 - t1) * 6 * t3;
        } else if (2 * t3 < 1) {
          val = t2;
        } else if (3 * t3 < 2) {
          val = t1 + (t2 - t1) * (2 / 3 - t3) * 6;
        } else {
          val = t1;
        }
        rgb[i] = val * 255;
      }
      return rgb;
    };
    convert.hsl.hsv = function(hsl2) {
      const h = hsl2[0];
      let s = hsl2[1] / 100;
      let l = hsl2[2] / 100;
      let smin = s;
      const lmin = Math.max(l, 0.01);
      l *= 2;
      s *= l <= 1 ? l : 2 - l;
      smin *= lmin <= 1 ? lmin : 2 - lmin;
      const v = (l + s) / 2;
      const sv = l === 0 ? 2 * smin / (lmin + smin) : 2 * s / (l + s);
      return [h, sv * 100, v * 100];
    };
    convert.hsv.rgb = function(hsv) {
      const h = hsv[0] / 60;
      const s = hsv[1] / 100;
      let v = hsv[2] / 100;
      const hi = Math.floor(h) % 6;
      const f = h - Math.floor(h);
      const p = 255 * v * (1 - s);
      const q = 255 * v * (1 - s * f);
      const t = 255 * v * (1 - s * (1 - f));
      v *= 255;
      switch (hi) {
        case 0:
          return [v, t, p];
        case 1:
          return [q, v, p];
        case 2:
          return [p, v, t];
        case 3:
          return [p, q, v];
        case 4:
          return [t, p, v];
        case 5:
          return [v, p, q];
      }
    };
    convert.hsv.hsl = function(hsv) {
      const h = hsv[0];
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const vmin = Math.max(v, 0.01);
      let sl;
      let l;
      l = (2 - s) * v;
      const lmin = (2 - s) * vmin;
      sl = s * vmin;
      sl /= lmin <= 1 ? lmin : 2 - lmin;
      sl = sl || 0;
      l /= 2;
      return [h, sl * 100, l * 100];
    };
    convert.hwb.rgb = function(hwb) {
      const h = hwb[0] / 360;
      let wh = hwb[1] / 100;
      let bl = hwb[2] / 100;
      const ratio = wh + bl;
      let f;
      if (ratio > 1) {
        wh /= ratio;
        bl /= ratio;
      }
      const i = Math.floor(6 * h);
      const v = 1 - bl;
      f = 6 * h - i;
      if ((i & 1) !== 0) {
        f = 1 - f;
      }
      const n = wh + f * (v - wh);
      let r;
      let g;
      let b;
      switch (i) {
        default:
        case 6:
        case 0:
          r = v;
          g = n;
          b = wh;
          break;
        case 1:
          r = n;
          g = v;
          b = wh;
          break;
        case 2:
          r = wh;
          g = v;
          b = n;
          break;
        case 3:
          r = wh;
          g = n;
          b = v;
          break;
        case 4:
          r = n;
          g = wh;
          b = v;
          break;
        case 5:
          r = v;
          g = wh;
          b = n;
          break;
      }
      return [r * 255, g * 255, b * 255];
    };
    convert.cmyk.rgb = function(cmyk) {
      const c = cmyk[0] / 100;
      const m = cmyk[1] / 100;
      const y = cmyk[2] / 100;
      const k = cmyk[3] / 100;
      const r = 1 - Math.min(1, c * (1 - k) + k);
      const g = 1 - Math.min(1, m * (1 - k) + k);
      const b = 1 - Math.min(1, y * (1 - k) + k);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.rgb = function(xyz) {
      const x = xyz[0] / 100;
      const y = xyz[1] / 100;
      const z = xyz[2] / 100;
      let r;
      let g;
      let b;
      r = x * 3.2406 + y * -1.5372 + z * -0.4986;
      g = x * -0.9689 + y * 1.8758 + z * 0.0415;
      b = x * 0.0557 + y * -0.204 + z * 1.057;
      r = r > 31308e-7 ? 1.055 * r ** (1 / 2.4) - 0.055 : r * 12.92;
      g = g > 31308e-7 ? 1.055 * g ** (1 / 2.4) - 0.055 : g * 12.92;
      b = b > 31308e-7 ? 1.055 * b ** (1 / 2.4) - 0.055 : b * 12.92;
      r = Math.min(Math.max(0, r), 1);
      g = Math.min(Math.max(0, g), 1);
      b = Math.min(Math.max(0, b), 1);
      return [r * 255, g * 255, b * 255];
    };
    convert.xyz.lab = function(xyz) {
      let x = xyz[0];
      let y = xyz[1];
      let z = xyz[2];
      x /= 95.047;
      y /= 100;
      z /= 108.883;
      x = x > 8856e-6 ? x ** (1 / 3) : 7.787 * x + 16 / 116;
      y = y > 8856e-6 ? y ** (1 / 3) : 7.787 * y + 16 / 116;
      z = z > 8856e-6 ? z ** (1 / 3) : 7.787 * z + 16 / 116;
      const l = 116 * y - 16;
      const a2 = 500 * (x - y);
      const b = 200 * (y - z);
      return [l, a2, b];
    };
    convert.lab.xyz = function(lab) {
      const l = lab[0];
      const a2 = lab[1];
      const b = lab[2];
      let x;
      let y;
      let z;
      y = (l + 16) / 116;
      x = a2 / 500 + y;
      z = y - b / 200;
      const y2 = y ** 3;
      const x2 = x ** 3;
      const z2 = z ** 3;
      y = y2 > 8856e-6 ? y2 : (y - 16 / 116) / 7.787;
      x = x2 > 8856e-6 ? x2 : (x - 16 / 116) / 7.787;
      z = z2 > 8856e-6 ? z2 : (z - 16 / 116) / 7.787;
      x *= 95.047;
      y *= 100;
      z *= 108.883;
      return [x, y, z];
    };
    convert.lab.lch = function(lab) {
      const l = lab[0];
      const a2 = lab[1];
      const b = lab[2];
      let h;
      const hr = Math.atan2(b, a2);
      h = hr * 360 / 2 / Math.PI;
      if (h < 0) {
        h += 360;
      }
      const c = Math.sqrt(a2 * a2 + b * b);
      return [l, c, h];
    };
    convert.lch.lab = function(lch) {
      const l = lch[0];
      const c = lch[1];
      const h = lch[2];
      const hr = h / 360 * 2 * Math.PI;
      const a2 = c * Math.cos(hr);
      const b = c * Math.sin(hr);
      return [l, a2, b];
    };
    convert.rgb.ansi16 = function(args2, saturation = null) {
      const [r, g, b] = args2;
      let value = saturation === null ? convert.rgb.hsv(args2)[2] : saturation;
      value = Math.round(value / 50);
      if (value === 0) {
        return 30;
      }
      let ansi = 30 + (Math.round(b / 255) << 2 | Math.round(g / 255) << 1 | Math.round(r / 255));
      if (value === 2) {
        ansi += 60;
      }
      return ansi;
    };
    convert.hsv.ansi16 = function(args2) {
      return convert.rgb.ansi16(convert.hsv.rgb(args2), args2[2]);
    };
    convert.rgb.ansi256 = function(args2) {
      const r = args2[0];
      const g = args2[1];
      const b = args2[2];
      if (r === g && g === b) {
        if (r < 8) {
          return 16;
        }
        if (r > 248) {
          return 231;
        }
        return Math.round((r - 8) / 247 * 24) + 232;
      }
      const ansi = 16 + 36 * Math.round(r / 255 * 5) + 6 * Math.round(g / 255 * 5) + Math.round(b / 255 * 5);
      return ansi;
    };
    convert.ansi16.rgb = function(args2) {
      let color = args2 % 10;
      if (color === 0 || color === 7) {
        if (args2 > 50) {
          color += 3.5;
        }
        color = color / 10.5 * 255;
        return [color, color, color];
      }
      const mult = (~~(args2 > 50) + 1) * 0.5;
      const r = (color & 1) * mult * 255;
      const g = (color >> 1 & 1) * mult * 255;
      const b = (color >> 2 & 1) * mult * 255;
      return [r, g, b];
    };
    convert.ansi256.rgb = function(args2) {
      if (args2 >= 232) {
        const c = (args2 - 232) * 10 + 8;
        return [c, c, c];
      }
      args2 -= 16;
      let rem;
      const r = Math.floor(args2 / 36) / 5 * 255;
      const g = Math.floor((rem = args2 % 36) / 6) / 5 * 255;
      const b = rem % 6 / 5 * 255;
      return [r, g, b];
    };
    convert.rgb.hex = function(args2) {
      const integer = ((Math.round(args2[0]) & 255) << 16) + ((Math.round(args2[1]) & 255) << 8) + (Math.round(args2[2]) & 255);
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.hex.rgb = function(args2) {
      const match = args2.toString(16).match(/[a-f0-9]{6}|[a-f0-9]{3}/i);
      if (!match) {
        return [0, 0, 0];
      }
      let colorString = match[0];
      if (match[0].length === 3) {
        colorString = colorString.split("").map((char) => {
          return char + char;
        }).join("");
      }
      const integer = parseInt(colorString, 16);
      const r = integer >> 16 & 255;
      const g = integer >> 8 & 255;
      const b = integer & 255;
      return [r, g, b];
    };
    convert.rgb.hcg = function(rgb) {
      const r = rgb[0] / 255;
      const g = rgb[1] / 255;
      const b = rgb[2] / 255;
      const max = Math.max(Math.max(r, g), b);
      const min = Math.min(Math.min(r, g), b);
      const chroma = max - min;
      let grayscale;
      let hue;
      if (chroma < 1) {
        grayscale = min / (1 - chroma);
      } else {
        grayscale = 0;
      }
      if (chroma <= 0) {
        hue = 0;
      } else if (max === r) {
        hue = (g - b) / chroma % 6;
      } else if (max === g) {
        hue = 2 + (b - r) / chroma;
      } else {
        hue = 4 + (r - g) / chroma;
      }
      hue /= 6;
      hue %= 1;
      return [hue * 360, chroma * 100, grayscale * 100];
    };
    convert.hsl.hcg = function(hsl2) {
      const s = hsl2[1] / 100;
      const l = hsl2[2] / 100;
      const c = l < 0.5 ? 2 * s * l : 2 * s * (1 - l);
      let f = 0;
      if (c < 1) {
        f = (l - 0.5 * c) / (1 - c);
      }
      return [hsl2[0], c * 100, f * 100];
    };
    convert.hsv.hcg = function(hsv) {
      const s = hsv[1] / 100;
      const v = hsv[2] / 100;
      const c = s * v;
      let f = 0;
      if (c < 1) {
        f = (v - c) / (1 - c);
      }
      return [hsv[0], c * 100, f * 100];
    };
    convert.hcg.rgb = function(hcg) {
      const h = hcg[0] / 360;
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      if (c === 0) {
        return [g * 255, g * 255, g * 255];
      }
      const pure = [0, 0, 0];
      const hi = h % 1 * 6;
      const v = hi % 1;
      const w = 1 - v;
      let mg = 0;
      switch (Math.floor(hi)) {
        case 0:
          pure[0] = 1;
          pure[1] = v;
          pure[2] = 0;
          break;
        case 1:
          pure[0] = w;
          pure[1] = 1;
          pure[2] = 0;
          break;
        case 2:
          pure[0] = 0;
          pure[1] = 1;
          pure[2] = v;
          break;
        case 3:
          pure[0] = 0;
          pure[1] = w;
          pure[2] = 1;
          break;
        case 4:
          pure[0] = v;
          pure[1] = 0;
          pure[2] = 1;
          break;
        default:
          pure[0] = 1;
          pure[1] = 0;
          pure[2] = w;
      }
      mg = (1 - c) * g;
      return [
        (c * pure[0] + mg) * 255,
        (c * pure[1] + mg) * 255,
        (c * pure[2] + mg) * 255
      ];
    };
    convert.hcg.hsv = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      let f = 0;
      if (v > 0) {
        f = c / v;
      }
      return [hcg[0], f * 100, v * 100];
    };
    convert.hcg.hsl = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const l = g * (1 - c) + 0.5 * c;
      let s = 0;
      if (l > 0 && l < 0.5) {
        s = c / (2 * l);
      } else if (l >= 0.5 && l < 1) {
        s = c / (2 * (1 - l));
      }
      return [hcg[0], s * 100, l * 100];
    };
    convert.hcg.hwb = function(hcg) {
      const c = hcg[1] / 100;
      const g = hcg[2] / 100;
      const v = c + g * (1 - c);
      return [hcg[0], (v - c) * 100, (1 - v) * 100];
    };
    convert.hwb.hcg = function(hwb) {
      const w = hwb[1] / 100;
      const b = hwb[2] / 100;
      const v = 1 - b;
      const c = v - w;
      let g = 0;
      if (c < 1) {
        g = (v - c) / (1 - c);
      }
      return [hwb[0], c * 100, g * 100];
    };
    convert.apple.rgb = function(apple) {
      return [apple[0] / 65535 * 255, apple[1] / 65535 * 255, apple[2] / 65535 * 255];
    };
    convert.rgb.apple = function(rgb) {
      return [rgb[0] / 255 * 65535, rgb[1] / 255 * 65535, rgb[2] / 255 * 65535];
    };
    convert.gray.rgb = function(args2) {
      return [args2[0] / 100 * 255, args2[0] / 100 * 255, args2[0] / 100 * 255];
    };
    convert.gray.hsl = function(args2) {
      return [0, 0, args2[0]];
    };
    convert.gray.hsv = convert.gray.hsl;
    convert.gray.hwb = function(gray) {
      return [0, 100, gray[0]];
    };
    convert.gray.cmyk = function(gray) {
      return [0, 0, 0, gray[0]];
    };
    convert.gray.lab = function(gray) {
      return [gray[0], 0, 0];
    };
    convert.gray.hex = function(gray) {
      const val = Math.round(gray[0] / 100 * 255) & 255;
      const integer = (val << 16) + (val << 8) + val;
      const string = integer.toString(16).toUpperCase();
      return "000000".substring(string.length) + string;
    };
    convert.rgb.gray = function(rgb) {
      const val = (rgb[0] + rgb[1] + rgb[2]) / 3;
      return [val / 255 * 100];
    };
  }
});

// node_modules/color-convert/route.js
var require_route = __commonJS({
  "node_modules/color-convert/route.js"(exports2, module2) {
    var conversions = require_conversions();
    function buildGraph() {
      const graph = {};
      const models = Object.keys(conversions);
      for (let len = models.length, i = 0; i < len; i++) {
        graph[models[i]] = {
          distance: -1,
          parent: null
        };
      }
      return graph;
    }
    function deriveBFS(fromModel) {
      const graph = buildGraph();
      const queue = [fromModel];
      graph[fromModel].distance = 0;
      while (queue.length) {
        const current = queue.pop();
        const adjacents = Object.keys(conversions[current]);
        for (let len = adjacents.length, i = 0; i < len; i++) {
          const adjacent = adjacents[i];
          const node = graph[adjacent];
          if (node.distance === -1) {
            node.distance = graph[current].distance + 1;
            node.parent = current;
            queue.unshift(adjacent);
          }
        }
      }
      return graph;
    }
    function link2(from, to) {
      return function(args2) {
        return to(from(args2));
      };
    }
    function wrapConversion(toModel, graph) {
      const path = [graph[toModel].parent, toModel];
      let fn3 = conversions[graph[toModel].parent][toModel];
      let cur = graph[toModel].parent;
      while (graph[cur].parent) {
        path.unshift(graph[cur].parent);
        fn3 = link2(conversions[graph[cur].parent][cur], fn3);
        cur = graph[cur].parent;
      }
      fn3.conversion = path;
      return fn3;
    }
    module2.exports = function(fromModel) {
      const graph = deriveBFS(fromModel);
      const conversion = {};
      const models = Object.keys(graph);
      for (let len = models.length, i = 0; i < len; i++) {
        const toModel = models[i];
        const node = graph[toModel];
        if (node.parent === null) {
          continue;
        }
        conversion[toModel] = wrapConversion(toModel, graph);
      }
      return conversion;
    };
  }
});

// node_modules/color-convert/index.js
var require_color_convert = __commonJS({
  "node_modules/color-convert/index.js"(exports2, module2) {
    var conversions = require_conversions();
    var route = require_route();
    var convert = {};
    var models = Object.keys(conversions);
    function wrapRaw(fn3) {
      const wrappedFn = function(...args2) {
        const arg0 = args2[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args2 = arg0;
        }
        return fn3(args2);
      };
      if ("conversion" in fn3) {
        wrappedFn.conversion = fn3.conversion;
      }
      return wrappedFn;
    }
    function wrapRounded(fn3) {
      const wrappedFn = function(...args2) {
        const arg0 = args2[0];
        if (arg0 === void 0 || arg0 === null) {
          return arg0;
        }
        if (arg0.length > 1) {
          args2 = arg0;
        }
        const result = fn3(args2);
        if (typeof result === "object") {
          for (let len = result.length, i = 0; i < len; i++) {
            result[i] = Math.round(result[i]);
          }
        }
        return result;
      };
      if ("conversion" in fn3) {
        wrappedFn.conversion = fn3.conversion;
      }
      return wrappedFn;
    }
    models.forEach((fromModel) => {
      convert[fromModel] = {};
      Object.defineProperty(convert[fromModel], "channels", { value: conversions[fromModel].channels });
      Object.defineProperty(convert[fromModel], "labels", { value: conversions[fromModel].labels });
      const routes = route(fromModel);
      const routeModels = Object.keys(routes);
      routeModels.forEach((toModel) => {
        const fn3 = routes[toModel];
        convert[fromModel][toModel] = wrapRounded(fn3);
        convert[fromModel][toModel].raw = wrapRaw(fn3);
      });
    });
    module2.exports = convert;
  }
});

// node_modules/ansi-styles/index.js
var require_ansi_styles = __commonJS({
  "node_modules/ansi-styles/index.js"(exports2, module2) {
    "use strict";
    var wrapAnsi16 = (fn3, offset) => (...args2) => {
      const code = fn3(...args2);
      return `\x1B[${code + offset}m`;
    };
    var wrapAnsi256 = (fn3, offset) => (...args2) => {
      const code = fn3(...args2);
      return `\x1B[${38 + offset};5;${code}m`;
    };
    var wrapAnsi16m = (fn3, offset) => (...args2) => {
      const rgb = fn3(...args2);
      return `\x1B[${38 + offset};2;${rgb[0]};${rgb[1]};${rgb[2]}m`;
    };
    var ansi2ansi = (n) => n;
    var rgb2rgb = (r, g, b) => [r, g, b];
    var setLazyProperty = (object, property, get2) => {
      Object.defineProperty(object, property, {
        get: () => {
          const value = get2();
          Object.defineProperty(object, property, {
            value,
            enumerable: true,
            configurable: true
          });
          return value;
        },
        enumerable: true,
        configurable: true
      });
    };
    var colorConvert;
    var makeDynamicStyles = (wrap, targetSpace, identity2, isBackground) => {
      if (colorConvert === void 0) {
        colorConvert = require_color_convert();
      }
      const offset = isBackground ? 10 : 0;
      const styles = {};
      for (const [sourceSpace, suite] of Object.entries(colorConvert)) {
        const name = sourceSpace === "ansi16" ? "ansi" : sourceSpace;
        if (sourceSpace === targetSpace) {
          styles[name] = wrap(identity2, offset);
        } else if (typeof suite === "object") {
          styles[name] = wrap(suite[targetSpace], offset);
        }
      }
      return styles;
    };
    function assembleStyles() {
      const codes = /* @__PURE__ */ new Map();
      const styles = {
        modifier: {
          reset: [0, 0],
          bold: [1, 22],
          dim: [2, 22],
          italic: [3, 23],
          underline: [4, 24],
          inverse: [7, 27],
          hidden: [8, 28],
          strikethrough: [9, 29]
        },
        color: {
          black: [30, 39],
          red: [31, 39],
          green: [32, 39],
          yellow: [33, 39],
          blue: [34, 39],
          magenta: [35, 39],
          cyan: [36, 39],
          white: [37, 39],
          blackBright: [90, 39],
          redBright: [91, 39],
          greenBright: [92, 39],
          yellowBright: [93, 39],
          blueBright: [94, 39],
          magentaBright: [95, 39],
          cyanBright: [96, 39],
          whiteBright: [97, 39]
        },
        bgColor: {
          bgBlack: [40, 49],
          bgRed: [41, 49],
          bgGreen: [42, 49],
          bgYellow: [43, 49],
          bgBlue: [44, 49],
          bgMagenta: [45, 49],
          bgCyan: [46, 49],
          bgWhite: [47, 49],
          bgBlackBright: [100, 49],
          bgRedBright: [101, 49],
          bgGreenBright: [102, 49],
          bgYellowBright: [103, 49],
          bgBlueBright: [104, 49],
          bgMagentaBright: [105, 49],
          bgCyanBright: [106, 49],
          bgWhiteBright: [107, 49]
        }
      };
      styles.color.gray = styles.color.blackBright;
      styles.bgColor.bgGray = styles.bgColor.bgBlackBright;
      styles.color.grey = styles.color.blackBright;
      styles.bgColor.bgGrey = styles.bgColor.bgBlackBright;
      for (const [groupName, group] of Object.entries(styles)) {
        for (const [styleName, style] of Object.entries(group)) {
          styles[styleName] = {
            open: `\x1B[${style[0]}m`,
            close: `\x1B[${style[1]}m`
          };
          group[styleName] = styles[styleName];
          codes.set(style[0], style[1]);
        }
        Object.defineProperty(styles, groupName, {
          value: group,
          enumerable: false
        });
      }
      Object.defineProperty(styles, "codes", {
        value: codes,
        enumerable: false
      });
      styles.color.close = "\x1B[39m";
      styles.bgColor.close = "\x1B[49m";
      setLazyProperty(styles.color, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, false));
      setLazyProperty(styles.color, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, false));
      setLazyProperty(styles.bgColor, "ansi", () => makeDynamicStyles(wrapAnsi16, "ansi16", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi256", () => makeDynamicStyles(wrapAnsi256, "ansi256", ansi2ansi, true));
      setLazyProperty(styles.bgColor, "ansi16m", () => makeDynamicStyles(wrapAnsi16m, "rgb", rgb2rgb, true));
      return styles;
    }
    Object.defineProperty(module2, "exports", {
      enumerable: true,
      get: assembleStyles
    });
  }
});

// node_modules/has-flag/index.js
var require_has_flag = __commonJS({
  "node_modules/has-flag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (flag, argv = process.argv) => {
      const prefix = flag.startsWith("-") ? "" : flag.length === 1 ? "-" : "--";
      const position = argv.indexOf(prefix + flag);
      const terminatorPosition = argv.indexOf("--");
      return position !== -1 && (terminatorPosition === -1 || position < terminatorPosition);
    };
  }
});

// node_modules/supports-color/index.js
var require_supports_color = __commonJS({
  "node_modules/supports-color/index.js"(exports2, module2) {
    "use strict";
    var os = require("os");
    var tty = require("tty");
    var hasFlag = require_has_flag();
    var { env } = process;
    var forceColor;
    if (hasFlag("no-color") || hasFlag("no-colors") || hasFlag("color=false") || hasFlag("color=never")) {
      forceColor = 0;
    } else if (hasFlag("color") || hasFlag("colors") || hasFlag("color=true") || hasFlag("color=always")) {
      forceColor = 1;
    }
    if ("FORCE_COLOR" in env) {
      if (env.FORCE_COLOR === "true") {
        forceColor = 1;
      } else if (env.FORCE_COLOR === "false") {
        forceColor = 0;
      } else {
        forceColor = env.FORCE_COLOR.length === 0 ? 1 : Math.min(parseInt(env.FORCE_COLOR, 10), 3);
      }
    }
    function translateLevel(level) {
      if (level === 0) {
        return false;
      }
      return {
        level,
        hasBasic: true,
        has256: level >= 2,
        has16m: level >= 3
      };
    }
    function supportsColor(haveStream, streamIsTTY) {
      if (forceColor === 0) {
        return 0;
      }
      if (hasFlag("color=16m") || hasFlag("color=full") || hasFlag("color=truecolor")) {
        return 3;
      }
      if (hasFlag("color=256")) {
        return 2;
      }
      if (haveStream && !streamIsTTY && forceColor === void 0) {
        return 0;
      }
      const min = forceColor || 0;
      if (env.TERM === "dumb") {
        return min;
      }
      if (process.platform === "win32") {
        const osRelease = os.release().split(".");
        if (Number(osRelease[0]) >= 10 && Number(osRelease[2]) >= 10586) {
          return Number(osRelease[2]) >= 14931 ? 3 : 2;
        }
        return 1;
      }
      if ("CI" in env) {
        if (["TRAVIS", "CIRCLECI", "APPVEYOR", "GITLAB_CI", "GITHUB_ACTIONS", "BUILDKITE"].some((sign) => sign in env) || env.CI_NAME === "codeship") {
          return 1;
        }
        return min;
      }
      if ("TEAMCITY_VERSION" in env) {
        return /^(9\.(0*[1-9]\d*)\.|\d{2,}\.)/.test(env.TEAMCITY_VERSION) ? 1 : 0;
      }
      if (env.COLORTERM === "truecolor") {
        return 3;
      }
      if ("TERM_PROGRAM" in env) {
        const version = parseInt((env.TERM_PROGRAM_VERSION || "").split(".")[0], 10);
        switch (env.TERM_PROGRAM) {
          case "iTerm.app":
            return version >= 3 ? 3 : 2;
          case "Apple_Terminal":
            return 2;
        }
      }
      if (/-256(color)?$/i.test(env.TERM)) {
        return 2;
      }
      if (/^screen|^xterm|^vt100|^vt220|^rxvt|color|ansi|cygwin|linux/i.test(env.TERM)) {
        return 1;
      }
      if ("COLORTERM" in env) {
        return 1;
      }
      return min;
    }
    function getSupportLevel(stream) {
      const level = supportsColor(stream, stream && stream.isTTY);
      return translateLevel(level);
    }
    module2.exports = {
      supportsColor: getSupportLevel,
      stdout: translateLevel(supportsColor(true, tty.isatty(1))),
      stderr: translateLevel(supportsColor(true, tty.isatty(2)))
    };
  }
});

// node_modules/chalk/source/util.js
var require_util = __commonJS({
  "node_modules/chalk/source/util.js"(exports2, module2) {
    "use strict";
    var stringReplaceAll = (string, substring, replacer) => {
      let index = string.indexOf(substring);
      if (index === -1) {
        return string;
      }
      const substringLength = substring.length;
      let endIndex = 0;
      let returnValue = "";
      do {
        returnValue += string.substr(endIndex, index - endIndex) + substring + replacer;
        endIndex = index + substringLength;
        index = string.indexOf(substring, endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    var stringEncaseCRLFWithFirstIndex = (string, prefix, postfix, index) => {
      let endIndex = 0;
      let returnValue = "";
      do {
        const gotCR = string[index - 1] === "\r";
        returnValue += string.substr(endIndex, (gotCR ? index - 1 : index) - endIndex) + prefix + (gotCR ? "\r\n" : "\n") + postfix;
        endIndex = index + 1;
        index = string.indexOf("\n", endIndex);
      } while (index !== -1);
      returnValue += string.substr(endIndex);
      return returnValue;
    };
    module2.exports = {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    };
  }
});

// node_modules/chalk/source/templates.js
var require_templates = __commonJS({
  "node_modules/chalk/source/templates.js"(exports2, module2) {
    "use strict";
    var TEMPLATE_REGEX = /(?:\\(u(?:[a-f\d]{4}|\{[a-f\d]{1,6}\})|x[a-f\d]{2}|.))|(?:\{(~)?(\w+(?:\([^)]*\))?(?:\.\w+(?:\([^)]*\))?)*)(?:[ \t]|(?=\r?\n)))|(\})|((?:.|[\r\n\f])+?)/gi;
    var STYLE_REGEX = /(?:^|\.)(\w+)(?:\(([^)]*)\))?/g;
    var STRING_REGEX = /^(['"])((?:\\.|(?!\1)[^\\])*)\1$/;
    var ESCAPE_REGEX = /\\(u(?:[a-f\d]{4}|{[a-f\d]{1,6}})|x[a-f\d]{2}|.)|([^\\])/gi;
    var ESCAPES = /* @__PURE__ */ new Map([
      ["n", "\n"],
      ["r", "\r"],
      ["t", "	"],
      ["b", "\b"],
      ["f", "\f"],
      ["v", "\v"],
      ["0", "\0"],
      ["\\", "\\"],
      ["e", "\x1B"],
      ["a", "\x07"]
    ]);
    function unescape(c) {
      const u = c[0] === "u";
      const bracket = c[1] === "{";
      if (u && !bracket && c.length === 5 || c[0] === "x" && c.length === 3) {
        return String.fromCharCode(parseInt(c.slice(1), 16));
      }
      if (u && bracket) {
        return String.fromCodePoint(parseInt(c.slice(2, -1), 16));
      }
      return ESCAPES.get(c) || c;
    }
    function parseArguments(name, arguments_) {
      const results = [];
      const chunks = arguments_.trim().split(/\s*,\s*/g);
      let matches;
      for (const chunk of chunks) {
        const number = Number(chunk);
        if (!Number.isNaN(number)) {
          results.push(number);
        } else if (matches = chunk.match(STRING_REGEX)) {
          results.push(matches[2].replace(ESCAPE_REGEX, (m, escape, character) => escape ? unescape(escape) : character));
        } else {
          throw new Error(`Invalid Chalk template style argument: ${chunk} (in style '${name}')`);
        }
      }
      return results;
    }
    function parseStyle(style) {
      STYLE_REGEX.lastIndex = 0;
      const results = [];
      let matches;
      while ((matches = STYLE_REGEX.exec(style)) !== null) {
        const name = matches[1];
        if (matches[2]) {
          const args2 = parseArguments(name, matches[2]);
          results.push([name].concat(args2));
        } else {
          results.push([name]);
        }
      }
      return results;
    }
    function buildStyle(chalk, styles) {
      const enabled = {};
      for (const layer of styles) {
        for (const style of layer.styles) {
          enabled[style[0]] = layer.inverse ? null : style.slice(1);
        }
      }
      let current = chalk;
      for (const [styleName, styles2] of Object.entries(enabled)) {
        if (!Array.isArray(styles2)) {
          continue;
        }
        if (!(styleName in current)) {
          throw new Error(`Unknown Chalk style: ${styleName}`);
        }
        current = styles2.length > 0 ? current[styleName](...styles2) : current[styleName];
      }
      return current;
    }
    module2.exports = (chalk, temporary) => {
      const styles = [];
      const chunks = [];
      let chunk = [];
      temporary.replace(TEMPLATE_REGEX, (m, escapeCharacter, inverse, style, close, character) => {
        if (escapeCharacter) {
          chunk.push(unescape(escapeCharacter));
        } else if (style) {
          const string = chunk.join("");
          chunk = [];
          chunks.push(styles.length === 0 ? string : buildStyle(chalk, styles)(string));
          styles.push({ inverse, styles: parseStyle(style) });
        } else if (close) {
          if (styles.length === 0) {
            throw new Error("Found extraneous } in Chalk template literal");
          }
          chunks.push(buildStyle(chalk, styles)(chunk.join("")));
          chunk = [];
          styles.pop();
        } else {
          chunk.push(character);
        }
      });
      chunks.push(chunk.join(""));
      if (styles.length > 0) {
        const errMessage = `Chalk template literal is missing ${styles.length} closing bracket${styles.length === 1 ? "" : "s"} (\`}\`)`;
        throw new Error(errMessage);
      }
      return chunks.join("");
    };
  }
});

// node_modules/chalk/source/index.js
var require_source = __commonJS({
  "node_modules/chalk/source/index.js"(exports2, module2) {
    "use strict";
    var ansiStyles = require_ansi_styles();
    var { stdout: stdoutColor, stderr: stderrColor } = require_supports_color();
    var {
      stringReplaceAll,
      stringEncaseCRLFWithFirstIndex
    } = require_util();
    var { isArray } = Array;
    var levelMapping = [
      "ansi",
      "ansi",
      "ansi256",
      "ansi16m"
    ];
    var styles = /* @__PURE__ */ Object.create(null);
    var applyOptions = (object, options = {}) => {
      if (options.level && !(Number.isInteger(options.level) && options.level >= 0 && options.level <= 3)) {
        throw new Error("The `level` option should be an integer from 0 to 3");
      }
      const colorLevel = stdoutColor ? stdoutColor.level : 0;
      object.level = options.level === void 0 ? colorLevel : options.level;
    };
    var ChalkClass = class {
      constructor(options) {
        return chalkFactory(options);
      }
    };
    var chalkFactory = (options) => {
      const chalk2 = {};
      applyOptions(chalk2, options);
      chalk2.template = (...arguments_) => chalkTag(chalk2.template, ...arguments_);
      Object.setPrototypeOf(chalk2, Chalk.prototype);
      Object.setPrototypeOf(chalk2.template, chalk2);
      chalk2.template.constructor = () => {
        throw new Error("`chalk.constructor()` is deprecated. Use `new chalk.Instance()` instead.");
      };
      chalk2.template.Instance = ChalkClass;
      return chalk2.template;
    };
    function Chalk(options) {
      return chalkFactory(options);
    }
    for (const [styleName, style] of Object.entries(ansiStyles)) {
      styles[styleName] = {
        get() {
          const builder = createBuilder(this, createStyler(style.open, style.close, this._styler), this._isEmpty);
          Object.defineProperty(this, styleName, { value: builder });
          return builder;
        }
      };
    }
    styles.visible = {
      get() {
        const builder = createBuilder(this, this._styler, true);
        Object.defineProperty(this, "visible", { value: builder });
        return builder;
      }
    };
    var usedModels = ["rgb", "hex", "keyword", "hsl", "hsv", "hwb", "ansi", "ansi256"];
    for (const model of usedModels) {
      styles[model] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.color[levelMapping[level]][model](...arguments_), ansiStyles.color.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    for (const model of usedModels) {
      const bgModel = "bg" + model[0].toUpperCase() + model.slice(1);
      styles[bgModel] = {
        get() {
          const { level } = this;
          return function(...arguments_) {
            const styler = createStyler(ansiStyles.bgColor[levelMapping[level]][model](...arguments_), ansiStyles.bgColor.close, this._styler);
            return createBuilder(this, styler, this._isEmpty);
          };
        }
      };
    }
    var proto = Object.defineProperties(() => {
    }, {
      ...styles,
      level: {
        enumerable: true,
        get() {
          return this._generator.level;
        },
        set(level) {
          this._generator.level = level;
        }
      }
    });
    var createStyler = (open, close, parent) => {
      let openAll;
      let closeAll;
      if (parent === void 0) {
        openAll = open;
        closeAll = close;
      } else {
        openAll = parent.openAll + open;
        closeAll = close + parent.closeAll;
      }
      return {
        open,
        close,
        openAll,
        closeAll,
        parent
      };
    };
    var createBuilder = (self2, _styler, _isEmpty) => {
      const builder = (...arguments_) => {
        if (isArray(arguments_[0]) && isArray(arguments_[0].raw)) {
          return applyStyle(builder, chalkTag(builder, ...arguments_));
        }
        return applyStyle(builder, arguments_.length === 1 ? "" + arguments_[0] : arguments_.join(" "));
      };
      Object.setPrototypeOf(builder, proto);
      builder._generator = self2;
      builder._styler = _styler;
      builder._isEmpty = _isEmpty;
      return builder;
    };
    var applyStyle = (self2, string) => {
      if (self2.level <= 0 || !string) {
        return self2._isEmpty ? "" : string;
      }
      let styler = self2._styler;
      if (styler === void 0) {
        return string;
      }
      const { openAll, closeAll } = styler;
      if (string.indexOf("\x1B") !== -1) {
        while (styler !== void 0) {
          string = stringReplaceAll(string, styler.close, styler.open);
          styler = styler.parent;
        }
      }
      const lfIndex = string.indexOf("\n");
      if (lfIndex !== -1) {
        string = stringEncaseCRLFWithFirstIndex(string, closeAll, openAll, lfIndex);
      }
      return openAll + string + closeAll;
    };
    var template;
    var chalkTag = (chalk2, ...strings) => {
      const [firstString] = strings;
      if (!isArray(firstString) || !isArray(firstString.raw)) {
        return strings.join(" ");
      }
      const arguments_ = strings.slice(1);
      const parts = [firstString.raw[0]];
      for (let i = 1; i < firstString.length; i++) {
        parts.push(String(arguments_[i - 1]).replace(/[{}\\]/g, "\\$&"), String(firstString.raw[i]));
      }
      if (template === void 0) {
        template = require_templates();
      }
      return template(chalk2, parts.join(""));
    };
    Object.defineProperties(Chalk.prototype, styles);
    var chalk = Chalk();
    chalk.supportsColor = stdoutColor;
    chalk.stderr = Chalk({ level: stderrColor ? stderrColor.level : 0 });
    chalk.stderr.supportsColor = stderrColor;
    module2.exports = chalk;
  }
});

// node_modules/dayjs/dayjs.min.js
var require_dayjs_min = __commonJS({
  "node_modules/dayjs/dayjs.min.js"(exports2, module2) {
    !function(t, e) {
      typeof exports2 == "object" && typeof module2 != "undefined" ? module2.exports = e() : typeof define == "function" && define.amd ? define(e) : (t = typeof globalThis != "undefined" ? globalThis : t || self).dayjs = e();
    }(exports2, function() {
      "use strict";
      var t = 1e3, e = 6e4, n = 36e5, r = "millisecond", i = "second", s = "minute", u = "hour", a2 = "day", o = "week", f = "month", h = "quarter", c = "year", d = "date", $ = "Invalid Date", l = /^(\d{4})[-/]?(\d{1,2})?[-/]?(\d{0,2})[Tt\s]*(\d{1,2})?:?(\d{1,2})?:?(\d{1,2})?[.:]?(\d+)?$/, y = /\[([^\]]+)]|Y{1,4}|M{1,4}|D{1,2}|d{1,4}|H{1,2}|h{1,2}|a|A|m{1,2}|s{1,2}|Z{1,2}|SSS/g, M = { name: "en", weekdays: "Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"), months: "January_February_March_April_May_June_July_August_September_October_November_December".split("_") }, m = function(t2, e2, n2) {
        var r2 = String(t2);
        return !r2 || r2.length >= e2 ? t2 : "" + Array(e2 + 1 - r2.length).join(n2) + t2;
      }, g = { s: m, z: function(t2) {
        var e2 = -t2.utcOffset(), n2 = Math.abs(e2), r2 = Math.floor(n2 / 60), i2 = n2 % 60;
        return (e2 <= 0 ? "+" : "-") + m(r2, 2, "0") + ":" + m(i2, 2, "0");
      }, m: function t2(e2, n2) {
        if (e2.date() < n2.date())
          return -t2(n2, e2);
        var r2 = 12 * (n2.year() - e2.year()) + (n2.month() - e2.month()), i2 = e2.clone().add(r2, f), s2 = n2 - i2 < 0, u2 = e2.clone().add(r2 + (s2 ? -1 : 1), f);
        return +(-(r2 + (n2 - i2) / (s2 ? i2 - u2 : u2 - i2)) || 0);
      }, a: function(t2) {
        return t2 < 0 ? Math.ceil(t2) || 0 : Math.floor(t2);
      }, p: function(t2) {
        return { M: f, y: c, w: o, d: a2, D: d, h: u, m: s, s: i, ms: r, Q: h }[t2] || String(t2 || "").toLowerCase().replace(/s$/, "");
      }, u: function(t2) {
        return t2 === void 0;
      } }, D = "en", v = {};
      v[D] = M;
      var p = function(t2) {
        return t2 instanceof _;
      }, S = function(t2, e2, n2) {
        var r2;
        if (!t2)
          return D;
        if (typeof t2 == "string")
          v[t2] && (r2 = t2), e2 && (v[t2] = e2, r2 = t2);
        else {
          var i2 = t2.name;
          v[i2] = t2, r2 = i2;
        }
        return !n2 && r2 && (D = r2), r2 || !n2 && D;
      }, w = function(t2, e2) {
        if (p(t2))
          return t2.clone();
        var n2 = typeof e2 == "object" ? e2 : {};
        return n2.date = t2, n2.args = arguments, new _(n2);
      }, O = g;
      O.l = S, O.i = p, O.w = function(t2, e2) {
        return w(t2, { locale: e2.$L, utc: e2.$u, x: e2.$x, $offset: e2.$offset });
      };
      var _ = function() {
        function M2(t2) {
          this.$L = S(t2.locale, null, true), this.parse(t2);
        }
        var m2 = M2.prototype;
        return m2.parse = function(t2) {
          this.$d = function(t3) {
            var e2 = t3.date, n2 = t3.utc;
            if (e2 === null)
              return new Date(NaN);
            if (O.u(e2))
              return new Date();
            if (e2 instanceof Date)
              return new Date(e2);
            if (typeof e2 == "string" && !/Z$/i.test(e2)) {
              var r2 = e2.match(l);
              if (r2) {
                var i2 = r2[2] - 1 || 0, s2 = (r2[7] || "0").substring(0, 3);
                return n2 ? new Date(Date.UTC(r2[1], i2, r2[3] || 1, r2[4] || 0, r2[5] || 0, r2[6] || 0, s2)) : new Date(r2[1], i2, r2[3] || 1, r2[4] || 0, r2[5] || 0, r2[6] || 0, s2);
              }
            }
            return new Date(e2);
          }(t2), this.$x = t2.x || {}, this.init();
        }, m2.init = function() {
          var t2 = this.$d;
          this.$y = t2.getFullYear(), this.$M = t2.getMonth(), this.$D = t2.getDate(), this.$W = t2.getDay(), this.$H = t2.getHours(), this.$m = t2.getMinutes(), this.$s = t2.getSeconds(), this.$ms = t2.getMilliseconds();
        }, m2.$utils = function() {
          return O;
        }, m2.isValid = function() {
          return !(this.$d.toString() === $);
        }, m2.isSame = function(t2, e2) {
          var n2 = w(t2);
          return this.startOf(e2) <= n2 && n2 <= this.endOf(e2);
        }, m2.isAfter = function(t2, e2) {
          return w(t2) < this.startOf(e2);
        }, m2.isBefore = function(t2, e2) {
          return this.endOf(e2) < w(t2);
        }, m2.$g = function(t2, e2, n2) {
          return O.u(t2) ? this[e2] : this.set(n2, t2);
        }, m2.unix = function() {
          return Math.floor(this.valueOf() / 1e3);
        }, m2.valueOf = function() {
          return this.$d.getTime();
        }, m2.startOf = function(t2, e2) {
          var n2 = this, r2 = !!O.u(e2) || e2, h2 = O.p(t2), $2 = function(t3, e3) {
            var i2 = O.w(n2.$u ? Date.UTC(n2.$y, e3, t3) : new Date(n2.$y, e3, t3), n2);
            return r2 ? i2 : i2.endOf(a2);
          }, l2 = function(t3, e3) {
            return O.w(n2.toDate()[t3].apply(n2.toDate("s"), (r2 ? [0, 0, 0, 0] : [23, 59, 59, 999]).slice(e3)), n2);
          }, y2 = this.$W, M3 = this.$M, m3 = this.$D, g2 = "set" + (this.$u ? "UTC" : "");
          switch (h2) {
            case c:
              return r2 ? $2(1, 0) : $2(31, 11);
            case f:
              return r2 ? $2(1, M3) : $2(0, M3 + 1);
            case o:
              var D2 = this.$locale().weekStart || 0, v2 = (y2 < D2 ? y2 + 7 : y2) - D2;
              return $2(r2 ? m3 - v2 : m3 + (6 - v2), M3);
            case a2:
            case d:
              return l2(g2 + "Hours", 0);
            case u:
              return l2(g2 + "Minutes", 1);
            case s:
              return l2(g2 + "Seconds", 2);
            case i:
              return l2(g2 + "Milliseconds", 3);
            default:
              return this.clone();
          }
        }, m2.endOf = function(t2) {
          return this.startOf(t2, false);
        }, m2.$set = function(t2, e2) {
          var n2, o2 = O.p(t2), h2 = "set" + (this.$u ? "UTC" : ""), $2 = (n2 = {}, n2[a2] = h2 + "Date", n2[d] = h2 + "Date", n2[f] = h2 + "Month", n2[c] = h2 + "FullYear", n2[u] = h2 + "Hours", n2[s] = h2 + "Minutes", n2[i] = h2 + "Seconds", n2[r] = h2 + "Milliseconds", n2)[o2], l2 = o2 === a2 ? this.$D + (e2 - this.$W) : e2;
          if (o2 === f || o2 === c) {
            var y2 = this.clone().set(d, 1);
            y2.$d[$2](l2), y2.init(), this.$d = y2.set(d, Math.min(this.$D, y2.daysInMonth())).$d;
          } else
            $2 && this.$d[$2](l2);
          return this.init(), this;
        }, m2.set = function(t2, e2) {
          return this.clone().$set(t2, e2);
        }, m2.get = function(t2) {
          return this[O.p(t2)]();
        }, m2.add = function(r2, h2) {
          var d2, $2 = this;
          r2 = Number(r2);
          var l2 = O.p(h2), y2 = function(t2) {
            var e2 = w($2);
            return O.w(e2.date(e2.date() + Math.round(t2 * r2)), $2);
          };
          if (l2 === f)
            return this.set(f, this.$M + r2);
          if (l2 === c)
            return this.set(c, this.$y + r2);
          if (l2 === a2)
            return y2(1);
          if (l2 === o)
            return y2(7);
          var M3 = (d2 = {}, d2[s] = e, d2[u] = n, d2[i] = t, d2)[l2] || 1, m3 = this.$d.getTime() + r2 * M3;
          return O.w(m3, this);
        }, m2.subtract = function(t2, e2) {
          return this.add(-1 * t2, e2);
        }, m2.format = function(t2) {
          var e2 = this, n2 = this.$locale();
          if (!this.isValid())
            return n2.invalidDate || $;
          var r2 = t2 || "YYYY-MM-DDTHH:mm:ssZ", i2 = O.z(this), s2 = this.$H, u2 = this.$m, a3 = this.$M, o2 = n2.weekdays, f2 = n2.months, h2 = function(t3, n3, i3, s3) {
            return t3 && (t3[n3] || t3(e2, r2)) || i3[n3].substr(0, s3);
          }, c2 = function(t3) {
            return O.s(s2 % 12 || 12, t3, "0");
          }, d2 = n2.meridiem || function(t3, e3, n3) {
            var r3 = t3 < 12 ? "AM" : "PM";
            return n3 ? r3.toLowerCase() : r3;
          }, l2 = { YY: String(this.$y).slice(-2), YYYY: this.$y, M: a3 + 1, MM: O.s(a3 + 1, 2, "0"), MMM: h2(n2.monthsShort, a3, f2, 3), MMMM: h2(f2, a3), D: this.$D, DD: O.s(this.$D, 2, "0"), d: String(this.$W), dd: h2(n2.weekdaysMin, this.$W, o2, 2), ddd: h2(n2.weekdaysShort, this.$W, o2, 3), dddd: o2[this.$W], H: String(s2), HH: O.s(s2, 2, "0"), h: c2(1), hh: c2(2), a: d2(s2, u2, true), A: d2(s2, u2, false), m: String(u2), mm: O.s(u2, 2, "0"), s: String(this.$s), ss: O.s(this.$s, 2, "0"), SSS: O.s(this.$ms, 3, "0"), Z: i2 };
          return r2.replace(y, function(t3, e3) {
            return e3 || l2[t3] || i2.replace(":", "");
          });
        }, m2.utcOffset = function() {
          return 15 * -Math.round(this.$d.getTimezoneOffset() / 15);
        }, m2.diff = function(r2, d2, $2) {
          var l2, y2 = O.p(d2), M3 = w(r2), m3 = (M3.utcOffset() - this.utcOffset()) * e, g2 = this - M3, D2 = O.m(this, M3);
          return D2 = (l2 = {}, l2[c] = D2 / 12, l2[f] = D2, l2[h] = D2 / 3, l2[o] = (g2 - m3) / 6048e5, l2[a2] = (g2 - m3) / 864e5, l2[u] = g2 / n, l2[s] = g2 / e, l2[i] = g2 / t, l2)[y2] || g2, $2 ? D2 : O.a(D2);
        }, m2.daysInMonth = function() {
          return this.endOf(f).$D;
        }, m2.$locale = function() {
          return v[this.$L];
        }, m2.locale = function(t2, e2) {
          if (!t2)
            return this.$L;
          var n2 = this.clone(), r2 = S(t2, e2, true);
          return r2 && (n2.$L = r2), n2;
        }, m2.clone = function() {
          return O.w(this.$d, this);
        }, m2.toDate = function() {
          return new Date(this.valueOf());
        }, m2.toJSON = function() {
          return this.isValid() ? this.toISOString() : null;
        }, m2.toISOString = function() {
          return this.$d.toISOString();
        }, m2.toString = function() {
          return this.$d.toUTCString();
        }, M2;
      }(), b = _.prototype;
      return w.prototype = b, [["$ms", r], ["$s", i], ["$m", s], ["$H", u], ["$W", a2], ["$M", f], ["$y", c], ["$D", d]].forEach(function(t2) {
        b[t2[1]] = function(e2) {
          return this.$g(e2, t2[0], t2[1]);
        };
      }), w.extend = function(t2, e2) {
        return t2.$i || (t2(e2, _, w), t2.$i = true), w;
      }, w.locale = S, w.isDayjs = p, w.unix = function(t2) {
        return w(1e3 * t2);
      }, w.en = v[D], w.Ls = v, w.p = {}, w;
    });
  }
});

// node_modules/debug/node_modules/ms/index.js
var require_ms = __commonJS({
  "node_modules/debug/node_modules/ms/index.js"(exports2, module2) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var y = d * 365.25;
    module2.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse2(val);
      } else if (type === "number" && isNaN(val) === false) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse2(str2) {
      str2 = String(str2);
      if (str2.length > 100) {
        return;
      }
      var match = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(str2);
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      if (ms >= d) {
        return Math.round(ms / d) + "d";
      }
      if (ms >= h) {
        return Math.round(ms / h) + "h";
      }
      if (ms >= m) {
        return Math.round(ms / m) + "m";
      }
      if (ms >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      return plural(ms, d, "day") || plural(ms, h, "hour") || plural(ms, m, "minute") || plural(ms, s, "second") || ms + " ms";
    }
    function plural(ms, n, name) {
      if (ms < n) {
        return;
      }
      if (ms < n * 1.5) {
        return Math.floor(ms / n) + " " + name;
      }
      return Math.ceil(ms / n) + " " + name + "s";
    }
  }
});

// node_modules/debug/src/debug.js
var require_debug = __commonJS({
  "node_modules/debug/src/debug.js"(exports2, module2) {
    exports2 = module2.exports = createDebug.debug = createDebug["default"] = createDebug;
    exports2.coerce = coerce;
    exports2.disable = disable;
    exports2.enable = enable;
    exports2.enabled = enabled;
    exports2.humanize = require_ms();
    exports2.names = [];
    exports2.skips = [];
    exports2.formatters = {};
    var prevTime;
    function selectColor(namespace) {
      var hash = 0, i;
      for (i in namespace) {
        hash = (hash << 5) - hash + namespace.charCodeAt(i);
        hash |= 0;
      }
      return exports2.colors[Math.abs(hash) % exports2.colors.length];
    }
    function createDebug(namespace) {
      function debug() {
        if (!debug.enabled)
          return;
        var self2 = debug;
        var curr = +new Date();
        var ms = curr - (prevTime || curr);
        self2.diff = ms;
        self2.prev = prevTime;
        self2.curr = curr;
        prevTime = curr;
        var args2 = new Array(arguments.length);
        for (var i = 0; i < args2.length; i++) {
          args2[i] = arguments[i];
        }
        args2[0] = exports2.coerce(args2[0]);
        if (typeof args2[0] !== "string") {
          args2.unshift("%O");
        }
        var index = 0;
        args2[0] = args2[0].replace(/%([a-zA-Z%])/g, function(match, format) {
          if (match === "%%")
            return match;
          index++;
          var formatter = exports2.formatters[format];
          if (typeof formatter === "function") {
            var val = args2[index];
            match = formatter.call(self2, val);
            args2.splice(index, 1);
            index--;
          }
          return match;
        });
        exports2.formatArgs.call(self2, args2);
        var logFn = debug.log || exports2.log || console.log.bind(console);
        logFn.apply(self2, args2);
      }
      debug.namespace = namespace;
      debug.enabled = exports2.enabled(namespace);
      debug.useColors = exports2.useColors();
      debug.color = selectColor(namespace);
      if (typeof exports2.init === "function") {
        exports2.init(debug);
      }
      return debug;
    }
    function enable(namespaces) {
      exports2.save(namespaces);
      exports2.names = [];
      exports2.skips = [];
      var split2 = (typeof namespaces === "string" ? namespaces : "").split(/[\s,]+/);
      var len = split2.length;
      for (var i = 0; i < len; i++) {
        if (!split2[i])
          continue;
        namespaces = split2[i].replace(/\*/g, ".*?");
        if (namespaces[0] === "-") {
          exports2.skips.push(new RegExp("^" + namespaces.substr(1) + "$"));
        } else {
          exports2.names.push(new RegExp("^" + namespaces + "$"));
        }
      }
    }
    function disable() {
      exports2.enable("");
    }
    function enabled(name) {
      var i, len;
      for (i = 0, len = exports2.skips.length; i < len; i++) {
        if (exports2.skips[i].test(name)) {
          return false;
        }
      }
      for (i = 0, len = exports2.names.length; i < len; i++) {
        if (exports2.names[i].test(name)) {
          return true;
        }
      }
      return false;
    }
    function coerce(val) {
      if (val instanceof Error)
        return val.stack || val.message;
      return val;
    }
  }
});

// node_modules/debug/src/browser.js
var require_browser = __commonJS({
  "node_modules/debug/src/browser.js"(exports2, module2) {
    exports2 = module2.exports = require_debug();
    exports2.log = log2;
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.storage = typeof chrome != "undefined" && typeof chrome.storage != "undefined" ? chrome.storage.local : localstorage();
    exports2.colors = [
      "lightseagreen",
      "forestgreen",
      "goldenrod",
      "dodgerblue",
      "darkorchid",
      "crimson"
    ];
    function useColors() {
      if (typeof window !== "undefined" && window.process && window.process.type === "renderer") {
        return true;
      }
      return typeof document !== "undefined" && document.documentElement && document.documentElement.style && document.documentElement.style.WebkitAppearance || typeof window !== "undefined" && window.console && (window.console.firebug || window.console.exception && window.console.table) || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || typeof navigator !== "undefined" && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/);
    }
    exports2.formatters.j = function(v) {
      try {
        return JSON.stringify(v);
      } catch (err) {
        return "[UnexpectedJSONParseError]: " + err.message;
      }
    };
    function formatArgs(args2) {
      var useColors2 = this.useColors;
      args2[0] = (useColors2 ? "%c" : "") + this.namespace + (useColors2 ? " %c" : " ") + args2[0] + (useColors2 ? "%c " : " ") + "+" + exports2.humanize(this.diff);
      if (!useColors2)
        return;
      var c = "color: " + this.color;
      args2.splice(1, 0, c, "color: inherit");
      var index = 0;
      var lastC = 0;
      args2[0].replace(/%[a-zA-Z%]/g, function(match) {
        if (match === "%%")
          return;
        index++;
        if (match === "%c") {
          lastC = index;
        }
      });
      args2.splice(lastC, 0, c);
    }
    function log2() {
      return typeof console === "object" && console.log && Function.prototype.apply.call(console.log, console, arguments);
    }
    function save(namespaces) {
      try {
        if (namespaces == null) {
          exports2.storage.removeItem("debug");
        } else {
          exports2.storage.debug = namespaces;
        }
      } catch (e) {
      }
    }
    function load() {
      var r;
      try {
        r = exports2.storage.debug;
      } catch (e) {
      }
      if (!r && typeof process !== "undefined" && "env" in process) {
        r = process.env.DEBUG;
      }
      return r;
    }
    exports2.enable(load());
    function localstorage() {
      try {
        return window.localStorage;
      } catch (e) {
      }
    }
  }
});

// node_modules/debug/src/node.js
var require_node = __commonJS({
  "node_modules/debug/src/node.js"(exports2, module2) {
    var tty = require("tty");
    var util = require("util");
    exports2 = module2.exports = require_debug();
    exports2.init = init;
    exports2.log = log2;
    exports2.formatArgs = formatArgs;
    exports2.save = save;
    exports2.load = load;
    exports2.useColors = useColors;
    exports2.colors = [6, 2, 3, 4, 5, 1];
    exports2.inspectOpts = Object.keys(process.env).filter(function(key) {
      return /^debug_/i.test(key);
    }).reduce(function(obj, key) {
      var prop = key.substring(6).toLowerCase().replace(/_([a-z])/g, function(_, k) {
        return k.toUpperCase();
      });
      var val = process.env[key];
      if (/^(yes|on|true|enabled)$/i.test(val))
        val = true;
      else if (/^(no|off|false|disabled)$/i.test(val))
        val = false;
      else if (val === "null")
        val = null;
      else
        val = Number(val);
      obj[prop] = val;
      return obj;
    }, {});
    var fd = parseInt(process.env.DEBUG_FD, 10) || 2;
    if (fd !== 1 && fd !== 2) {
      util.deprecate(function() {
      }, "except for stderr(2) and stdout(1), any other usage of DEBUG_FD is deprecated. Override debug.log if you want to use a different log function (https://git.io/debug_fd)")();
    }
    var stream = fd === 1 ? process.stdout : fd === 2 ? process.stderr : createWritableStdioStream(fd);
    function useColors() {
      return "colors" in exports2.inspectOpts ? Boolean(exports2.inspectOpts.colors) : tty.isatty(fd);
    }
    exports2.formatters.o = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts).split("\n").map(function(str2) {
        return str2.trim();
      }).join(" ");
    };
    exports2.formatters.O = function(v) {
      this.inspectOpts.colors = this.useColors;
      return util.inspect(v, this.inspectOpts);
    };
    function formatArgs(args2) {
      var name = this.namespace;
      var useColors2 = this.useColors;
      if (useColors2) {
        var c = this.color;
        var prefix = "  \x1B[3" + c + ";1m" + name + " \x1B[0m";
        args2[0] = prefix + args2[0].split("\n").join("\n" + prefix);
        args2.push("\x1B[3" + c + "m+" + exports2.humanize(this.diff) + "\x1B[0m");
      } else {
        args2[0] = new Date().toUTCString() + " " + name + " " + args2[0];
      }
    }
    function log2() {
      return stream.write(util.format.apply(util, arguments) + "\n");
    }
    function save(namespaces) {
      if (namespaces == null) {
        delete process.env.DEBUG;
      } else {
        process.env.DEBUG = namespaces;
      }
    }
    function load() {
      return process.env.DEBUG;
    }
    function createWritableStdioStream(fd2) {
      var stream2;
      var tty_wrap = process.binding("tty_wrap");
      switch (tty_wrap.guessHandleType(fd2)) {
        case "TTY":
          stream2 = new tty.WriteStream(fd2);
          stream2._type = "tty";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        case "FILE":
          var fs = require("fs");
          stream2 = new fs.SyncWriteStream(fd2, { autoClose: false });
          stream2._type = "fs";
          break;
        case "PIPE":
        case "TCP":
          var net = require("net");
          stream2 = new net.Socket({
            fd: fd2,
            readable: false,
            writable: true
          });
          stream2.readable = false;
          stream2.read = null;
          stream2._type = "pipe";
          if (stream2._handle && stream2._handle.unref) {
            stream2._handle.unref();
          }
          break;
        default:
          throw new Error("Implement me. Unknown stream file type!");
      }
      stream2.fd = fd2;
      stream2._isStdio = true;
      return stream2;
    }
    function init(debug) {
      debug.inspectOpts = {};
      var keys2 = Object.keys(exports2.inspectOpts);
      for (var i = 0; i < keys2.length; i++) {
        debug.inspectOpts[keys2[i]] = exports2.inspectOpts[keys2[i]];
      }
    }
    exports2.enable(load());
  }
});

// node_modules/debug/src/index.js
var require_src = __commonJS({
  "node_modules/debug/src/index.js"(exports2, module2) {
    if (typeof process !== "undefined" && process.type === "renderer") {
      module2.exports = require_browser();
    } else {
      module2.exports = require_node();
    }
  }
});

// node_modules/encodeurl/index.js
var require_encodeurl = __commonJS({
  "node_modules/encodeurl/index.js"(exports2, module2) {
    "use strict";
    module2.exports = encodeUrl;
    var ENCODE_CHARS_REGEXP = /(?:[^\x21\x25\x26-\x3B\x3D\x3F-\x5B\x5D\x5F\x61-\x7A\x7E]|%(?:[^0-9A-Fa-f]|[0-9A-Fa-f][^0-9A-Fa-f]|$))+/g;
    var UNMATCHED_SURROGATE_PAIR_REGEXP = /(^|[^\uD800-\uDBFF])[\uDC00-\uDFFF]|[\uD800-\uDBFF]([^\uDC00-\uDFFF]|$)/g;
    var UNMATCHED_SURROGATE_PAIR_REPLACE = "$1\uFFFD$2";
    function encodeUrl(url) {
      return String(url).replace(UNMATCHED_SURROGATE_PAIR_REGEXP, UNMATCHED_SURROGATE_PAIR_REPLACE).replace(ENCODE_CHARS_REGEXP, encodeURI);
    }
  }
});

// node_modules/escape-html/index.js
var require_escape_html = __commonJS({
  "node_modules/escape-html/index.js"(exports2, module2) {
    "use strict";
    var matchHtmlRegExp = /["'&<>]/;
    module2.exports = escapeHtml;
    function escapeHtml(string) {
      var str2 = "" + string;
      var match = matchHtmlRegExp.exec(str2);
      if (!match) {
        return str2;
      }
      var escape;
      var html2 = "";
      var index = 0;
      var lastIndex = 0;
      for (index = match.index; index < str2.length; index++) {
        switch (str2.charCodeAt(index)) {
          case 34:
            escape = "&quot;";
            break;
          case 38:
            escape = "&amp;";
            break;
          case 39:
            escape = "&#39;";
            break;
          case 60:
            escape = "&lt;";
            break;
          case 62:
            escape = "&gt;";
            break;
          default:
            continue;
        }
        if (lastIndex !== index) {
          html2 += str2.substring(lastIndex, index);
        }
        lastIndex = index + 1;
        html2 += escape;
      }
      return lastIndex !== index ? html2 + str2.substring(lastIndex, index) : html2;
    }
  }
});

// node_modules/ee-first/index.js
var require_ee_first = __commonJS({
  "node_modules/ee-first/index.js"(exports2, module2) {
    "use strict";
    module2.exports = first3;
    function first3(stuff, done) {
      if (!Array.isArray(stuff))
        throw new TypeError("arg must be an array of [ee, events...] arrays");
      var cleanups = [];
      for (var i = 0; i < stuff.length; i++) {
        var arr = stuff[i];
        if (!Array.isArray(arr) || arr.length < 2)
          throw new TypeError("each array member must be [ee, events...]");
        var ee = arr[0];
        for (var j = 1; j < arr.length; j++) {
          var event = arr[j];
          var fn3 = listener(event, callback);
          ee.on(event, fn3);
          cleanups.push({
            ee,
            event,
            fn: fn3
          });
        }
      }
      function callback() {
        cleanup();
        done.apply(null, arguments);
      }
      function cleanup() {
        var x;
        for (var i2 = 0; i2 < cleanups.length; i2++) {
          x = cleanups[i2];
          x.ee.removeListener(x.event, x.fn);
        }
      }
      function thunk(fn4) {
        done = fn4;
      }
      thunk.cancel = cleanup;
      return thunk;
    }
    function listener(event, done) {
      return function onevent(arg1) {
        var args2 = new Array(arguments.length);
        var ee = this;
        var err = event === "error" ? arg1 : null;
        for (var i = 0; i < args2.length; i++) {
          args2[i] = arguments[i];
        }
        done(err, ee, event, args2);
      };
    }
  }
});

// node_modules/on-finished/index.js
var require_on_finished = __commonJS({
  "node_modules/on-finished/index.js"(exports2, module2) {
    "use strict";
    module2.exports = onFinished;
    module2.exports.isFinished = isFinished;
    var first3 = require_ee_first();
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn3) {
      process.nextTick(fn3.bind.apply(fn3, arguments));
    };
    function onFinished(msg, listener) {
      if (isFinished(msg) !== false) {
        defer(listener, null, msg);
        return msg;
      }
      attachListener(msg, listener);
      return msg;
    }
    function isFinished(msg) {
      var socket = msg.socket;
      if (typeof msg.finished === "boolean") {
        return Boolean(msg.finished || socket && !socket.writable);
      }
      if (typeof msg.complete === "boolean") {
        return Boolean(msg.upgrade || !socket || !socket.readable || msg.complete && !msg.readable);
      }
      return void 0;
    }
    function attachFinishedListener(msg, callback) {
      var eeMsg;
      var eeSocket;
      var finished = false;
      function onFinish(error) {
        eeMsg.cancel();
        eeSocket.cancel();
        finished = true;
        callback(error);
      }
      eeMsg = eeSocket = first3([[msg, "end", "finish"]], onFinish);
      function onSocket(socket) {
        msg.removeListener("socket", onSocket);
        if (finished)
          return;
        if (eeMsg !== eeSocket)
          return;
        eeSocket = first3([[socket, "error", "close"]], onFinish);
      }
      if (msg.socket) {
        onSocket(msg.socket);
        return;
      }
      msg.on("socket", onSocket);
      if (msg.socket === void 0) {
        patchAssignSocket(msg, onSocket);
      }
    }
    function attachListener(msg, listener) {
      var attached = msg.__onFinished;
      if (!attached || !attached.queue) {
        attached = msg.__onFinished = createListener(msg);
        attachFinishedListener(msg, attached);
      }
      attached.queue.push(listener);
    }
    function createListener(msg) {
      function listener(err) {
        if (msg.__onFinished === listener)
          msg.__onFinished = null;
        if (!listener.queue)
          return;
        var queue = listener.queue;
        listener.queue = null;
        for (var i = 0; i < queue.length; i++) {
          queue[i](err, msg);
        }
      }
      listener.queue = [];
      return listener;
    }
    function patchAssignSocket(res, callback) {
      var assignSocket = res.assignSocket;
      if (typeof assignSocket !== "function")
        return;
      res.assignSocket = function _assignSocket(socket) {
        assignSocket.call(this, socket);
        callback(socket);
      };
    }
  }
});

// node_modules/parseurl/index.js
var require_parseurl = __commonJS({
  "node_modules/parseurl/index.js"(exports2, module2) {
    "use strict";
    var url = require("url");
    var parse2 = url.parse;
    var Url = url.Url;
    module2.exports = parseurl;
    module2.exports.original = originalurl;
    function parseurl(req) {
      var url2 = req.url;
      if (url2 === void 0) {
        return void 0;
      }
      var parsed = req._parsedUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedUrl = parsed;
    }
    function originalurl(req) {
      var url2 = req.originalUrl;
      if (typeof url2 !== "string") {
        return parseurl(req);
      }
      var parsed = req._parsedOriginalUrl;
      if (fresh(url2, parsed)) {
        return parsed;
      }
      parsed = fastparse(url2);
      parsed._raw = url2;
      return req._parsedOriginalUrl = parsed;
    }
    function fastparse(str2) {
      if (typeof str2 !== "string" || str2.charCodeAt(0) !== 47) {
        return parse2(str2);
      }
      var pathname = str2;
      var query = null;
      var search = null;
      for (var i = 1; i < str2.length; i++) {
        switch (str2.charCodeAt(i)) {
          case 63:
            if (search === null) {
              pathname = str2.substring(0, i);
              query = str2.substring(i + 1);
              search = str2.substring(i);
            }
            break;
          case 9:
          case 10:
          case 12:
          case 13:
          case 32:
          case 35:
          case 160:
          case 65279:
            return parse2(str2);
        }
      }
      var url2 = Url !== void 0 ? new Url() : {};
      url2.path = str2;
      url2.href = str2;
      url2.pathname = pathname;
      if (search !== null) {
        url2.query = query;
        url2.search = search;
      }
      return url2;
    }
    function fresh(url2, parsedUrl) {
      return typeof parsedUrl === "object" && parsedUrl !== null && (Url === void 0 || parsedUrl instanceof Url) && parsedUrl._raw === url2;
    }
  }
});

// node_modules/statuses/codes.json
var require_codes = __commonJS({
  "node_modules/statuses/codes.json"(exports2, module2) {
    module2.exports = {
      "100": "Continue",
      "101": "Switching Protocols",
      "102": "Processing",
      "103": "Early Hints",
      "200": "OK",
      "201": "Created",
      "202": "Accepted",
      "203": "Non-Authoritative Information",
      "204": "No Content",
      "205": "Reset Content",
      "206": "Partial Content",
      "207": "Multi-Status",
      "208": "Already Reported",
      "226": "IM Used",
      "300": "Multiple Choices",
      "301": "Moved Permanently",
      "302": "Found",
      "303": "See Other",
      "304": "Not Modified",
      "305": "Use Proxy",
      "306": "(Unused)",
      "307": "Temporary Redirect",
      "308": "Permanent Redirect",
      "400": "Bad Request",
      "401": "Unauthorized",
      "402": "Payment Required",
      "403": "Forbidden",
      "404": "Not Found",
      "405": "Method Not Allowed",
      "406": "Not Acceptable",
      "407": "Proxy Authentication Required",
      "408": "Request Timeout",
      "409": "Conflict",
      "410": "Gone",
      "411": "Length Required",
      "412": "Precondition Failed",
      "413": "Payload Too Large",
      "414": "URI Too Long",
      "415": "Unsupported Media Type",
      "416": "Range Not Satisfiable",
      "417": "Expectation Failed",
      "418": "I'm a teapot",
      "421": "Misdirected Request",
      "422": "Unprocessable Entity",
      "423": "Locked",
      "424": "Failed Dependency",
      "425": "Unordered Collection",
      "426": "Upgrade Required",
      "428": "Precondition Required",
      "429": "Too Many Requests",
      "431": "Request Header Fields Too Large",
      "451": "Unavailable For Legal Reasons",
      "500": "Internal Server Error",
      "501": "Not Implemented",
      "502": "Bad Gateway",
      "503": "Service Unavailable",
      "504": "Gateway Timeout",
      "505": "HTTP Version Not Supported",
      "506": "Variant Also Negotiates",
      "507": "Insufficient Storage",
      "508": "Loop Detected",
      "509": "Bandwidth Limit Exceeded",
      "510": "Not Extended",
      "511": "Network Authentication Required"
    };
  }
});

// node_modules/statuses/index.js
var require_statuses = __commonJS({
  "node_modules/statuses/index.js"(exports2, module2) {
    "use strict";
    var codes = require_codes();
    module2.exports = status;
    status.STATUS_CODES = codes;
    status.codes = populateStatusesMap(status, codes);
    status.redirect = {
      300: true,
      301: true,
      302: true,
      303: true,
      305: true,
      307: true,
      308: true
    };
    status.empty = {
      204: true,
      205: true,
      304: true
    };
    status.retry = {
      502: true,
      503: true,
      504: true
    };
    function populateStatusesMap(statuses, codes2) {
      var arr = [];
      Object.keys(codes2).forEach(function forEachCode(code) {
        var message2 = codes2[code];
        var status2 = Number(code);
        statuses[status2] = message2;
        statuses[message2] = status2;
        statuses[message2.toLowerCase()] = status2;
        arr.push(status2);
      });
      return arr;
    }
    function status(code) {
      if (typeof code === "number") {
        if (!status[code])
          throw new Error("invalid status code: " + code);
        return code;
      }
      if (typeof code !== "string") {
        throw new TypeError("code must be a number or string");
      }
      var n = parseInt(code, 10);
      if (!isNaN(n)) {
        if (!status[n])
          throw new Error("invalid status code: " + n);
        return n;
      }
      n = status[code.toLowerCase()];
      if (!n)
        throw new Error('invalid status message: "' + code + '"');
      return n;
    }
  }
});

// node_modules/unpipe/index.js
var require_unpipe = __commonJS({
  "node_modules/unpipe/index.js"(exports2, module2) {
    "use strict";
    module2.exports = unpipe;
    function hasPipeDataListeners(stream) {
      var listeners = stream.listeners("data");
      for (var i = 0; i < listeners.length; i++) {
        if (listeners[i].name === "ondata") {
          return true;
        }
      }
      return false;
    }
    function unpipe(stream) {
      if (!stream) {
        throw new TypeError("argument stream is required");
      }
      if (typeof stream.unpipe === "function") {
        stream.unpipe();
        return;
      }
      if (!hasPipeDataListeners(stream)) {
        return;
      }
      var listener;
      var listeners = stream.listeners("close");
      for (var i = 0; i < listeners.length; i++) {
        listener = listeners[i];
        if (listener.name !== "cleanup" && listener.name !== "onclose") {
          continue;
        }
        listener.call(stream);
      }
    }
  }
});

// node_modules/finalhandler/index.js
var require_finalhandler = __commonJS({
  "node_modules/finalhandler/index.js"(exports2, module2) {
    "use strict";
    var debug = require_src()("finalhandler");
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var onFinished = require_on_finished();
    var parseUrl = require_parseurl();
    var statuses = require_statuses();
    var unpipe = require_unpipe();
    var DOUBLE_SPACE_REGEXP = /\x20{2}/g;
    var NEWLINE_REGEXP = /\n/g;
    var defer = typeof setImmediate === "function" ? setImmediate : function(fn3) {
      process.nextTick(fn3.bind.apply(fn3, arguments));
    };
    var isFinished = onFinished.isFinished;
    function createHtmlDocument(message2) {
      var body2 = escapeHtml(message2).replace(NEWLINE_REGEXP, "<br>").replace(DOUBLE_SPACE_REGEXP, " &nbsp;");
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>Error</title>\n</head>\n<body>\n<pre>' + body2 + "</pre>\n</body>\n</html>\n";
    }
    module2.exports = finalhandler2;
    function finalhandler2(req, res, options) {
      var opts = options || {};
      var env = opts.env || process.env.NODE_ENV || "development";
      var onerror = opts.onerror;
      return function(err) {
        var headers;
        var msg;
        var status;
        if (!err && headersSent(res)) {
          debug("cannot 404 after headers sent");
          return;
        }
        if (err) {
          status = getErrorStatusCode(err);
          if (status === void 0) {
            status = getResponseStatusCode(res);
          } else {
            headers = getErrorHeaders(err);
          }
          msg = getErrorMessage(err, status, env);
        } else {
          status = 404;
          msg = "Cannot " + req.method + " " + encodeUrl(getResourceName(req));
        }
        debug("default %s", status);
        if (err && onerror) {
          defer(onerror, err, req, res);
        }
        if (headersSent(res)) {
          debug("cannot %d after headers sent", status);
          req.socket.destroy();
          return;
        }
        send(req, res, status, headers, msg);
      };
    }
    function getErrorHeaders(err) {
      if (!err.headers || typeof err.headers !== "object") {
        return void 0;
      }
      var headers = /* @__PURE__ */ Object.create(null);
      var keys2 = Object.keys(err.headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        headers[key] = err.headers[key];
      }
      return headers;
    }
    function getErrorMessage(err, status, env) {
      var msg;
      if (env !== "production") {
        msg = err.stack;
        if (!msg && typeof err.toString === "function") {
          msg = err.toString();
        }
      }
      return msg || statuses[status];
    }
    function getErrorStatusCode(err) {
      if (typeof err.status === "number" && err.status >= 400 && err.status < 600) {
        return err.status;
      }
      if (typeof err.statusCode === "number" && err.statusCode >= 400 && err.statusCode < 600) {
        return err.statusCode;
      }
      return void 0;
    }
    function getResourceName(req) {
      try {
        return parseUrl.original(req).pathname;
      } catch (e) {
        return "resource";
      }
    }
    function getResponseStatusCode(res) {
      var status = res.statusCode;
      if (typeof status !== "number" || status < 400 || status > 599) {
        status = 500;
      }
      return status;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function send(req, res, status, headers, message2) {
      function write() {
        var body2 = createHtmlDocument(message2);
        res.statusCode = status;
        res.statusMessage = statuses[status];
        setHeaders(res, headers);
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Content-Type", "text/html; charset=utf-8");
        res.setHeader("Content-Length", Buffer.byteLength(body2, "utf8"));
        if (req.method === "HEAD") {
          res.end();
          return;
        }
        res.end(body2, "utf8");
      }
      if (isFinished(req)) {
        write();
        return;
      }
      unpipe(req);
      onFinished(req, write);
      req.resume();
    }
    function setHeaders(res, headers) {
      if (!headers) {
        return;
      }
      var keys2 = Object.keys(headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// node_modules/formidable/lib/file.js
var require_file = __commonJS({
  "node_modules/formidable/lib/file.js"(exports2, module2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var util = require("util");
    var fs = require("fs");
    var EventEmitter = require("events").EventEmitter;
    var crypto = require("crypto");
    function File(properties) {
      EventEmitter.call(this);
      this.size = 0;
      this.path = null;
      this.name = null;
      this.type = null;
      this.hash = null;
      this.lastModifiedDate = null;
      this._writeStream = null;
      for (var key in properties) {
        this[key] = properties[key];
      }
      if (typeof this.hash === "string") {
        this.hash = crypto.createHash(properties.hash);
      } else {
        this.hash = null;
      }
    }
    module2.exports = File;
    util.inherits(File, EventEmitter);
    File.prototype.open = function() {
      this._writeStream = new fs.WriteStream(this.path);
    };
    File.prototype.toJSON = function() {
      var json = {
        size: this.size,
        path: this.path,
        name: this.name,
        type: this.type,
        mtime: this.lastModifiedDate,
        length: this.length,
        filename: this.filename,
        mime: this.mime
      };
      if (this.hash && this.hash != "") {
        json.hash = this.hash;
      }
      return json;
    };
    File.prototype.write = function(buffer, cb) {
      var self2 = this;
      if (self2.hash) {
        self2.hash.update(buffer);
      }
      if (this._writeStream.closed) {
        return cb();
      }
      this._writeStream.write(buffer, function() {
        self2.lastModifiedDate = new Date();
        self2.size += buffer.length;
        self2.emit("progress", self2.size);
        cb();
      });
    };
    File.prototype.end = function(cb) {
      var self2 = this;
      if (self2.hash) {
        self2.hash = self2.hash.digest("hex");
      }
      this._writeStream.end(function() {
        self2.emit("end");
        cb();
      });
    };
  }
});

// node_modules/formidable/lib/multipart_parser.js
var require_multipart_parser = __commonJS({
  "node_modules/formidable/lib/multipart_parser.js"(exports2) {
    var Buffer2 = require("buffer").Buffer;
    var s = 0;
    var S = {
      PARSER_UNINITIALIZED: s++,
      START: s++,
      START_BOUNDARY: s++,
      HEADER_FIELD_START: s++,
      HEADER_FIELD: s++,
      HEADER_VALUE_START: s++,
      HEADER_VALUE: s++,
      HEADER_VALUE_ALMOST_DONE: s++,
      HEADERS_ALMOST_DONE: s++,
      PART_DATA_START: s++,
      PART_DATA: s++,
      PART_END: s++,
      END: s++
    };
    var f = 1;
    var F = {
      PART_BOUNDARY: f,
      LAST_BOUNDARY: f *= 2
    };
    var LF = 10;
    var CR = 13;
    var SPACE = 32;
    var HYPHEN = 45;
    var COLON = 58;
    var A = 97;
    var Z = 122;
    var lower = function(c) {
      return c | 32;
    };
    for (s in S) {
      exports2[s] = S[s];
    }
    function MultipartParser() {
      this.boundary = null;
      this.boundaryChars = null;
      this.lookbehind = null;
      this.state = S.PARSER_UNINITIALIZED;
      this.index = null;
      this.flags = 0;
    }
    exports2.MultipartParser = MultipartParser;
    MultipartParser.stateToString = function(stateNumber) {
      for (var state in S) {
        var number = S[state];
        if (number === stateNumber)
          return state;
      }
    };
    MultipartParser.prototype.initWithBoundary = function(str2) {
      this.boundary = new Buffer2(str2.length + 4);
      this.boundary.write("\r\n--", 0);
      this.boundary.write(str2, 4);
      this.lookbehind = new Buffer2(this.boundary.length + 8);
      this.state = S.START;
      this.boundaryChars = {};
      for (var i = 0; i < this.boundary.length; i++) {
        this.boundaryChars[this.boundary[i]] = true;
      }
    };
    MultipartParser.prototype.write = function(buffer) {
      var self2 = this, i = 0, len = buffer.length, prevIndex = this.index, index = this.index, state = this.state, flags = this.flags, lookbehind = this.lookbehind, boundary = this.boundary, boundaryChars = this.boundaryChars, boundaryLength = this.boundary.length, boundaryEnd = boundaryLength - 1, bufferLength = buffer.length, c, cl, mark = function(name) {
        self2[name + "Mark"] = i;
      }, clear = function(name) {
        delete self2[name + "Mark"];
      }, callback = function(name, buffer2, start, end) {
        if (start !== void 0 && start === end) {
          return;
        }
        var callbackSymbol = "on" + name.substr(0, 1).toUpperCase() + name.substr(1);
        if (callbackSymbol in self2) {
          self2[callbackSymbol](buffer2, start, end);
        }
      }, dataCallback = function(name, clear2) {
        var markSymbol = name + "Mark";
        if (!(markSymbol in self2)) {
          return;
        }
        if (!clear2) {
          callback(name, buffer, self2[markSymbol], buffer.length);
          self2[markSymbol] = 0;
        } else {
          callback(name, buffer, self2[markSymbol], i);
          delete self2[markSymbol];
        }
      };
      for (i = 0; i < len; i++) {
        c = buffer[i];
        switch (state) {
          case S.PARSER_UNINITIALIZED:
            return i;
          case S.START:
            index = 0;
            state = S.START_BOUNDARY;
          case S.START_BOUNDARY:
            if (index == boundary.length - 2) {
              if (c == HYPHEN) {
                flags |= F.LAST_BOUNDARY;
              } else if (c != CR) {
                return i;
              }
              index++;
              break;
            } else if (index - 1 == boundary.length - 2) {
              if (flags & F.LAST_BOUNDARY && c == HYPHEN) {
                callback("end");
                state = S.END;
                flags = 0;
              } else if (!(flags & F.LAST_BOUNDARY) && c == LF) {
                index = 0;
                callback("partBegin");
                state = S.HEADER_FIELD_START;
              } else {
                return i;
              }
              break;
            }
            if (c != boundary[index + 2]) {
              index = -2;
            }
            if (c == boundary[index + 2]) {
              index++;
            }
            break;
          case S.HEADER_FIELD_START:
            state = S.HEADER_FIELD;
            mark("headerField");
            index = 0;
          case S.HEADER_FIELD:
            if (c == CR) {
              clear("headerField");
              state = S.HEADERS_ALMOST_DONE;
              break;
            }
            index++;
            if (c == HYPHEN) {
              break;
            }
            if (c == COLON) {
              if (index == 1) {
                return i;
              }
              dataCallback("headerField", true);
              state = S.HEADER_VALUE_START;
              break;
            }
            cl = lower(c);
            if (cl < A || cl > Z) {
              return i;
            }
            break;
          case S.HEADER_VALUE_START:
            if (c == SPACE) {
              break;
            }
            mark("headerValue");
            state = S.HEADER_VALUE;
          case S.HEADER_VALUE:
            if (c == CR) {
              dataCallback("headerValue", true);
              callback("headerEnd");
              state = S.HEADER_VALUE_ALMOST_DONE;
            }
            break;
          case S.HEADER_VALUE_ALMOST_DONE:
            if (c != LF) {
              return i;
            }
            state = S.HEADER_FIELD_START;
            break;
          case S.HEADERS_ALMOST_DONE:
            if (c != LF) {
              return i;
            }
            callback("headersEnd");
            state = S.PART_DATA_START;
            break;
          case S.PART_DATA_START:
            state = S.PART_DATA;
            mark("partData");
          case S.PART_DATA:
            prevIndex = index;
            if (index === 0) {
              i += boundaryEnd;
              while (i < bufferLength && !(buffer[i] in boundaryChars)) {
                i += boundaryLength;
              }
              i -= boundaryEnd;
              c = buffer[i];
            }
            if (index < boundary.length) {
              if (boundary[index] == c) {
                if (index === 0) {
                  dataCallback("partData", true);
                }
                index++;
              } else {
                index = 0;
              }
            } else if (index == boundary.length) {
              index++;
              if (c == CR) {
                flags |= F.PART_BOUNDARY;
              } else if (c == HYPHEN) {
                flags |= F.LAST_BOUNDARY;
              } else {
                index = 0;
              }
            } else if (index - 1 == boundary.length) {
              if (flags & F.PART_BOUNDARY) {
                index = 0;
                if (c == LF) {
                  flags &= ~F.PART_BOUNDARY;
                  callback("partEnd");
                  callback("partBegin");
                  state = S.HEADER_FIELD_START;
                  break;
                }
              } else if (flags & F.LAST_BOUNDARY) {
                if (c == HYPHEN) {
                  callback("partEnd");
                  callback("end");
                  state = S.END;
                  flags = 0;
                } else {
                  index = 0;
                }
              } else {
                index = 0;
              }
            }
            if (index > 0) {
              lookbehind[index - 1] = c;
            } else if (prevIndex > 0) {
              callback("partData", lookbehind, 0, prevIndex);
              prevIndex = 0;
              mark("partData");
              i--;
            }
            break;
          case S.END:
            break;
          default:
            return i;
        }
      }
      dataCallback("headerField");
      dataCallback("headerValue");
      dataCallback("partData");
      this.index = index;
      this.state = state;
      this.flags = flags;
      return len;
    };
    MultipartParser.prototype.end = function() {
      var callback = function(self2, name) {
        var callbackSymbol = "on" + name.substr(0, 1).toUpperCase() + name.substr(1);
        if (callbackSymbol in self2) {
          self2[callbackSymbol]();
        }
      };
      if (this.state == S.HEADER_FIELD_START && this.index === 0 || this.state == S.PART_DATA && this.index == this.boundary.length) {
        callback(this, "partEnd");
        callback(this, "end");
      } else if (this.state != S.END) {
        return new Error("MultipartParser.end(): stream ended unexpectedly: " + this.explain());
      }
    };
    MultipartParser.prototype.explain = function() {
      return "state = " + MultipartParser.stateToString(this.state);
    };
  }
});

// node_modules/formidable/lib/querystring_parser.js
var require_querystring_parser = __commonJS({
  "node_modules/formidable/lib/querystring_parser.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var querystring = require("querystring");
    function QuerystringParser(maxKeys) {
      this.maxKeys = maxKeys;
      this.buffer = "";
    }
    exports2.QuerystringParser = QuerystringParser;
    QuerystringParser.prototype.write = function(buffer) {
      this.buffer += buffer.toString("ascii");
      return buffer.length;
    };
    QuerystringParser.prototype.end = function() {
      var fields = querystring.parse(this.buffer, "&", "=", { maxKeys: this.maxKeys });
      for (var field in fields) {
        this.onField(field, fields[field]);
      }
      this.buffer = "";
      this.onEnd();
    };
  }
});

// node_modules/formidable/lib/octet_parser.js
var require_octet_parser = __commonJS({
  "node_modules/formidable/lib/octet_parser.js"(exports2) {
    var EventEmitter = require("events").EventEmitter;
    var util = require("util");
    function OctetParser(options) {
      if (!(this instanceof OctetParser))
        return new OctetParser(options);
      EventEmitter.call(this);
    }
    util.inherits(OctetParser, EventEmitter);
    exports2.OctetParser = OctetParser;
    OctetParser.prototype.write = function(buffer) {
      this.emit("data", buffer);
      return buffer.length;
    };
    OctetParser.prototype.end = function() {
      this.emit("end");
    };
  }
});

// node_modules/formidable/lib/json_parser.js
var require_json_parser = __commonJS({
  "node_modules/formidable/lib/json_parser.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var Buffer2 = require("buffer").Buffer;
    function JSONParser(parent) {
      this.parent = parent;
      this.chunks = [];
      this.bytesWritten = 0;
    }
    exports2.JSONParser = JSONParser;
    JSONParser.prototype.write = function(buffer) {
      this.bytesWritten += buffer.length;
      this.chunks.push(buffer);
      return buffer.length;
    };
    JSONParser.prototype.end = function() {
      try {
        var fields = JSON.parse(Buffer2.concat(this.chunks));
        for (var field in fields) {
          this.onField(field, fields[field]);
        }
      } catch (e) {
        this.parent.emit("error", e);
      }
      this.data = null;
      this.onEnd();
    };
  }
});

// node_modules/formidable/lib/incoming_form.js
var require_incoming_form = __commonJS({
  "node_modules/formidable/lib/incoming_form.js"(exports2) {
    if (global.GENTLY)
      require = GENTLY.hijack(require);
    var crypto = require("crypto");
    var fs = require("fs");
    var util = require("util");
    var path = require("path");
    var File = require_file();
    var MultipartParser = require_multipart_parser().MultipartParser;
    var QuerystringParser = require_querystring_parser().QuerystringParser;
    var OctetParser = require_octet_parser().OctetParser;
    var JSONParser = require_json_parser().JSONParser;
    var StringDecoder = require("string_decoder").StringDecoder;
    var EventEmitter = require("events").EventEmitter;
    var Stream = require("stream").Stream;
    var os = require("os");
    function IncomingForm2(opts) {
      if (!(this instanceof IncomingForm2))
        return new IncomingForm2(opts);
      EventEmitter.call(this);
      opts = opts || {};
      this.error = null;
      this.ended = false;
      this.maxFields = opts.maxFields || 1e3;
      this.maxFieldsSize = opts.maxFieldsSize || 20 * 1024 * 1024;
      this.maxFileSize = opts.maxFileSize || 200 * 1024 * 1024;
      this.keepExtensions = opts.keepExtensions || false;
      this.uploadDir = opts.uploadDir || os.tmpdir && os.tmpdir() || os.tmpDir();
      this.encoding = opts.encoding || "utf-8";
      this.headers = null;
      this.type = null;
      this.hash = opts.hash || false;
      this.multiples = opts.multiples || false;
      this.bytesReceived = null;
      this.bytesExpected = null;
      this._parser = null;
      this._flushing = 0;
      this._fieldsSize = 0;
      this._fileSize = 0;
      this.openedFiles = [];
      return this;
    }
    util.inherits(IncomingForm2, EventEmitter);
    exports2.IncomingForm = IncomingForm2;
    IncomingForm2.prototype.parse = function(req, cb) {
      this.pause = function() {
        try {
          req.pause();
        } catch (err) {
          if (!this.ended) {
            this._error(err);
          }
          return false;
        }
        return true;
      };
      this.resume = function() {
        try {
          req.resume();
        } catch (err) {
          if (!this.ended) {
            this._error(err);
          }
          return false;
        }
        return true;
      };
      if (cb) {
        var fields = {}, files = {};
        this.on("field", function(name, value) {
          fields[name] = value;
        }).on("file", function(name, file) {
          if (this.multiples) {
            if (files[name]) {
              if (!Array.isArray(files[name])) {
                files[name] = [files[name]];
              }
              files[name].push(file);
            } else {
              files[name] = file;
            }
          } else {
            files[name] = file;
          }
        }).on("error", function(err) {
          cb(err, fields, files);
        }).on("end", function() {
          cb(null, fields, files);
        });
      }
      this.writeHeaders(req.headers);
      var self2 = this;
      req.on("error", function(err) {
        self2._error(err);
      }).on("aborted", function() {
        self2.emit("aborted");
        self2._error(new Error("Request aborted"));
      }).on("data", function(buffer) {
        self2.write(buffer);
      }).on("end", function() {
        if (self2.error) {
          return;
        }
        var err = self2._parser.end();
        if (err) {
          self2._error(err);
        }
      });
      return this;
    };
    IncomingForm2.prototype.writeHeaders = function(headers) {
      this.headers = headers;
      this._parseContentLength();
      this._parseContentType();
    };
    IncomingForm2.prototype.write = function(buffer) {
      if (this.error) {
        return;
      }
      if (!this._parser) {
        this._error(new Error("uninitialized parser"));
        return;
      }
      if (typeof this._parser.write !== "function") {
        this._error(new Error("did not expect data"));
        return;
      }
      this.bytesReceived += buffer.length;
      this.emit("progress", this.bytesReceived, this.bytesExpected);
      var bytesParsed = this._parser.write(buffer);
      if (bytesParsed !== buffer.length) {
        this._error(new Error("parser error, " + bytesParsed + " of " + buffer.length + " bytes parsed"));
      }
      return bytesParsed;
    };
    IncomingForm2.prototype.pause = function() {
      return false;
    };
    IncomingForm2.prototype.resume = function() {
      return false;
    };
    IncomingForm2.prototype.onPart = function(part) {
      this.handlePart(part);
    };
    IncomingForm2.prototype.handlePart = function(part) {
      var self2 = this;
      if (part.filename === void 0) {
        var value = "", decoder = new StringDecoder(this.encoding);
        part.on("data", function(buffer) {
          self2._fieldsSize += buffer.length;
          if (self2._fieldsSize > self2.maxFieldsSize) {
            self2._error(new Error("maxFieldsSize exceeded, received " + self2._fieldsSize + " bytes of field data"));
            return;
          }
          value += decoder.write(buffer);
        });
        part.on("end", function() {
          self2.emit("field", part.name, value);
        });
        return;
      }
      this._flushing++;
      var file = new File({
        path: this._uploadPath(part.filename),
        name: part.filename,
        type: part.mime,
        hash: self2.hash
      });
      this.emit("fileBegin", part.name, file);
      file.open();
      this.openedFiles.push(file);
      part.on("data", function(buffer) {
        self2._fileSize += buffer.length;
        if (self2._fileSize > self2.maxFileSize) {
          self2._error(new Error("maxFileSize exceeded, received " + self2._fileSize + " bytes of file data"));
          return;
        }
        if (buffer.length == 0) {
          return;
        }
        self2.pause();
        file.write(buffer, function() {
          self2.resume();
        });
      });
      part.on("end", function() {
        file.end(function() {
          self2._flushing--;
          self2.emit("file", part.name, file);
          self2._maybeEnd();
        });
      });
    };
    function dummyParser(self2) {
      return {
        end: function() {
          self2.ended = true;
          self2._maybeEnd();
          return null;
        }
      };
    }
    IncomingForm2.prototype._parseContentType = function() {
      if (this.bytesExpected === 0) {
        this._parser = dummyParser(this);
        return;
      }
      if (!this.headers["content-type"]) {
        this._error(new Error("bad content-type header, no content-type"));
        return;
      }
      if (this.headers["content-type"].match(/octet-stream/i)) {
        this._initOctetStream();
        return;
      }
      if (this.headers["content-type"].match(/urlencoded/i)) {
        this._initUrlencoded();
        return;
      }
      if (this.headers["content-type"].match(/multipart/i)) {
        var m = this.headers["content-type"].match(/boundary=(?:"([^"]+)"|([^;]+))/i);
        if (m) {
          this._initMultipart(m[1] || m[2]);
        } else {
          this._error(new Error("bad content-type header, no multipart boundary"));
        }
        return;
      }
      if (this.headers["content-type"].match(/json/i)) {
        this._initJSONencoded();
        return;
      }
      this._error(new Error("bad content-type header, unknown content-type: " + this.headers["content-type"]));
    };
    IncomingForm2.prototype._error = function(err) {
      if (this.error || this.ended) {
        return;
      }
      this.error = err;
      this.emit("error", err);
      if (Array.isArray(this.openedFiles)) {
        this.openedFiles.forEach(function(file) {
          file._writeStream.on("error", function() {
          }).destroy();
          setTimeout(fs.unlink, 0, file.path, function(error) {
          });
        });
      }
    };
    IncomingForm2.prototype._parseContentLength = function() {
      this.bytesReceived = 0;
      if (this.headers["content-length"]) {
        this.bytesExpected = parseInt(this.headers["content-length"], 10);
      } else if (this.headers["transfer-encoding"] === void 0) {
        this.bytesExpected = 0;
      }
      if (this.bytesExpected !== null) {
        this.emit("progress", this.bytesReceived, this.bytesExpected);
      }
    };
    IncomingForm2.prototype._newParser = function() {
      return new MultipartParser();
    };
    IncomingForm2.prototype._initMultipart = function(boundary) {
      this.type = "multipart";
      var parser = new MultipartParser(), self2 = this, headerField, headerValue, part;
      parser.initWithBoundary(boundary);
      parser.onPartBegin = function() {
        part = new Stream();
        part.readable = true;
        part.headers = {};
        part.name = null;
        part.filename = null;
        part.mime = null;
        part.transferEncoding = "binary";
        part.transferBuffer = "";
        headerField = "";
        headerValue = "";
      };
      parser.onHeaderField = function(b, start, end) {
        headerField += b.toString(self2.encoding, start, end);
      };
      parser.onHeaderValue = function(b, start, end) {
        headerValue += b.toString(self2.encoding, start, end);
      };
      parser.onHeaderEnd = function() {
        headerField = headerField.toLowerCase();
        part.headers[headerField] = headerValue;
        var m = headerValue.match(/\bname=("([^"]*)"|([^\(\)<>@,;:\\"\/\[\]\?=\{\}\s\t/]+))/i);
        if (headerField == "content-disposition") {
          if (m) {
            part.name = m[2] || m[3] || "";
          }
          part.filename = self2._fileName(headerValue);
        } else if (headerField == "content-type") {
          part.mime = headerValue;
        } else if (headerField == "content-transfer-encoding") {
          part.transferEncoding = headerValue.toLowerCase();
        }
        headerField = "";
        headerValue = "";
      };
      parser.onHeadersEnd = function() {
        switch (part.transferEncoding) {
          case "binary":
          case "7bit":
          case "8bit":
            parser.onPartData = function(b, start, end) {
              part.emit("data", b.slice(start, end));
            };
            parser.onPartEnd = function() {
              part.emit("end");
            };
            break;
          case "base64":
            parser.onPartData = function(b, start, end) {
              part.transferBuffer += b.slice(start, end).toString("ascii");
              var offset = parseInt(part.transferBuffer.length / 4, 10) * 4;
              part.emit("data", new Buffer(part.transferBuffer.substring(0, offset), "base64"));
              part.transferBuffer = part.transferBuffer.substring(offset);
            };
            parser.onPartEnd = function() {
              part.emit("data", new Buffer(part.transferBuffer, "base64"));
              part.emit("end");
            };
            break;
          default:
            return self2._error(new Error("unknown transfer-encoding"));
        }
        self2.onPart(part);
      };
      parser.onEnd = function() {
        self2.ended = true;
        self2._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._fileName = function(headerValue) {
      var m = headerValue.match(/\bfilename=("(.*?)"|([^\(\)<>@,;:\\"\/\[\]\?=\{\}\s\t/]+))($|;\s)/i);
      if (!m)
        return;
      var match = m[2] || m[3] || "";
      var filename = match.substr(match.lastIndexOf("\\") + 1);
      filename = filename.replace(/%22/g, '"');
      filename = filename.replace(/&#([\d]{4});/g, function(m2, code) {
        return String.fromCharCode(code);
      });
      return filename;
    };
    IncomingForm2.prototype._initUrlencoded = function() {
      this.type = "urlencoded";
      var parser = new QuerystringParser(this.maxFields), self2 = this;
      parser.onField = function(key, val) {
        self2.emit("field", key, val);
      };
      parser.onEnd = function() {
        self2.ended = true;
        self2._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._initOctetStream = function() {
      this.type = "octet-stream";
      var filename = this.headers["x-file-name"];
      var mime = this.headers["content-type"];
      var file = new File({
        path: this._uploadPath(filename),
        name: filename,
        type: mime
      });
      this.emit("fileBegin", filename, file);
      file.open();
      this.openedFiles.push(file);
      this._flushing++;
      var self2 = this;
      self2._parser = new OctetParser();
      var outstandingWrites = 0;
      self2._parser.on("data", function(buffer) {
        self2.pause();
        outstandingWrites++;
        file.write(buffer, function() {
          outstandingWrites--;
          self2.resume();
          if (self2.ended) {
            self2._parser.emit("doneWritingFile");
          }
        });
      });
      self2._parser.on("end", function() {
        self2._flushing--;
        self2.ended = true;
        var done = function() {
          file.end(function() {
            self2.emit("file", "file", file);
            self2._maybeEnd();
          });
        };
        if (outstandingWrites === 0) {
          done();
        } else {
          self2._parser.once("doneWritingFile", done);
        }
      });
    };
    IncomingForm2.prototype._initJSONencoded = function() {
      this.type = "json";
      var parser = new JSONParser(this), self2 = this;
      parser.onField = function(key, val) {
        self2.emit("field", key, val);
      };
      parser.onEnd = function() {
        self2.ended = true;
        self2._maybeEnd();
      };
      this._parser = parser;
    };
    IncomingForm2.prototype._uploadPath = function(filename) {
      var buf = crypto.randomBytes(16);
      var name = "upload_" + buf.toString("hex");
      if (this.keepExtensions) {
        var ext = path.extname(filename);
        ext = ext.replace(/(\.[a-z0-9]+).*/i, "$1");
        name += ext;
      }
      return path.join(this.uploadDir, name);
    };
    IncomingForm2.prototype._maybeEnd = function() {
      if (!this.ended || this._flushing || this.error) {
        return;
      }
      this.emit("end");
    };
  }
});

// node_modules/formidable/lib/index.js
var require_lib2 = __commonJS({
  "node_modules/formidable/lib/index.js"(exports2, module2) {
    var IncomingForm2 = require_incoming_form().IncomingForm;
    IncomingForm2.IncomingForm = IncomingForm2;
    module2.exports = IncomingForm2;
  }
});

// node_modules/ip/lib/ip.js
var require_ip = __commonJS({
  "node_modules/ip/lib/ip.js"(exports2) {
    "use strict";
    var ip = exports2;
    var Buffer2 = require("buffer").Buffer;
    var os = require("os");
    ip.toBuffer = function(ip2, buff, offset) {
      offset = ~~offset;
      var result;
      if (this.isV4Format(ip2)) {
        result = buff || new Buffer2(offset + 4);
        ip2.split(/\./g).map(function(byte) {
          result[offset++] = parseInt(byte, 10) & 255;
        });
      } else if (this.isV6Format(ip2)) {
        var sections = ip2.split(":", 8);
        var i;
        for (i = 0; i < sections.length; i++) {
          var isv4 = this.isV4Format(sections[i]);
          var v4Buffer;
          if (isv4) {
            v4Buffer = this.toBuffer(sections[i]);
            sections[i] = v4Buffer.slice(0, 2).toString("hex");
          }
          if (v4Buffer && ++i < 8) {
            sections.splice(i, 0, v4Buffer.slice(2, 4).toString("hex"));
          }
        }
        if (sections[0] === "") {
          while (sections.length < 8)
            sections.unshift("0");
        } else if (sections[sections.length - 1] === "") {
          while (sections.length < 8)
            sections.push("0");
        } else if (sections.length < 8) {
          for (i = 0; i < sections.length && sections[i] !== ""; i++)
            ;
          var argv = [i, 1];
          for (i = 9 - sections.length; i > 0; i--) {
            argv.push("0");
          }
          sections.splice.apply(sections, argv);
        }
        result = buff || new Buffer2(offset + 16);
        for (i = 0; i < sections.length; i++) {
          var word = parseInt(sections[i], 16);
          result[offset++] = word >> 8 & 255;
          result[offset++] = word & 255;
        }
      }
      if (!result) {
        throw Error("Invalid ip address: " + ip2);
      }
      return result;
    };
    ip.toString = function(buff, offset, length) {
      offset = ~~offset;
      length = length || buff.length - offset;
      var result = [];
      if (length === 4) {
        for (var i = 0; i < length; i++) {
          result.push(buff[offset + i]);
        }
        result = result.join(".");
      } else if (length === 16) {
        for (var i = 0; i < length; i += 2) {
          result.push(buff.readUInt16BE(offset + i).toString(16));
        }
        result = result.join(":");
        result = result.replace(/(^|:)0(:0)*:0(:|$)/, "$1::$3");
        result = result.replace(/:{3,4}/, "::");
      }
      return result;
    };
    var ipv4Regex = /^(\d{1,3}\.){3,3}\d{1,3}$/;
    var ipv6Regex = /^(::)?(((\d{1,3}\.){3}(\d{1,3}){1})?([0-9a-f]){0,4}:{0,2}){1,8}(::)?$/i;
    ip.isV4Format = function(ip2) {
      return ipv4Regex.test(ip2);
    };
    ip.isV6Format = function(ip2) {
      return ipv6Regex.test(ip2);
    };
    function _normalizeFamily(family) {
      return family ? family.toLowerCase() : "ipv4";
    }
    ip.fromPrefixLen = function(prefixlen, family) {
      if (prefixlen > 32) {
        family = "ipv6";
      } else {
        family = _normalizeFamily(family);
      }
      var len = 4;
      if (family === "ipv6") {
        len = 16;
      }
      var buff = new Buffer2(len);
      for (var i = 0, n = buff.length; i < n; ++i) {
        var bits = 8;
        if (prefixlen < 8) {
          bits = prefixlen;
        }
        prefixlen -= bits;
        buff[i] = ~(255 >> bits) & 255;
      }
      return ip.toString(buff);
    };
    ip.mask = function(addr, mask) {
      addr = ip.toBuffer(addr);
      mask = ip.toBuffer(mask);
      var result = new Buffer2(Math.max(addr.length, mask.length));
      var i = 0;
      if (addr.length === mask.length) {
        for (i = 0; i < addr.length; i++) {
          result[i] = addr[i] & mask[i];
        }
      } else if (mask.length === 4) {
        for (i = 0; i < mask.length; i++) {
          result[i] = addr[addr.length - 4 + i] & mask[i];
        }
      } else {
        for (var i = 0; i < result.length - 6; i++) {
          result[i] = 0;
        }
        result[10] = 255;
        result[11] = 255;
        for (i = 0; i < addr.length; i++) {
          result[i + 12] = addr[i] & mask[i + 12];
        }
        i = i + 12;
      }
      for (; i < result.length; i++)
        result[i] = 0;
      return ip.toString(result);
    };
    ip.cidr = function(cidrString) {
      var cidrParts = cidrString.split("/");
      var addr = cidrParts[0];
      if (cidrParts.length !== 2)
        throw new Error("invalid CIDR subnet: " + addr);
      var mask = ip.fromPrefixLen(parseInt(cidrParts[1], 10));
      return ip.mask(addr, mask);
    };
    ip.subnet = function(addr, mask) {
      var networkAddress = ip.toLong(ip.mask(addr, mask));
      var maskBuffer = ip.toBuffer(mask);
      var maskLength = 0;
      for (var i = 0; i < maskBuffer.length; i++) {
        if (maskBuffer[i] === 255) {
          maskLength += 8;
        } else {
          var octet = maskBuffer[i] & 255;
          while (octet) {
            octet = octet << 1 & 255;
            maskLength++;
          }
        }
      }
      var numberOfAddresses = Math.pow(2, 32 - maskLength);
      return {
        networkAddress: ip.fromLong(networkAddress),
        firstAddress: numberOfAddresses <= 2 ? ip.fromLong(networkAddress) : ip.fromLong(networkAddress + 1),
        lastAddress: numberOfAddresses <= 2 ? ip.fromLong(networkAddress + numberOfAddresses - 1) : ip.fromLong(networkAddress + numberOfAddresses - 2),
        broadcastAddress: ip.fromLong(networkAddress + numberOfAddresses - 1),
        subnetMask: mask,
        subnetMaskLength: maskLength,
        numHosts: numberOfAddresses <= 2 ? numberOfAddresses : numberOfAddresses - 2,
        length: numberOfAddresses,
        contains: function(other) {
          return networkAddress === ip.toLong(ip.mask(other, mask));
        }
      };
    };
    ip.cidrSubnet = function(cidrString) {
      var cidrParts = cidrString.split("/");
      var addr = cidrParts[0];
      if (cidrParts.length !== 2)
        throw new Error("invalid CIDR subnet: " + addr);
      var mask = ip.fromPrefixLen(parseInt(cidrParts[1], 10));
      return ip.subnet(addr, mask);
    };
    ip.not = function(addr) {
      var buff = ip.toBuffer(addr);
      for (var i = 0; i < buff.length; i++) {
        buff[i] = 255 ^ buff[i];
      }
      return ip.toString(buff);
    };
    ip.or = function(a2, b) {
      a2 = ip.toBuffer(a2);
      b = ip.toBuffer(b);
      if (a2.length === b.length) {
        for (var i = 0; i < a2.length; ++i) {
          a2[i] |= b[i];
        }
        return ip.toString(a2);
      } else {
        var buff = a2;
        var other = b;
        if (b.length > a2.length) {
          buff = b;
          other = a2;
        }
        var offset = buff.length - other.length;
        for (var i = offset; i < buff.length; ++i) {
          buff[i] |= other[i - offset];
        }
        return ip.toString(buff);
      }
    };
    ip.isEqual = function(a2, b) {
      a2 = ip.toBuffer(a2);
      b = ip.toBuffer(b);
      if (a2.length === b.length) {
        for (var i = 0; i < a2.length; i++) {
          if (a2[i] !== b[i])
            return false;
        }
        return true;
      }
      if (b.length === 4) {
        var t = b;
        b = a2;
        a2 = t;
      }
      for (var i = 0; i < 10; i++) {
        if (b[i] !== 0)
          return false;
      }
      var word = b.readUInt16BE(10);
      if (word !== 0 && word !== 65535)
        return false;
      for (var i = 0; i < 4; i++) {
        if (a2[i] !== b[i + 12])
          return false;
      }
      return true;
    };
    ip.isPrivate = function(addr) {
      return /^(::f{4}:)?10\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?192\.168\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?172\.(1[6-9]|2\d|30|31)\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?127\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^(::f{4}:)?169\.254\.([0-9]{1,3})\.([0-9]{1,3})$/i.test(addr) || /^f[cd][0-9a-f]{2}:/i.test(addr) || /^fe80:/i.test(addr) || /^::1$/.test(addr) || /^::$/.test(addr);
    };
    ip.isPublic = function(addr) {
      return !ip.isPrivate(addr);
    };
    ip.isLoopback = function(addr) {
      return /^(::f{4}:)?127\.([0-9]{1,3})\.([0-9]{1,3})\.([0-9]{1,3})/.test(addr) || /^fe80::1$/.test(addr) || /^::1$/.test(addr) || /^::$/.test(addr);
    };
    ip.loopback = function(family) {
      family = _normalizeFamily(family);
      if (family !== "ipv4" && family !== "ipv6") {
        throw new Error("family must be ipv4 or ipv6");
      }
      return family === "ipv4" ? "127.0.0.1" : "fe80::1";
    };
    ip.address = function(name, family) {
      var interfaces = os.networkInterfaces();
      var all;
      family = _normalizeFamily(family);
      if (name && name !== "private" && name !== "public") {
        var res = interfaces[name].filter(function(details) {
          var itemFamily = details.family.toLowerCase();
          return itemFamily === family;
        });
        if (res.length === 0)
          return void 0;
        return res[0].address;
      }
      var all = Object.keys(interfaces).map(function(nic) {
        var addresses = interfaces[nic].filter(function(details) {
          details.family = details.family.toLowerCase();
          if (details.family !== family || ip.isLoopback(details.address)) {
            return false;
          } else if (!name) {
            return true;
          }
          return name === "public" ? ip.isPrivate(details.address) : ip.isPublic(details.address);
        });
        return addresses.length ? addresses[0].address : void 0;
      }).filter(Boolean);
      return !all.length ? ip.loopback(family) : all[0];
    };
    ip.toLong = function(ip2) {
      var ipl = 0;
      ip2.split(".").forEach(function(octet) {
        ipl <<= 8;
        ipl += parseInt(octet);
      });
      return ipl >>> 0;
    };
    ip.fromLong = function(ipl) {
      return (ipl >>> 24) + "." + (ipl >> 16 & 255) + "." + (ipl >> 8 & 255) + "." + (ipl & 255);
    };
  }
});

// node_modules/@sindresorhus/is/dist/index.js
var require_dist = __commonJS({
  "node_modules/@sindresorhus/is/dist/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var typedArrayTypeNames = [
      "Int8Array",
      "Uint8Array",
      "Uint8ClampedArray",
      "Int16Array",
      "Uint16Array",
      "Int32Array",
      "Uint32Array",
      "Float32Array",
      "Float64Array",
      "BigInt64Array",
      "BigUint64Array"
    ];
    function isTypedArrayName(name) {
      return typedArrayTypeNames.includes(name);
    }
    var objectTypeNames = [
      "Function",
      "Generator",
      "AsyncGenerator",
      "GeneratorFunction",
      "AsyncGeneratorFunction",
      "AsyncFunction",
      "Observable",
      "Array",
      "Buffer",
      "Object",
      "RegExp",
      "Date",
      "Error",
      "Map",
      "Set",
      "WeakMap",
      "WeakSet",
      "ArrayBuffer",
      "SharedArrayBuffer",
      "DataView",
      "Promise",
      "URL",
      "FormData",
      "URLSearchParams",
      "HTMLElement",
      ...typedArrayTypeNames
    ];
    function isObjectTypeName(name) {
      return objectTypeNames.includes(name);
    }
    var primitiveTypeNames = [
      "null",
      "undefined",
      "string",
      "number",
      "bigint",
      "boolean",
      "symbol"
    ];
    function isPrimitiveTypeName(name) {
      return primitiveTypeNames.includes(name);
    }
    function isOfType(type) {
      return (value) => typeof value === type;
    }
    var { toString: toString2 } = Object.prototype;
    var getObjectType = (value) => {
      const objectTypeName = toString2.call(value).slice(8, -1);
      if (/HTML\w+Element/.test(objectTypeName) && is.domElement(value)) {
        return "HTMLElement";
      }
      if (isObjectTypeName(objectTypeName)) {
        return objectTypeName;
      }
      return void 0;
    };
    var isObjectOfType = (type) => (value) => getObjectType(value) === type;
    function is(value) {
      if (value === null) {
        return "null";
      }
      switch (typeof value) {
        case "undefined":
          return "undefined";
        case "string":
          return "string";
        case "number":
          return "number";
        case "boolean":
          return "boolean";
        case "function":
          return "Function";
        case "bigint":
          return "bigint";
        case "symbol":
          return "symbol";
        default:
      }
      if (is.observable(value)) {
        return "Observable";
      }
      if (is.array(value)) {
        return "Array";
      }
      if (is.buffer(value)) {
        return "Buffer";
      }
      const tagType = getObjectType(value);
      if (tagType) {
        return tagType;
      }
      if (value instanceof String || value instanceof Boolean || value instanceof Number) {
        throw new TypeError("Please don't use object wrappers for primitive types");
      }
      return "Object";
    }
    is.undefined = isOfType("undefined");
    is.string = isOfType("string");
    var isNumberType = isOfType("number");
    is.number = (value) => isNumberType(value) && !is.nan(value);
    is.bigint = isOfType("bigint");
    is.function_ = isOfType("function");
    is.null_ = (value) => value === null;
    is.class_ = (value) => is.function_(value) && value.toString().startsWith("class ");
    is.boolean = (value) => value === true || value === false;
    is.symbol = isOfType("symbol");
    is.numericString = (value) => is.string(value) && !is.emptyStringOrWhitespace(value) && !Number.isNaN(Number(value));
    is.array = (value, assertion) => {
      if (!Array.isArray(value)) {
        return false;
      }
      if (!is.function_(assertion)) {
        return true;
      }
      return value.every(assertion);
    };
    is.buffer = (value) => {
      var _a2, _b, _c, _d;
      return (_d = (_c = (_b = (_a2 = value) === null || _a2 === void 0 ? void 0 : _a2.constructor) === null || _b === void 0 ? void 0 : _b.isBuffer) === null || _c === void 0 ? void 0 : _c.call(_b, value)) !== null && _d !== void 0 ? _d : false;
    };
    is.nullOrUndefined = (value) => is.null_(value) || is.undefined(value);
    is.object = (value) => !is.null_(value) && (typeof value === "object" || is.function_(value));
    is.iterable = (value) => {
      var _a2;
      return is.function_((_a2 = value) === null || _a2 === void 0 ? void 0 : _a2[Symbol.iterator]);
    };
    is.asyncIterable = (value) => {
      var _a2;
      return is.function_((_a2 = value) === null || _a2 === void 0 ? void 0 : _a2[Symbol.asyncIterator]);
    };
    is.generator = (value) => {
      var _a2, _b;
      return is.iterable(value) && is.function_((_a2 = value) === null || _a2 === void 0 ? void 0 : _a2.next) && is.function_((_b = value) === null || _b === void 0 ? void 0 : _b.throw);
    };
    is.asyncGenerator = (value) => is.asyncIterable(value) && is.function_(value.next) && is.function_(value.throw);
    is.nativePromise = (value) => isObjectOfType("Promise")(value);
    var hasPromiseAPI = (value) => {
      var _a2, _b;
      return is.function_((_a2 = value) === null || _a2 === void 0 ? void 0 : _a2.then) && is.function_((_b = value) === null || _b === void 0 ? void 0 : _b.catch);
    };
    is.promise = (value) => is.nativePromise(value) || hasPromiseAPI(value);
    is.generatorFunction = isObjectOfType("GeneratorFunction");
    is.asyncGeneratorFunction = (value) => getObjectType(value) === "AsyncGeneratorFunction";
    is.asyncFunction = (value) => getObjectType(value) === "AsyncFunction";
    is.boundFunction = (value) => is.function_(value) && !value.hasOwnProperty("prototype");
    is.regExp = isObjectOfType("RegExp");
    is.date = isObjectOfType("Date");
    is.error = isObjectOfType("Error");
    is.map = (value) => isObjectOfType("Map")(value);
    is.set = (value) => isObjectOfType("Set")(value);
    is.weakMap = (value) => isObjectOfType("WeakMap")(value);
    is.weakSet = (value) => isObjectOfType("WeakSet")(value);
    is.int8Array = isObjectOfType("Int8Array");
    is.uint8Array = isObjectOfType("Uint8Array");
    is.uint8ClampedArray = isObjectOfType("Uint8ClampedArray");
    is.int16Array = isObjectOfType("Int16Array");
    is.uint16Array = isObjectOfType("Uint16Array");
    is.int32Array = isObjectOfType("Int32Array");
    is.uint32Array = isObjectOfType("Uint32Array");
    is.float32Array = isObjectOfType("Float32Array");
    is.float64Array = isObjectOfType("Float64Array");
    is.bigInt64Array = isObjectOfType("BigInt64Array");
    is.bigUint64Array = isObjectOfType("BigUint64Array");
    is.arrayBuffer = isObjectOfType("ArrayBuffer");
    is.sharedArrayBuffer = isObjectOfType("SharedArrayBuffer");
    is.dataView = isObjectOfType("DataView");
    is.enumCase = (value, targetEnum) => Object.values(targetEnum).includes(value);
    is.directInstanceOf = (instance, class_) => Object.getPrototypeOf(instance) === class_.prototype;
    is.urlInstance = (value) => isObjectOfType("URL")(value);
    is.urlString = (value) => {
      if (!is.string(value)) {
        return false;
      }
      try {
        new URL(value);
        return true;
      } catch (_a2) {
        return false;
      }
    };
    is.truthy = (value) => Boolean(value);
    is.falsy = (value) => !value;
    is.nan = (value) => Number.isNaN(value);
    is.primitive = (value) => is.null_(value) || isPrimitiveTypeName(typeof value);
    is.integer = (value) => Number.isInteger(value);
    is.safeInteger = (value) => Number.isSafeInteger(value);
    is.plainObject = (value) => {
      if (toString2.call(value) !== "[object Object]") {
        return false;
      }
      const prototype = Object.getPrototypeOf(value);
      return prototype === null || prototype === Object.getPrototypeOf({});
    };
    is.typedArray = (value) => isTypedArrayName(getObjectType(value));
    var isValidLength = (value) => is.safeInteger(value) && value >= 0;
    is.arrayLike = (value) => !is.nullOrUndefined(value) && !is.function_(value) && isValidLength(value.length);
    is.inRange = (value, range) => {
      if (is.number(range)) {
        return value >= Math.min(0, range) && value <= Math.max(range, 0);
      }
      if (is.array(range) && range.length === 2) {
        return value >= Math.min(...range) && value <= Math.max(...range);
      }
      throw new TypeError(`Invalid range: ${JSON.stringify(range)}`);
    };
    var NODE_TYPE_ELEMENT = 1;
    var DOM_PROPERTIES_TO_CHECK = [
      "innerHTML",
      "ownerDocument",
      "style",
      "attributes",
      "nodeValue"
    ];
    is.domElement = (value) => {
      return is.object(value) && value.nodeType === NODE_TYPE_ELEMENT && is.string(value.nodeName) && !is.plainObject(value) && DOM_PROPERTIES_TO_CHECK.every((property) => property in value);
    };
    is.observable = (value) => {
      var _a2, _b, _c, _d;
      if (!value) {
        return false;
      }
      if (value === ((_b = (_a2 = value)[Symbol.observable]) === null || _b === void 0 ? void 0 : _b.call(_a2))) {
        return true;
      }
      if (value === ((_d = (_c = value)["@@observable"]) === null || _d === void 0 ? void 0 : _d.call(_c))) {
        return true;
      }
      return false;
    };
    is.nodeStream = (value) => is.object(value) && is.function_(value.pipe) && !is.observable(value);
    is.infinite = (value) => value === Infinity || value === -Infinity;
    var isAbsoluteMod2 = (remainder) => (value) => is.integer(value) && Math.abs(value % 2) === remainder;
    is.evenInteger = isAbsoluteMod2(0);
    is.oddInteger = isAbsoluteMod2(1);
    is.emptyArray = (value) => is.array(value) && value.length === 0;
    is.nonEmptyArray = (value) => is.array(value) && value.length > 0;
    is.emptyString = (value) => is.string(value) && value.length === 0;
    is.nonEmptyString = (value) => is.string(value) && value.length > 0;
    var isWhiteSpaceString = (value) => is.string(value) && !/\S/.test(value);
    is.emptyStringOrWhitespace = (value) => is.emptyString(value) || isWhiteSpaceString(value);
    is.emptyObject = (value) => is.object(value) && !is.map(value) && !is.set(value) && Object.keys(value).length === 0;
    is.nonEmptyObject = (value) => is.object(value) && !is.map(value) && !is.set(value) && Object.keys(value).length > 0;
    is.emptySet = (value) => is.set(value) && value.size === 0;
    is.nonEmptySet = (value) => is.set(value) && value.size > 0;
    is.emptyMap = (value) => is.map(value) && value.size === 0;
    is.nonEmptyMap = (value) => is.map(value) && value.size > 0;
    is.propertyKey = (value) => is.any([is.string, is.number, is.symbol], value);
    is.formData = (value) => isObjectOfType("FormData")(value);
    is.urlSearchParams = (value) => isObjectOfType("URLSearchParams")(value);
    var predicateOnArray = (method, predicate, values) => {
      if (!is.function_(predicate)) {
        throw new TypeError(`Invalid predicate: ${JSON.stringify(predicate)}`);
      }
      if (values.length === 0) {
        throw new TypeError("Invalid number of values");
      }
      return method.call(values, predicate);
    };
    is.any = (predicate, ...values) => {
      const predicates = is.array(predicate) ? predicate : [predicate];
      return predicates.some((singlePredicate) => predicateOnArray(Array.prototype.some, singlePredicate, values));
    };
    is.all = (predicate, ...values) => predicateOnArray(Array.prototype.every, predicate, values);
    var assertType = (condition, description, value, options = {}) => {
      if (!condition) {
        const { multipleValues } = options;
        const valuesMessage = multipleValues ? `received values of types ${[
          ...new Set(value.map((singleValue) => `\`${is(singleValue)}\``))
        ].join(", ")}` : `received value of type \`${is(value)}\``;
        throw new TypeError(`Expected value which is \`${description}\`, ${valuesMessage}.`);
      }
    };
    exports2.assert = {
      undefined: (value) => assertType(is.undefined(value), "undefined", value),
      string: (value) => assertType(is.string(value), "string", value),
      number: (value) => assertType(is.number(value), "number", value),
      bigint: (value) => assertType(is.bigint(value), "bigint", value),
      function_: (value) => assertType(is.function_(value), "Function", value),
      null_: (value) => assertType(is.null_(value), "null", value),
      class_: (value) => assertType(is.class_(value), "Class", value),
      boolean: (value) => assertType(is.boolean(value), "boolean", value),
      symbol: (value) => assertType(is.symbol(value), "symbol", value),
      numericString: (value) => assertType(is.numericString(value), "string with a number", value),
      array: (value, assertion) => {
        const assert2 = assertType;
        assert2(is.array(value), "Array", value);
        if (assertion) {
          value.forEach(assertion);
        }
      },
      buffer: (value) => assertType(is.buffer(value), "Buffer", value),
      nullOrUndefined: (value) => assertType(is.nullOrUndefined(value), "null or undefined", value),
      object: (value) => assertType(is.object(value), "Object", value),
      iterable: (value) => assertType(is.iterable(value), "Iterable", value),
      asyncIterable: (value) => assertType(is.asyncIterable(value), "AsyncIterable", value),
      generator: (value) => assertType(is.generator(value), "Generator", value),
      asyncGenerator: (value) => assertType(is.asyncGenerator(value), "AsyncGenerator", value),
      nativePromise: (value) => assertType(is.nativePromise(value), "native Promise", value),
      promise: (value) => assertType(is.promise(value), "Promise", value),
      generatorFunction: (value) => assertType(is.generatorFunction(value), "GeneratorFunction", value),
      asyncGeneratorFunction: (value) => assertType(is.asyncGeneratorFunction(value), "AsyncGeneratorFunction", value),
      asyncFunction: (value) => assertType(is.asyncFunction(value), "AsyncFunction", value),
      boundFunction: (value) => assertType(is.boundFunction(value), "Function", value),
      regExp: (value) => assertType(is.regExp(value), "RegExp", value),
      date: (value) => assertType(is.date(value), "Date", value),
      error: (value) => assertType(is.error(value), "Error", value),
      map: (value) => assertType(is.map(value), "Map", value),
      set: (value) => assertType(is.set(value), "Set", value),
      weakMap: (value) => assertType(is.weakMap(value), "WeakMap", value),
      weakSet: (value) => assertType(is.weakSet(value), "WeakSet", value),
      int8Array: (value) => assertType(is.int8Array(value), "Int8Array", value),
      uint8Array: (value) => assertType(is.uint8Array(value), "Uint8Array", value),
      uint8ClampedArray: (value) => assertType(is.uint8ClampedArray(value), "Uint8ClampedArray", value),
      int16Array: (value) => assertType(is.int16Array(value), "Int16Array", value),
      uint16Array: (value) => assertType(is.uint16Array(value), "Uint16Array", value),
      int32Array: (value) => assertType(is.int32Array(value), "Int32Array", value),
      uint32Array: (value) => assertType(is.uint32Array(value), "Uint32Array", value),
      float32Array: (value) => assertType(is.float32Array(value), "Float32Array", value),
      float64Array: (value) => assertType(is.float64Array(value), "Float64Array", value),
      bigInt64Array: (value) => assertType(is.bigInt64Array(value), "BigInt64Array", value),
      bigUint64Array: (value) => assertType(is.bigUint64Array(value), "BigUint64Array", value),
      arrayBuffer: (value) => assertType(is.arrayBuffer(value), "ArrayBuffer", value),
      sharedArrayBuffer: (value) => assertType(is.sharedArrayBuffer(value), "SharedArrayBuffer", value),
      dataView: (value) => assertType(is.dataView(value), "DataView", value),
      enumCase: (value, targetEnum) => assertType(is.enumCase(value, targetEnum), "EnumCase", value),
      urlInstance: (value) => assertType(is.urlInstance(value), "URL", value),
      urlString: (value) => assertType(is.urlString(value), "string with a URL", value),
      truthy: (value) => assertType(is.truthy(value), "truthy", value),
      falsy: (value) => assertType(is.falsy(value), "falsy", value),
      nan: (value) => assertType(is.nan(value), "NaN", value),
      primitive: (value) => assertType(is.primitive(value), "primitive", value),
      integer: (value) => assertType(is.integer(value), "integer", value),
      safeInteger: (value) => assertType(is.safeInteger(value), "integer", value),
      plainObject: (value) => assertType(is.plainObject(value), "plain object", value),
      typedArray: (value) => assertType(is.typedArray(value), "TypedArray", value),
      arrayLike: (value) => assertType(is.arrayLike(value), "array-like", value),
      domElement: (value) => assertType(is.domElement(value), "HTMLElement", value),
      observable: (value) => assertType(is.observable(value), "Observable", value),
      nodeStream: (value) => assertType(is.nodeStream(value), "Node.js Stream", value),
      infinite: (value) => assertType(is.infinite(value), "infinite number", value),
      emptyArray: (value) => assertType(is.emptyArray(value), "empty array", value),
      nonEmptyArray: (value) => assertType(is.nonEmptyArray(value), "non-empty array", value),
      emptyString: (value) => assertType(is.emptyString(value), "empty string", value),
      nonEmptyString: (value) => assertType(is.nonEmptyString(value), "non-empty string", value),
      emptyStringOrWhitespace: (value) => assertType(is.emptyStringOrWhitespace(value), "empty string or whitespace", value),
      emptyObject: (value) => assertType(is.emptyObject(value), "empty object", value),
      nonEmptyObject: (value) => assertType(is.nonEmptyObject(value), "non-empty object", value),
      emptySet: (value) => assertType(is.emptySet(value), "empty set", value),
      nonEmptySet: (value) => assertType(is.nonEmptySet(value), "non-empty set", value),
      emptyMap: (value) => assertType(is.emptyMap(value), "empty map", value),
      nonEmptyMap: (value) => assertType(is.nonEmptyMap(value), "non-empty map", value),
      propertyKey: (value) => assertType(is.propertyKey(value), "PropertyKey", value),
      formData: (value) => assertType(is.formData(value), "FormData", value),
      urlSearchParams: (value) => assertType(is.urlSearchParams(value), "URLSearchParams", value),
      evenInteger: (value) => assertType(is.evenInteger(value), "even integer", value),
      oddInteger: (value) => assertType(is.oddInteger(value), "odd integer", value),
      directInstanceOf: (instance, class_) => assertType(is.directInstanceOf(instance, class_), "T", instance),
      inRange: (value, range) => assertType(is.inRange(value, range), "in range", value),
      any: (predicate, ...values) => {
        return assertType(is.any(predicate, ...values), "predicate returns truthy for any value", values, { multipleValues: true });
      },
      all: (predicate, ...values) => assertType(is.all(predicate, ...values), "predicate returns truthy for all values", values, { multipleValues: true })
    };
    Object.defineProperties(is, {
      class: {
        value: is.class_
      },
      function: {
        value: is.function_
      },
      null: {
        value: is.null_
      }
    });
    Object.defineProperties(exports2.assert, {
      class: {
        value: exports2.assert.class_
      },
      function: {
        value: exports2.assert.function_
      },
      null: {
        value: exports2.assert.null_
      }
    });
    exports2.default = is;
    module2.exports = is;
    module2.exports.default = is;
    module2.exports.assert = exports2.assert;
  }
});

// node_modules/p-cancelable/index.js
var require_p_cancelable = __commonJS({
  "node_modules/p-cancelable/index.js"(exports2, module2) {
    "use strict";
    var CancelError = class extends Error {
      constructor(reason) {
        super(reason || "Promise was canceled");
        this.name = "CancelError";
      }
      get isCanceled() {
        return true;
      }
    };
    var PCancelable = class {
      static fn(userFn) {
        return (...arguments_) => {
          return new PCancelable((resolve, reject, onCancel) => {
            arguments_.push(onCancel);
            userFn(...arguments_).then(resolve, reject);
          });
        };
      }
      constructor(executor) {
        this._cancelHandlers = [];
        this._isPending = true;
        this._isCanceled = false;
        this._rejectOnCancel = true;
        this._promise = new Promise((resolve, reject) => {
          this._reject = reject;
          const onResolve = (value) => {
            if (!this._isCanceled || !onCancel.shouldReject) {
              this._isPending = false;
              resolve(value);
            }
          };
          const onReject = (error) => {
            this._isPending = false;
            reject(error);
          };
          const onCancel = (handler) => {
            if (!this._isPending) {
              throw new Error("The `onCancel` handler was attached after the promise settled.");
            }
            this._cancelHandlers.push(handler);
          };
          Object.defineProperties(onCancel, {
            shouldReject: {
              get: () => this._rejectOnCancel,
              set: (boolean) => {
                this._rejectOnCancel = boolean;
              }
            }
          });
          return executor(onResolve, onReject, onCancel);
        });
      }
      then(onFulfilled, onRejected) {
        return this._promise.then(onFulfilled, onRejected);
      }
      catch(onRejected) {
        return this._promise.catch(onRejected);
      }
      finally(onFinally) {
        return this._promise.finally(onFinally);
      }
      cancel(reason) {
        if (!this._isPending || this._isCanceled) {
          return;
        }
        this._isCanceled = true;
        if (this._cancelHandlers.length > 0) {
          try {
            for (const handler of this._cancelHandlers) {
              handler();
            }
          } catch (error) {
            this._reject(error);
            return;
          }
        }
        if (this._rejectOnCancel) {
          this._reject(new CancelError(reason));
        }
      }
      get isCanceled() {
        return this._isCanceled;
      }
    };
    Object.setPrototypeOf(PCancelable.prototype, Promise.prototype);
    module2.exports = PCancelable;
    module2.exports.CancelError = CancelError;
  }
});

// node_modules/defer-to-connect/dist/source/index.js
var require_source2 = __commonJS({
  "node_modules/defer-to-connect/dist/source/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function isTLSSocket(socket) {
      return socket.encrypted;
    }
    var deferToConnect = (socket, fn3) => {
      let listeners;
      if (typeof fn3 === "function") {
        const connect = fn3;
        listeners = { connect };
      } else {
        listeners = fn3;
      }
      const hasConnectListener = typeof listeners.connect === "function";
      const hasSecureConnectListener = typeof listeners.secureConnect === "function";
      const hasCloseListener = typeof listeners.close === "function";
      const onConnect = () => {
        if (hasConnectListener) {
          listeners.connect();
        }
        if (isTLSSocket(socket) && hasSecureConnectListener) {
          if (socket.authorized) {
            listeners.secureConnect();
          } else if (!socket.authorizationError) {
            socket.once("secureConnect", listeners.secureConnect);
          }
        }
        if (hasCloseListener) {
          socket.once("close", listeners.close);
        }
      };
      if (socket.writable && !socket.connecting) {
        onConnect();
      } else if (socket.connecting) {
        socket.once("connect", onConnect);
      } else if (socket.destroyed && hasCloseListener) {
        listeners.close(socket._hadError);
      }
    };
    exports2.default = deferToConnect;
    module2.exports = deferToConnect;
    module2.exports.default = deferToConnect;
  }
});

// node_modules/@szmarczak/http-timer/dist/source/index.js
var require_source3 = __commonJS({
  "node_modules/@szmarczak/http-timer/dist/source/index.js"(exports2, module2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var defer_to_connect_1 = require_source2();
    var util_1 = require("util");
    var nodejsMajorVersion = Number(process.versions.node.split(".")[0]);
    var timer = (request) => {
      if (request.timings) {
        return request.timings;
      }
      const timings = {
        start: Date.now(),
        socket: void 0,
        lookup: void 0,
        connect: void 0,
        secureConnect: void 0,
        upload: void 0,
        response: void 0,
        end: void 0,
        error: void 0,
        abort: void 0,
        phases: {
          wait: void 0,
          dns: void 0,
          tcp: void 0,
          tls: void 0,
          request: void 0,
          firstByte: void 0,
          download: void 0,
          total: void 0
        }
      };
      request.timings = timings;
      const handleError = (origin) => {
        const emit = origin.emit.bind(origin);
        origin.emit = (event, ...args2) => {
          if (event === "error") {
            timings.error = Date.now();
            timings.phases.total = timings.error - timings.start;
            origin.emit = emit;
          }
          return emit(event, ...args2);
        };
      };
      handleError(request);
      const onAbort = () => {
        timings.abort = Date.now();
        if (!timings.response || nodejsMajorVersion >= 13) {
          timings.phases.total = Date.now() - timings.start;
        }
      };
      request.prependOnceListener("abort", onAbort);
      const onSocket = (socket) => {
        timings.socket = Date.now();
        timings.phases.wait = timings.socket - timings.start;
        if (util_1.types.isProxy(socket)) {
          return;
        }
        const lookupListener = () => {
          timings.lookup = Date.now();
          timings.phases.dns = timings.lookup - timings.socket;
        };
        socket.prependOnceListener("lookup", lookupListener);
        defer_to_connect_1.default(socket, {
          connect: () => {
            timings.connect = Date.now();
            if (timings.lookup === void 0) {
              socket.removeListener("lookup", lookupListener);
              timings.lookup = timings.connect;
              timings.phases.dns = timings.lookup - timings.socket;
            }
            timings.phases.tcp = timings.connect - timings.lookup;
          },
          secureConnect: () => {
            timings.secureConnect = Date.now();
            timings.phases.tls = timings.secureConnect - timings.connect;
          }
        });
      };
      if (request.socket) {
        onSocket(request.socket);
      } else {
        request.prependOnceListener("socket", onSocket);
      }
      const onUpload = () => {
        var _a2;
        timings.upload = Date.now();
        timings.phases.request = timings.upload - ((_a2 = timings.secureConnect) !== null && _a2 !== void 0 ? _a2 : timings.connect);
      };
      const writableFinished = () => {
        if (typeof request.writableFinished === "boolean") {
          return request.writableFinished;
        }
        return request.finished && request.outputSize === 0 && (!request.socket || request.socket.writableLength === 0);
      };
      if (writableFinished()) {
        onUpload();
      } else {
        request.prependOnceListener("finish", onUpload);
      }
      request.prependOnceListener("response", (response) => {
        timings.response = Date.now();
        timings.phases.firstByte = timings.response - timings.upload;
        response.timings = timings;
        handleError(response);
        response.prependOnceListener("end", () => {
          timings.end = Date.now();
          timings.phases.download = timings.end - timings.response;
          timings.phases.total = timings.end - timings.start;
        });
        response.prependOnceListener("aborted", onAbort);
      });
      return timings;
    };
    exports2.default = timer;
    module2.exports = timer;
    module2.exports.default = timer;
  }
});

// node_modules/cacheable-lookup/source/index.js
var require_source4 = __commonJS({
  "node_modules/cacheable-lookup/source/index.js"(exports2, module2) {
    "use strict";
    var {
      V4MAPPED,
      ADDRCONFIG,
      ALL,
      promises: {
        Resolver: AsyncResolver
      },
      lookup: dnsLookup
    } = require("dns");
    var { promisify } = require("util");
    var os = require("os");
    var kCacheableLookupCreateConnection = Symbol("cacheableLookupCreateConnection");
    var kCacheableLookupInstance = Symbol("cacheableLookupInstance");
    var kExpires = Symbol("expires");
    var supportsALL = typeof ALL === "number";
    var verifyAgent = (agent) => {
      if (!(agent && typeof agent.createConnection === "function")) {
        throw new Error("Expected an Agent instance as the first argument");
      }
    };
    var map4to6 = (entries) => {
      for (const entry of entries) {
        if (entry.family === 6) {
          continue;
        }
        entry.address = `::ffff:${entry.address}`;
        entry.family = 6;
      }
    };
    var getIfaceInfo = () => {
      let has4 = false;
      let has6 = false;
      for (const device of Object.values(os.networkInterfaces())) {
        for (const iface of device) {
          if (iface.internal) {
            continue;
          }
          if (iface.family === "IPv6") {
            has6 = true;
          } else {
            has4 = true;
          }
          if (has4 && has6) {
            return { has4, has6 };
          }
        }
      }
      return { has4, has6 };
    };
    var isIterable = (map2) => {
      return Symbol.iterator in map2;
    };
    var ttl = { ttl: true };
    var all = { all: true };
    var CacheableLookup = class {
      constructor({
        cache = /* @__PURE__ */ new Map(),
        maxTtl = Infinity,
        fallbackDuration = 3600,
        errorTtl = 0.15,
        resolver = new AsyncResolver(),
        lookup = dnsLookup
      } = {}) {
        this.maxTtl = maxTtl;
        this.errorTtl = errorTtl;
        this._cache = cache;
        this._resolver = resolver;
        this._dnsLookup = promisify(lookup);
        if (this._resolver instanceof AsyncResolver) {
          this._resolve4 = this._resolver.resolve4.bind(this._resolver);
          this._resolve6 = this._resolver.resolve6.bind(this._resolver);
        } else {
          this._resolve4 = promisify(this._resolver.resolve4.bind(this._resolver));
          this._resolve6 = promisify(this._resolver.resolve6.bind(this._resolver));
        }
        this._iface = getIfaceInfo();
        this._pending = {};
        this._nextRemovalTime = false;
        this._hostnamesToFallback = /* @__PURE__ */ new Set();
        if (fallbackDuration < 1) {
          this._fallback = false;
        } else {
          this._fallback = true;
          const interval = setInterval(() => {
            this._hostnamesToFallback.clear();
          }, fallbackDuration * 1e3);
          if (interval.unref) {
            interval.unref();
          }
        }
        this.lookup = this.lookup.bind(this);
        this.lookupAsync = this.lookupAsync.bind(this);
      }
      set servers(servers) {
        this.clear();
        this._resolver.setServers(servers);
      }
      get servers() {
        return this._resolver.getServers();
      }
      lookup(hostname, options, callback) {
        if (typeof options === "function") {
          callback = options;
          options = {};
        } else if (typeof options === "number") {
          options = {
            family: options
          };
        }
        if (!callback) {
          throw new Error("Callback must be a function.");
        }
        this.lookupAsync(hostname, options).then((result) => {
          if (options.all) {
            callback(null, result);
          } else {
            callback(null, result.address, result.family, result.expires, result.ttl);
          }
        }, callback);
      }
      async lookupAsync(hostname, options = {}) {
        if (typeof options === "number") {
          options = {
            family: options
          };
        }
        let cached = await this.query(hostname);
        if (options.family === 6) {
          const filtered = cached.filter((entry) => entry.family === 6);
          if (options.hints & V4MAPPED) {
            if (supportsALL && options.hints & ALL || filtered.length === 0) {
              map4to6(cached);
            } else {
              cached = filtered;
            }
          } else {
            cached = filtered;
          }
        } else if (options.family === 4) {
          cached = cached.filter((entry) => entry.family === 4);
        }
        if (options.hints & ADDRCONFIG) {
          const { _iface } = this;
          cached = cached.filter((entry) => entry.family === 6 ? _iface.has6 : _iface.has4);
        }
        if (cached.length === 0) {
          const error = new Error(`cacheableLookup ENOTFOUND ${hostname}`);
          error.code = "ENOTFOUND";
          error.hostname = hostname;
          throw error;
        }
        if (options.all) {
          return cached;
        }
        return cached[0];
      }
      async query(hostname) {
        let cached = await this._cache.get(hostname);
        if (!cached) {
          const pending = this._pending[hostname];
          if (pending) {
            cached = await pending;
          } else {
            const newPromise = this.queryAndCache(hostname);
            this._pending[hostname] = newPromise;
            try {
              cached = await newPromise;
            } finally {
              delete this._pending[hostname];
            }
          }
        }
        cached = cached.map((entry) => {
          return { ...entry };
        });
        return cached;
      }
      async _resolve(hostname) {
        const wrap = async (promise) => {
          try {
            return await promise;
          } catch (error) {
            if (error.code === "ENODATA" || error.code === "ENOTFOUND") {
              return [];
            }
            throw error;
          }
        };
        const [A, AAAA] = await Promise.all([
          this._resolve4(hostname, ttl),
          this._resolve6(hostname, ttl)
        ].map((promise) => wrap(promise)));
        let aTtl = 0;
        let aaaaTtl = 0;
        let cacheTtl = 0;
        const now = Date.now();
        for (const entry of A) {
          entry.family = 4;
          entry.expires = now + entry.ttl * 1e3;
          aTtl = Math.max(aTtl, entry.ttl);
        }
        for (const entry of AAAA) {
          entry.family = 6;
          entry.expires = now + entry.ttl * 1e3;
          aaaaTtl = Math.max(aaaaTtl, entry.ttl);
        }
        if (A.length > 0) {
          if (AAAA.length > 0) {
            cacheTtl = Math.min(aTtl, aaaaTtl);
          } else {
            cacheTtl = aTtl;
          }
        } else {
          cacheTtl = aaaaTtl;
        }
        return {
          entries: [
            ...A,
            ...AAAA
          ],
          cacheTtl
        };
      }
      async _lookup(hostname) {
        try {
          const entries = await this._dnsLookup(hostname, {
            all: true
          });
          return {
            entries,
            cacheTtl: 0
          };
        } catch (_) {
          return {
            entries: [],
            cacheTtl: 0
          };
        }
      }
      async _set(hostname, data, cacheTtl) {
        if (this.maxTtl > 0 && cacheTtl > 0) {
          cacheTtl = Math.min(cacheTtl, this.maxTtl) * 1e3;
          data[kExpires] = Date.now() + cacheTtl;
          try {
            await this._cache.set(hostname, data, cacheTtl);
          } catch (error) {
            this.lookupAsync = async () => {
              const cacheError = new Error("Cache Error. Please recreate the CacheableLookup instance.");
              cacheError.cause = error;
              throw cacheError;
            };
          }
          if (isIterable(this._cache)) {
            this._tick(cacheTtl);
          }
        }
      }
      async queryAndCache(hostname) {
        if (this._hostnamesToFallback.has(hostname)) {
          return this._dnsLookup(hostname, all);
        }
        let query = await this._resolve(hostname);
        if (query.entries.length === 0 && this._fallback) {
          query = await this._lookup(hostname);
          if (query.entries.length !== 0) {
            this._hostnamesToFallback.add(hostname);
          }
        }
        const cacheTtl = query.entries.length === 0 ? this.errorTtl : query.cacheTtl;
        await this._set(hostname, query.entries, cacheTtl);
        return query.entries;
      }
      _tick(ms) {
        const nextRemovalTime = this._nextRemovalTime;
        if (!nextRemovalTime || ms < nextRemovalTime) {
          clearTimeout(this._removalTimeout);
          this._nextRemovalTime = ms;
          this._removalTimeout = setTimeout(() => {
            this._nextRemovalTime = false;
            let nextExpiry = Infinity;
            const now = Date.now();
            for (const [hostname, entries] of this._cache) {
              const expires = entries[kExpires];
              if (now >= expires) {
                this._cache.delete(hostname);
              } else if (expires < nextExpiry) {
                nextExpiry = expires;
              }
            }
            if (nextExpiry !== Infinity) {
              this._tick(nextExpiry - now);
            }
          }, ms);
          if (this._removalTimeout.unref) {
            this._removalTimeout.unref();
          }
        }
      }
      install(agent) {
        verifyAgent(agent);
        if (kCacheableLookupCreateConnection in agent) {
          throw new Error("CacheableLookup has been already installed");
        }
        agent[kCacheableLookupCreateConnection] = agent.createConnection;
        agent[kCacheableLookupInstance] = this;
        agent.createConnection = (options, callback) => {
          if (!("lookup" in options)) {
            options.lookup = this.lookup;
          }
          return agent[kCacheableLookupCreateConnection](options, callback);
        };
      }
      uninstall(agent) {
        verifyAgent(agent);
        if (agent[kCacheableLookupCreateConnection]) {
          if (agent[kCacheableLookupInstance] !== this) {
            throw new Error("The agent is not owned by this CacheableLookup instance");
          }
          agent.createConnection = agent[kCacheableLookupCreateConnection];
          delete agent[kCacheableLookupCreateConnection];
          delete agent[kCacheableLookupInstance];
        }
      }
      updateInterfaceInfo() {
        const { _iface } = this;
        this._iface = getIfaceInfo();
        if (_iface.has4 && !this._iface.has4 || _iface.has6 && !this._iface.has6) {
          this._cache.clear();
        }
      }
      clear(hostname) {
        if (hostname) {
          this._cache.delete(hostname);
          return;
        }
        this._cache.clear();
      }
    };
    module2.exports = CacheableLookup;
    module2.exports.default = CacheableLookup;
  }
});

// node_modules/normalize-url/index.js
var require_normalize_url = __commonJS({
  "node_modules/normalize-url/index.js"(exports2, module2) {
    "use strict";
    var DATA_URL_DEFAULT_MIME_TYPE = "text/plain";
    var DATA_URL_DEFAULT_CHARSET = "us-ascii";
    var testParameter = (name, filters) => {
      return filters.some((filter2) => filter2 instanceof RegExp ? filter2.test(name) : filter2 === name);
    };
    var normalizeDataURL = (urlString, { stripHash }) => {
      const match = /^data:(?<type>[^,]*?),(?<data>[^#]*?)(?:#(?<hash>.*))?$/.exec(urlString);
      if (!match) {
        throw new Error(`Invalid URL: ${urlString}`);
      }
      let { type, data, hash } = match.groups;
      const mediaType = type.split(";");
      hash = stripHash ? "" : hash;
      let isBase64 = false;
      if (mediaType[mediaType.length - 1] === "base64") {
        mediaType.pop();
        isBase64 = true;
      }
      const mimeType = (mediaType.shift() || "").toLowerCase();
      const attributes = mediaType.map((attribute) => {
        let [key, value = ""] = attribute.split("=").map((string) => string.trim());
        if (key === "charset") {
          value = value.toLowerCase();
          if (value === DATA_URL_DEFAULT_CHARSET) {
            return "";
          }
        }
        return `${key}${value ? `=${value}` : ""}`;
      }).filter(Boolean);
      const normalizedMediaType = [
        ...attributes
      ];
      if (isBase64) {
        normalizedMediaType.push("base64");
      }
      if (normalizedMediaType.length !== 0 || mimeType && mimeType !== DATA_URL_DEFAULT_MIME_TYPE) {
        normalizedMediaType.unshift(mimeType);
      }
      return `data:${normalizedMediaType.join(";")},${isBase64 ? data.trim() : data}${hash ? `#${hash}` : ""}`;
    };
    var normalizeUrl = (urlString, options) => {
      options = {
        defaultProtocol: "http:",
        normalizeProtocol: true,
        forceHttp: false,
        forceHttps: false,
        stripAuthentication: true,
        stripHash: false,
        stripTextFragment: true,
        stripWWW: true,
        removeQueryParameters: [/^utm_\w+/i],
        removeTrailingSlash: true,
        removeSingleSlash: true,
        removeDirectoryIndex: false,
        sortQueryParameters: true,
        ...options
      };
      urlString = urlString.trim();
      if (/^data:/i.test(urlString)) {
        return normalizeDataURL(urlString, options);
      }
      if (/^view-source:/i.test(urlString)) {
        throw new Error("`view-source:` is not supported as it is a non-standard protocol");
      }
      const hasRelativeProtocol = urlString.startsWith("//");
      const isRelativeUrl = !hasRelativeProtocol && /^\.*\//.test(urlString);
      if (!isRelativeUrl) {
        urlString = urlString.replace(/^(?!(?:\w+:)?\/\/)|^\/\//, options.defaultProtocol);
      }
      const urlObj = new URL(urlString);
      if (options.forceHttp && options.forceHttps) {
        throw new Error("The `forceHttp` and `forceHttps` options cannot be used together");
      }
      if (options.forceHttp && urlObj.protocol === "https:") {
        urlObj.protocol = "http:";
      }
      if (options.forceHttps && urlObj.protocol === "http:") {
        urlObj.protocol = "https:";
      }
      if (options.stripAuthentication) {
        urlObj.username = "";
        urlObj.password = "";
      }
      if (options.stripHash) {
        urlObj.hash = "";
      } else if (options.stripTextFragment) {
        urlObj.hash = urlObj.hash.replace(/#?:~:text.*?$/i, "");
      }
      if (urlObj.pathname) {
        urlObj.pathname = urlObj.pathname.replace(/(?<!\b(?:[a-z][a-z\d+\-.]{1,50}:))\/{2,}/g, "/");
      }
      if (urlObj.pathname) {
        try {
          urlObj.pathname = decodeURI(urlObj.pathname);
        } catch (_) {
        }
      }
      if (options.removeDirectoryIndex === true) {
        options.removeDirectoryIndex = [/^index\.[a-z]+$/];
      }
      if (Array.isArray(options.removeDirectoryIndex) && options.removeDirectoryIndex.length > 0) {
        let pathComponents = urlObj.pathname.split("/");
        const lastComponent = pathComponents[pathComponents.length - 1];
        if (testParameter(lastComponent, options.removeDirectoryIndex)) {
          pathComponents = pathComponents.slice(0, pathComponents.length - 1);
          urlObj.pathname = pathComponents.slice(1).join("/") + "/";
        }
      }
      if (urlObj.hostname) {
        urlObj.hostname = urlObj.hostname.replace(/\.$/, "");
        if (options.stripWWW && /^www\.(?!www\.)(?:[a-z\-\d]{1,63})\.(?:[a-z.\-\d]{2,63})$/.test(urlObj.hostname)) {
          urlObj.hostname = urlObj.hostname.replace(/^www\./, "");
        }
      }
      if (Array.isArray(options.removeQueryParameters)) {
        for (const key of [...urlObj.searchParams.keys()]) {
          if (testParameter(key, options.removeQueryParameters)) {
            urlObj.searchParams.delete(key);
          }
        }
      }
      if (options.removeQueryParameters === true) {
        urlObj.search = "";
      }
      if (options.sortQueryParameters) {
        urlObj.searchParams.sort();
      }
      if (options.removeTrailingSlash) {
        urlObj.pathname = urlObj.pathname.replace(/\/$/, "");
      }
      const oldUrlString = urlString;
      urlString = urlObj.toString();
      if (!options.removeSingleSlash && urlObj.pathname === "/" && !oldUrlString.endsWith("/") && urlObj.hash === "") {
        urlString = urlString.replace(/\/$/, "");
      }
      if ((options.removeTrailingSlash || urlObj.pathname === "/") && urlObj.hash === "" && options.removeSingleSlash) {
        urlString = urlString.replace(/\/$/, "");
      }
      if (hasRelativeProtocol && !options.normalizeProtocol) {
        urlString = urlString.replace(/^http:\/\//, "//");
      }
      if (options.stripProtocol) {
        urlString = urlString.replace(/^(?:https?:)?\/\//, "");
      }
      return urlString;
    };
    module2.exports = normalizeUrl;
  }
});

// node_modules/wrappy/wrappy.js
var require_wrappy = __commonJS({
  "node_modules/wrappy/wrappy.js"(exports2, module2) {
    module2.exports = wrappy;
    function wrappy(fn3, cb) {
      if (fn3 && cb)
        return wrappy(fn3)(cb);
      if (typeof fn3 !== "function")
        throw new TypeError("need wrapper function");
      Object.keys(fn3).forEach(function(k) {
        wrapper[k] = fn3[k];
      });
      return wrapper;
      function wrapper() {
        var args2 = new Array(arguments.length);
        for (var i = 0; i < args2.length; i++) {
          args2[i] = arguments[i];
        }
        var ret = fn3.apply(this, args2);
        var cb2 = args2[args2.length - 1];
        if (typeof ret === "function" && ret !== cb2) {
          Object.keys(cb2).forEach(function(k) {
            ret[k] = cb2[k];
          });
        }
        return ret;
      }
    }
  }
});

// node_modules/once/once.js
var require_once = __commonJS({
  "node_modules/once/once.js"(exports2, module2) {
    var wrappy = require_wrappy();
    module2.exports = wrappy(once);
    module2.exports.strict = wrappy(onceStrict);
    once.proto = once(function() {
      Object.defineProperty(Function.prototype, "once", {
        value: function() {
          return once(this);
        },
        configurable: true
      });
      Object.defineProperty(Function.prototype, "onceStrict", {
        value: function() {
          return onceStrict(this);
        },
        configurable: true
      });
    });
    function once(fn3) {
      var f = function() {
        if (f.called)
          return f.value;
        f.called = true;
        return f.value = fn3.apply(this, arguments);
      };
      f.called = false;
      return f;
    }
    function onceStrict(fn3) {
      var f = function() {
        if (f.called)
          throw new Error(f.onceError);
        f.called = true;
        return f.value = fn3.apply(this, arguments);
      };
      var name = fn3.name || "Function wrapped with `once`";
      f.onceError = name + " shouldn't be called more than once";
      f.called = false;
      return f;
    }
  }
});

// node_modules/end-of-stream/index.js
var require_end_of_stream = __commonJS({
  "node_modules/end-of-stream/index.js"(exports2, module2) {
    var once = require_once();
    var noop = function() {
    };
    var isRequest = function(stream) {
      return stream.setHeader && typeof stream.abort === "function";
    };
    var isChildProcess = function(stream) {
      return stream.stdio && Array.isArray(stream.stdio) && stream.stdio.length === 3;
    };
    var eos = function(stream, opts, callback) {
      if (typeof opts === "function")
        return eos(stream, null, opts);
      if (!opts)
        opts = {};
      callback = once(callback || noop);
      var ws = stream._writableState;
      var rs = stream._readableState;
      var readable = opts.readable || opts.readable !== false && stream.readable;
      var writable = opts.writable || opts.writable !== false && stream.writable;
      var cancelled = false;
      var onlegacyfinish = function() {
        if (!stream.writable)
          onfinish();
      };
      var onfinish = function() {
        writable = false;
        if (!readable)
          callback.call(stream);
      };
      var onend = function() {
        readable = false;
        if (!writable)
          callback.call(stream);
      };
      var onexit = function(exitCode) {
        callback.call(stream, exitCode ? new Error("exited with error code: " + exitCode) : null);
      };
      var onerror = function(err) {
        callback.call(stream, err);
      };
      var onclose = function() {
        process.nextTick(onclosenexttick);
      };
      var onclosenexttick = function() {
        if (cancelled)
          return;
        if (readable && !(rs && (rs.ended && !rs.destroyed)))
          return callback.call(stream, new Error("premature close"));
        if (writable && !(ws && (ws.ended && !ws.destroyed)))
          return callback.call(stream, new Error("premature close"));
      };
      var onrequest = function() {
        stream.req.on("finish", onfinish);
      };
      if (isRequest(stream)) {
        stream.on("complete", onfinish);
        stream.on("abort", onclose);
        if (stream.req)
          onrequest();
        else
          stream.on("request", onrequest);
      } else if (writable && !ws) {
        stream.on("end", onlegacyfinish);
        stream.on("close", onlegacyfinish);
      }
      if (isChildProcess(stream))
        stream.on("exit", onexit);
      stream.on("end", onend);
      stream.on("finish", onfinish);
      if (opts.error !== false)
        stream.on("error", onerror);
      stream.on("close", onclose);
      return function() {
        cancelled = true;
        stream.removeListener("complete", onfinish);
        stream.removeListener("abort", onclose);
        stream.removeListener("request", onrequest);
        if (stream.req)
          stream.req.removeListener("finish", onfinish);
        stream.removeListener("end", onlegacyfinish);
        stream.removeListener("close", onlegacyfinish);
        stream.removeListener("finish", onfinish);
        stream.removeListener("exit", onexit);
        stream.removeListener("end", onend);
        stream.removeListener("error", onerror);
        stream.removeListener("close", onclose);
      };
    };
    module2.exports = eos;
  }
});

// node_modules/pump/index.js
var require_pump = __commonJS({
  "node_modules/pump/index.js"(exports2, module2) {
    var once = require_once();
    var eos = require_end_of_stream();
    var fs = require("fs");
    var noop = function() {
    };
    var ancient = /^v?\.0/.test(process.version);
    var isFn = function(fn3) {
      return typeof fn3 === "function";
    };
    var isFS = function(stream) {
      if (!ancient)
        return false;
      if (!fs)
        return false;
      return (stream instanceof (fs.ReadStream || noop) || stream instanceof (fs.WriteStream || noop)) && isFn(stream.close);
    };
    var isRequest = function(stream) {
      return stream.setHeader && isFn(stream.abort);
    };
    var destroyer = function(stream, reading, writing, callback) {
      callback = once(callback);
      var closed = false;
      stream.on("close", function() {
        closed = true;
      });
      eos(stream, { readable: reading, writable: writing }, function(err) {
        if (err)
          return callback(err);
        closed = true;
        callback();
      });
      var destroyed = false;
      return function(err) {
        if (closed)
          return;
        if (destroyed)
          return;
        destroyed = true;
        if (isFS(stream))
          return stream.close(noop);
        if (isRequest(stream))
          return stream.abort();
        if (isFn(stream.destroy))
          return stream.destroy();
        callback(err || new Error("stream was destroyed"));
      };
    };
    var call = function(fn3) {
      fn3();
    };
    var pipe = function(from, to) {
      return from.pipe(to);
    };
    var pump = function() {
      var streams = Array.prototype.slice.call(arguments);
      var callback = isFn(streams[streams.length - 1] || noop) && streams.pop() || noop;
      if (Array.isArray(streams[0]))
        streams = streams[0];
      if (streams.length < 2)
        throw new Error("pump requires two streams per minimum");
      var error;
      var destroys = streams.map(function(stream, i) {
        var reading = i < streams.length - 1;
        var writing = i > 0;
        return destroyer(stream, reading, writing, function(err) {
          if (!error)
            error = err;
          if (err)
            destroys.forEach(call);
          if (reading)
            return;
          destroys.forEach(call);
          callback(error);
        });
      });
      return streams.reduce(pipe);
    };
    module2.exports = pump;
  }
});

// node_modules/get-stream/buffer-stream.js
var require_buffer_stream = __commonJS({
  "node_modules/get-stream/buffer-stream.js"(exports2, module2) {
    "use strict";
    var { PassThrough: PassThroughStream } = require("stream");
    module2.exports = (options) => {
      options = { ...options };
      const { array } = options;
      let { encoding } = options;
      const isBuffer = encoding === "buffer";
      let objectMode = false;
      if (array) {
        objectMode = !(encoding || isBuffer);
      } else {
        encoding = encoding || "utf8";
      }
      if (isBuffer) {
        encoding = null;
      }
      const stream = new PassThroughStream({ objectMode });
      if (encoding) {
        stream.setEncoding(encoding);
      }
      let length = 0;
      const chunks = [];
      stream.on("data", (chunk) => {
        chunks.push(chunk);
        if (objectMode) {
          length = chunks.length;
        } else {
          length += chunk.length;
        }
      });
      stream.getBufferedValue = () => {
        if (array) {
          return chunks;
        }
        return isBuffer ? Buffer.concat(chunks, length) : chunks.join("");
      };
      stream.getBufferedLength = () => length;
      return stream;
    };
  }
});

// node_modules/get-stream/index.js
var require_get_stream = __commonJS({
  "node_modules/get-stream/index.js"(exports2, module2) {
    "use strict";
    var { constants: BufferConstants } = require("buffer");
    var pump = require_pump();
    var bufferStream = require_buffer_stream();
    var MaxBufferError = class extends Error {
      constructor() {
        super("maxBuffer exceeded");
        this.name = "MaxBufferError";
      }
    };
    async function getStream(inputStream, options) {
      if (!inputStream) {
        return Promise.reject(new Error("Expected a stream"));
      }
      options = {
        maxBuffer: Infinity,
        ...options
      };
      const { maxBuffer } = options;
      let stream;
      await new Promise((resolve, reject) => {
        const rejectPromise = (error) => {
          if (error && stream.getBufferedLength() <= BufferConstants.MAX_LENGTH) {
            error.bufferedData = stream.getBufferedValue();
          }
          reject(error);
        };
        stream = pump(inputStream, bufferStream(options), (error) => {
          if (error) {
            rejectPromise(error);
            return;
          }
          resolve();
        });
        stream.on("data", () => {
          if (stream.getBufferedLength() > maxBuffer) {
            rejectPromise(new MaxBufferError());
          }
        });
      });
      return stream.getBufferedValue();
    }
    module2.exports = getStream;
    module2.exports.default = getStream;
    module2.exports.buffer = (stream, options) => getStream(stream, { ...options, encoding: "buffer" });
    module2.exports.array = (stream, options) => getStream(stream, { ...options, array: true });
    module2.exports.MaxBufferError = MaxBufferError;
  }
});

// node_modules/http-cache-semantics/index.js
var require_http_cache_semantics = __commonJS({
  "node_modules/http-cache-semantics/index.js"(exports2, module2) {
    "use strict";
    var statusCodeCacheableByDefault = /* @__PURE__ */ new Set([
      200,
      203,
      204,
      206,
      300,
      301,
      404,
      405,
      410,
      414,
      501
    ]);
    var understoodStatuses = /* @__PURE__ */ new Set([
      200,
      203,
      204,
      300,
      301,
      302,
      303,
      307,
      308,
      404,
      405,
      410,
      414,
      501
    ]);
    var errorStatusCodes = /* @__PURE__ */ new Set([
      500,
      502,
      503,
      504
    ]);
    var hopByHopHeaders = {
      date: true,
      connection: true,
      "keep-alive": true,
      "proxy-authenticate": true,
      "proxy-authorization": true,
      te: true,
      trailer: true,
      "transfer-encoding": true,
      upgrade: true
    };
    var excludedFromRevalidationUpdate = {
      "content-length": true,
      "content-encoding": true,
      "transfer-encoding": true,
      "content-range": true
    };
    function toNumberOrZero(s) {
      const n = parseInt(s, 10);
      return isFinite(n) ? n : 0;
    }
    function isErrorResponse(response) {
      if (!response) {
        return true;
      }
      return errorStatusCodes.has(response.status);
    }
    function parseCacheControl(header) {
      const cc = {};
      if (!header)
        return cc;
      const parts = header.trim().split(/\s*,\s*/);
      for (const part of parts) {
        const [k, v] = part.split(/\s*=\s*/, 2);
        cc[k] = v === void 0 ? true : v.replace(/^"|"$/g, "");
      }
      return cc;
    }
    function formatCacheControl(cc) {
      let parts = [];
      for (const k in cc) {
        const v = cc[k];
        parts.push(v === true ? k : k + "=" + v);
      }
      if (!parts.length) {
        return void 0;
      }
      return parts.join(", ");
    }
    module2.exports = class CachePolicy {
      constructor(req, res, {
        shared,
        cacheHeuristic,
        immutableMinTimeToLive,
        ignoreCargoCult,
        _fromObject
      } = {}) {
        if (_fromObject) {
          this._fromObject(_fromObject);
          return;
        }
        if (!res || !res.headers) {
          throw Error("Response headers missing");
        }
        this._assertRequestHasHeaders(req);
        this._responseTime = this.now();
        this._isShared = shared !== false;
        this._cacheHeuristic = cacheHeuristic !== void 0 ? cacheHeuristic : 0.1;
        this._immutableMinTtl = immutableMinTimeToLive !== void 0 ? immutableMinTimeToLive : 24 * 3600 * 1e3;
        this._status = "status" in res ? res.status : 200;
        this._resHeaders = res.headers;
        this._rescc = parseCacheControl(res.headers["cache-control"]);
        this._method = "method" in req ? req.method : "GET";
        this._url = req.url;
        this._host = req.headers.host;
        this._noAuthorization = !req.headers.authorization;
        this._reqHeaders = res.headers.vary ? req.headers : null;
        this._reqcc = parseCacheControl(req.headers["cache-control"]);
        if (ignoreCargoCult && "pre-check" in this._rescc && "post-check" in this._rescc) {
          delete this._rescc["pre-check"];
          delete this._rescc["post-check"];
          delete this._rescc["no-cache"];
          delete this._rescc["no-store"];
          delete this._rescc["must-revalidate"];
          this._resHeaders = Object.assign({}, this._resHeaders, {
            "cache-control": formatCacheControl(this._rescc)
          });
          delete this._resHeaders.expires;
          delete this._resHeaders.pragma;
        }
        if (res.headers["cache-control"] == null && /no-cache/.test(res.headers.pragma)) {
          this._rescc["no-cache"] = true;
        }
      }
      now() {
        return Date.now();
      }
      storable() {
        return !!(!this._reqcc["no-store"] && (this._method === "GET" || this._method === "HEAD" || this._method === "POST" && this._hasExplicitExpiration()) && understoodStatuses.has(this._status) && !this._rescc["no-store"] && (!this._isShared || !this._rescc.private) && (!this._isShared || this._noAuthorization || this._allowsStoringAuthenticated()) && (this._resHeaders.expires || this._rescc["max-age"] || this._isShared && this._rescc["s-maxage"] || this._rescc.public || statusCodeCacheableByDefault.has(this._status)));
      }
      _hasExplicitExpiration() {
        return this._isShared && this._rescc["s-maxage"] || this._rescc["max-age"] || this._resHeaders.expires;
      }
      _assertRequestHasHeaders(req) {
        if (!req || !req.headers) {
          throw Error("Request headers missing");
        }
      }
      satisfiesWithoutRevalidation(req) {
        this._assertRequestHasHeaders(req);
        const requestCC = parseCacheControl(req.headers["cache-control"]);
        if (requestCC["no-cache"] || /no-cache/.test(req.headers.pragma)) {
          return false;
        }
        if (requestCC["max-age"] && this.age() > requestCC["max-age"]) {
          return false;
        }
        if (requestCC["min-fresh"] && this.timeToLive() < 1e3 * requestCC["min-fresh"]) {
          return false;
        }
        if (this.stale()) {
          const allowsStale = requestCC["max-stale"] && !this._rescc["must-revalidate"] && (requestCC["max-stale"] === true || requestCC["max-stale"] > this.age() - this.maxAge());
          if (!allowsStale) {
            return false;
          }
        }
        return this._requestMatches(req, false);
      }
      _requestMatches(req, allowHeadMethod) {
        return (!this._url || this._url === req.url) && this._host === req.headers.host && (!req.method || this._method === req.method || allowHeadMethod && req.method === "HEAD") && this._varyMatches(req);
      }
      _allowsStoringAuthenticated() {
        return this._rescc["must-revalidate"] || this._rescc.public || this._rescc["s-maxage"];
      }
      _varyMatches(req) {
        if (!this._resHeaders.vary) {
          return true;
        }
        if (this._resHeaders.vary === "*") {
          return false;
        }
        const fields = this._resHeaders.vary.trim().toLowerCase().split(/\s*,\s*/);
        for (const name of fields) {
          if (req.headers[name] !== this._reqHeaders[name])
            return false;
        }
        return true;
      }
      _copyWithoutHopByHopHeaders(inHeaders) {
        const headers = {};
        for (const name in inHeaders) {
          if (hopByHopHeaders[name])
            continue;
          headers[name] = inHeaders[name];
        }
        if (inHeaders.connection) {
          const tokens = inHeaders.connection.trim().split(/\s*,\s*/);
          for (const name of tokens) {
            delete headers[name];
          }
        }
        if (headers.warning) {
          const warnings = headers.warning.split(/,/).filter((warning) => {
            return !/^\s*1[0-9][0-9]/.test(warning);
          });
          if (!warnings.length) {
            delete headers.warning;
          } else {
            headers.warning = warnings.join(",").trim();
          }
        }
        return headers;
      }
      responseHeaders() {
        const headers = this._copyWithoutHopByHopHeaders(this._resHeaders);
        const age = this.age();
        if (age > 3600 * 24 && !this._hasExplicitExpiration() && this.maxAge() > 3600 * 24) {
          headers.warning = (headers.warning ? `${headers.warning}, ` : "") + '113 - "rfc7234 5.5.4"';
        }
        headers.age = `${Math.round(age)}`;
        headers.date = new Date(this.now()).toUTCString();
        return headers;
      }
      date() {
        const serverDate = Date.parse(this._resHeaders.date);
        if (isFinite(serverDate)) {
          return serverDate;
        }
        return this._responseTime;
      }
      age() {
        let age = this._ageValue();
        const residentTime = (this.now() - this._responseTime) / 1e3;
        return age + residentTime;
      }
      _ageValue() {
        return toNumberOrZero(this._resHeaders.age);
      }
      maxAge() {
        if (!this.storable() || this._rescc["no-cache"]) {
          return 0;
        }
        if (this._isShared && (this._resHeaders["set-cookie"] && !this._rescc.public && !this._rescc.immutable)) {
          return 0;
        }
        if (this._resHeaders.vary === "*") {
          return 0;
        }
        if (this._isShared) {
          if (this._rescc["proxy-revalidate"]) {
            return 0;
          }
          if (this._rescc["s-maxage"]) {
            return toNumberOrZero(this._rescc["s-maxage"]);
          }
        }
        if (this._rescc["max-age"]) {
          return toNumberOrZero(this._rescc["max-age"]);
        }
        const defaultMinTtl = this._rescc.immutable ? this._immutableMinTtl : 0;
        const serverDate = this.date();
        if (this._resHeaders.expires) {
          const expires = Date.parse(this._resHeaders.expires);
          if (Number.isNaN(expires) || expires < serverDate) {
            return 0;
          }
          return Math.max(defaultMinTtl, (expires - serverDate) / 1e3);
        }
        if (this._resHeaders["last-modified"]) {
          const lastModified = Date.parse(this._resHeaders["last-modified"]);
          if (isFinite(lastModified) && serverDate > lastModified) {
            return Math.max(defaultMinTtl, (serverDate - lastModified) / 1e3 * this._cacheHeuristic);
          }
        }
        return defaultMinTtl;
      }
      timeToLive() {
        const age = this.maxAge() - this.age();
        const staleIfErrorAge = age + toNumberOrZero(this._rescc["stale-if-error"]);
        const staleWhileRevalidateAge = age + toNumberOrZero(this._rescc["stale-while-revalidate"]);
        return Math.max(0, age, staleIfErrorAge, staleWhileRevalidateAge) * 1e3;
      }
      stale() {
        return this.maxAge() <= this.age();
      }
      _useStaleIfError() {
        return this.maxAge() + toNumberOrZero(this._rescc["stale-if-error"]) > this.age();
      }
      useStaleWhileRevalidate() {
        return this.maxAge() + toNumberOrZero(this._rescc["stale-while-revalidate"]) > this.age();
      }
      static fromObject(obj) {
        return new this(void 0, void 0, { _fromObject: obj });
      }
      _fromObject(obj) {
        if (this._responseTime)
          throw Error("Reinitialized");
        if (!obj || obj.v !== 1)
          throw Error("Invalid serialization");
        this._responseTime = obj.t;
        this._isShared = obj.sh;
        this._cacheHeuristic = obj.ch;
        this._immutableMinTtl = obj.imm !== void 0 ? obj.imm : 24 * 3600 * 1e3;
        this._status = obj.st;
        this._resHeaders = obj.resh;
        this._rescc = obj.rescc;
        this._method = obj.m;
        this._url = obj.u;
        this._host = obj.h;
        this._noAuthorization = obj.a;
        this._reqHeaders = obj.reqh;
        this._reqcc = obj.reqcc;
      }
      toObject() {
        return {
          v: 1,
          t: this._responseTime,
          sh: this._isShared,
          ch: this._cacheHeuristic,
          imm: this._immutableMinTtl,
          st: this._status,
          resh: this._resHeaders,
          rescc: this._rescc,
          m: this._method,
          u: this._url,
          h: this._host,
          a: this._noAuthorization,
          reqh: this._reqHeaders,
          reqcc: this._reqcc
        };
      }
      revalidationHeaders(incomingReq) {
        this._assertRequestHasHeaders(incomingReq);
        const headers = this._copyWithoutHopByHopHeaders(incomingReq.headers);
        delete headers["if-range"];
        if (!this._requestMatches(incomingReq, true) || !this.storable()) {
          delete headers["if-none-match"];
          delete headers["if-modified-since"];
          return headers;
        }
        if (this._resHeaders.etag) {
          headers["if-none-match"] = headers["if-none-match"] ? `${headers["if-none-match"]}, ${this._resHeaders.etag}` : this._resHeaders.etag;
        }
        const forbidsWeakValidators = headers["accept-ranges"] || headers["if-match"] || headers["if-unmodified-since"] || this._method && this._method != "GET";
        if (forbidsWeakValidators) {
          delete headers["if-modified-since"];
          if (headers["if-none-match"]) {
            const etags = headers["if-none-match"].split(/,/).filter((etag) => {
              return !/^\s*W\//.test(etag);
            });
            if (!etags.length) {
              delete headers["if-none-match"];
            } else {
              headers["if-none-match"] = etags.join(",").trim();
            }
          }
        } else if (this._resHeaders["last-modified"] && !headers["if-modified-since"]) {
          headers["if-modified-since"] = this._resHeaders["last-modified"];
        }
        return headers;
      }
      revalidatedPolicy(request, response) {
        this._assertRequestHasHeaders(request);
        if (this._useStaleIfError() && isErrorResponse(response)) {
          return {
            modified: false,
            matches: false,
            policy: this
          };
        }
        if (!response || !response.headers) {
          throw Error("Response headers missing");
        }
        let matches = false;
        if (response.status !== void 0 && response.status != 304) {
          matches = false;
        } else if (response.headers.etag && !/^\s*W\//.test(response.headers.etag)) {
          matches = this._resHeaders.etag && this._resHeaders.etag.replace(/^\s*W\//, "") === response.headers.etag;
        } else if (this._resHeaders.etag && response.headers.etag) {
          matches = this._resHeaders.etag.replace(/^\s*W\//, "") === response.headers.etag.replace(/^\s*W\//, "");
        } else if (this._resHeaders["last-modified"]) {
          matches = this._resHeaders["last-modified"] === response.headers["last-modified"];
        } else {
          if (!this._resHeaders.etag && !this._resHeaders["last-modified"] && !response.headers.etag && !response.headers["last-modified"]) {
            matches = true;
          }
        }
        if (!matches) {
          return {
            policy: new this.constructor(request, response),
            modified: response.status != 304,
            matches: false
          };
        }
        const headers = {};
        for (const k in this._resHeaders) {
          headers[k] = k in response.headers && !excludedFromRevalidationUpdate[k] ? response.headers[k] : this._resHeaders[k];
        }
        const newResponse = Object.assign({}, response, {
          status: this._status,
          method: this._method,
          headers
        });
        return {
          policy: new this.constructor(request, newResponse, {
            shared: this._isShared,
            cacheHeuristic: this._cacheHeuristic,
            immutableMinTimeToLive: this._immutableMinTtl
          }),
          modified: false,
          matches: true
        };
      }
    };
  }
});

// node_modules/lowercase-keys/index.js
var require_lowercase_keys = __commonJS({
  "node_modules/lowercase-keys/index.js"(exports2, module2) {
    "use strict";
    module2.exports = (object) => {
      const result = {};
      for (const [key, value] of Object.entries(object)) {
        result[key.toLowerCase()] = value;
      }
      return result;
    };
  }
});

// node_modules/responselike/src/index.js
var require_src2 = __commonJS({
  "node_modules/responselike/src/index.js"(exports2, module2) {
    "use strict";
    var Readable = require("stream").Readable;
    var lowercaseKeys = require_lowercase_keys();
    var Response = class extends Readable {
      constructor(statusCode, headers, body2, url) {
        if (typeof statusCode !== "number") {
          throw new TypeError("Argument `statusCode` should be a number");
        }
        if (typeof headers !== "object") {
          throw new TypeError("Argument `headers` should be an object");
        }
        if (!(body2 instanceof Buffer)) {
          throw new TypeError("Argument `body` should be a buffer");
        }
        if (typeof url !== "string") {
          throw new TypeError("Argument `url` should be a string");
        }
        super();
        this.statusCode = statusCode;
        this.headers = lowercaseKeys(headers);
        this.body = body2;
        this.url = url;
      }
      _read() {
        this.push(this.body);
        this.push(null);
      }
    };
    module2.exports = Response;
  }
});

// node_modules/clone-response/node_modules/mimic-response/index.js
var require_mimic_response = __commonJS({
  "node_modules/clone-response/node_modules/mimic-response/index.js"(exports2, module2) {
    "use strict";
    var knownProps = [
      "destroy",
      "setTimeout",
      "socket",
      "headers",
      "trailers",
      "rawHeaders",
      "statusCode",
      "httpVersion",
      "httpVersionMinor",
      "httpVersionMajor",
      "rawTrailers",
      "statusMessage"
    ];
    module2.exports = (fromStream, toStream) => {
      const fromProps = new Set(Object.keys(fromStream).concat(knownProps));
      for (const prop of fromProps) {
        if (prop in toStream) {
          continue;
        }
        toStream[prop] = typeof fromStream[prop] === "function" ? fromStream[prop].bind(fromStream) : fromStream[prop];
      }
    };
  }
});

// node_modules/clone-response/src/index.js
var require_src3 = __commonJS({
  "node_modules/clone-response/src/index.js"(exports2, module2) {
    "use strict";
    var PassThrough = require("stream").PassThrough;
    var mimicResponse = require_mimic_response();
    var cloneResponse = (response) => {
      if (!(response && response.pipe)) {
        throw new TypeError("Parameter `response` must be a response stream.");
      }
      const clone = new PassThrough();
      mimicResponse(response, clone);
      return response.pipe(clone);
    };
    module2.exports = cloneResponse;
  }
});

// node_modules/json-buffer/index.js
var require_json_buffer = __commonJS({
  "node_modules/json-buffer/index.js"(exports2) {
    exports2.stringify = function stringify(o) {
      if (typeof o == "undefined")
        return o;
      if (o && Buffer.isBuffer(o))
        return JSON.stringify(":base64:" + o.toString("base64"));
      if (o && o.toJSON)
        o = o.toJSON();
      if (o && typeof o === "object") {
        var s = "";
        var array = Array.isArray(o);
        s = array ? "[" : "{";
        var first3 = true;
        for (var k in o) {
          var ignore = typeof o[k] == "function" || !array && typeof o[k] === "undefined";
          if (Object.hasOwnProperty.call(o, k) && !ignore) {
            if (!first3)
              s += ",";
            first3 = false;
            if (array) {
              if (o[k] == void 0)
                s += "null";
              else
                s += stringify(o[k]);
            } else if (o[k] !== void 0) {
              s += stringify(k) + ":" + stringify(o[k]);
            }
          }
        }
        s += array ? "]" : "}";
        return s;
      } else if (typeof o === "string") {
        return JSON.stringify(/^:/.test(o) ? ":" + o : o);
      } else if (typeof o === "undefined") {
        return "null";
      } else
        return JSON.stringify(o);
    };
    exports2.parse = function(s) {
      return JSON.parse(s, function(key, value) {
        if (typeof value === "string") {
          if (/^:base64:/.test(value))
            return Buffer.from(value.substring(8), "base64");
          else
            return /^:/.test(value) ? value.substring(1) : value;
        }
        return value;
      });
    };
  }
});

// node_modules/keyv/src/index.js
var require_src4 = __commonJS({
  "node_modules/keyv/src/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var JSONB = require_json_buffer();
    var loadStore = (options) => {
      const adapters = {
        redis: "@keyv/redis",
        mongodb: "@keyv/mongo",
        mongo: "@keyv/mongo",
        sqlite: "@keyv/sqlite",
        postgresql: "@keyv/postgres",
        postgres: "@keyv/postgres",
        mysql: "@keyv/mysql"
      };
      if (options.adapter || options.uri) {
        const adapter = options.adapter || /^[^:]*/.exec(options.uri)[0];
        return new (require(adapters[adapter]))(options);
      }
      return /* @__PURE__ */ new Map();
    };
    var Keyv = class extends EventEmitter {
      constructor(uri, options) {
        super();
        this.opts = Object.assign({
          namespace: "keyv",
          serialize: JSONB.stringify,
          deserialize: JSONB.parse
        }, typeof uri === "string" ? { uri } : uri, options);
        if (!this.opts.store) {
          const adapterOptions = Object.assign({}, this.opts);
          this.opts.store = loadStore(adapterOptions);
        }
        if (typeof this.opts.store.on === "function") {
          this.opts.store.on("error", (error) => this.emit("error", error));
        }
        this.opts.store.namespace = this.opts.namespace;
      }
      _getKeyPrefix(key) {
        return `${this.opts.namespace}:${key}`;
      }
      get(key, options) {
        const keyPrefixed = this._getKeyPrefix(key);
        const { store } = this.opts;
        return Promise.resolve().then(() => store.get(keyPrefixed)).then((data) => typeof data === "string" ? this.opts.deserialize(data) : data).then((data) => {
          if (data === void 0) {
            return void 0;
          }
          if (typeof data.expires === "number" && Date.now() > data.expires) {
            this.delete(key);
            return void 0;
          }
          return options && options.raw ? data : data.value;
        });
      }
      set(key, value, ttl) {
        const keyPrefixed = this._getKeyPrefix(key);
        if (typeof ttl === "undefined") {
          ttl = this.opts.ttl;
        }
        if (ttl === 0) {
          ttl = void 0;
        }
        const { store } = this.opts;
        return Promise.resolve().then(() => {
          const expires = typeof ttl === "number" ? Date.now() + ttl : null;
          value = { value, expires };
          return this.opts.serialize(value);
        }).then((value2) => store.set(keyPrefixed, value2, ttl)).then(() => true);
      }
      delete(key) {
        const keyPrefixed = this._getKeyPrefix(key);
        const { store } = this.opts;
        return Promise.resolve().then(() => store.delete(keyPrefixed));
      }
      clear() {
        const { store } = this.opts;
        return Promise.resolve().then(() => store.clear());
      }
    };
    module2.exports = Keyv;
  }
});

// node_modules/cacheable-request/src/index.js
var require_src5 = __commonJS({
  "node_modules/cacheable-request/src/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var urlLib = require("url");
    var normalizeUrl = require_normalize_url();
    var getStream = require_get_stream();
    var CachePolicy = require_http_cache_semantics();
    var Response = require_src2();
    var lowercaseKeys = require_lowercase_keys();
    var cloneResponse = require_src3();
    var Keyv = require_src4();
    var CacheableRequest = class {
      constructor(request, cacheAdapter) {
        if (typeof request !== "function") {
          throw new TypeError("Parameter `request` must be a function");
        }
        this.cache = new Keyv({
          uri: typeof cacheAdapter === "string" && cacheAdapter,
          store: typeof cacheAdapter !== "string" && cacheAdapter,
          namespace: "cacheable-request"
        });
        return this.createCacheableRequest(request);
      }
      createCacheableRequest(request) {
        return (opts, cb) => {
          let url;
          if (typeof opts === "string") {
            url = normalizeUrlObject(urlLib.parse(opts));
            opts = {};
          } else if (opts instanceof urlLib.URL) {
            url = normalizeUrlObject(urlLib.parse(opts.toString()));
            opts = {};
          } else {
            const [pathname, ...searchParts] = (opts.path || "").split("?");
            const search = searchParts.length > 0 ? `?${searchParts.join("?")}` : "";
            url = normalizeUrlObject({ ...opts, pathname, search });
          }
          opts = {
            headers: {},
            method: "GET",
            cache: true,
            strictTtl: false,
            automaticFailover: false,
            ...opts,
            ...urlObjectToRequestOptions(url)
          };
          opts.headers = lowercaseKeys(opts.headers);
          const ee = new EventEmitter();
          const normalizedUrlString = normalizeUrl(urlLib.format(url), {
            stripWWW: false,
            removeTrailingSlash: false,
            stripAuthentication: false
          });
          const key = `${opts.method}:${normalizedUrlString}`;
          let revalidate = false;
          let madeRequest = false;
          const makeRequest = (opts2) => {
            madeRequest = true;
            let requestErrored = false;
            let requestErrorCallback;
            const requestErrorPromise = new Promise((resolve) => {
              requestErrorCallback = () => {
                if (!requestErrored) {
                  requestErrored = true;
                  resolve();
                }
              };
            });
            const handler = (response) => {
              if (revalidate && !opts2.forceRefresh) {
                response.status = response.statusCode;
                const revalidatedPolicy = CachePolicy.fromObject(revalidate.cachePolicy).revalidatedPolicy(opts2, response);
                if (!revalidatedPolicy.modified) {
                  const headers = revalidatedPolicy.policy.responseHeaders();
                  response = new Response(revalidate.statusCode, headers, revalidate.body, revalidate.url);
                  response.cachePolicy = revalidatedPolicy.policy;
                  response.fromCache = true;
                }
              }
              if (!response.fromCache) {
                response.cachePolicy = new CachePolicy(opts2, response, opts2);
                response.fromCache = false;
              }
              let clonedResponse;
              if (opts2.cache && response.cachePolicy.storable()) {
                clonedResponse = cloneResponse(response);
                (async () => {
                  try {
                    const bodyPromise = getStream.buffer(response);
                    await Promise.race([
                      requestErrorPromise,
                      new Promise((resolve) => response.once("end", resolve))
                    ]);
                    if (requestErrored) {
                      return;
                    }
                    const body2 = await bodyPromise;
                    const value = {
                      cachePolicy: response.cachePolicy.toObject(),
                      url: response.url,
                      statusCode: response.fromCache ? revalidate.statusCode : response.statusCode,
                      body: body2
                    };
                    let ttl = opts2.strictTtl ? response.cachePolicy.timeToLive() : void 0;
                    if (opts2.maxTtl) {
                      ttl = ttl ? Math.min(ttl, opts2.maxTtl) : opts2.maxTtl;
                    }
                    await this.cache.set(key, value, ttl);
                  } catch (error) {
                    ee.emit("error", new CacheableRequest.CacheError(error));
                  }
                })();
              } else if (opts2.cache && revalidate) {
                (async () => {
                  try {
                    await this.cache.delete(key);
                  } catch (error) {
                    ee.emit("error", new CacheableRequest.CacheError(error));
                  }
                })();
              }
              ee.emit("response", clonedResponse || response);
              if (typeof cb === "function") {
                cb(clonedResponse || response);
              }
            };
            try {
              const req = request(opts2, handler);
              req.once("error", requestErrorCallback);
              req.once("abort", requestErrorCallback);
              ee.emit("request", req);
            } catch (error) {
              ee.emit("error", new CacheableRequest.RequestError(error));
            }
          };
          (async () => {
            const get2 = async (opts2) => {
              await Promise.resolve();
              const cacheEntry = opts2.cache ? await this.cache.get(key) : void 0;
              if (typeof cacheEntry === "undefined") {
                return makeRequest(opts2);
              }
              const policy = CachePolicy.fromObject(cacheEntry.cachePolicy);
              if (policy.satisfiesWithoutRevalidation(opts2) && !opts2.forceRefresh) {
                const headers = policy.responseHeaders();
                const response = new Response(cacheEntry.statusCode, headers, cacheEntry.body, cacheEntry.url);
                response.cachePolicy = policy;
                response.fromCache = true;
                ee.emit("response", response);
                if (typeof cb === "function") {
                  cb(response);
                }
              } else {
                revalidate = cacheEntry;
                opts2.headers = policy.revalidationHeaders(opts2);
                makeRequest(opts2);
              }
            };
            const errorHandler = (error) => ee.emit("error", new CacheableRequest.CacheError(error));
            this.cache.once("error", errorHandler);
            ee.on("response", () => this.cache.removeListener("error", errorHandler));
            try {
              await get2(opts);
            } catch (error) {
              if (opts.automaticFailover && !madeRequest) {
                makeRequest(opts);
              }
              ee.emit("error", new CacheableRequest.CacheError(error));
            }
          })();
          return ee;
        };
      }
    };
    function urlObjectToRequestOptions(url) {
      const options = { ...url };
      options.path = `${url.pathname || "/"}${url.search || ""}`;
      delete options.pathname;
      delete options.search;
      return options;
    }
    function normalizeUrlObject(url) {
      return {
        protocol: url.protocol,
        auth: url.auth,
        hostname: url.hostname || url.host || "localhost",
        port: url.port,
        pathname: url.pathname,
        search: url.search
      };
    }
    CacheableRequest.RequestError = class extends Error {
      constructor(error) {
        super(error.message);
        this.name = "RequestError";
        Object.assign(this, error);
      }
    };
    CacheableRequest.CacheError = class extends Error {
      constructor(error) {
        super(error.message);
        this.name = "CacheError";
        Object.assign(this, error);
      }
    };
    module2.exports = CacheableRequest;
  }
});

// node_modules/mimic-response/index.js
var require_mimic_response2 = __commonJS({
  "node_modules/mimic-response/index.js"(exports2, module2) {
    "use strict";
    var knownProperties = [
      "aborted",
      "complete",
      "headers",
      "httpVersion",
      "httpVersionMinor",
      "httpVersionMajor",
      "method",
      "rawHeaders",
      "rawTrailers",
      "setTimeout",
      "socket",
      "statusCode",
      "statusMessage",
      "trailers",
      "url"
    ];
    module2.exports = (fromStream, toStream) => {
      if (toStream._readableState.autoDestroy) {
        throw new Error("The second stream must have the `autoDestroy` option set to `false`");
      }
      const fromProperties = new Set(Object.keys(fromStream).concat(knownProperties));
      const properties = {};
      for (const property of fromProperties) {
        if (property in toStream) {
          continue;
        }
        properties[property] = {
          get() {
            const value = fromStream[property];
            const isFunction = typeof value === "function";
            return isFunction ? value.bind(fromStream) : value;
          },
          set(value) {
            fromStream[property] = value;
          },
          enumerable: true,
          configurable: false
        };
      }
      Object.defineProperties(toStream, properties);
      fromStream.once("aborted", () => {
        toStream.destroy();
        toStream.emit("aborted");
      });
      fromStream.once("close", () => {
        if (fromStream.complete) {
          if (toStream.readable) {
            toStream.once("end", () => {
              toStream.emit("close");
            });
          } else {
            toStream.emit("close");
          }
        } else {
          toStream.emit("close");
        }
      });
      return toStream;
    };
  }
});

// node_modules/decompress-response/index.js
var require_decompress_response = __commonJS({
  "node_modules/decompress-response/index.js"(exports2, module2) {
    "use strict";
    var { Transform, PassThrough } = require("stream");
    var zlib = require("zlib");
    var mimicResponse = require_mimic_response2();
    module2.exports = (response) => {
      const contentEncoding = (response.headers["content-encoding"] || "").toLowerCase();
      if (!["gzip", "deflate", "br"].includes(contentEncoding)) {
        return response;
      }
      const isBrotli = contentEncoding === "br";
      if (isBrotli && typeof zlib.createBrotliDecompress !== "function") {
        response.destroy(new Error("Brotli is not supported on Node.js < 12"));
        return response;
      }
      let isEmpty = true;
      const checker = new Transform({
        transform(data, _encoding, callback) {
          isEmpty = false;
          callback(null, data);
        },
        flush(callback) {
          callback();
        }
      });
      const finalStream = new PassThrough({
        autoDestroy: false,
        destroy(error, callback) {
          response.destroy();
          callback(error);
        }
      });
      const decompressStream = isBrotli ? zlib.createBrotliDecompress() : zlib.createUnzip();
      decompressStream.once("error", (error) => {
        if (isEmpty && !response.readable) {
          finalStream.end();
          return;
        }
        finalStream.destroy(error);
      });
      mimicResponse(response, finalStream);
      response.pipe(checker).pipe(decompressStream).pipe(finalStream);
      return finalStream;
    };
  }
});

// node_modules/quick-lru/index.js
var require_quick_lru = __commonJS({
  "node_modules/quick-lru/index.js"(exports2, module2) {
    "use strict";
    var QuickLRU = class {
      constructor(options = {}) {
        if (!(options.maxSize && options.maxSize > 0)) {
          throw new TypeError("`maxSize` must be a number greater than 0");
        }
        this.maxSize = options.maxSize;
        this.onEviction = options.onEviction;
        this.cache = /* @__PURE__ */ new Map();
        this.oldCache = /* @__PURE__ */ new Map();
        this._size = 0;
      }
      _set(key, value) {
        this.cache.set(key, value);
        this._size++;
        if (this._size >= this.maxSize) {
          this._size = 0;
          if (typeof this.onEviction === "function") {
            for (const [key2, value2] of this.oldCache.entries()) {
              this.onEviction(key2, value2);
            }
          }
          this.oldCache = this.cache;
          this.cache = /* @__PURE__ */ new Map();
        }
      }
      get(key) {
        if (this.cache.has(key)) {
          return this.cache.get(key);
        }
        if (this.oldCache.has(key)) {
          const value = this.oldCache.get(key);
          this.oldCache.delete(key);
          this._set(key, value);
          return value;
        }
      }
      set(key, value) {
        if (this.cache.has(key)) {
          this.cache.set(key, value);
        } else {
          this._set(key, value);
        }
        return this;
      }
      has(key) {
        return this.cache.has(key) || this.oldCache.has(key);
      }
      peek(key) {
        if (this.cache.has(key)) {
          return this.cache.get(key);
        }
        if (this.oldCache.has(key)) {
          return this.oldCache.get(key);
        }
      }
      delete(key) {
        const deleted = this.cache.delete(key);
        if (deleted) {
          this._size--;
        }
        return this.oldCache.delete(key) || deleted;
      }
      clear() {
        this.cache.clear();
        this.oldCache.clear();
        this._size = 0;
      }
      *keys() {
        for (const [key] of this) {
          yield key;
        }
      }
      *values() {
        for (const [, value] of this) {
          yield value;
        }
      }
      *[Symbol.iterator]() {
        for (const item of this.cache) {
          yield item;
        }
        for (const item of this.oldCache) {
          const [key] = item;
          if (!this.cache.has(key)) {
            yield item;
          }
        }
      }
      get size() {
        let oldCacheSize = 0;
        for (const key of this.oldCache.keys()) {
          if (!this.cache.has(key)) {
            oldCacheSize++;
          }
        }
        return Math.min(this._size + oldCacheSize, this.maxSize);
      }
    };
    module2.exports = QuickLRU;
  }
});

// node_modules/http2-wrapper/source/agent.js
var require_agent = __commonJS({
  "node_modules/http2-wrapper/source/agent.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events");
    var tls = require("tls");
    var http2 = require("http2");
    var QuickLRU = require_quick_lru();
    var kCurrentStreamsCount = Symbol("currentStreamsCount");
    var kRequest = Symbol("request");
    var kOriginSet = Symbol("cachedOriginSet");
    var kGracefullyClosing = Symbol("gracefullyClosing");
    var nameKeys = [
      "maxDeflateDynamicTableSize",
      "maxSessionMemory",
      "maxHeaderListPairs",
      "maxOutstandingPings",
      "maxReservedRemoteStreams",
      "maxSendHeaderBlockLength",
      "paddingStrategy",
      "localAddress",
      "path",
      "rejectUnauthorized",
      "minDHSize",
      "ca",
      "cert",
      "clientCertEngine",
      "ciphers",
      "key",
      "pfx",
      "servername",
      "minVersion",
      "maxVersion",
      "secureProtocol",
      "crl",
      "honorCipherOrder",
      "ecdhCurve",
      "dhparam",
      "secureOptions",
      "sessionIdContext"
    ];
    var getSortedIndex = (array, value, compare2) => {
      let low = 0;
      let high = array.length;
      while (low < high) {
        const mid = low + high >>> 1;
        if (compare2(array[mid], value)) {
          low = mid + 1;
        } else {
          high = mid;
        }
      }
      return low;
    };
    var compareSessions = (a2, b) => {
      return a2.remoteSettings.maxConcurrentStreams > b.remoteSettings.maxConcurrentStreams;
    };
    var closeCoveredSessions = (where, session) => {
      for (const coveredSession of where) {
        if (coveredSession[kOriginSet].length < session[kOriginSet].length && coveredSession[kOriginSet].every((origin) => session[kOriginSet].includes(origin)) && coveredSession[kCurrentStreamsCount] + session[kCurrentStreamsCount] <= session.remoteSettings.maxConcurrentStreams) {
          gracefullyClose(coveredSession);
        }
      }
    };
    var closeSessionIfCovered = (where, coveredSession) => {
      for (const session of where) {
        if (coveredSession[kOriginSet].length < session[kOriginSet].length && coveredSession[kOriginSet].every((origin) => session[kOriginSet].includes(origin)) && coveredSession[kCurrentStreamsCount] + session[kCurrentStreamsCount] <= session.remoteSettings.maxConcurrentStreams) {
          gracefullyClose(coveredSession);
        }
      }
    };
    var getSessions = ({ agent, isFree }) => {
      const result = {};
      for (const normalizedOptions in agent.sessions) {
        const sessions = agent.sessions[normalizedOptions];
        const filtered = sessions.filter((session) => {
          const result2 = session[Agent.kCurrentStreamsCount] < session.remoteSettings.maxConcurrentStreams;
          return isFree ? result2 : !result2;
        });
        if (filtered.length !== 0) {
          result[normalizedOptions] = filtered;
        }
      }
      return result;
    };
    var gracefullyClose = (session) => {
      session[kGracefullyClosing] = true;
      if (session[kCurrentStreamsCount] === 0) {
        session.close();
      }
    };
    var Agent = class extends EventEmitter {
      constructor({ timeout = 6e4, maxSessions = Infinity, maxFreeSessions = 10, maxCachedTlsSessions = 100 } = {}) {
        super();
        this.sessions = {};
        this.queue = {};
        this.timeout = timeout;
        this.maxSessions = maxSessions;
        this.maxFreeSessions = maxFreeSessions;
        this._freeSessionsCount = 0;
        this._sessionsCount = 0;
        this.settings = {
          enablePush: false
        };
        this.tlsSessionCache = new QuickLRU({ maxSize: maxCachedTlsSessions });
      }
      static normalizeOrigin(url, servername) {
        if (typeof url === "string") {
          url = new URL(url);
        }
        if (servername && url.hostname !== servername) {
          url.hostname = servername;
        }
        return url.origin;
      }
      normalizeOptions(options) {
        let normalized = "";
        if (options) {
          for (const key of nameKeys) {
            if (options[key]) {
              normalized += `:${options[key]}`;
            }
          }
        }
        return normalized;
      }
      _tryToCreateNewSession(normalizedOptions, normalizedOrigin) {
        if (!(normalizedOptions in this.queue) || !(normalizedOrigin in this.queue[normalizedOptions])) {
          return;
        }
        const item = this.queue[normalizedOptions][normalizedOrigin];
        if (this._sessionsCount < this.maxSessions && !item.completed) {
          item.completed = true;
          item();
        }
      }
      getSession(origin, options, listeners) {
        return new Promise((resolve, reject) => {
          if (Array.isArray(listeners)) {
            listeners = [...listeners];
            resolve();
          } else {
            listeners = [{ resolve, reject }];
          }
          const normalizedOptions = this.normalizeOptions(options);
          const normalizedOrigin = Agent.normalizeOrigin(origin, options && options.servername);
          if (normalizedOrigin === void 0) {
            for (const { reject: reject2 } of listeners) {
              reject2(new TypeError("The `origin` argument needs to be a string or an URL object"));
            }
            return;
          }
          if (normalizedOptions in this.sessions) {
            const sessions = this.sessions[normalizedOptions];
            let maxConcurrentStreams = -1;
            let currentStreamsCount = -1;
            let optimalSession;
            for (const session of sessions) {
              const sessionMaxConcurrentStreams = session.remoteSettings.maxConcurrentStreams;
              if (sessionMaxConcurrentStreams < maxConcurrentStreams) {
                break;
              }
              if (session[kOriginSet].includes(normalizedOrigin)) {
                const sessionCurrentStreamsCount = session[kCurrentStreamsCount];
                if (sessionCurrentStreamsCount >= sessionMaxConcurrentStreams || session[kGracefullyClosing] || session.destroyed) {
                  continue;
                }
                if (!optimalSession) {
                  maxConcurrentStreams = sessionMaxConcurrentStreams;
                }
                if (sessionCurrentStreamsCount > currentStreamsCount) {
                  optimalSession = session;
                  currentStreamsCount = sessionCurrentStreamsCount;
                }
              }
            }
            if (optimalSession) {
              if (listeners.length !== 1) {
                for (const { reject: reject2 } of listeners) {
                  const error = new Error(`Expected the length of listeners to be 1, got ${listeners.length}.
Please report this to https://github.com/szmarczak/http2-wrapper/`);
                  reject2(error);
                }
                return;
              }
              listeners[0].resolve(optimalSession);
              return;
            }
          }
          if (normalizedOptions in this.queue) {
            if (normalizedOrigin in this.queue[normalizedOptions]) {
              this.queue[normalizedOptions][normalizedOrigin].listeners.push(...listeners);
              this._tryToCreateNewSession(normalizedOptions, normalizedOrigin);
              return;
            }
          } else {
            this.queue[normalizedOptions] = {};
          }
          const removeFromQueue = () => {
            if (normalizedOptions in this.queue && this.queue[normalizedOptions][normalizedOrigin] === entry) {
              delete this.queue[normalizedOptions][normalizedOrigin];
              if (Object.keys(this.queue[normalizedOptions]).length === 0) {
                delete this.queue[normalizedOptions];
              }
            }
          };
          const entry = () => {
            const name = `${normalizedOrigin}:${normalizedOptions}`;
            let receivedSettings = false;
            try {
              const session = http2.connect(origin, {
                createConnection: this.createConnection,
                settings: this.settings,
                session: this.tlsSessionCache.get(name),
                ...options
              });
              session[kCurrentStreamsCount] = 0;
              session[kGracefullyClosing] = false;
              const isFree = () => session[kCurrentStreamsCount] < session.remoteSettings.maxConcurrentStreams;
              let wasFree = true;
              session.socket.once("session", (tlsSession) => {
                this.tlsSessionCache.set(name, tlsSession);
              });
              session.once("error", (error) => {
                for (const { reject: reject2 } of listeners) {
                  reject2(error);
                }
                this.tlsSessionCache.delete(name);
              });
              session.setTimeout(this.timeout, () => {
                session.destroy();
              });
              session.once("close", () => {
                if (receivedSettings) {
                  if (wasFree) {
                    this._freeSessionsCount--;
                  }
                  this._sessionsCount--;
                  const where = this.sessions[normalizedOptions];
                  where.splice(where.indexOf(session), 1);
                  if (where.length === 0) {
                    delete this.sessions[normalizedOptions];
                  }
                } else {
                  const error = new Error("Session closed without receiving a SETTINGS frame");
                  error.code = "HTTP2WRAPPER_NOSETTINGS";
                  for (const { reject: reject2 } of listeners) {
                    reject2(error);
                  }
                  removeFromQueue();
                }
                this._tryToCreateNewSession(normalizedOptions, normalizedOrigin);
              });
              const processListeners = () => {
                if (!(normalizedOptions in this.queue) || !isFree()) {
                  return;
                }
                for (const origin2 of session[kOriginSet]) {
                  if (origin2 in this.queue[normalizedOptions]) {
                    const { listeners: listeners2 } = this.queue[normalizedOptions][origin2];
                    while (listeners2.length !== 0 && isFree()) {
                      listeners2.shift().resolve(session);
                    }
                    const where = this.queue[normalizedOptions];
                    if (where[origin2].listeners.length === 0) {
                      delete where[origin2];
                      if (Object.keys(where).length === 0) {
                        delete this.queue[normalizedOptions];
                        break;
                      }
                    }
                    if (!isFree()) {
                      break;
                    }
                  }
                }
              };
              session.on("origin", () => {
                session[kOriginSet] = session.originSet;
                if (!isFree()) {
                  return;
                }
                processListeners();
                closeCoveredSessions(this.sessions[normalizedOptions], session);
              });
              session.once("remoteSettings", () => {
                session.ref();
                session.unref();
                this._sessionsCount++;
                if (entry.destroyed) {
                  const error = new Error("Agent has been destroyed");
                  for (const listener of listeners) {
                    listener.reject(error);
                  }
                  session.destroy();
                  return;
                }
                session[kOriginSet] = session.originSet;
                {
                  const where = this.sessions;
                  if (normalizedOptions in where) {
                    const sessions = where[normalizedOptions];
                    sessions.splice(getSortedIndex(sessions, session, compareSessions), 0, session);
                  } else {
                    where[normalizedOptions] = [session];
                  }
                }
                this._freeSessionsCount += 1;
                receivedSettings = true;
                this.emit("session", session);
                processListeners();
                removeFromQueue();
                if (session[kCurrentStreamsCount] === 0 && this._freeSessionsCount > this.maxFreeSessions) {
                  session.close();
                }
                if (listeners.length !== 0) {
                  this.getSession(normalizedOrigin, options, listeners);
                  listeners.length = 0;
                }
                session.on("remoteSettings", () => {
                  processListeners();
                  closeCoveredSessions(this.sessions[normalizedOptions], session);
                });
              });
              session[kRequest] = session.request;
              session.request = (headers, streamOptions) => {
                if (session[kGracefullyClosing]) {
                  throw new Error("The session is gracefully closing. No new streams are allowed.");
                }
                const stream = session[kRequest](headers, streamOptions);
                session.ref();
                ++session[kCurrentStreamsCount];
                if (session[kCurrentStreamsCount] === session.remoteSettings.maxConcurrentStreams) {
                  this._freeSessionsCount--;
                }
                stream.once("close", () => {
                  wasFree = isFree();
                  --session[kCurrentStreamsCount];
                  if (!session.destroyed && !session.closed) {
                    closeSessionIfCovered(this.sessions[normalizedOptions], session);
                    if (isFree() && !session.closed) {
                      if (!wasFree) {
                        this._freeSessionsCount++;
                        wasFree = true;
                      }
                      const isEmpty = session[kCurrentStreamsCount] === 0;
                      if (isEmpty) {
                        session.unref();
                      }
                      if (isEmpty && (this._freeSessionsCount > this.maxFreeSessions || session[kGracefullyClosing])) {
                        session.close();
                      } else {
                        closeCoveredSessions(this.sessions[normalizedOptions], session);
                        processListeners();
                      }
                    }
                  }
                });
                return stream;
              };
            } catch (error) {
              for (const listener of listeners) {
                listener.reject(error);
              }
              removeFromQueue();
            }
          };
          entry.listeners = listeners;
          entry.completed = false;
          entry.destroyed = false;
          this.queue[normalizedOptions][normalizedOrigin] = entry;
          this._tryToCreateNewSession(normalizedOptions, normalizedOrigin);
        });
      }
      request(origin, options, headers, streamOptions) {
        return new Promise((resolve, reject) => {
          this.getSession(origin, options, [{
            reject,
            resolve: (session) => {
              try {
                resolve(session.request(headers, streamOptions));
              } catch (error) {
                reject(error);
              }
            }
          }]);
        });
      }
      createConnection(origin, options) {
        return Agent.connect(origin, options);
      }
      static connect(origin, options) {
        options.ALPNProtocols = ["h2"];
        const port = origin.port || 443;
        const host = origin.hostname || origin.host;
        if (typeof options.servername === "undefined") {
          options.servername = host;
        }
        return tls.connect(port, host, options);
      }
      closeFreeSessions() {
        for (const sessions of Object.values(this.sessions)) {
          for (const session of sessions) {
            if (session[kCurrentStreamsCount] === 0) {
              session.close();
            }
          }
        }
      }
      destroy(reason) {
        for (const sessions of Object.values(this.sessions)) {
          for (const session of sessions) {
            session.destroy(reason);
          }
        }
        for (const entriesOfAuthority of Object.values(this.queue)) {
          for (const entry of Object.values(entriesOfAuthority)) {
            entry.destroyed = true;
          }
        }
        this.queue = {};
      }
      get freeSessions() {
        return getSessions({ agent: this, isFree: true });
      }
      get busySessions() {
        return getSessions({ agent: this, isFree: false });
      }
    };
    Agent.kCurrentStreamsCount = kCurrentStreamsCount;
    Agent.kGracefullyClosing = kGracefullyClosing;
    module2.exports = {
      Agent,
      globalAgent: new Agent()
    };
  }
});

// node_modules/http2-wrapper/source/incoming-message.js
var require_incoming_message = __commonJS({
  "node_modules/http2-wrapper/source/incoming-message.js"(exports2, module2) {
    "use strict";
    var { Readable } = require("stream");
    var IncomingMessage = class extends Readable {
      constructor(socket, highWaterMark) {
        super({
          highWaterMark,
          autoDestroy: false
        });
        this.statusCode = null;
        this.statusMessage = "";
        this.httpVersion = "2.0";
        this.httpVersionMajor = 2;
        this.httpVersionMinor = 0;
        this.headers = {};
        this.trailers = {};
        this.req = null;
        this.aborted = false;
        this.complete = false;
        this.upgrade = null;
        this.rawHeaders = [];
        this.rawTrailers = [];
        this.socket = socket;
        this.connection = socket;
        this._dumped = false;
      }
      _destroy(error) {
        this.req._request.destroy(error);
      }
      setTimeout(ms, callback) {
        this.req.setTimeout(ms, callback);
        return this;
      }
      _dump() {
        if (!this._dumped) {
          this._dumped = true;
          this.removeAllListeners("data");
          this.resume();
        }
      }
      _read() {
        if (this.req) {
          this.req._request.resume();
        }
      }
    };
    module2.exports = IncomingMessage;
  }
});

// node_modules/http2-wrapper/source/utils/url-to-options.js
var require_url_to_options = __commonJS({
  "node_modules/http2-wrapper/source/utils/url-to-options.js"(exports2, module2) {
    "use strict";
    module2.exports = (url) => {
      const options = {
        protocol: url.protocol,
        hostname: typeof url.hostname === "string" && url.hostname.startsWith("[") ? url.hostname.slice(1, -1) : url.hostname,
        host: url.host,
        hash: url.hash,
        search: url.search,
        pathname: url.pathname,
        href: url.href,
        path: `${url.pathname || ""}${url.search || ""}`
      };
      if (typeof url.port === "string" && url.port.length !== 0) {
        options.port = Number(url.port);
      }
      if (url.username || url.password) {
        options.auth = `${url.username || ""}:${url.password || ""}`;
      }
      return options;
    };
  }
});

// node_modules/http2-wrapper/source/utils/proxy-events.js
var require_proxy_events = __commonJS({
  "node_modules/http2-wrapper/source/utils/proxy-events.js"(exports2, module2) {
    "use strict";
    module2.exports = (from, to, events) => {
      for (const event of events) {
        from.on(event, (...args2) => to.emit(event, ...args2));
      }
    };
  }
});

// node_modules/http2-wrapper/source/utils/is-request-pseudo-header.js
var require_is_request_pseudo_header = __commonJS({
  "node_modules/http2-wrapper/source/utils/is-request-pseudo-header.js"(exports2, module2) {
    "use strict";
    module2.exports = (header) => {
      switch (header) {
        case ":method":
        case ":scheme":
        case ":authority":
        case ":path":
          return true;
        default:
          return false;
      }
    };
  }
});

// node_modules/http2-wrapper/source/utils/errors.js
var require_errors = __commonJS({
  "node_modules/http2-wrapper/source/utils/errors.js"(exports2, module2) {
    "use strict";
    var makeError = (Base, key, getMessage) => {
      module2.exports[key] = class NodeError extends Base {
        constructor(...args2) {
          super(typeof getMessage === "string" ? getMessage : getMessage(args2));
          this.name = `${super.name} [${key}]`;
          this.code = key;
        }
      };
    };
    makeError(TypeError, "ERR_INVALID_ARG_TYPE", (args2) => {
      const type = args2[0].includes(".") ? "property" : "argument";
      let valid = args2[1];
      const isManyTypes = Array.isArray(valid);
      if (isManyTypes) {
        valid = `${valid.slice(0, -1).join(", ")} or ${valid.slice(-1)}`;
      }
      return `The "${args2[0]}" ${type} must be ${isManyTypes ? "one of" : "of"} type ${valid}. Received ${typeof args2[2]}`;
    });
    makeError(TypeError, "ERR_INVALID_PROTOCOL", (args2) => {
      return `Protocol "${args2[0]}" not supported. Expected "${args2[1]}"`;
    });
    makeError(Error, "ERR_HTTP_HEADERS_SENT", (args2) => {
      return `Cannot ${args2[0]} headers after they are sent to the client`;
    });
    makeError(TypeError, "ERR_INVALID_HTTP_TOKEN", (args2) => {
      return `${args2[0]} must be a valid HTTP token [${args2[1]}]`;
    });
    makeError(TypeError, "ERR_HTTP_INVALID_HEADER_VALUE", (args2) => {
      return `Invalid value "${args2[0]} for header "${args2[1]}"`;
    });
    makeError(TypeError, "ERR_INVALID_CHAR", (args2) => {
      return `Invalid character in ${args2[0]} [${args2[1]}]`;
    });
  }
});

// node_modules/http2-wrapper/source/client-request.js
var require_client_request = __commonJS({
  "node_modules/http2-wrapper/source/client-request.js"(exports2, module2) {
    "use strict";
    var http2 = require("http2");
    var { Writable } = require("stream");
    var { Agent, globalAgent } = require_agent();
    var IncomingMessage = require_incoming_message();
    var urlToOptions = require_url_to_options();
    var proxyEvents = require_proxy_events();
    var isRequestPseudoHeader = require_is_request_pseudo_header();
    var {
      ERR_INVALID_ARG_TYPE,
      ERR_INVALID_PROTOCOL,
      ERR_HTTP_HEADERS_SENT,
      ERR_INVALID_HTTP_TOKEN,
      ERR_HTTP_INVALID_HEADER_VALUE,
      ERR_INVALID_CHAR
    } = require_errors();
    var {
      HTTP2_HEADER_STATUS,
      HTTP2_HEADER_METHOD,
      HTTP2_HEADER_PATH,
      HTTP2_METHOD_CONNECT
    } = http2.constants;
    var kHeaders = Symbol("headers");
    var kOrigin = Symbol("origin");
    var kSession = Symbol("session");
    var kOptions = Symbol("options");
    var kFlushedHeaders = Symbol("flushedHeaders");
    var kJobs = Symbol("jobs");
    var isValidHttpToken = /^[\^`\-\w!#$%&*+.|~]+$/;
    var isInvalidHeaderValue = /[^\t\u0020-\u007E\u0080-\u00FF]/;
    var ClientRequest = class extends Writable {
      constructor(input, options, callback) {
        super({
          autoDestroy: false
        });
        const hasInput = typeof input === "string" || input instanceof URL;
        if (hasInput) {
          input = urlToOptions(input instanceof URL ? input : new URL(input));
        }
        if (typeof options === "function" || options === void 0) {
          callback = options;
          options = hasInput ? input : { ...input };
        } else {
          options = { ...input, ...options };
        }
        if (options.h2session) {
          this[kSession] = options.h2session;
        } else if (options.agent === false) {
          this.agent = new Agent({ maxFreeSessions: 0 });
        } else if (typeof options.agent === "undefined" || options.agent === null) {
          if (typeof options.createConnection === "function") {
            this.agent = new Agent({ maxFreeSessions: 0 });
            this.agent.createConnection = options.createConnection;
          } else {
            this.agent = globalAgent;
          }
        } else if (typeof options.agent.request === "function") {
          this.agent = options.agent;
        } else {
          throw new ERR_INVALID_ARG_TYPE("options.agent", ["Agent-like Object", "undefined", "false"], options.agent);
        }
        if (options.protocol && options.protocol !== "https:") {
          throw new ERR_INVALID_PROTOCOL(options.protocol, "https:");
        }
        const port = options.port || options.defaultPort || this.agent && this.agent.defaultPort || 443;
        const host = options.hostname || options.host || "localhost";
        delete options.hostname;
        delete options.host;
        delete options.port;
        const { timeout } = options;
        options.timeout = void 0;
        this[kHeaders] = /* @__PURE__ */ Object.create(null);
        this[kJobs] = [];
        this.socket = null;
        this.connection = null;
        this.method = options.method || "GET";
        this.path = options.path;
        this.res = null;
        this.aborted = false;
        this.reusedSocket = false;
        if (options.headers) {
          for (const [header, value] of Object.entries(options.headers)) {
            this.setHeader(header, value);
          }
        }
        if (options.auth && !("authorization" in this[kHeaders])) {
          this[kHeaders].authorization = "Basic " + Buffer.from(options.auth).toString("base64");
        }
        options.session = options.tlsSession;
        options.path = options.socketPath;
        this[kOptions] = options;
        if (port === 443) {
          this[kOrigin] = `https://${host}`;
          if (!(":authority" in this[kHeaders])) {
            this[kHeaders][":authority"] = host;
          }
        } else {
          this[kOrigin] = `https://${host}:${port}`;
          if (!(":authority" in this[kHeaders])) {
            this[kHeaders][":authority"] = `${host}:${port}`;
          }
        }
        if (timeout) {
          this.setTimeout(timeout);
        }
        if (callback) {
          this.once("response", callback);
        }
        this[kFlushedHeaders] = false;
      }
      get method() {
        return this[kHeaders][HTTP2_HEADER_METHOD];
      }
      set method(value) {
        if (value) {
          this[kHeaders][HTTP2_HEADER_METHOD] = value.toUpperCase();
        }
      }
      get path() {
        return this[kHeaders][HTTP2_HEADER_PATH];
      }
      set path(value) {
        if (value) {
          this[kHeaders][HTTP2_HEADER_PATH] = value;
        }
      }
      get _mustNotHaveABody() {
        return this.method === "GET" || this.method === "HEAD" || this.method === "DELETE";
      }
      _write(chunk, encoding, callback) {
        if (this._mustNotHaveABody) {
          callback(new Error("The GET, HEAD and DELETE methods must NOT have a body"));
          return;
        }
        this.flushHeaders();
        const callWrite = () => this._request.write(chunk, encoding, callback);
        if (this._request) {
          callWrite();
        } else {
          this[kJobs].push(callWrite);
        }
      }
      _final(callback) {
        if (this.destroyed) {
          return;
        }
        this.flushHeaders();
        const callEnd = () => {
          if (this._mustNotHaveABody) {
            callback();
            return;
          }
          this._request.end(callback);
        };
        if (this._request) {
          callEnd();
        } else {
          this[kJobs].push(callEnd);
        }
      }
      abort() {
        if (this.res && this.res.complete) {
          return;
        }
        if (!this.aborted) {
          process.nextTick(() => this.emit("abort"));
        }
        this.aborted = true;
        this.destroy();
      }
      _destroy(error, callback) {
        if (this.res) {
          this.res._dump();
        }
        if (this._request) {
          this._request.destroy();
        }
        callback(error);
      }
      async flushHeaders() {
        if (this[kFlushedHeaders] || this.destroyed) {
          return;
        }
        this[kFlushedHeaders] = true;
        const isConnectMethod = this.method === HTTP2_METHOD_CONNECT;
        const onStream = (stream) => {
          this._request = stream;
          if (this.destroyed) {
            stream.destroy();
            return;
          }
          if (!isConnectMethod) {
            proxyEvents(stream, this, ["timeout", "continue", "close", "error"]);
          }
          const waitForEnd = (fn3) => {
            return (...args2) => {
              if (!this.writable && !this.destroyed) {
                fn3(...args2);
              } else {
                this.once("finish", () => {
                  fn3(...args2);
                });
              }
            };
          };
          stream.once("response", waitForEnd((headers, flags, rawHeaders) => {
            const response = new IncomingMessage(this.socket, stream.readableHighWaterMark);
            this.res = response;
            response.req = this;
            response.statusCode = headers[HTTP2_HEADER_STATUS];
            response.headers = headers;
            response.rawHeaders = rawHeaders;
            response.once("end", () => {
              if (this.aborted) {
                response.aborted = true;
                response.emit("aborted");
              } else {
                response.complete = true;
                response.socket = null;
                response.connection = null;
              }
            });
            if (isConnectMethod) {
              response.upgrade = true;
              if (this.emit("connect", response, stream, Buffer.alloc(0))) {
                this.emit("close");
              } else {
                stream.destroy();
              }
            } else {
              stream.on("data", (chunk) => {
                if (!response._dumped && !response.push(chunk)) {
                  stream.pause();
                }
              });
              stream.once("end", () => {
                response.push(null);
              });
              if (!this.emit("response", response)) {
                response._dump();
              }
            }
          }));
          stream.once("headers", waitForEnd((headers) => this.emit("information", { statusCode: headers[HTTP2_HEADER_STATUS] })));
          stream.once("trailers", waitForEnd((trailers, flags, rawTrailers) => {
            const { res } = this;
            res.trailers = trailers;
            res.rawTrailers = rawTrailers;
          }));
          const { socket } = stream.session;
          this.socket = socket;
          this.connection = socket;
          for (const job of this[kJobs]) {
            job();
          }
          this.emit("socket", this.socket);
        };
        if (this[kSession]) {
          try {
            onStream(this[kSession].request(this[kHeaders]));
          } catch (error) {
            this.emit("error", error);
          }
        } else {
          this.reusedSocket = true;
          try {
            onStream(await this.agent.request(this[kOrigin], this[kOptions], this[kHeaders]));
          } catch (error) {
            this.emit("error", error);
          }
        }
      }
      getHeader(name) {
        if (typeof name !== "string") {
          throw new ERR_INVALID_ARG_TYPE("name", "string", name);
        }
        return this[kHeaders][name.toLowerCase()];
      }
      get headersSent() {
        return this[kFlushedHeaders];
      }
      removeHeader(name) {
        if (typeof name !== "string") {
          throw new ERR_INVALID_ARG_TYPE("name", "string", name);
        }
        if (this.headersSent) {
          throw new ERR_HTTP_HEADERS_SENT("remove");
        }
        delete this[kHeaders][name.toLowerCase()];
      }
      setHeader(name, value) {
        if (this.headersSent) {
          throw new ERR_HTTP_HEADERS_SENT("set");
        }
        if (typeof name !== "string" || !isValidHttpToken.test(name) && !isRequestPseudoHeader(name)) {
          throw new ERR_INVALID_HTTP_TOKEN("Header name", name);
        }
        if (typeof value === "undefined") {
          throw new ERR_HTTP_INVALID_HEADER_VALUE(value, name);
        }
        if (isInvalidHeaderValue.test(value)) {
          throw new ERR_INVALID_CHAR("header content", name);
        }
        this[kHeaders][name.toLowerCase()] = value;
      }
      setNoDelay() {
      }
      setSocketKeepAlive() {
      }
      setTimeout(ms, callback) {
        const applyTimeout = () => this._request.setTimeout(ms, callback);
        if (this._request) {
          applyTimeout();
        } else {
          this[kJobs].push(applyTimeout);
        }
        return this;
      }
      get maxHeadersCount() {
        if (!this.destroyed && this._request) {
          return this._request.session.localSettings.maxHeaderListSize;
        }
        return void 0;
      }
      set maxHeadersCount(_value) {
      }
    };
    module2.exports = ClientRequest;
  }
});

// node_modules/resolve-alpn/index.js
var require_resolve_alpn = __commonJS({
  "node_modules/resolve-alpn/index.js"(exports2, module2) {
    "use strict";
    var tls = require("tls");
    module2.exports = (options = {}, connect = tls.connect) => new Promise((resolve, reject) => {
      let timeout = false;
      let socket;
      const callback = async () => {
        await socketPromise;
        socket.off("timeout", onTimeout);
        socket.off("error", reject);
        if (options.resolveSocket) {
          resolve({ alpnProtocol: socket.alpnProtocol, socket, timeout });
          if (timeout) {
            await Promise.resolve();
            socket.emit("timeout");
          }
        } else {
          socket.destroy();
          resolve({ alpnProtocol: socket.alpnProtocol, timeout });
        }
      };
      const onTimeout = async () => {
        timeout = true;
        callback();
      };
      const socketPromise = (async () => {
        try {
          socket = await connect(options, callback);
          socket.on("error", reject);
          socket.once("timeout", onTimeout);
        } catch (error) {
          reject(error);
        }
      })();
    });
  }
});

// node_modules/http2-wrapper/source/utils/calculate-server-name.js
var require_calculate_server_name = __commonJS({
  "node_modules/http2-wrapper/source/utils/calculate-server-name.js"(exports2, module2) {
    "use strict";
    var net = require("net");
    module2.exports = (options) => {
      let servername = options.host;
      const hostHeader = options.headers && options.headers.host;
      if (hostHeader) {
        if (hostHeader.startsWith("[")) {
          const index = hostHeader.indexOf("]");
          if (index === -1) {
            servername = hostHeader;
          } else {
            servername = hostHeader.slice(1, -1);
          }
        } else {
          servername = hostHeader.split(":", 1)[0];
        }
      }
      if (net.isIP(servername)) {
        return "";
      }
      return servername;
    };
  }
});

// node_modules/http2-wrapper/source/auto.js
var require_auto = __commonJS({
  "node_modules/http2-wrapper/source/auto.js"(exports2, module2) {
    "use strict";
    var http = require("http");
    var https = require("https");
    var resolveALPN = require_resolve_alpn();
    var QuickLRU = require_quick_lru();
    var Http2ClientRequest = require_client_request();
    var calculateServerName = require_calculate_server_name();
    var urlToOptions = require_url_to_options();
    var cache = new QuickLRU({ maxSize: 100 });
    var queue = /* @__PURE__ */ new Map();
    var installSocket = (agent, socket, options) => {
      socket._httpMessage = { shouldKeepAlive: true };
      const onFree = () => {
        agent.emit("free", socket, options);
      };
      socket.on("free", onFree);
      const onClose = () => {
        agent.removeSocket(socket, options);
      };
      socket.on("close", onClose);
      const onRemove = () => {
        agent.removeSocket(socket, options);
        socket.off("close", onClose);
        socket.off("free", onFree);
        socket.off("agentRemove", onRemove);
      };
      socket.on("agentRemove", onRemove);
      agent.emit("free", socket, options);
    };
    var resolveProtocol = async (options) => {
      const name = `${options.host}:${options.port}:${options.ALPNProtocols.sort()}`;
      if (!cache.has(name)) {
        if (queue.has(name)) {
          const result = await queue.get(name);
          return result.alpnProtocol;
        }
        const { path, agent } = options;
        options.path = options.socketPath;
        const resultPromise = resolveALPN(options);
        queue.set(name, resultPromise);
        try {
          const { socket, alpnProtocol } = await resultPromise;
          cache.set(name, alpnProtocol);
          options.path = path;
          if (alpnProtocol === "h2") {
            socket.destroy();
          } else {
            const { globalAgent } = https;
            const defaultCreateConnection = https.Agent.prototype.createConnection;
            if (agent) {
              if (agent.createConnection === defaultCreateConnection) {
                installSocket(agent, socket, options);
              } else {
                socket.destroy();
              }
            } else if (globalAgent.createConnection === defaultCreateConnection) {
              installSocket(globalAgent, socket, options);
            } else {
              socket.destroy();
            }
          }
          queue.delete(name);
          return alpnProtocol;
        } catch (error) {
          queue.delete(name);
          throw error;
        }
      }
      return cache.get(name);
    };
    module2.exports = async (input, options, callback) => {
      if (typeof input === "string" || input instanceof URL) {
        input = urlToOptions(new URL(input));
      }
      if (typeof options === "function") {
        callback = options;
        options = void 0;
      }
      options = {
        ALPNProtocols: ["h2", "http/1.1"],
        ...input,
        ...options,
        resolveSocket: true
      };
      if (!Array.isArray(options.ALPNProtocols) || options.ALPNProtocols.length === 0) {
        throw new Error("The `ALPNProtocols` option must be an Array with at least one entry");
      }
      options.protocol = options.protocol || "https:";
      const isHttps = options.protocol === "https:";
      options.host = options.hostname || options.host || "localhost";
      options.session = options.tlsSession;
      options.servername = options.servername || calculateServerName(options);
      options.port = options.port || (isHttps ? 443 : 80);
      options._defaultAgent = isHttps ? https.globalAgent : http.globalAgent;
      const agents = options.agent;
      if (agents) {
        if (agents.addRequest) {
          throw new Error("The `options.agent` object can contain only `http`, `https` or `http2` properties");
        }
        options.agent = agents[isHttps ? "https" : "http"];
      }
      if (isHttps) {
        const protocol = await resolveProtocol(options);
        if (protocol === "h2") {
          if (agents) {
            options.agent = agents.http2;
          }
          return new Http2ClientRequest(options, callback);
        }
      }
      return http.request(options, callback);
    };
    module2.exports.protocolCache = cache;
  }
});

// node_modules/http2-wrapper/source/index.js
var require_source5 = __commonJS({
  "node_modules/http2-wrapper/source/index.js"(exports2, module2) {
    "use strict";
    var http2 = require("http2");
    var agent = require_agent();
    var ClientRequest = require_client_request();
    var IncomingMessage = require_incoming_message();
    var auto = require_auto();
    var request = (url, options, callback) => {
      return new ClientRequest(url, options, callback);
    };
    var get2 = (url, options, callback) => {
      const req = new ClientRequest(url, options, callback);
      req.end();
      return req;
    };
    module2.exports = {
      ...http2,
      ClientRequest,
      IncomingMessage,
      ...agent,
      request,
      get: get2,
      auto
    };
  }
});

// node_modules/got/dist/source/core/utils/is-form-data.js
var require_is_form_data = __commonJS({
  "node_modules/got/dist/source/core/utils/is-form-data.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var is_1 = require_dist();
    exports2.default = (body2) => is_1.default.nodeStream(body2) && is_1.default.function_(body2.getBoundary);
  }
});

// node_modules/got/dist/source/core/utils/get-body-size.js
var require_get_body_size = __commonJS({
  "node_modules/got/dist/source/core/utils/get-body-size.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var fs_1 = require("fs");
    var util_1 = require("util");
    var is_1 = require_dist();
    var is_form_data_1 = require_is_form_data();
    var statAsync = util_1.promisify(fs_1.stat);
    exports2.default = async (body2, headers) => {
      if (headers && "content-length" in headers) {
        return Number(headers["content-length"]);
      }
      if (!body2) {
        return 0;
      }
      if (is_1.default.string(body2)) {
        return Buffer.byteLength(body2);
      }
      if (is_1.default.buffer(body2)) {
        return body2.length;
      }
      if (is_form_data_1.default(body2)) {
        return util_1.promisify(body2.getLength.bind(body2))();
      }
      if (body2 instanceof fs_1.ReadStream) {
        const { size } = await statAsync(body2.path);
        if (size === 0) {
          return void 0;
        }
        return size;
      }
      return void 0;
    };
  }
});

// node_modules/got/dist/source/core/utils/proxy-events.js
var require_proxy_events2 = __commonJS({
  "node_modules/got/dist/source/core/utils/proxy-events.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    function default_1(from, to, events) {
      const fns = {};
      for (const event of events) {
        fns[event] = (...args2) => {
          to.emit(event, ...args2);
        };
        from.on(event, fns[event]);
      }
      return () => {
        for (const event of events) {
          from.off(event, fns[event]);
        }
      };
    }
    exports2.default = default_1;
  }
});

// node_modules/got/dist/source/core/utils/unhandle.js
var require_unhandle = __commonJS({
  "node_modules/got/dist/source/core/utils/unhandle.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.default = () => {
      const handlers = [];
      return {
        once(origin, event, fn3) {
          origin.once(event, fn3);
          handlers.push({ origin, event, fn: fn3 });
        },
        unhandleAll() {
          for (const handler of handlers) {
            const { origin, event, fn: fn3 } = handler;
            origin.removeListener(event, fn3);
          }
          handlers.length = 0;
        }
      };
    };
  }
});

// node_modules/got/dist/source/core/utils/timed-out.js
var require_timed_out = __commonJS({
  "node_modules/got/dist/source/core/utils/timed-out.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.TimeoutError = void 0;
    var net = require("net");
    var unhandle_1 = require_unhandle();
    var reentry = Symbol("reentry");
    var noop = () => {
    };
    var TimeoutError = class extends Error {
      constructor(threshold, event) {
        super(`Timeout awaiting '${event}' for ${threshold}ms`);
        this.event = event;
        this.name = "TimeoutError";
        this.code = "ETIMEDOUT";
      }
    };
    exports2.TimeoutError = TimeoutError;
    exports2.default = (request, delays, options) => {
      if (reentry in request) {
        return noop;
      }
      request[reentry] = true;
      const cancelers = [];
      const { once, unhandleAll } = unhandle_1.default();
      const addTimeout = (delay, callback, event) => {
        var _a2;
        const timeout = setTimeout(callback, delay, delay, event);
        (_a2 = timeout.unref) === null || _a2 === void 0 ? void 0 : _a2.call(timeout);
        const cancel = () => {
          clearTimeout(timeout);
        };
        cancelers.push(cancel);
        return cancel;
      };
      const { host, hostname } = options;
      const timeoutHandler = (delay, event) => {
        request.destroy(new TimeoutError(delay, event));
      };
      const cancelTimeouts = () => {
        for (const cancel of cancelers) {
          cancel();
        }
        unhandleAll();
      };
      request.once("error", (error) => {
        cancelTimeouts();
        if (request.listenerCount("error") === 0) {
          throw error;
        }
      });
      request.once("close", cancelTimeouts);
      once(request, "response", (response) => {
        once(response, "end", cancelTimeouts);
      });
      if (typeof delays.request !== "undefined") {
        addTimeout(delays.request, timeoutHandler, "request");
      }
      if (typeof delays.socket !== "undefined") {
        const socketTimeoutHandler = () => {
          timeoutHandler(delays.socket, "socket");
        };
        request.setTimeout(delays.socket, socketTimeoutHandler);
        cancelers.push(() => {
          request.removeListener("timeout", socketTimeoutHandler);
        });
      }
      once(request, "socket", (socket) => {
        var _a2;
        const { socketPath } = request;
        if (socket.connecting) {
          const hasPath = Boolean(socketPath !== null && socketPath !== void 0 ? socketPath : net.isIP((_a2 = hostname !== null && hostname !== void 0 ? hostname : host) !== null && _a2 !== void 0 ? _a2 : "") !== 0);
          if (typeof delays.lookup !== "undefined" && !hasPath && typeof socket.address().address === "undefined") {
            const cancelTimeout = addTimeout(delays.lookup, timeoutHandler, "lookup");
            once(socket, "lookup", cancelTimeout);
          }
          if (typeof delays.connect !== "undefined") {
            const timeConnect = () => addTimeout(delays.connect, timeoutHandler, "connect");
            if (hasPath) {
              once(socket, "connect", timeConnect());
            } else {
              once(socket, "lookup", (error) => {
                if (error === null) {
                  once(socket, "connect", timeConnect());
                }
              });
            }
          }
          if (typeof delays.secureConnect !== "undefined" && options.protocol === "https:") {
            once(socket, "connect", () => {
              const cancelTimeout = addTimeout(delays.secureConnect, timeoutHandler, "secureConnect");
              once(socket, "secureConnect", cancelTimeout);
            });
          }
        }
        if (typeof delays.send !== "undefined") {
          const timeRequest = () => addTimeout(delays.send, timeoutHandler, "send");
          if (socket.connecting) {
            once(socket, "connect", () => {
              once(request, "upload-complete", timeRequest());
            });
          } else {
            once(request, "upload-complete", timeRequest());
          }
        }
      });
      if (typeof delays.response !== "undefined") {
        once(request, "upload-complete", () => {
          const cancelTimeout = addTimeout(delays.response, timeoutHandler, "response");
          once(request, "response", cancelTimeout);
        });
      }
      return cancelTimeouts;
    };
  }
});

// node_modules/got/dist/source/core/utils/url-to-options.js
var require_url_to_options2 = __commonJS({
  "node_modules/got/dist/source/core/utils/url-to-options.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var is_1 = require_dist();
    exports2.default = (url) => {
      url = url;
      const options = {
        protocol: url.protocol,
        hostname: is_1.default.string(url.hostname) && url.hostname.startsWith("[") ? url.hostname.slice(1, -1) : url.hostname,
        host: url.host,
        hash: url.hash,
        search: url.search,
        pathname: url.pathname,
        href: url.href,
        path: `${url.pathname || ""}${url.search || ""}`
      };
      if (is_1.default.string(url.port) && url.port.length > 0) {
        options.port = Number(url.port);
      }
      if (url.username || url.password) {
        options.auth = `${url.username || ""}:${url.password || ""}`;
      }
      return options;
    };
  }
});

// node_modules/got/dist/source/core/utils/options-to-url.js
var require_options_to_url = __commonJS({
  "node_modules/got/dist/source/core/utils/options-to-url.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var url_1 = require("url");
    var keys2 = [
      "protocol",
      "host",
      "hostname",
      "port",
      "pathname",
      "search"
    ];
    exports2.default = (origin, options) => {
      var _a2, _b;
      if (options.path) {
        if (options.pathname) {
          throw new TypeError("Parameters `path` and `pathname` are mutually exclusive.");
        }
        if (options.search) {
          throw new TypeError("Parameters `path` and `search` are mutually exclusive.");
        }
        if (options.searchParams) {
          throw new TypeError("Parameters `path` and `searchParams` are mutually exclusive.");
        }
      }
      if (options.search && options.searchParams) {
        throw new TypeError("Parameters `search` and `searchParams` are mutually exclusive.");
      }
      if (!origin) {
        if (!options.protocol) {
          throw new TypeError("No URL protocol specified");
        }
        origin = `${options.protocol}//${(_b = (_a2 = options.hostname) !== null && _a2 !== void 0 ? _a2 : options.host) !== null && _b !== void 0 ? _b : ""}`;
      }
      const url = new url_1.URL(origin);
      if (options.path) {
        const searchIndex = options.path.indexOf("?");
        if (searchIndex === -1) {
          options.pathname = options.path;
        } else {
          options.pathname = options.path.slice(0, searchIndex);
          options.search = options.path.slice(searchIndex + 1);
        }
        delete options.path;
      }
      for (const key of keys2) {
        if (options[key]) {
          url[key] = options[key].toString();
        }
      }
      return url;
    };
  }
});

// node_modules/got/dist/source/core/utils/weakable-map.js
var require_weakable_map = __commonJS({
  "node_modules/got/dist/source/core/utils/weakable-map.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var WeakableMap = class {
      constructor() {
        this.weakMap = /* @__PURE__ */ new WeakMap();
        this.map = /* @__PURE__ */ new Map();
      }
      set(key, value) {
        if (typeof key === "object") {
          this.weakMap.set(key, value);
        } else {
          this.map.set(key, value);
        }
      }
      get(key) {
        if (typeof key === "object") {
          return this.weakMap.get(key);
        }
        return this.map.get(key);
      }
      has(key) {
        if (typeof key === "object") {
          return this.weakMap.has(key);
        }
        return this.map.has(key);
      }
    };
    exports2.default = WeakableMap;
  }
});

// node_modules/got/dist/source/core/utils/get-buffer.js
var require_get_buffer = __commonJS({
  "node_modules/got/dist/source/core/utils/get-buffer.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var getBuffer = async (stream) => {
      const chunks = [];
      let length = 0;
      for await (const chunk of stream) {
        chunks.push(chunk);
        length += Buffer.byteLength(chunk);
      }
      if (Buffer.isBuffer(chunks[0])) {
        return Buffer.concat(chunks, length);
      }
      return Buffer.from(chunks.join(""));
    };
    exports2.default = getBuffer;
  }
});

// node_modules/got/dist/source/core/utils/dns-ip-version.js
var require_dns_ip_version = __commonJS({
  "node_modules/got/dist/source/core/utils/dns-ip-version.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.dnsLookupIpVersionToFamily = exports2.isDnsLookupIpVersion = void 0;
    var conversionTable = {
      auto: 0,
      ipv4: 4,
      ipv6: 6
    };
    exports2.isDnsLookupIpVersion = (value) => {
      return value in conversionTable;
    };
    exports2.dnsLookupIpVersionToFamily = (dnsLookupIpVersion) => {
      if (exports2.isDnsLookupIpVersion(dnsLookupIpVersion)) {
        return conversionTable[dnsLookupIpVersion];
      }
      throw new Error("Invalid DNS lookup IP version");
    };
  }
});

// node_modules/got/dist/source/core/utils/is-response-ok.js
var require_is_response_ok = __commonJS({
  "node_modules/got/dist/source/core/utils/is-response-ok.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.isResponseOk = void 0;
    exports2.isResponseOk = (response) => {
      const { statusCode } = response;
      const limitStatusCode = response.request.options.followRedirect ? 299 : 399;
      return statusCode >= 200 && statusCode <= limitStatusCode || statusCode === 304;
    };
  }
});

// node_modules/got/dist/source/utils/deprecation-warning.js
var require_deprecation_warning = __commonJS({
  "node_modules/got/dist/source/utils/deprecation-warning.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var alreadyWarned = /* @__PURE__ */ new Set();
    exports2.default = (message2) => {
      if (alreadyWarned.has(message2)) {
        return;
      }
      alreadyWarned.add(message2);
      process.emitWarning(`Got: ${message2}`, {
        type: "DeprecationWarning"
      });
    };
  }
});

// node_modules/got/dist/source/as-promise/normalize-arguments.js
var require_normalize_arguments = __commonJS({
  "node_modules/got/dist/source/as-promise/normalize-arguments.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var is_1 = require_dist();
    var normalizeArguments = (options, defaults) => {
      if (is_1.default.null_(options.encoding)) {
        throw new TypeError("To get a Buffer, set `options.responseType` to `buffer` instead");
      }
      is_1.assert.any([is_1.default.string, is_1.default.undefined], options.encoding);
      is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.resolveBodyOnly);
      is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.methodRewriting);
      is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.isStream);
      is_1.assert.any([is_1.default.string, is_1.default.undefined], options.responseType);
      if (options.responseType === void 0) {
        options.responseType = "text";
      }
      const { retry } = options;
      if (defaults) {
        options.retry = { ...defaults.retry };
      } else {
        options.retry = {
          calculateDelay: (retryObject) => retryObject.computedValue,
          limit: 0,
          methods: [],
          statusCodes: [],
          errorCodes: [],
          maxRetryAfter: void 0
        };
      }
      if (is_1.default.object(retry)) {
        options.retry = {
          ...options.retry,
          ...retry
        };
        options.retry.methods = [...new Set(options.retry.methods.map((method) => method.toUpperCase()))];
        options.retry.statusCodes = [...new Set(options.retry.statusCodes)];
        options.retry.errorCodes = [...new Set(options.retry.errorCodes)];
      } else if (is_1.default.number(retry)) {
        options.retry.limit = retry;
      }
      if (is_1.default.undefined(options.retry.maxRetryAfter)) {
        options.retry.maxRetryAfter = Math.min(...[options.timeout.request, options.timeout.connect].filter(is_1.default.number));
      }
      if (is_1.default.object(options.pagination)) {
        if (defaults) {
          options.pagination = {
            ...defaults.pagination,
            ...options.pagination
          };
        }
        const { pagination } = options;
        if (!is_1.default.function_(pagination.transform)) {
          throw new Error("`options.pagination.transform` must be implemented");
        }
        if (!is_1.default.function_(pagination.shouldContinue)) {
          throw new Error("`options.pagination.shouldContinue` must be implemented");
        }
        if (!is_1.default.function_(pagination.filter)) {
          throw new TypeError("`options.pagination.filter` must be implemented");
        }
        if (!is_1.default.function_(pagination.paginate)) {
          throw new Error("`options.pagination.paginate` must be implemented");
        }
      }
      if (options.responseType === "json" && options.headers.accept === void 0) {
        options.headers.accept = "application/json";
      }
      return options;
    };
    exports2.default = normalizeArguments;
  }
});

// node_modules/got/dist/source/core/calculate-retry-delay.js
var require_calculate_retry_delay = __commonJS({
  "node_modules/got/dist/source/core/calculate-retry-delay.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.retryAfterStatusCodes = void 0;
    exports2.retryAfterStatusCodes = /* @__PURE__ */ new Set([413, 429, 503]);
    var calculateRetryDelay = ({ attemptCount, retryOptions, error, retryAfter }) => {
      if (attemptCount > retryOptions.limit) {
        return 0;
      }
      const hasMethod = retryOptions.methods.includes(error.options.method);
      const hasErrorCode = retryOptions.errorCodes.includes(error.code);
      const hasStatusCode = error.response && retryOptions.statusCodes.includes(error.response.statusCode);
      if (!hasMethod || !hasErrorCode && !hasStatusCode) {
        return 0;
      }
      if (error.response) {
        if (retryAfter) {
          if (retryOptions.maxRetryAfter === void 0 || retryAfter > retryOptions.maxRetryAfter) {
            return 0;
          }
          return retryAfter;
        }
        if (error.response.statusCode === 413) {
          return 0;
        }
      }
      const noise = Math.random() * 100;
      return 2 ** (attemptCount - 1) * 1e3 + noise;
    };
    exports2.default = calculateRetryDelay;
  }
});

// node_modules/got/dist/source/core/index.js
var require_core = __commonJS({
  "node_modules/got/dist/source/core/index.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.UnsupportedProtocolError = exports2.ReadError = exports2.TimeoutError = exports2.UploadError = exports2.CacheError = exports2.HTTPError = exports2.MaxRedirectsError = exports2.RequestError = exports2.setNonEnumerableProperties = exports2.knownHookEvents = exports2.withoutBody = exports2.kIsNormalizedAlready = void 0;
    var util_1 = require("util");
    var stream_1 = require("stream");
    var fs_1 = require("fs");
    var url_1 = require("url");
    var http = require("http");
    var http_1 = require("http");
    var https = require("https");
    var http_timer_1 = require_source3();
    var cacheable_lookup_1 = require_source4();
    var CacheableRequest = require_src5();
    var decompressResponse = require_decompress_response();
    var http2wrapper = require_source5();
    var lowercaseKeys = require_lowercase_keys();
    var is_1 = require_dist();
    var get_body_size_1 = require_get_body_size();
    var is_form_data_1 = require_is_form_data();
    var proxy_events_1 = require_proxy_events2();
    var timed_out_1 = require_timed_out();
    var url_to_options_1 = require_url_to_options2();
    var options_to_url_1 = require_options_to_url();
    var weakable_map_1 = require_weakable_map();
    var get_buffer_1 = require_get_buffer();
    var dns_ip_version_1 = require_dns_ip_version();
    var is_response_ok_1 = require_is_response_ok();
    var deprecation_warning_1 = require_deprecation_warning();
    var normalize_arguments_1 = require_normalize_arguments();
    var calculate_retry_delay_1 = require_calculate_retry_delay();
    var globalDnsCache;
    var kRequest = Symbol("request");
    var kResponse = Symbol("response");
    var kResponseSize = Symbol("responseSize");
    var kDownloadedSize = Symbol("downloadedSize");
    var kBodySize = Symbol("bodySize");
    var kUploadedSize = Symbol("uploadedSize");
    var kServerResponsesPiped = Symbol("serverResponsesPiped");
    var kUnproxyEvents = Symbol("unproxyEvents");
    var kIsFromCache = Symbol("isFromCache");
    var kCancelTimeouts = Symbol("cancelTimeouts");
    var kStartedReading = Symbol("startedReading");
    var kStopReading = Symbol("stopReading");
    var kTriggerRead = Symbol("triggerRead");
    var kBody = Symbol("body");
    var kJobs = Symbol("jobs");
    var kOriginalResponse = Symbol("originalResponse");
    var kRetryTimeout = Symbol("retryTimeout");
    exports2.kIsNormalizedAlready = Symbol("isNormalizedAlready");
    var supportsBrotli = is_1.default.string(process.versions.brotli);
    exports2.withoutBody = /* @__PURE__ */ new Set(["GET", "HEAD"]);
    exports2.knownHookEvents = [
      "init",
      "beforeRequest",
      "beforeRedirect",
      "beforeError",
      "beforeRetry",
      "afterResponse"
    ];
    function validateSearchParameters(searchParameters) {
      for (const key in searchParameters) {
        const value = searchParameters[key];
        if (!is_1.default.string(value) && !is_1.default.number(value) && !is_1.default.boolean(value) && !is_1.default.null_(value) && !is_1.default.undefined(value)) {
          throw new TypeError(`The \`searchParams\` value '${String(value)}' must be a string, number, boolean or null`);
        }
      }
    }
    function isClientRequest(clientRequest) {
      return is_1.default.object(clientRequest) && !("statusCode" in clientRequest);
    }
    var cacheableStore = new weakable_map_1.default();
    var waitForOpenFile = async (file) => new Promise((resolve, reject) => {
      const onError = (error) => {
        reject(error);
      };
      if (!file.pending) {
        resolve();
      }
      file.once("error", onError);
      file.once("ready", () => {
        file.off("error", onError);
        resolve();
      });
    });
    var redirectCodes = /* @__PURE__ */ new Set([300, 301, 302, 303, 304, 307, 308]);
    var nonEnumerableProperties = [
      "context",
      "body",
      "json",
      "form"
    ];
    exports2.setNonEnumerableProperties = (sources, to) => {
      const properties = {};
      for (const source of sources) {
        if (!source) {
          continue;
        }
        for (const name of nonEnumerableProperties) {
          if (!(name in source)) {
            continue;
          }
          properties[name] = {
            writable: true,
            configurable: true,
            enumerable: false,
            value: source[name]
          };
        }
      }
      Object.defineProperties(to, properties);
    };
    var RequestError = class extends Error {
      constructor(message2, error, self2) {
        var _a2, _b;
        super(message2);
        Error.captureStackTrace(this, this.constructor);
        this.name = "RequestError";
        this.code = (_a2 = error.code) !== null && _a2 !== void 0 ? _a2 : "ERR_GOT_REQUEST_ERROR";
        if (self2 instanceof Request) {
          Object.defineProperty(this, "request", {
            enumerable: false,
            value: self2
          });
          Object.defineProperty(this, "response", {
            enumerable: false,
            value: self2[kResponse]
          });
          Object.defineProperty(this, "options", {
            enumerable: false,
            value: self2.options
          });
        } else {
          Object.defineProperty(this, "options", {
            enumerable: false,
            value: self2
          });
        }
        this.timings = (_b = this.request) === null || _b === void 0 ? void 0 : _b.timings;
        if (is_1.default.string(error.stack) && is_1.default.string(this.stack)) {
          const indexOfMessage = this.stack.indexOf(this.message) + this.message.length;
          const thisStackTrace = this.stack.slice(indexOfMessage).split("\n").reverse();
          const errorStackTrace = error.stack.slice(error.stack.indexOf(error.message) + error.message.length).split("\n").reverse();
          while (errorStackTrace.length !== 0 && errorStackTrace[0] === thisStackTrace[0]) {
            thisStackTrace.shift();
          }
          this.stack = `${this.stack.slice(0, indexOfMessage)}${thisStackTrace.reverse().join("\n")}${errorStackTrace.reverse().join("\n")}`;
        }
      }
    };
    exports2.RequestError = RequestError;
    var MaxRedirectsError = class extends RequestError {
      constructor(request) {
        super(`Redirected ${request.options.maxRedirects} times. Aborting.`, {}, request);
        this.name = "MaxRedirectsError";
        this.code = "ERR_TOO_MANY_REDIRECTS";
      }
    };
    exports2.MaxRedirectsError = MaxRedirectsError;
    var HTTPError = class extends RequestError {
      constructor(response) {
        super(`Response code ${response.statusCode} (${response.statusMessage})`, {}, response.request);
        this.name = "HTTPError";
        this.code = "ERR_NON_2XX_3XX_RESPONSE";
      }
    };
    exports2.HTTPError = HTTPError;
    var CacheError = class extends RequestError {
      constructor(error, request) {
        super(error.message, error, request);
        this.name = "CacheError";
        this.code = this.code === "ERR_GOT_REQUEST_ERROR" ? "ERR_CACHE_ACCESS" : this.code;
      }
    };
    exports2.CacheError = CacheError;
    var UploadError = class extends RequestError {
      constructor(error, request) {
        super(error.message, error, request);
        this.name = "UploadError";
        this.code = this.code === "ERR_GOT_REQUEST_ERROR" ? "ERR_UPLOAD" : this.code;
      }
    };
    exports2.UploadError = UploadError;
    var TimeoutError = class extends RequestError {
      constructor(error, timings, request) {
        super(error.message, error, request);
        this.name = "TimeoutError";
        this.event = error.event;
        this.timings = timings;
      }
    };
    exports2.TimeoutError = TimeoutError;
    var ReadError = class extends RequestError {
      constructor(error, request) {
        super(error.message, error, request);
        this.name = "ReadError";
        this.code = this.code === "ERR_GOT_REQUEST_ERROR" ? "ERR_READING_RESPONSE_STREAM" : this.code;
      }
    };
    exports2.ReadError = ReadError;
    var UnsupportedProtocolError = class extends RequestError {
      constructor(options) {
        super(`Unsupported protocol "${options.url.protocol}"`, {}, options);
        this.name = "UnsupportedProtocolError";
        this.code = "ERR_UNSUPPORTED_PROTOCOL";
      }
    };
    exports2.UnsupportedProtocolError = UnsupportedProtocolError;
    var proxiedRequestEvents = [
      "socket",
      "connect",
      "continue",
      "information",
      "upgrade",
      "timeout"
    ];
    var Request = class extends stream_1.Duplex {
      constructor(url, options = {}, defaults) {
        super({
          autoDestroy: false,
          highWaterMark: 0
        });
        this[kDownloadedSize] = 0;
        this[kUploadedSize] = 0;
        this.requestInitialized = false;
        this[kServerResponsesPiped] = /* @__PURE__ */ new Set();
        this.redirects = [];
        this[kStopReading] = false;
        this[kTriggerRead] = false;
        this[kJobs] = [];
        this.retryCount = 0;
        this._progressCallbacks = [];
        const unlockWrite = () => this._unlockWrite();
        const lockWrite = () => this._lockWrite();
        this.on("pipe", (source) => {
          source.prependListener("data", unlockWrite);
          source.on("data", lockWrite);
          source.prependListener("end", unlockWrite);
          source.on("end", lockWrite);
        });
        this.on("unpipe", (source) => {
          source.off("data", unlockWrite);
          source.off("data", lockWrite);
          source.off("end", unlockWrite);
          source.off("end", lockWrite);
        });
        this.on("pipe", (source) => {
          if (source instanceof http_1.IncomingMessage) {
            this.options.headers = {
              ...source.headers,
              ...this.options.headers
            };
          }
        });
        const { json, body: body2, form } = options;
        if (json || body2 || form) {
          this._lockWrite();
        }
        if (exports2.kIsNormalizedAlready in options) {
          this.options = options;
        } else {
          try {
            this.options = this.constructor.normalizeArguments(url, options, defaults);
          } catch (error) {
            if (is_1.default.nodeStream(options.body)) {
              options.body.destroy();
            }
            this.destroy(error);
            return;
          }
        }
        (async () => {
          var _a2;
          try {
            if (this.options.body instanceof fs_1.ReadStream) {
              await waitForOpenFile(this.options.body);
            }
            const { url: normalizedURL } = this.options;
            if (!normalizedURL) {
              throw new TypeError("Missing `url` property");
            }
            this.requestUrl = normalizedURL.toString();
            decodeURI(this.requestUrl);
            await this._finalizeBody();
            await this._makeRequest();
            if (this.destroyed) {
              (_a2 = this[kRequest]) === null || _a2 === void 0 ? void 0 : _a2.destroy();
              return;
            }
            for (const job of this[kJobs]) {
              job();
            }
            this[kJobs].length = 0;
            this.requestInitialized = true;
          } catch (error) {
            if (error instanceof RequestError) {
              this._beforeError(error);
              return;
            }
            if (!this.destroyed) {
              this.destroy(error);
            }
          }
        })();
      }
      static normalizeArguments(url, options, defaults) {
        var _a2, _b, _c, _d, _e;
        const rawOptions = options;
        if (is_1.default.object(url) && !is_1.default.urlInstance(url)) {
          options = { ...defaults, ...url, ...options };
        } else {
          if (url && options && options.url !== void 0) {
            throw new TypeError("The `url` option is mutually exclusive with the `input` argument");
          }
          options = { ...defaults, ...options };
          if (url !== void 0) {
            options.url = url;
          }
          if (is_1.default.urlInstance(options.url)) {
            options.url = new url_1.URL(options.url.toString());
          }
        }
        if (options.cache === false) {
          options.cache = void 0;
        }
        if (options.dnsCache === false) {
          options.dnsCache = void 0;
        }
        is_1.assert.any([is_1.default.string, is_1.default.undefined], options.method);
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.headers);
        is_1.assert.any([is_1.default.string, is_1.default.urlInstance, is_1.default.undefined], options.prefixUrl);
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.cookieJar);
        is_1.assert.any([is_1.default.object, is_1.default.string, is_1.default.undefined], options.searchParams);
        is_1.assert.any([is_1.default.object, is_1.default.string, is_1.default.undefined], options.cache);
        is_1.assert.any([is_1.default.object, is_1.default.number, is_1.default.undefined], options.timeout);
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.context);
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.hooks);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.decompress);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.ignoreInvalidCookies);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.followRedirect);
        is_1.assert.any([is_1.default.number, is_1.default.undefined], options.maxRedirects);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.throwHttpErrors);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.http2);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.allowGetBody);
        is_1.assert.any([is_1.default.string, is_1.default.undefined], options.localAddress);
        is_1.assert.any([dns_ip_version_1.isDnsLookupIpVersion, is_1.default.undefined], options.dnsLookupIpVersion);
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.https);
        is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.rejectUnauthorized);
        if (options.https) {
          is_1.assert.any([is_1.default.boolean, is_1.default.undefined], options.https.rejectUnauthorized);
          is_1.assert.any([is_1.default.function_, is_1.default.undefined], options.https.checkServerIdentity);
          is_1.assert.any([is_1.default.string, is_1.default.object, is_1.default.array, is_1.default.undefined], options.https.certificateAuthority);
          is_1.assert.any([is_1.default.string, is_1.default.object, is_1.default.array, is_1.default.undefined], options.https.key);
          is_1.assert.any([is_1.default.string, is_1.default.object, is_1.default.array, is_1.default.undefined], options.https.certificate);
          is_1.assert.any([is_1.default.string, is_1.default.undefined], options.https.passphrase);
          is_1.assert.any([is_1.default.string, is_1.default.buffer, is_1.default.array, is_1.default.undefined], options.https.pfx);
        }
        is_1.assert.any([is_1.default.object, is_1.default.undefined], options.cacheOptions);
        if (is_1.default.string(options.method)) {
          options.method = options.method.toUpperCase();
        } else {
          options.method = "GET";
        }
        if (options.headers === (defaults === null || defaults === void 0 ? void 0 : defaults.headers)) {
          options.headers = { ...options.headers };
        } else {
          options.headers = lowercaseKeys({ ...defaults === null || defaults === void 0 ? void 0 : defaults.headers, ...options.headers });
        }
        if ("slashes" in options) {
          throw new TypeError("The legacy `url.Url` has been deprecated. Use `URL` instead.");
        }
        if ("auth" in options) {
          throw new TypeError("Parameter `auth` is deprecated. Use `username` / `password` instead.");
        }
        if ("searchParams" in options) {
          if (options.searchParams && options.searchParams !== (defaults === null || defaults === void 0 ? void 0 : defaults.searchParams)) {
            let searchParameters;
            if (is_1.default.string(options.searchParams) || options.searchParams instanceof url_1.URLSearchParams) {
              searchParameters = new url_1.URLSearchParams(options.searchParams);
            } else {
              validateSearchParameters(options.searchParams);
              searchParameters = new url_1.URLSearchParams();
              for (const key in options.searchParams) {
                const value = options.searchParams[key];
                if (value === null) {
                  searchParameters.append(key, "");
                } else if (value !== void 0) {
                  searchParameters.append(key, value);
                }
              }
            }
            (_a2 = defaults === null || defaults === void 0 ? void 0 : defaults.searchParams) === null || _a2 === void 0 ? void 0 : _a2.forEach((value, key) => {
              if (!searchParameters.has(key)) {
                searchParameters.append(key, value);
              }
            });
            options.searchParams = searchParameters;
          }
        }
        options.username = (_b = options.username) !== null && _b !== void 0 ? _b : "";
        options.password = (_c = options.password) !== null && _c !== void 0 ? _c : "";
        if (is_1.default.undefined(options.prefixUrl)) {
          options.prefixUrl = (_d = defaults === null || defaults === void 0 ? void 0 : defaults.prefixUrl) !== null && _d !== void 0 ? _d : "";
        } else {
          options.prefixUrl = options.prefixUrl.toString();
          if (options.prefixUrl !== "" && !options.prefixUrl.endsWith("/")) {
            options.prefixUrl += "/";
          }
        }
        if (is_1.default.string(options.url)) {
          if (options.url.startsWith("/")) {
            throw new Error("`input` must not start with a slash when using `prefixUrl`");
          }
          options.url = options_to_url_1.default(options.prefixUrl + options.url, options);
        } else if (is_1.default.undefined(options.url) && options.prefixUrl !== "" || options.protocol) {
          options.url = options_to_url_1.default(options.prefixUrl, options);
        }
        if (options.url) {
          if ("port" in options) {
            delete options.port;
          }
          let { prefixUrl } = options;
          Object.defineProperty(options, "prefixUrl", {
            set: (value) => {
              const url2 = options.url;
              if (!url2.href.startsWith(value)) {
                throw new Error(`Cannot change \`prefixUrl\` from ${prefixUrl} to ${value}: ${url2.href}`);
              }
              options.url = new url_1.URL(value + url2.href.slice(prefixUrl.length));
              prefixUrl = value;
            },
            get: () => prefixUrl
          });
          let { protocol } = options.url;
          if (protocol === "unix:") {
            protocol = "http:";
            options.url = new url_1.URL(`http://unix${options.url.pathname}${options.url.search}`);
          }
          if (options.searchParams) {
            options.url.search = options.searchParams.toString();
          }
          if (protocol !== "http:" && protocol !== "https:") {
            throw new UnsupportedProtocolError(options);
          }
          if (options.username === "") {
            options.username = options.url.username;
          } else {
            options.url.username = options.username;
          }
          if (options.password === "") {
            options.password = options.url.password;
          } else {
            options.url.password = options.password;
          }
        }
        const { cookieJar } = options;
        if (cookieJar) {
          let { setCookie, getCookieString } = cookieJar;
          is_1.assert.function_(setCookie);
          is_1.assert.function_(getCookieString);
          if (setCookie.length === 4 && getCookieString.length === 0) {
            setCookie = util_1.promisify(setCookie.bind(options.cookieJar));
            getCookieString = util_1.promisify(getCookieString.bind(options.cookieJar));
            options.cookieJar = {
              setCookie,
              getCookieString
            };
          }
        }
        const { cache } = options;
        if (cache) {
          if (!cacheableStore.has(cache)) {
            cacheableStore.set(cache, new CacheableRequest((requestOptions, handler) => {
              const result = requestOptions[kRequest](requestOptions, handler);
              if (is_1.default.promise(result)) {
                result.once = (event, handler2) => {
                  if (event === "error") {
                    result.catch(handler2);
                  } else if (event === "abort") {
                    (async () => {
                      try {
                        const request = await result;
                        request.once("abort", handler2);
                      } catch (_a3) {
                      }
                    })();
                  } else {
                    throw new Error(`Unknown HTTP2 promise event: ${event}`);
                  }
                  return result;
                };
              }
              return result;
            }, cache));
          }
        }
        options.cacheOptions = { ...options.cacheOptions };
        if (options.dnsCache === true) {
          if (!globalDnsCache) {
            globalDnsCache = new cacheable_lookup_1.default();
          }
          options.dnsCache = globalDnsCache;
        } else if (!is_1.default.undefined(options.dnsCache) && !options.dnsCache.lookup) {
          throw new TypeError(`Parameter \`dnsCache\` must be a CacheableLookup instance or a boolean, got ${is_1.default(options.dnsCache)}`);
        }
        if (is_1.default.number(options.timeout)) {
          options.timeout = { request: options.timeout };
        } else if (defaults && options.timeout !== defaults.timeout) {
          options.timeout = {
            ...defaults.timeout,
            ...options.timeout
          };
        } else {
          options.timeout = { ...options.timeout };
        }
        if (!options.context) {
          options.context = {};
        }
        const areHooksDefault = options.hooks === (defaults === null || defaults === void 0 ? void 0 : defaults.hooks);
        options.hooks = { ...options.hooks };
        for (const event of exports2.knownHookEvents) {
          if (event in options.hooks) {
            if (is_1.default.array(options.hooks[event])) {
              options.hooks[event] = [...options.hooks[event]];
            } else {
              throw new TypeError(`Parameter \`${event}\` must be an Array, got ${is_1.default(options.hooks[event])}`);
            }
          } else {
            options.hooks[event] = [];
          }
        }
        if (defaults && !areHooksDefault) {
          for (const event of exports2.knownHookEvents) {
            const defaultHooks = defaults.hooks[event];
            if (defaultHooks.length > 0) {
              options.hooks[event] = [
                ...defaults.hooks[event],
                ...options.hooks[event]
              ];
            }
          }
        }
        if ("family" in options) {
          deprecation_warning_1.default('"options.family" was never documented, please use "options.dnsLookupIpVersion"');
        }
        if (defaults === null || defaults === void 0 ? void 0 : defaults.https) {
          options.https = { ...defaults.https, ...options.https };
        }
        if ("rejectUnauthorized" in options) {
          deprecation_warning_1.default('"options.rejectUnauthorized" is now deprecated, please use "options.https.rejectUnauthorized"');
        }
        if ("checkServerIdentity" in options) {
          deprecation_warning_1.default('"options.checkServerIdentity" was never documented, please use "options.https.checkServerIdentity"');
        }
        if ("ca" in options) {
          deprecation_warning_1.default('"options.ca" was never documented, please use "options.https.certificateAuthority"');
        }
        if ("key" in options) {
          deprecation_warning_1.default('"options.key" was never documented, please use "options.https.key"');
        }
        if ("cert" in options) {
          deprecation_warning_1.default('"options.cert" was never documented, please use "options.https.certificate"');
        }
        if ("passphrase" in options) {
          deprecation_warning_1.default('"options.passphrase" was never documented, please use "options.https.passphrase"');
        }
        if ("pfx" in options) {
          deprecation_warning_1.default('"options.pfx" was never documented, please use "options.https.pfx"');
        }
        if ("followRedirects" in options) {
          throw new TypeError("The `followRedirects` option does not exist. Use `followRedirect` instead.");
        }
        if (options.agent) {
          for (const key in options.agent) {
            if (key !== "http" && key !== "https" && key !== "http2") {
              throw new TypeError(`Expected the \`options.agent\` properties to be \`http\`, \`https\` or \`http2\`, got \`${key}\``);
            }
          }
        }
        options.maxRedirects = (_e = options.maxRedirects) !== null && _e !== void 0 ? _e : 0;
        exports2.setNonEnumerableProperties([defaults, rawOptions], options);
        return normalize_arguments_1.default(options, defaults);
      }
      _lockWrite() {
        const onLockedWrite = () => {
          throw new TypeError("The payload has been already provided");
        };
        this.write = onLockedWrite;
        this.end = onLockedWrite;
      }
      _unlockWrite() {
        this.write = super.write;
        this.end = super.end;
      }
      async _finalizeBody() {
        const { options } = this;
        const { headers } = options;
        const isForm = !is_1.default.undefined(options.form);
        const isJSON = !is_1.default.undefined(options.json);
        const isBody = !is_1.default.undefined(options.body);
        const hasPayload = isForm || isJSON || isBody;
        const cannotHaveBody = exports2.withoutBody.has(options.method) && !(options.method === "GET" && options.allowGetBody);
        this._cannotHaveBody = cannotHaveBody;
        if (hasPayload) {
          if (cannotHaveBody) {
            throw new TypeError(`The \`${options.method}\` method cannot be used with a body`);
          }
          if ([isBody, isForm, isJSON].filter((isTrue) => isTrue).length > 1) {
            throw new TypeError("The `body`, `json` and `form` options are mutually exclusive");
          }
          if (isBody && !(options.body instanceof stream_1.Readable) && !is_1.default.string(options.body) && !is_1.default.buffer(options.body) && !is_form_data_1.default(options.body)) {
            throw new TypeError("The `body` option must be a stream.Readable, string or Buffer");
          }
          if (isForm && !is_1.default.object(options.form)) {
            throw new TypeError("The `form` option must be an Object");
          }
          {
            const noContentType = !is_1.default.string(headers["content-type"]);
            if (isBody) {
              if (is_form_data_1.default(options.body) && noContentType) {
                headers["content-type"] = `multipart/form-data; boundary=${options.body.getBoundary()}`;
              }
              this[kBody] = options.body;
            } else if (isForm) {
              if (noContentType) {
                headers["content-type"] = "application/x-www-form-urlencoded";
              }
              this[kBody] = new url_1.URLSearchParams(options.form).toString();
            } else {
              if (noContentType) {
                headers["content-type"] = "application/json";
              }
              this[kBody] = options.stringifyJson(options.json);
            }
            const uploadBodySize = await get_body_size_1.default(this[kBody], options.headers);
            if (is_1.default.undefined(headers["content-length"]) && is_1.default.undefined(headers["transfer-encoding"])) {
              if (!cannotHaveBody && !is_1.default.undefined(uploadBodySize)) {
                headers["content-length"] = String(uploadBodySize);
              }
            }
          }
        } else if (cannotHaveBody) {
          this._lockWrite();
        } else {
          this._unlockWrite();
        }
        this[kBodySize] = Number(headers["content-length"]) || void 0;
      }
      async _onResponseBase(response) {
        const { options } = this;
        const { url } = options;
        this[kOriginalResponse] = response;
        if (options.decompress) {
          response = decompressResponse(response);
        }
        const statusCode = response.statusCode;
        const typedResponse = response;
        typedResponse.statusMessage = typedResponse.statusMessage ? typedResponse.statusMessage : http.STATUS_CODES[statusCode];
        typedResponse.url = options.url.toString();
        typedResponse.requestUrl = this.requestUrl;
        typedResponse.redirectUrls = this.redirects;
        typedResponse.request = this;
        typedResponse.isFromCache = response.fromCache || false;
        typedResponse.ip = this.ip;
        typedResponse.retryCount = this.retryCount;
        this[kIsFromCache] = typedResponse.isFromCache;
        this[kResponseSize] = Number(response.headers["content-length"]) || void 0;
        this[kResponse] = response;
        response.once("end", () => {
          this[kResponseSize] = this[kDownloadedSize];
          this.emit("downloadProgress", this.downloadProgress);
        });
        response.once("error", (error) => {
          response.destroy();
          this._beforeError(new ReadError(error, this));
        });
        response.once("aborted", () => {
          this._beforeError(new ReadError({
            name: "Error",
            message: "The server aborted pending request",
            code: "ECONNRESET"
          }, this));
        });
        this.emit("downloadProgress", this.downloadProgress);
        const rawCookies = response.headers["set-cookie"];
        if (is_1.default.object(options.cookieJar) && rawCookies) {
          let promises = rawCookies.map(async (rawCookie) => options.cookieJar.setCookie(rawCookie, url.toString()));
          if (options.ignoreInvalidCookies) {
            promises = promises.map(async (p) => p.catch(() => {
            }));
          }
          try {
            await Promise.all(promises);
          } catch (error) {
            this._beforeError(error);
            return;
          }
        }
        if (options.followRedirect && response.headers.location && redirectCodes.has(statusCode)) {
          response.resume();
          if (this[kRequest]) {
            this[kCancelTimeouts]();
            delete this[kRequest];
            this[kUnproxyEvents]();
          }
          const shouldBeGet = statusCode === 303 && options.method !== "GET" && options.method !== "HEAD";
          if (shouldBeGet || !options.methodRewriting) {
            options.method = "GET";
            if ("body" in options) {
              delete options.body;
            }
            if ("json" in options) {
              delete options.json;
            }
            if ("form" in options) {
              delete options.form;
            }
            this[kBody] = void 0;
            delete options.headers["content-length"];
          }
          if (this.redirects.length >= options.maxRedirects) {
            this._beforeError(new MaxRedirectsError(this));
            return;
          }
          try {
            const redirectBuffer = Buffer.from(response.headers.location, "binary").toString();
            const redirectUrl = new url_1.URL(redirectBuffer, url);
            const redirectString = redirectUrl.toString();
            decodeURI(redirectString);
            if (redirectUrl.hostname !== url.hostname || redirectUrl.port !== url.port) {
              if ("host" in options.headers) {
                delete options.headers.host;
              }
              if ("cookie" in options.headers) {
                delete options.headers.cookie;
              }
              if ("authorization" in options.headers) {
                delete options.headers.authorization;
              }
              if (options.username || options.password) {
                options.username = "";
                options.password = "";
              }
            } else {
              redirectUrl.username = options.username;
              redirectUrl.password = options.password;
            }
            this.redirects.push(redirectString);
            options.url = redirectUrl;
            for (const hook of options.hooks.beforeRedirect) {
              await hook(options, typedResponse);
            }
            this.emit("redirect", typedResponse, options);
            await this._makeRequest();
          } catch (error) {
            this._beforeError(error);
            return;
          }
          return;
        }
        if (options.isStream && options.throwHttpErrors && !is_response_ok_1.isResponseOk(typedResponse)) {
          this._beforeError(new HTTPError(typedResponse));
          return;
        }
        response.on("readable", () => {
          if (this[kTriggerRead]) {
            this._read();
          }
        });
        this.on("resume", () => {
          response.resume();
        });
        this.on("pause", () => {
          response.pause();
        });
        response.once("end", () => {
          this.push(null);
        });
        this.emit("response", response);
        for (const destination of this[kServerResponsesPiped]) {
          if (destination.headersSent) {
            continue;
          }
          for (const key in response.headers) {
            const isAllowed = options.decompress ? key !== "content-encoding" : true;
            const value = response.headers[key];
            if (isAllowed) {
              destination.setHeader(key, value);
            }
          }
          destination.statusCode = statusCode;
        }
      }
      async _onResponse(response) {
        try {
          await this._onResponseBase(response);
        } catch (error) {
          this._beforeError(error);
        }
      }
      _onRequest(request) {
        const { options } = this;
        const { timeout, url } = options;
        http_timer_1.default(request);
        this[kCancelTimeouts] = timed_out_1.default(request, timeout, url);
        const responseEventName = options.cache ? "cacheableResponse" : "response";
        request.once(responseEventName, (response) => {
          void this._onResponse(response);
        });
        request.once("error", (error) => {
          var _a2;
          request.destroy();
          (_a2 = request.res) === null || _a2 === void 0 ? void 0 : _a2.removeAllListeners("end");
          error = error instanceof timed_out_1.TimeoutError ? new TimeoutError(error, this.timings, this) : new RequestError(error.message, error, this);
          this._beforeError(error);
        });
        this[kUnproxyEvents] = proxy_events_1.default(request, this, proxiedRequestEvents);
        this[kRequest] = request;
        this.emit("uploadProgress", this.uploadProgress);
        const body2 = this[kBody];
        const currentRequest = this.redirects.length === 0 ? this : request;
        if (is_1.default.nodeStream(body2)) {
          body2.pipe(currentRequest);
          body2.once("error", (error) => {
            this._beforeError(new UploadError(error, this));
          });
        } else {
          this._unlockWrite();
          if (!is_1.default.undefined(body2)) {
            this._writeRequest(body2, void 0, () => {
            });
            currentRequest.end();
            this._lockWrite();
          } else if (this._cannotHaveBody || this._noPipe) {
            currentRequest.end();
            this._lockWrite();
          }
        }
        this.emit("request", request);
      }
      async _createCacheableRequest(url, options) {
        return new Promise((resolve, reject) => {
          Object.assign(options, url_to_options_1.default(url));
          delete options.url;
          let request;
          const cacheRequest = cacheableStore.get(options.cache)(options, async (response) => {
            response._readableState.autoDestroy = false;
            if (request) {
              (await request).emit("cacheableResponse", response);
            }
            resolve(response);
          });
          options.url = url;
          cacheRequest.once("error", reject);
          cacheRequest.once("request", async (requestOrPromise) => {
            request = requestOrPromise;
            resolve(request);
          });
        });
      }
      async _makeRequest() {
        var _a2, _b, _c, _d, _e;
        const { options } = this;
        const { headers } = options;
        for (const key in headers) {
          if (is_1.default.undefined(headers[key])) {
            delete headers[key];
          } else if (is_1.default.null_(headers[key])) {
            throw new TypeError(`Use \`undefined\` instead of \`null\` to delete the \`${key}\` header`);
          }
        }
        if (options.decompress && is_1.default.undefined(headers["accept-encoding"])) {
          headers["accept-encoding"] = supportsBrotli ? "gzip, deflate, br" : "gzip, deflate";
        }
        if (options.cookieJar) {
          const cookieString = await options.cookieJar.getCookieString(options.url.toString());
          if (is_1.default.nonEmptyString(cookieString)) {
            options.headers.cookie = cookieString;
          }
        }
        for (const hook of options.hooks.beforeRequest) {
          const result = await hook(options);
          if (!is_1.default.undefined(result)) {
            options.request = () => result;
            break;
          }
        }
        if (options.body && this[kBody] !== options.body) {
          this[kBody] = options.body;
        }
        const { agent, request, timeout, url } = options;
        if (options.dnsCache && !("lookup" in options)) {
          options.lookup = options.dnsCache.lookup;
        }
        if (url.hostname === "unix") {
          const matches = /(?<socketPath>.+?):(?<path>.+)/.exec(`${url.pathname}${url.search}`);
          if (matches === null || matches === void 0 ? void 0 : matches.groups) {
            const { socketPath, path } = matches.groups;
            Object.assign(options, {
              socketPath,
              path,
              host: ""
            });
          }
        }
        const isHttps = url.protocol === "https:";
        let fallbackFn;
        if (options.http2) {
          fallbackFn = http2wrapper.auto;
        } else {
          fallbackFn = isHttps ? https.request : http.request;
        }
        const realFn = (_a2 = options.request) !== null && _a2 !== void 0 ? _a2 : fallbackFn;
        const fn3 = options.cache ? this._createCacheableRequest : realFn;
        if (agent && !options.http2) {
          options.agent = agent[isHttps ? "https" : "http"];
        }
        options[kRequest] = realFn;
        delete options.request;
        delete options.timeout;
        const requestOptions = options;
        requestOptions.shared = (_b = options.cacheOptions) === null || _b === void 0 ? void 0 : _b.shared;
        requestOptions.cacheHeuristic = (_c = options.cacheOptions) === null || _c === void 0 ? void 0 : _c.cacheHeuristic;
        requestOptions.immutableMinTimeToLive = (_d = options.cacheOptions) === null || _d === void 0 ? void 0 : _d.immutableMinTimeToLive;
        requestOptions.ignoreCargoCult = (_e = options.cacheOptions) === null || _e === void 0 ? void 0 : _e.ignoreCargoCult;
        if (options.dnsLookupIpVersion !== void 0) {
          try {
            requestOptions.family = dns_ip_version_1.dnsLookupIpVersionToFamily(options.dnsLookupIpVersion);
          } catch (_f) {
            throw new Error("Invalid `dnsLookupIpVersion` option value");
          }
        }
        if (options.https) {
          if ("rejectUnauthorized" in options.https) {
            requestOptions.rejectUnauthorized = options.https.rejectUnauthorized;
          }
          if (options.https.checkServerIdentity) {
            requestOptions.checkServerIdentity = options.https.checkServerIdentity;
          }
          if (options.https.certificateAuthority) {
            requestOptions.ca = options.https.certificateAuthority;
          }
          if (options.https.certificate) {
            requestOptions.cert = options.https.certificate;
          }
          if (options.https.key) {
            requestOptions.key = options.https.key;
          }
          if (options.https.passphrase) {
            requestOptions.passphrase = options.https.passphrase;
          }
          if (options.https.pfx) {
            requestOptions.pfx = options.https.pfx;
          }
        }
        try {
          let requestOrResponse = await fn3(url, requestOptions);
          if (is_1.default.undefined(requestOrResponse)) {
            requestOrResponse = fallbackFn(url, requestOptions);
          }
          options.request = request;
          options.timeout = timeout;
          options.agent = agent;
          if (options.https) {
            if ("rejectUnauthorized" in options.https) {
              delete requestOptions.rejectUnauthorized;
            }
            if (options.https.checkServerIdentity) {
              delete requestOptions.checkServerIdentity;
            }
            if (options.https.certificateAuthority) {
              delete requestOptions.ca;
            }
            if (options.https.certificate) {
              delete requestOptions.cert;
            }
            if (options.https.key) {
              delete requestOptions.key;
            }
            if (options.https.passphrase) {
              delete requestOptions.passphrase;
            }
            if (options.https.pfx) {
              delete requestOptions.pfx;
            }
          }
          if (isClientRequest(requestOrResponse)) {
            this._onRequest(requestOrResponse);
          } else if (this.writable) {
            this.once("finish", () => {
              void this._onResponse(requestOrResponse);
            });
            this._unlockWrite();
            this.end();
            this._lockWrite();
          } else {
            void this._onResponse(requestOrResponse);
          }
        } catch (error) {
          if (error instanceof CacheableRequest.CacheError) {
            throw new CacheError(error, this);
          }
          throw new RequestError(error.message, error, this);
        }
      }
      async _error(error) {
        try {
          for (const hook of this.options.hooks.beforeError) {
            error = await hook(error);
          }
        } catch (error_) {
          error = new RequestError(error_.message, error_, this);
        }
        this.destroy(error);
      }
      _beforeError(error) {
        if (this[kStopReading]) {
          return;
        }
        const { options } = this;
        const retryCount = this.retryCount + 1;
        this[kStopReading] = true;
        if (!(error instanceof RequestError)) {
          error = new RequestError(error.message, error, this);
        }
        const typedError = error;
        const { response } = typedError;
        void (async () => {
          if (response && !response.body) {
            response.setEncoding(this._readableState.encoding);
            try {
              response.rawBody = await get_buffer_1.default(response);
              response.body = response.rawBody.toString();
            } catch (_a2) {
            }
          }
          if (this.listenerCount("retry") !== 0) {
            let backoff;
            try {
              let retryAfter;
              if (response && "retry-after" in response.headers) {
                retryAfter = Number(response.headers["retry-after"]);
                if (Number.isNaN(retryAfter)) {
                  retryAfter = Date.parse(response.headers["retry-after"]) - Date.now();
                  if (retryAfter <= 0) {
                    retryAfter = 1;
                  }
                } else {
                  retryAfter *= 1e3;
                }
              }
              backoff = await options.retry.calculateDelay({
                attemptCount: retryCount,
                retryOptions: options.retry,
                error: typedError,
                retryAfter,
                computedValue: calculate_retry_delay_1.default({
                  attemptCount: retryCount,
                  retryOptions: options.retry,
                  error: typedError,
                  retryAfter,
                  computedValue: 0
                })
              });
            } catch (error_) {
              void this._error(new RequestError(error_.message, error_, this));
              return;
            }
            if (backoff) {
              const retry = async () => {
                try {
                  for (const hook of this.options.hooks.beforeRetry) {
                    await hook(this.options, typedError, retryCount);
                  }
                } catch (error_) {
                  void this._error(new RequestError(error_.message, error, this));
                  return;
                }
                if (this.destroyed) {
                  return;
                }
                this.destroy();
                this.emit("retry", retryCount, error);
              };
              this[kRetryTimeout] = setTimeout(retry, backoff);
              return;
            }
          }
          void this._error(typedError);
        })();
      }
      _read() {
        this[kTriggerRead] = true;
        const response = this[kResponse];
        if (response && !this[kStopReading]) {
          if (response.readableLength) {
            this[kTriggerRead] = false;
          }
          let data;
          while ((data = response.read()) !== null) {
            this[kDownloadedSize] += data.length;
            this[kStartedReading] = true;
            const progress = this.downloadProgress;
            if (progress.percent < 1) {
              this.emit("downloadProgress", progress);
            }
            this.push(data);
          }
        }
      }
      _write(chunk, encoding, callback) {
        const write = () => {
          this._writeRequest(chunk, encoding, callback);
        };
        if (this.requestInitialized) {
          write();
        } else {
          this[kJobs].push(write);
        }
      }
      _writeRequest(chunk, encoding, callback) {
        if (this[kRequest].destroyed) {
          return;
        }
        this._progressCallbacks.push(() => {
          this[kUploadedSize] += Buffer.byteLength(chunk, encoding);
          const progress = this.uploadProgress;
          if (progress.percent < 1) {
            this.emit("uploadProgress", progress);
          }
        });
        this[kRequest].write(chunk, encoding, (error) => {
          if (!error && this._progressCallbacks.length > 0) {
            this._progressCallbacks.shift()();
          }
          callback(error);
        });
      }
      _final(callback) {
        const endRequest = () => {
          while (this._progressCallbacks.length !== 0) {
            this._progressCallbacks.shift()();
          }
          if (!(kRequest in this)) {
            callback();
            return;
          }
          if (this[kRequest].destroyed) {
            callback();
            return;
          }
          this[kRequest].end((error) => {
            if (!error) {
              this[kBodySize] = this[kUploadedSize];
              this.emit("uploadProgress", this.uploadProgress);
              this[kRequest].emit("upload-complete");
            }
            callback(error);
          });
        };
        if (this.requestInitialized) {
          endRequest();
        } else {
          this[kJobs].push(endRequest);
        }
      }
      _destroy(error, callback) {
        var _a2;
        this[kStopReading] = true;
        clearTimeout(this[kRetryTimeout]);
        if (kRequest in this) {
          this[kCancelTimeouts]();
          if (!((_a2 = this[kResponse]) === null || _a2 === void 0 ? void 0 : _a2.complete)) {
            this[kRequest].destroy();
          }
        }
        if (error !== null && !is_1.default.undefined(error) && !(error instanceof RequestError)) {
          error = new RequestError(error.message, error, this);
        }
        callback(error);
      }
      get _isAboutToError() {
        return this[kStopReading];
      }
      get ip() {
        var _a2;
        return (_a2 = this.socket) === null || _a2 === void 0 ? void 0 : _a2.remoteAddress;
      }
      get aborted() {
        var _a2, _b, _c;
        return ((_b = (_a2 = this[kRequest]) === null || _a2 === void 0 ? void 0 : _a2.destroyed) !== null && _b !== void 0 ? _b : this.destroyed) && !((_c = this[kOriginalResponse]) === null || _c === void 0 ? void 0 : _c.complete);
      }
      get socket() {
        var _a2, _b;
        return (_b = (_a2 = this[kRequest]) === null || _a2 === void 0 ? void 0 : _a2.socket) !== null && _b !== void 0 ? _b : void 0;
      }
      get downloadProgress() {
        let percent;
        if (this[kResponseSize]) {
          percent = this[kDownloadedSize] / this[kResponseSize];
        } else if (this[kResponseSize] === this[kDownloadedSize]) {
          percent = 1;
        } else {
          percent = 0;
        }
        return {
          percent,
          transferred: this[kDownloadedSize],
          total: this[kResponseSize]
        };
      }
      get uploadProgress() {
        let percent;
        if (this[kBodySize]) {
          percent = this[kUploadedSize] / this[kBodySize];
        } else if (this[kBodySize] === this[kUploadedSize]) {
          percent = 1;
        } else {
          percent = 0;
        }
        return {
          percent,
          transferred: this[kUploadedSize],
          total: this[kBodySize]
        };
      }
      get timings() {
        var _a2;
        return (_a2 = this[kRequest]) === null || _a2 === void 0 ? void 0 : _a2.timings;
      }
      get isFromCache() {
        return this[kIsFromCache];
      }
      pipe(destination, options) {
        if (this[kStartedReading]) {
          throw new Error("Failed to pipe. The response has been emitted already.");
        }
        if (destination instanceof http_1.ServerResponse) {
          this[kServerResponsesPiped].add(destination);
        }
        return super.pipe(destination, options);
      }
      unpipe(destination) {
        if (destination instanceof http_1.ServerResponse) {
          this[kServerResponsesPiped].delete(destination);
        }
        super.unpipe(destination);
        return this;
      }
    };
    exports2.default = Request;
  }
});

// node_modules/got/dist/source/as-promise/types.js
var require_types3 = __commonJS({
  "node_modules/got/dist/source/as-promise/types.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.CancelError = exports2.ParseError = void 0;
    var core_1 = require_core();
    var ParseError = class extends core_1.RequestError {
      constructor(error, response) {
        const { options } = response.request;
        super(`${error.message} in "${options.url.toString()}"`, error, response.request);
        this.name = "ParseError";
        this.code = this.code === "ERR_GOT_REQUEST_ERROR" ? "ERR_BODY_PARSE_FAILURE" : this.code;
      }
    };
    exports2.ParseError = ParseError;
    var CancelError = class extends core_1.RequestError {
      constructor(request) {
        super("Promise was canceled", {}, request);
        this.name = "CancelError";
        this.code = "ERR_CANCELED";
      }
      get isCanceled() {
        return true;
      }
    };
    exports2.CancelError = CancelError;
    __exportStar(require_core(), exports2);
  }
});

// node_modules/got/dist/source/as-promise/parse-body.js
var require_parse_body = __commonJS({
  "node_modules/got/dist/source/as-promise/parse-body.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var types_1 = require_types3();
    var parseBody = (response, responseType, parseJson, encoding) => {
      const { rawBody } = response;
      try {
        if (responseType === "text") {
          return rawBody.toString(encoding);
        }
        if (responseType === "json") {
          return rawBody.length === 0 ? "" : parseJson(rawBody.toString());
        }
        if (responseType === "buffer") {
          return rawBody;
        }
        throw new types_1.ParseError({
          message: `Unknown body type '${responseType}'`,
          name: "Error"
        }, response);
      } catch (error) {
        throw new types_1.ParseError(error, response);
      }
    };
    exports2.default = parseBody;
  }
});

// node_modules/got/dist/source/as-promise/index.js
var require_as_promise = __commonJS({
  "node_modules/got/dist/source/as-promise/index.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var events_1 = require("events");
    var is_1 = require_dist();
    var PCancelable = require_p_cancelable();
    var types_1 = require_types3();
    var parse_body_1 = require_parse_body();
    var core_1 = require_core();
    var proxy_events_1 = require_proxy_events2();
    var get_buffer_1 = require_get_buffer();
    var is_response_ok_1 = require_is_response_ok();
    var proxiedRequestEvents = [
      "request",
      "response",
      "redirect",
      "uploadProgress",
      "downloadProgress"
    ];
    function asPromise(normalizedOptions) {
      let globalRequest;
      let globalResponse;
      const emitter = new events_1.EventEmitter();
      const promise = new PCancelable((resolve, reject, onCancel) => {
        const makeRequest = (retryCount) => {
          const request = new core_1.default(void 0, normalizedOptions);
          request.retryCount = retryCount;
          request._noPipe = true;
          onCancel(() => request.destroy());
          onCancel.shouldReject = false;
          onCancel(() => reject(new types_1.CancelError(request)));
          globalRequest = request;
          request.once("response", async (response) => {
            var _a2;
            response.retryCount = retryCount;
            if (response.request.aborted) {
              return;
            }
            let rawBody;
            try {
              rawBody = await get_buffer_1.default(request);
              response.rawBody = rawBody;
            } catch (_b) {
              return;
            }
            if (request._isAboutToError) {
              return;
            }
            const contentEncoding = ((_a2 = response.headers["content-encoding"]) !== null && _a2 !== void 0 ? _a2 : "").toLowerCase();
            const isCompressed = ["gzip", "deflate", "br"].includes(contentEncoding);
            const { options } = request;
            if (isCompressed && !options.decompress) {
              response.body = rawBody;
            } else {
              try {
                response.body = parse_body_1.default(response, options.responseType, options.parseJson, options.encoding);
              } catch (error) {
                response.body = rawBody.toString();
                if (is_response_ok_1.isResponseOk(response)) {
                  request._beforeError(error);
                  return;
                }
              }
            }
            try {
              for (const [index, hook] of options.hooks.afterResponse.entries()) {
                response = await hook(response, async (updatedOptions) => {
                  const typedOptions = core_1.default.normalizeArguments(void 0, {
                    ...updatedOptions,
                    retry: {
                      calculateDelay: () => 0
                    },
                    throwHttpErrors: false,
                    resolveBodyOnly: false
                  }, options);
                  typedOptions.hooks.afterResponse = typedOptions.hooks.afterResponse.slice(0, index);
                  for (const hook2 of typedOptions.hooks.beforeRetry) {
                    await hook2(typedOptions);
                  }
                  const promise2 = asPromise(typedOptions);
                  onCancel(() => {
                    promise2.catch(() => {
                    });
                    promise2.cancel();
                  });
                  return promise2;
                });
              }
            } catch (error) {
              request._beforeError(new types_1.RequestError(error.message, error, request));
              return;
            }
            if (!is_response_ok_1.isResponseOk(response)) {
              request._beforeError(new types_1.HTTPError(response));
              return;
            }
            globalResponse = response;
            resolve(request.options.resolveBodyOnly ? response.body : response);
          });
          const onError = (error) => {
            if (promise.isCanceled) {
              return;
            }
            const { options } = request;
            if (error instanceof types_1.HTTPError && !options.throwHttpErrors) {
              const { response } = error;
              resolve(request.options.resolveBodyOnly ? response.body : response);
              return;
            }
            reject(error);
          };
          request.once("error", onError);
          const previousBody = request.options.body;
          request.once("retry", (newRetryCount, error) => {
            var _a2, _b;
            if (previousBody === ((_a2 = error.request) === null || _a2 === void 0 ? void 0 : _a2.options.body) && is_1.default.nodeStream((_b = error.request) === null || _b === void 0 ? void 0 : _b.options.body)) {
              onError(error);
              return;
            }
            makeRequest(newRetryCount);
          });
          proxy_events_1.default(request, emitter, proxiedRequestEvents);
        };
        makeRequest(0);
      });
      promise.on = (event, fn3) => {
        emitter.on(event, fn3);
        return promise;
      };
      const shortcut = (responseType) => {
        const newPromise = (async () => {
          await promise;
          const { options } = globalResponse.request;
          return parse_body_1.default(globalResponse, responseType, options.parseJson, options.encoding);
        })();
        Object.defineProperties(newPromise, Object.getOwnPropertyDescriptors(promise));
        return newPromise;
      };
      promise.json = () => {
        const { headers } = globalRequest.options;
        if (!globalRequest.writableFinished && headers.accept === void 0) {
          headers.accept = "application/json";
        }
        return shortcut("json");
      };
      promise.buffer = () => shortcut("buffer");
      promise.text = () => shortcut("text");
      return promise;
    }
    exports2.default = asPromise;
    __exportStar(require_types3(), exports2);
  }
});

// node_modules/got/dist/source/as-promise/create-rejection.js
var require_create_rejection = __commonJS({
  "node_modules/got/dist/source/as-promise/create-rejection.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var types_1 = require_types3();
    function createRejection(error, ...beforeErrorGroups) {
      const promise = (async () => {
        if (error instanceof types_1.RequestError) {
          try {
            for (const hooks of beforeErrorGroups) {
              if (hooks) {
                for (const hook of hooks) {
                  error = await hook(error);
                }
              }
            }
          } catch (error_) {
            error = error_;
          }
        }
        throw error;
      })();
      const returnPromise = () => promise;
      promise.json = returnPromise;
      promise.text = returnPromise;
      promise.buffer = returnPromise;
      promise.on = returnPromise;
      return promise;
    }
    exports2.default = createRejection;
  }
});

// node_modules/got/dist/source/utils/deep-freeze.js
var require_deep_freeze = __commonJS({
  "node_modules/got/dist/source/utils/deep-freeze.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
    var is_1 = require_dist();
    function deepFreeze(object) {
      for (const value of Object.values(object)) {
        if (is_1.default.plainObject(value) || is_1.default.array(value)) {
          deepFreeze(value);
        }
      }
      return Object.freeze(object);
    }
    exports2.default = deepFreeze;
  }
});

// node_modules/got/dist/source/types.js
var require_types4 = __commonJS({
  "node_modules/got/dist/source/types.js"(exports2) {
    "use strict";
    Object.defineProperty(exports2, "__esModule", { value: true });
  }
});

// node_modules/got/dist/source/create.js
var require_create = __commonJS({
  "node_modules/got/dist/source/create.js"(exports2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    exports2.defaultHandler = void 0;
    var is_1 = require_dist();
    var as_promise_1 = require_as_promise();
    var create_rejection_1 = require_create_rejection();
    var core_1 = require_core();
    var deep_freeze_1 = require_deep_freeze();
    var errors = {
      RequestError: as_promise_1.RequestError,
      CacheError: as_promise_1.CacheError,
      ReadError: as_promise_1.ReadError,
      HTTPError: as_promise_1.HTTPError,
      MaxRedirectsError: as_promise_1.MaxRedirectsError,
      TimeoutError: as_promise_1.TimeoutError,
      ParseError: as_promise_1.ParseError,
      CancelError: as_promise_1.CancelError,
      UnsupportedProtocolError: as_promise_1.UnsupportedProtocolError,
      UploadError: as_promise_1.UploadError
    };
    var delay = async (ms) => new Promise((resolve) => {
      setTimeout(resolve, ms);
    });
    var { normalizeArguments } = core_1.default;
    var mergeOptions = (...sources) => {
      let mergedOptions;
      for (const source of sources) {
        mergedOptions = normalizeArguments(void 0, source, mergedOptions);
      }
      return mergedOptions;
    };
    var getPromiseOrStream = (options) => options.isStream ? new core_1.default(void 0, options) : as_promise_1.default(options);
    var isGotInstance = (value) => "defaults" in value && "options" in value.defaults;
    var aliases = [
      "get",
      "post",
      "put",
      "patch",
      "head",
      "delete"
    ];
    exports2.defaultHandler = (options, next) => next(options);
    var callInitHooks = (hooks, options) => {
      if (hooks) {
        for (const hook of hooks) {
          hook(options);
        }
      }
    };
    var create = (defaults) => {
      defaults._rawHandlers = defaults.handlers;
      defaults.handlers = defaults.handlers.map((fn3) => (options, next) => {
        let root;
        const result = fn3(options, (newOptions) => {
          root = next(newOptions);
          return root;
        });
        if (result !== root && !options.isStream && root) {
          const typedResult = result;
          const { then: promiseThen, catch: promiseCatch, finally: promiseFianlly } = typedResult;
          Object.setPrototypeOf(typedResult, Object.getPrototypeOf(root));
          Object.defineProperties(typedResult, Object.getOwnPropertyDescriptors(root));
          typedResult.then = promiseThen;
          typedResult.catch = promiseCatch;
          typedResult.finally = promiseFianlly;
        }
        return result;
      });
      const got = (url, options = {}, _defaults) => {
        var _a2, _b;
        let iteration = 0;
        const iterateHandlers = (newOptions) => {
          return defaults.handlers[iteration++](newOptions, iteration === defaults.handlers.length ? getPromiseOrStream : iterateHandlers);
        };
        if (is_1.default.plainObject(url)) {
          const mergedOptions = {
            ...url,
            ...options
          };
          core_1.setNonEnumerableProperties([url, options], mergedOptions);
          options = mergedOptions;
          url = void 0;
        }
        try {
          let initHookError;
          try {
            callInitHooks(defaults.options.hooks.init, options);
            callInitHooks((_a2 = options.hooks) === null || _a2 === void 0 ? void 0 : _a2.init, options);
          } catch (error) {
            initHookError = error;
          }
          const normalizedOptions = normalizeArguments(url, options, _defaults !== null && _defaults !== void 0 ? _defaults : defaults.options);
          normalizedOptions[core_1.kIsNormalizedAlready] = true;
          if (initHookError) {
            throw new as_promise_1.RequestError(initHookError.message, initHookError, normalizedOptions);
          }
          return iterateHandlers(normalizedOptions);
        } catch (error) {
          if (options.isStream) {
            throw error;
          } else {
            return create_rejection_1.default(error, defaults.options.hooks.beforeError, (_b = options.hooks) === null || _b === void 0 ? void 0 : _b.beforeError);
          }
        }
      };
      got.extend = (...instancesOrOptions) => {
        const optionsArray = [defaults.options];
        let handlers = [...defaults._rawHandlers];
        let isMutableDefaults;
        for (const value of instancesOrOptions) {
          if (isGotInstance(value)) {
            optionsArray.push(value.defaults.options);
            handlers.push(...value.defaults._rawHandlers);
            isMutableDefaults = value.defaults.mutableDefaults;
          } else {
            optionsArray.push(value);
            if ("handlers" in value) {
              handlers.push(...value.handlers);
            }
            isMutableDefaults = value.mutableDefaults;
          }
        }
        handlers = handlers.filter((handler) => handler !== exports2.defaultHandler);
        if (handlers.length === 0) {
          handlers.push(exports2.defaultHandler);
        }
        return create({
          options: mergeOptions(...optionsArray),
          handlers,
          mutableDefaults: Boolean(isMutableDefaults)
        });
      };
      const paginateEach = async function* (url, options) {
        let normalizedOptions = normalizeArguments(url, options, defaults.options);
        normalizedOptions.resolveBodyOnly = false;
        const pagination = normalizedOptions.pagination;
        if (!is_1.default.object(pagination)) {
          throw new TypeError("`options.pagination` must be implemented");
        }
        const all = [];
        let { countLimit } = pagination;
        let numberOfRequests = 0;
        while (numberOfRequests < pagination.requestLimit) {
          if (numberOfRequests !== 0) {
            await delay(pagination.backoff);
          }
          const result = await got(void 0, void 0, normalizedOptions);
          const parsed = await pagination.transform(result);
          const current = [];
          for (const item of parsed) {
            if (pagination.filter(item, all, current)) {
              if (!pagination.shouldContinue(item, all, current)) {
                return;
              }
              yield item;
              if (pagination.stackAllItems) {
                all.push(item);
              }
              current.push(item);
              if (--countLimit <= 0) {
                return;
              }
            }
          }
          const optionsToMerge = pagination.paginate(result, all, current);
          if (optionsToMerge === false) {
            return;
          }
          if (optionsToMerge === result.request.options) {
            normalizedOptions = result.request.options;
          } else if (optionsToMerge !== void 0) {
            normalizedOptions = normalizeArguments(void 0, optionsToMerge, normalizedOptions);
          }
          numberOfRequests++;
        }
      };
      got.paginate = paginateEach;
      got.paginate.all = async (url, options) => {
        const results = [];
        for await (const item of paginateEach(url, options)) {
          results.push(item);
        }
        return results;
      };
      got.paginate.each = paginateEach;
      got.stream = (url, options) => got(url, { ...options, isStream: true });
      for (const method of aliases) {
        got[method] = (url, options) => got(url, { ...options, method });
        got.stream[method] = (url, options) => {
          return got(url, { ...options, method, isStream: true });
        };
      }
      Object.assign(got, errors);
      Object.defineProperty(got, "defaults", {
        value: defaults.mutableDefaults ? defaults : deep_freeze_1.default(defaults),
        writable: defaults.mutableDefaults,
        configurable: defaults.mutableDefaults,
        enumerable: true
      });
      got.mergeOptions = mergeOptions;
      return got;
    };
    exports2.default = create;
    __exportStar(require_types4(), exports2);
  }
});

// node_modules/got/dist/source/index.js
var require_source6 = __commonJS({
  "node_modules/got/dist/source/index.js"(exports2, module2) {
    "use strict";
    var __createBinding = exports2 && exports2.__createBinding || (Object.create ? function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      Object.defineProperty(o, k2, { enumerable: true, get: function() {
        return m[k];
      } });
    } : function(o, m, k, k2) {
      if (k2 === void 0)
        k2 = k;
      o[k2] = m[k];
    });
    var __exportStar = exports2 && exports2.__exportStar || function(m, exports3) {
      for (var p in m)
        if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports3, p))
          __createBinding(exports3, m, p);
    };
    Object.defineProperty(exports2, "__esModule", { value: true });
    var url_1 = require("url");
    var create_1 = require_create();
    var defaults = {
      options: {
        method: "GET",
        retry: {
          limit: 2,
          methods: [
            "GET",
            "PUT",
            "HEAD",
            "DELETE",
            "OPTIONS",
            "TRACE"
          ],
          statusCodes: [
            408,
            413,
            429,
            500,
            502,
            503,
            504,
            521,
            522,
            524
          ],
          errorCodes: [
            "ETIMEDOUT",
            "ECONNRESET",
            "EADDRINUSE",
            "ECONNREFUSED",
            "EPIPE",
            "ENOTFOUND",
            "ENETUNREACH",
            "EAI_AGAIN"
          ],
          maxRetryAfter: void 0,
          calculateDelay: ({ computedValue }) => computedValue
        },
        timeout: {},
        headers: {
          "user-agent": "got (https://github.com/sindresorhus/got)"
        },
        hooks: {
          init: [],
          beforeRequest: [],
          beforeRedirect: [],
          beforeRetry: [],
          beforeError: [],
          afterResponse: []
        },
        cache: void 0,
        dnsCache: void 0,
        decompress: true,
        throwHttpErrors: true,
        followRedirect: true,
        isStream: false,
        responseType: "text",
        resolveBodyOnly: false,
        maxRedirects: 10,
        prefixUrl: "",
        methodRewriting: true,
        ignoreInvalidCookies: false,
        context: {},
        http2: false,
        allowGetBody: false,
        https: void 0,
        pagination: {
          transform: (response) => {
            if (response.request.options.responseType === "json") {
              return response.body;
            }
            return JSON.parse(response.body);
          },
          paginate: (response) => {
            if (!Reflect.has(response.headers, "link")) {
              return false;
            }
            const items = response.headers.link.split(",");
            let next;
            for (const item of items) {
              const parsed = item.split(";");
              if (parsed[1].includes("next")) {
                next = parsed[0].trimStart().trim();
                next = next.slice(1, -1);
                break;
              }
            }
            if (next) {
              const options = {
                url: new url_1.URL(next)
              };
              return options;
            }
            return false;
          },
          filter: () => true,
          shouldContinue: () => true,
          countLimit: Infinity,
          backoff: 0,
          requestLimit: 1e4,
          stackAllItems: true
        },
        parseJson: (text) => JSON.parse(text),
        stringifyJson: (object) => JSON.stringify(object),
        cacheOptions: {}
      },
      handlers: [create_1.defaultHandler],
      mutableDefaults: false
    };
    var got = create_1.default(defaults);
    exports2.default = got;
    module2.exports = got;
    module2.exports.default = got;
    module2.exports.__esModule = true;
    __exportStar(require_create(), exports2);
    __exportStar(require_as_promise(), exports2);
  }
});

// node_modules/ini/ini.js
var require_ini = __commonJS({
  "node_modules/ini/ini.js"(exports2) {
    exports2.parse = exports2.decode = decode;
    exports2.stringify = exports2.encode = encode;
    exports2.safe = safe;
    exports2.unsafe = unsafe;
    var eol = typeof process !== "undefined" && process.platform === "win32" ? "\r\n" : "\n";
    function encode(obj, opt) {
      var children = [];
      var out = "";
      if (typeof opt === "string") {
        opt = {
          section: opt,
          whitespace: false
        };
      } else {
        opt = opt || {};
        opt.whitespace = opt.whitespace === true;
      }
      var separator = opt.whitespace ? " = " : "=";
      Object.keys(obj).forEach(function(k, _, __) {
        var val = obj[k];
        if (val && Array.isArray(val)) {
          val.forEach(function(item) {
            out += safe(k + "[]") + separator + safe(item) + "\n";
          });
        } else if (val && typeof val === "object")
          children.push(k);
        else
          out += safe(k) + separator + safe(val) + eol;
      });
      if (opt.section && out.length)
        out = "[" + safe(opt.section) + "]" + eol + out;
      children.forEach(function(k, _, __) {
        var nk = dotSplit(k).join("\\.");
        var section = (opt.section ? opt.section + "." : "") + nk;
        var child = encode(obj[k], {
          section,
          whitespace: opt.whitespace
        });
        if (out.length && child.length)
          out += eol;
        out += child;
      });
      return out;
    }
    function dotSplit(str2) {
      return str2.replace(/\1/g, "LITERAL\\1LITERAL").replace(/\\\./g, "").split(/\./).map(function(part) {
        return part.replace(/\1/g, "\\.").replace(/\2LITERAL\\1LITERAL\2/g, "");
      });
    }
    function decode(str2) {
      var out = {};
      var p = out;
      var section = null;
      var re = /^\[([^\]]*)\]$|^([^=]+)(=(.*))?$/i;
      var lines = str2.split(/[\r\n]+/g);
      lines.forEach(function(line, _, __) {
        if (!line || line.match(/^\s*[;#]/))
          return;
        var match = line.match(re);
        if (!match)
          return;
        if (match[1] !== void 0) {
          section = unsafe(match[1]);
          if (section === "__proto__") {
            p = {};
            return;
          }
          p = out[section] = out[section] || {};
          return;
        }
        var key = unsafe(match[2]);
        if (key === "__proto__")
          return;
        var value = match[3] ? unsafe(match[4]) : true;
        switch (value) {
          case "true":
          case "false":
          case "null":
            value = JSON.parse(value);
        }
        if (key.length > 2 && key.slice(-2) === "[]") {
          key = key.substring(0, key.length - 2);
          if (key === "__proto__")
            return;
          if (!p[key])
            p[key] = [];
          else if (!Array.isArray(p[key]))
            p[key] = [p[key]];
        }
        if (Array.isArray(p[key]))
          p[key].push(value);
        else
          p[key] = value;
      });
      Object.keys(out).filter(function(k, _, __) {
        if (!out[k] || typeof out[k] !== "object" || Array.isArray(out[k]))
          return false;
        var parts = dotSplit(k);
        var p2 = out;
        var l = parts.pop();
        var nl = l.replace(/\\\./g, ".");
        parts.forEach(function(part, _2, __2) {
          if (part === "__proto__")
            return;
          if (!p2[part] || typeof p2[part] !== "object")
            p2[part] = {};
          p2 = p2[part];
        });
        if (p2 === out && nl === l)
          return false;
        p2[nl] = out[k];
        return true;
      }).forEach(function(del, _, __) {
        delete out[del];
      });
      return out;
    }
    function isQuoted(val) {
      return val.charAt(0) === '"' && val.slice(-1) === '"' || val.charAt(0) === "'" && val.slice(-1) === "'";
    }
    function safe(val) {
      return typeof val !== "string" || val.match(/[=\r\n]/) || val.match(/^\[/) || val.length > 1 && isQuoted(val) || val !== val.trim() ? JSON.stringify(val) : val.replace(/;/g, "\\;").replace(/#/g, "\\#");
    }
    function unsafe(val, doUnesc) {
      val = (val || "").trim();
      if (isQuoted(val)) {
        if (val.charAt(0) === "'")
          val = val.substr(1, val.length - 2);
        try {
          val = JSON.parse(val);
        } catch (_) {
        }
      } else {
        var esc = false;
        var unesc = "";
        for (var i = 0, l = val.length; i < l; i++) {
          var c = val.charAt(i);
          if (esc) {
            if ("\\;#".indexOf(c) !== -1)
              unesc += c;
            else
              unesc += "\\" + c;
            esc = false;
          } else if (";#".indexOf(c) !== -1)
            break;
          else if (c === "\\")
            esc = true;
          else
            unesc += c;
        }
        if (esc)
          unesc += "\\";
        return unesc.trim();
      }
      return val;
    }
  }
});

// node_modules/strip-json-comments/index.js
var require_strip_json_comments = __commonJS({
  "node_modules/strip-json-comments/index.js"(exports2, module2) {
    "use strict";
    var singleComment = 1;
    var multiComment = 2;
    function stripWithoutWhitespace() {
      return "";
    }
    function stripWithWhitespace(str2, start, end) {
      return str2.slice(start, end).replace(/\S/g, " ");
    }
    module2.exports = function(str2, opts) {
      opts = opts || {};
      var currentChar;
      var nextChar;
      var insideString = false;
      var insideComment = false;
      var offset = 0;
      var ret = "";
      var strip = opts.whitespace === false ? stripWithoutWhitespace : stripWithWhitespace;
      for (var i = 0; i < str2.length; i++) {
        currentChar = str2[i];
        nextChar = str2[i + 1];
        if (!insideComment && currentChar === '"') {
          var escaped = str2[i - 1] === "\\" && str2[i - 2] !== "\\";
          if (!escaped) {
            insideString = !insideString;
          }
        }
        if (insideString) {
          continue;
        }
        if (!insideComment && currentChar + nextChar === "//") {
          ret += str2.slice(offset, i);
          offset = i;
          insideComment = singleComment;
          i++;
        } else if (insideComment === singleComment && currentChar + nextChar === "\r\n") {
          i++;
          insideComment = false;
          ret += strip(str2, offset, i);
          offset = i;
          continue;
        } else if (insideComment === singleComment && currentChar === "\n") {
          insideComment = false;
          ret += strip(str2, offset, i);
          offset = i;
        } else if (!insideComment && currentChar + nextChar === "/*") {
          ret += str2.slice(offset, i);
          offset = i;
          insideComment = multiComment;
          i++;
          continue;
        } else if (insideComment === multiComment && currentChar + nextChar === "*/") {
          i++;
          insideComment = false;
          ret += strip(str2, offset, i + 1);
          offset = i + 1;
          continue;
        }
      }
      return ret + (insideComment ? strip(str2.substr(offset)) : str2.substr(offset));
    };
  }
});

// node_modules/rc/lib/utils.js
var require_utils = __commonJS({
  "node_modules/rc/lib/utils.js"(exports2) {
    "use strict";
    var fs = require("fs");
    var ini = require_ini();
    var path = require("path");
    var stripJsonComments = require_strip_json_comments();
    var parse2 = exports2.parse = function(content) {
      if (/^\s*{/.test(content))
        return JSON.parse(stripJsonComments(content));
      return ini.parse(content);
    };
    var file = exports2.file = function() {
      var args2 = [].slice.call(arguments).filter(function(arg) {
        return arg != null;
      });
      for (var i in args2)
        if (typeof args2[i] !== "string")
          return;
      var file2 = path.join.apply(null, args2);
      var content;
      try {
        return fs.readFileSync(file2, "utf-8");
      } catch (err) {
        return;
      }
    };
    var json = exports2.json = function() {
      var content = file.apply(null, arguments);
      return content ? parse2(content) : null;
    };
    var env = exports2.env = function(prefix, env2) {
      env2 = env2 || process.env;
      var obj = {};
      var l = prefix.length;
      for (var k in env2) {
        if (k.toLowerCase().indexOf(prefix.toLowerCase()) === 0) {
          var keypath = k.substring(l).split("__");
          var _emptyStringIndex;
          while ((_emptyStringIndex = keypath.indexOf("")) > -1) {
            keypath.splice(_emptyStringIndex, 1);
          }
          var cursor = obj;
          keypath.forEach(function _buildSubObj(_subkey, i) {
            if (!_subkey || typeof cursor !== "object")
              return;
            if (i === keypath.length - 1)
              cursor[_subkey] = env2[k];
            if (cursor[_subkey] === void 0)
              cursor[_subkey] = {};
            cursor = cursor[_subkey];
          });
        }
      }
      return obj;
    };
    var find2 = exports2.find = function() {
      var rel = path.join.apply(null, [].slice.call(arguments));
      function find3(start, rel2) {
        var file2 = path.join(start, rel2);
        try {
          fs.statSync(file2);
          return file2;
        } catch (err) {
          if (path.dirname(start) !== start)
            return find3(path.dirname(start), rel2);
        }
      }
      return find3(process.cwd(), rel);
    };
  }
});

// node_modules/deep-extend/lib/deep-extend.js
var require_deep_extend = __commonJS({
  "node_modules/deep-extend/lib/deep-extend.js"(exports2, module2) {
    "use strict";
    function isSpecificValue(val) {
      return val instanceof Buffer || val instanceof Date || val instanceof RegExp ? true : false;
    }
    function cloneSpecificValue(val) {
      if (val instanceof Buffer) {
        var x = Buffer.alloc ? Buffer.alloc(val.length) : new Buffer(val.length);
        val.copy(x);
        return x;
      } else if (val instanceof Date) {
        return new Date(val.getTime());
      } else if (val instanceof RegExp) {
        return new RegExp(val);
      } else {
        throw new Error("Unexpected situation");
      }
    }
    function deepCloneArray(arr) {
      var clone = [];
      arr.forEach(function(item, index) {
        if (typeof item === "object" && item !== null) {
          if (Array.isArray(item)) {
            clone[index] = deepCloneArray(item);
          } else if (isSpecificValue(item)) {
            clone[index] = cloneSpecificValue(item);
          } else {
            clone[index] = deepExtend({}, item);
          }
        } else {
          clone[index] = item;
        }
      });
      return clone;
    }
    function safeGetProperty(object, property) {
      return property === "__proto__" ? void 0 : object[property];
    }
    var deepExtend = module2.exports = function() {
      if (arguments.length < 1 || typeof arguments[0] !== "object") {
        return false;
      }
      if (arguments.length < 2) {
        return arguments[0];
      }
      var target = arguments[0];
      var args2 = Array.prototype.slice.call(arguments, 1);
      var val, src, clone;
      args2.forEach(function(obj) {
        if (typeof obj !== "object" || obj === null || Array.isArray(obj)) {
          return;
        }
        Object.keys(obj).forEach(function(key) {
          src = safeGetProperty(target, key);
          val = safeGetProperty(obj, key);
          if (val === target) {
            return;
          } else if (typeof val !== "object" || val === null) {
            target[key] = val;
            return;
          } else if (Array.isArray(val)) {
            target[key] = deepCloneArray(val);
            return;
          } else if (isSpecificValue(val)) {
            target[key] = cloneSpecificValue(val);
            return;
          } else if (typeof src !== "object" || src === null || Array.isArray(src)) {
            target[key] = deepExtend({}, val);
            return;
          } else {
            target[key] = deepExtend(src, val);
            return;
          }
        });
      });
      return target;
    };
  }
});

// node_modules/minimist/index.js
var require_minimist = __commonJS({
  "node_modules/minimist/index.js"(exports2, module2) {
    module2.exports = function(args2, opts) {
      if (!opts)
        opts = {};
      var flags = { bools: {}, strings: {}, unknownFn: null };
      if (typeof opts["unknown"] === "function") {
        flags.unknownFn = opts["unknown"];
      }
      if (typeof opts["boolean"] === "boolean" && opts["boolean"]) {
        flags.allBools = true;
      } else {
        [].concat(opts["boolean"]).filter(Boolean).forEach(function(key2) {
          flags.bools[key2] = true;
        });
      }
      var aliases = {};
      Object.keys(opts.alias || {}).forEach(function(key2) {
        aliases[key2] = [].concat(opts.alias[key2]);
        aliases[key2].forEach(function(x) {
          aliases[x] = [key2].concat(aliases[key2].filter(function(y) {
            return x !== y;
          }));
        });
      });
      [].concat(opts.string).filter(Boolean).forEach(function(key2) {
        flags.strings[key2] = true;
        if (aliases[key2]) {
          flags.strings[aliases[key2]] = true;
        }
      });
      var defaults = opts["default"] || {};
      var argv = { _: [] };
      Object.keys(flags.bools).forEach(function(key2) {
        setArg(key2, defaults[key2] === void 0 ? false : defaults[key2]);
      });
      var notFlags = [];
      if (args2.indexOf("--") !== -1) {
        notFlags = args2.slice(args2.indexOf("--") + 1);
        args2 = args2.slice(0, args2.indexOf("--"));
      }
      function argDefined(key2, arg2) {
        return flags.allBools && /^--[^=]+$/.test(arg2) || flags.strings[key2] || flags.bools[key2] || aliases[key2];
      }
      function setArg(key2, val, arg2) {
        if (arg2 && flags.unknownFn && !argDefined(key2, arg2)) {
          if (flags.unknownFn(arg2) === false)
            return;
        }
        var value2 = !flags.strings[key2] && isNumber(val) ? Number(val) : val;
        setKey(argv, key2.split("."), value2);
        (aliases[key2] || []).forEach(function(x) {
          setKey(argv, x.split("."), value2);
        });
      }
      function setKey(obj, keys2, value2) {
        var o = obj;
        for (var i2 = 0; i2 < keys2.length - 1; i2++) {
          var key2 = keys2[i2];
          if (key2 === "__proto__")
            return;
          if (o[key2] === void 0)
            o[key2] = {};
          if (o[key2] === Object.prototype || o[key2] === Number.prototype || o[key2] === String.prototype)
            o[key2] = {};
          if (o[key2] === Array.prototype)
            o[key2] = [];
          o = o[key2];
        }
        var key2 = keys2[keys2.length - 1];
        if (key2 === "__proto__")
          return;
        if (o === Object.prototype || o === Number.prototype || o === String.prototype)
          o = {};
        if (o === Array.prototype)
          o = [];
        if (o[key2] === void 0 || flags.bools[key2] || typeof o[key2] === "boolean") {
          o[key2] = value2;
        } else if (Array.isArray(o[key2])) {
          o[key2].push(value2);
        } else {
          o[key2] = [o[key2], value2];
        }
      }
      function aliasIsBoolean(key2) {
        return aliases[key2].some(function(x) {
          return flags.bools[x];
        });
      }
      for (var i = 0; i < args2.length; i++) {
        var arg = args2[i];
        if (/^--.+=/.test(arg)) {
          var m = arg.match(/^--([^=]+)=([\s\S]*)$/);
          var key = m[1];
          var value = m[2];
          if (flags.bools[key]) {
            value = value !== "false";
          }
          setArg(key, value, arg);
        } else if (/^--no-.+/.test(arg)) {
          var key = arg.match(/^--no-(.+)/)[1];
          setArg(key, false, arg);
        } else if (/^--.+/.test(arg)) {
          var key = arg.match(/^--(.+)/)[1];
          var next = args2[i + 1];
          if (next !== void 0 && !/^-/.test(next) && !flags.bools[key] && !flags.allBools && (aliases[key] ? !aliasIsBoolean(key) : true)) {
            setArg(key, next, arg);
            i++;
          } else if (/^(true|false)$/.test(next)) {
            setArg(key, next === "true", arg);
            i++;
          } else {
            setArg(key, flags.strings[key] ? "" : true, arg);
          }
        } else if (/^-[^-]+/.test(arg)) {
          var letters = arg.slice(1, -1).split("");
          var broken = false;
          for (var j = 0; j < letters.length; j++) {
            var next = arg.slice(j + 2);
            if (next === "-") {
              setArg(letters[j], next, arg);
              continue;
            }
            if (/[A-Za-z]/.test(letters[j]) && /=/.test(next)) {
              setArg(letters[j], next.split("=")[1], arg);
              broken = true;
              break;
            }
            if (/[A-Za-z]/.test(letters[j]) && /-?\d+(\.\d*)?(e-?\d+)?$/.test(next)) {
              setArg(letters[j], next, arg);
              broken = true;
              break;
            }
            if (letters[j + 1] && letters[j + 1].match(/\W/)) {
              setArg(letters[j], arg.slice(j + 2), arg);
              broken = true;
              break;
            } else {
              setArg(letters[j], flags.strings[letters[j]] ? "" : true, arg);
            }
          }
          var key = arg.slice(-1)[0];
          if (!broken && key !== "-") {
            if (args2[i + 1] && !/^(-|--)[^-]/.test(args2[i + 1]) && !flags.bools[key] && (aliases[key] ? !aliasIsBoolean(key) : true)) {
              setArg(key, args2[i + 1], arg);
              i++;
            } else if (args2[i + 1] && /^(true|false)$/.test(args2[i + 1])) {
              setArg(key, args2[i + 1] === "true", arg);
              i++;
            } else {
              setArg(key, flags.strings[key] ? "" : true, arg);
            }
          }
        } else {
          if (!flags.unknownFn || flags.unknownFn(arg) !== false) {
            argv._.push(flags.strings["_"] || !isNumber(arg) ? arg : Number(arg));
          }
          if (opts.stopEarly) {
            argv._.push.apply(argv._, args2.slice(i + 1));
            break;
          }
        }
      }
      Object.keys(defaults).forEach(function(key2) {
        if (!hasKey(argv, key2.split("."))) {
          setKey(argv, key2.split("."), defaults[key2]);
          (aliases[key2] || []).forEach(function(x) {
            setKey(argv, x.split("."), defaults[key2]);
          });
        }
      });
      if (opts["--"]) {
        argv["--"] = new Array();
        notFlags.forEach(function(key2) {
          argv["--"].push(key2);
        });
      } else {
        notFlags.forEach(function(key2) {
          argv._.push(key2);
        });
      }
      return argv;
    };
    function hasKey(obj, keys2) {
      var o = obj;
      keys2.slice(0, -1).forEach(function(key2) {
        o = o[key2] || {};
      });
      var key = keys2[keys2.length - 1];
      return key in o;
    }
    function isNumber(x) {
      if (typeof x === "number")
        return true;
      if (/^0x[0-9a-f]+$/i.test(x))
        return true;
      return /^[-+]?(?:\d+(?:\.\d*)?|\.\d+)(e[-+]?\d+)?$/.test(x);
    }
  }
});

// node_modules/rc/index.js
var require_rc = __commonJS({
  "node_modules/rc/index.js"(exports2, module2) {
    var cc = require_utils();
    var join3 = require("path").join;
    var deepExtend = require_deep_extend();
    var etc = "/etc";
    var win = process.platform === "win32";
    var home = win ? process.env.USERPROFILE : process.env.HOME;
    module2.exports = function(name, defaults, argv, parse2) {
      if (typeof name !== "string")
        throw new Error("rc(name): name *must* be string");
      if (!argv)
        argv = require_minimist()(process.argv.slice(2));
      defaults = (typeof defaults === "string" ? cc.json(defaults) : defaults) || {};
      parse2 = parse2 || cc.parse;
      var env = cc.env(name + "_");
      var configs = [defaults];
      var configFiles = [];
      function addConfigFile(file) {
        if (configFiles.indexOf(file) >= 0)
          return;
        var fileConfig = cc.file(file);
        if (fileConfig) {
          configs.push(parse2(fileConfig));
          configFiles.push(file);
        }
      }
      if (!win)
        [
          join3(etc, name, "config"),
          join3(etc, name + "rc")
        ].forEach(addConfigFile);
      if (home)
        [
          join3(home, ".config", name, "config"),
          join3(home, ".config", name),
          join3(home, "." + name, "config"),
          join3(home, "." + name + "rc")
        ].forEach(addConfigFile);
      addConfigFile(cc.find("." + name + "rc"));
      if (env.config)
        addConfigFile(env.config);
      if (argv.config)
        addConfigFile(argv.config);
      return deepExtend.apply(null, configs.concat([
        env,
        argv,
        configFiles.length ? { configs: configFiles, config: configFiles[configFiles.length - 1] } : void 0
      ]));
    };
  }
});

// node_modules/registry-url/index.js
var require_registry_url = __commonJS({
  "node_modules/registry-url/index.js"(exports2, module2) {
    "use strict";
    var rc = require_rc();
    var registryUrl = (scope) => {
      const result = rc("npm", { registry: "https://registry.npmjs.org/" });
      const url = result[`${scope}:registry`] || result.config_registry || result.registry;
      return url.slice(-1) === "/" ? url : `${url}/`;
    };
    module2.exports = registryUrl;
    module2.exports.default = registryUrl;
  }
});

// node_modules/registry-auth-token/base64.js
var require_base64 = __commonJS({
  "node_modules/registry-auth-token/base64.js"(exports2, module2) {
    function decodeBase64(base64) {
      return Buffer.from(base64, "base64").toString("utf8");
    }
    function encodeBase64(string) {
      return Buffer.from(string, "utf8").toString("base64");
    }
    module2.exports = {
      decodeBase64,
      encodeBase64
    };
  }
});

// node_modules/registry-auth-token/index.js
var require_registry_auth_token = __commonJS({
  "node_modules/registry-auth-token/index.js"(exports2, module2) {
    var url = require("url");
    var base64 = require_base64();
    var decodeBase64 = base64.decodeBase64;
    var encodeBase64 = base64.encodeBase64;
    var tokenKey = ":_authToken";
    var legacyTokenKey = ":_auth";
    var userKey = ":username";
    var passwordKey = ":_password";
    module2.exports = function() {
      var checkUrl;
      var options;
      if (arguments.length >= 2) {
        checkUrl = arguments[0];
        options = arguments[1];
      } else if (typeof arguments[0] === "string") {
        checkUrl = arguments[0];
      } else {
        options = arguments[0];
      }
      options = options || {};
      options.npmrc = options.npmrc || require_rc()("npm", { registry: "https://registry.npmjs.org/" }, {
        config: process.env.npm_config_userconfig || process.env.NPM_CONFIG_USERCONFIG
      });
      checkUrl = checkUrl || options.npmrc.registry;
      return getRegistryAuthInfo(checkUrl, options) || getLegacyAuthInfo(options.npmrc);
    };
    function getRegistryAuthInfo(checkUrl, options) {
      var parsed = url.parse(checkUrl, false, true);
      var pathname;
      while (pathname !== "/" && parsed.pathname !== pathname) {
        pathname = parsed.pathname || "/";
        var regUrl = "//" + parsed.host + pathname.replace(/\/$/, "");
        var authInfo = getAuthInfoForUrl(regUrl, options.npmrc);
        if (authInfo) {
          return authInfo;
        }
        if (!options.recursive) {
          return /\/$/.test(checkUrl) ? void 0 : getRegistryAuthInfo(url.resolve(checkUrl, "."), options);
        }
        parsed.pathname = url.resolve(normalizePath(pathname), "..") || "/";
      }
      return void 0;
    }
    function getLegacyAuthInfo(npmrc) {
      if (!npmrc._auth) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(npmrc._auth);
      return { token, type: "Basic" };
    }
    function normalizePath(path) {
      return path[path.length - 1] === "/" ? path : path + "/";
    }
    function getAuthInfoForUrl(regUrl, npmrc) {
      var bearerAuth = getBearerToken(npmrc[regUrl + tokenKey] || npmrc[regUrl + "/" + tokenKey]);
      if (bearerAuth) {
        return bearerAuth;
      }
      var username = npmrc[regUrl + userKey] || npmrc[regUrl + "/" + userKey];
      var password = npmrc[regUrl + passwordKey] || npmrc[regUrl + "/" + passwordKey];
      var basicAuth = getTokenForUsernameAndPassword(username, password);
      if (basicAuth) {
        return basicAuth;
      }
      var basicAuthWithToken = getLegacyAuthToken(npmrc[regUrl + legacyTokenKey] || npmrc[regUrl + "/" + legacyTokenKey]);
      if (basicAuthWithToken) {
        return basicAuthWithToken;
      }
      return void 0;
    }
    function replaceEnvironmentVariable(token) {
      return token.replace(/^\$\{?([^}]*)\}?$/, function(fullMatch, envVar) {
        return process.env[envVar];
      });
    }
    function getBearerToken(tok) {
      if (!tok) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(tok);
      return { token, type: "Bearer" };
    }
    function getTokenForUsernameAndPassword(username, password) {
      if (!username || !password) {
        return void 0;
      }
      var pass = decodeBase64(replaceEnvironmentVariable(password));
      var token = encodeBase64(username + ":" + pass);
      return {
        token,
        type: "Basic",
        password: pass,
        username
      };
    }
    function getLegacyAuthToken(tok) {
      if (!tok) {
        return void 0;
      }
      var token = replaceEnvironmentVariable(tok);
      return { token, type: "Basic" };
    }
  }
});

// node_modules/semver/internal/constants.js
var require_constants = __commonJS({
  "node_modules/semver/internal/constants.js"(exports2, module2) {
    var SEMVER_SPEC_VERSION = "2.0.0";
    var MAX_LENGTH = 256;
    var MAX_SAFE_INTEGER = Number.MAX_SAFE_INTEGER || 9007199254740991;
    var MAX_SAFE_COMPONENT_LENGTH = 16;
    module2.exports = {
      SEMVER_SPEC_VERSION,
      MAX_LENGTH,
      MAX_SAFE_INTEGER,
      MAX_SAFE_COMPONENT_LENGTH
    };
  }
});

// node_modules/semver/internal/debug.js
var require_debug2 = __commonJS({
  "node_modules/semver/internal/debug.js"(exports2, module2) {
    var debug = typeof process === "object" && process.env && process.env.NODE_DEBUG && /\bsemver\b/i.test(process.env.NODE_DEBUG) ? (...args2) => console.error("SEMVER", ...args2) : () => {
    };
    module2.exports = debug;
  }
});

// node_modules/semver/internal/re.js
var require_re = __commonJS({
  "node_modules/semver/internal/re.js"(exports2, module2) {
    var { MAX_SAFE_COMPONENT_LENGTH } = require_constants();
    var debug = require_debug2();
    exports2 = module2.exports = {};
    var re = exports2.re = [];
    var src = exports2.src = [];
    var t = exports2.t = {};
    var R = 0;
    var createToken = (name, value, isGlobal) => {
      const index = R++;
      debug(index, value);
      t[name] = index;
      src[index] = value;
      re[index] = new RegExp(value, isGlobal ? "g" : void 0);
    };
    createToken("NUMERICIDENTIFIER", "0|[1-9]\\d*");
    createToken("NUMERICIDENTIFIERLOOSE", "[0-9]+");
    createToken("NONNUMERICIDENTIFIER", "\\d*[a-zA-Z-][a-zA-Z0-9-]*");
    createToken("MAINVERSION", `(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})\\.(${src[t.NUMERICIDENTIFIER]})`);
    createToken("MAINVERSIONLOOSE", `(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})\\.(${src[t.NUMERICIDENTIFIERLOOSE]})`);
    createToken("PRERELEASEIDENTIFIER", `(?:${src[t.NUMERICIDENTIFIER]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASEIDENTIFIERLOOSE", `(?:${src[t.NUMERICIDENTIFIERLOOSE]}|${src[t.NONNUMERICIDENTIFIER]})`);
    createToken("PRERELEASE", `(?:-(${src[t.PRERELEASEIDENTIFIER]}(?:\\.${src[t.PRERELEASEIDENTIFIER]})*))`);
    createToken("PRERELEASELOOSE", `(?:-?(${src[t.PRERELEASEIDENTIFIERLOOSE]}(?:\\.${src[t.PRERELEASEIDENTIFIERLOOSE]})*))`);
    createToken("BUILDIDENTIFIER", "[0-9A-Za-z-]+");
    createToken("BUILD", `(?:\\+(${src[t.BUILDIDENTIFIER]}(?:\\.${src[t.BUILDIDENTIFIER]})*))`);
    createToken("FULLPLAIN", `v?${src[t.MAINVERSION]}${src[t.PRERELEASE]}?${src[t.BUILD]}?`);
    createToken("FULL", `^${src[t.FULLPLAIN]}$`);
    createToken("LOOSEPLAIN", `[v=\\s]*${src[t.MAINVERSIONLOOSE]}${src[t.PRERELEASELOOSE]}?${src[t.BUILD]}?`);
    createToken("LOOSE", `^${src[t.LOOSEPLAIN]}$`);
    createToken("GTLT", "((?:<|>)?=?)");
    createToken("XRANGEIDENTIFIERLOOSE", `${src[t.NUMERICIDENTIFIERLOOSE]}|x|X|\\*`);
    createToken("XRANGEIDENTIFIER", `${src[t.NUMERICIDENTIFIER]}|x|X|\\*`);
    createToken("XRANGEPLAIN", `[v=\\s]*(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:\\.(${src[t.XRANGEIDENTIFIER]})(?:${src[t.PRERELEASE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGEPLAINLOOSE", `[v=\\s]*(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:\\.(${src[t.XRANGEIDENTIFIERLOOSE]})(?:${src[t.PRERELEASELOOSE]})?${src[t.BUILD]}?)?)?`);
    createToken("XRANGE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAIN]}$`);
    createToken("XRANGELOOSE", `^${src[t.GTLT]}\\s*${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COERCE", `${"(^|[^\\d])(\\d{1,"}${MAX_SAFE_COMPONENT_LENGTH}})(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:\\.(\\d{1,${MAX_SAFE_COMPONENT_LENGTH}}))?(?:$|[^\\d])`);
    createToken("COERCERTL", src[t.COERCE], true);
    createToken("LONETILDE", "(?:~>?)");
    createToken("TILDETRIM", `(\\s*)${src[t.LONETILDE]}\\s+`, true);
    exports2.tildeTrimReplace = "$1~";
    createToken("TILDE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAIN]}$`);
    createToken("TILDELOOSE", `^${src[t.LONETILDE]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("LONECARET", "(?:\\^)");
    createToken("CARETTRIM", `(\\s*)${src[t.LONECARET]}\\s+`, true);
    exports2.caretTrimReplace = "$1^";
    createToken("CARET", `^${src[t.LONECARET]}${src[t.XRANGEPLAIN]}$`);
    createToken("CARETLOOSE", `^${src[t.LONECARET]}${src[t.XRANGEPLAINLOOSE]}$`);
    createToken("COMPARATORLOOSE", `^${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]})$|^$`);
    createToken("COMPARATOR", `^${src[t.GTLT]}\\s*(${src[t.FULLPLAIN]})$|^$`);
    createToken("COMPARATORTRIM", `(\\s*)${src[t.GTLT]}\\s*(${src[t.LOOSEPLAIN]}|${src[t.XRANGEPLAIN]})`, true);
    exports2.comparatorTrimReplace = "$1$2$3";
    createToken("HYPHENRANGE", `^\\s*(${src[t.XRANGEPLAIN]})\\s+-\\s+(${src[t.XRANGEPLAIN]})\\s*$`);
    createToken("HYPHENRANGELOOSE", `^\\s*(${src[t.XRANGEPLAINLOOSE]})\\s+-\\s+(${src[t.XRANGEPLAINLOOSE]})\\s*$`);
    createToken("STAR", "(<|>)?=?\\s*\\*");
    createToken("GTE0", "^\\s*>=\\s*0.0.0\\s*$");
    createToken("GTE0PRE", "^\\s*>=\\s*0.0.0-0\\s*$");
  }
});

// node_modules/semver/internal/parse-options.js
var require_parse_options = __commonJS({
  "node_modules/semver/internal/parse-options.js"(exports2, module2) {
    var opts = ["includePrerelease", "loose", "rtl"];
    var parseOptions = (options) => !options ? {} : typeof options !== "object" ? { loose: true } : opts.filter((k) => options[k]).reduce((options2, k) => {
      options2[k] = true;
      return options2;
    }, {});
    module2.exports = parseOptions;
  }
});

// node_modules/semver/internal/identifiers.js
var require_identifiers = __commonJS({
  "node_modules/semver/internal/identifiers.js"(exports2, module2) {
    var numeric = /^[0-9]+$/;
    var compareIdentifiers = (a2, b) => {
      const anum = numeric.test(a2);
      const bnum = numeric.test(b);
      if (anum && bnum) {
        a2 = +a2;
        b = +b;
      }
      return a2 === b ? 0 : anum && !bnum ? -1 : bnum && !anum ? 1 : a2 < b ? -1 : 1;
    };
    var rcompareIdentifiers = (a2, b) => compareIdentifiers(b, a2);
    module2.exports = {
      compareIdentifiers,
      rcompareIdentifiers
    };
  }
});

// node_modules/semver/classes/semver.js
var require_semver = __commonJS({
  "node_modules/semver/classes/semver.js"(exports2, module2) {
    var debug = require_debug2();
    var { MAX_LENGTH, MAX_SAFE_INTEGER } = require_constants();
    var { re, t } = require_re();
    var parseOptions = require_parse_options();
    var { compareIdentifiers } = require_identifiers();
    var SemVer = class {
      constructor(version, options) {
        options = parseOptions(options);
        if (version instanceof SemVer) {
          if (version.loose === !!options.loose && version.includePrerelease === !!options.includePrerelease) {
            return version;
          } else {
            version = version.version;
          }
        } else if (typeof version !== "string") {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        if (version.length > MAX_LENGTH) {
          throw new TypeError(`version is longer than ${MAX_LENGTH} characters`);
        }
        debug("SemVer", version, options);
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        const m = version.trim().match(options.loose ? re[t.LOOSE] : re[t.FULL]);
        if (!m) {
          throw new TypeError(`Invalid Version: ${version}`);
        }
        this.raw = version;
        this.major = +m[1];
        this.minor = +m[2];
        this.patch = +m[3];
        if (this.major > MAX_SAFE_INTEGER || this.major < 0) {
          throw new TypeError("Invalid major version");
        }
        if (this.minor > MAX_SAFE_INTEGER || this.minor < 0) {
          throw new TypeError("Invalid minor version");
        }
        if (this.patch > MAX_SAFE_INTEGER || this.patch < 0) {
          throw new TypeError("Invalid patch version");
        }
        if (!m[4]) {
          this.prerelease = [];
        } else {
          this.prerelease = m[4].split(".").map((id) => {
            if (/^[0-9]+$/.test(id)) {
              const num = +id;
              if (num >= 0 && num < MAX_SAFE_INTEGER) {
                return num;
              }
            }
            return id;
          });
        }
        this.build = m[5] ? m[5].split(".") : [];
        this.format();
      }
      format() {
        this.version = `${this.major}.${this.minor}.${this.patch}`;
        if (this.prerelease.length) {
          this.version += `-${this.prerelease.join(".")}`;
        }
        return this.version;
      }
      toString() {
        return this.version;
      }
      compare(other) {
        debug("SemVer.compare", this.version, this.options, other);
        if (!(other instanceof SemVer)) {
          if (typeof other === "string" && other === this.version) {
            return 0;
          }
          other = new SemVer(other, this.options);
        }
        if (other.version === this.version) {
          return 0;
        }
        return this.compareMain(other) || this.comparePre(other);
      }
      compareMain(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        return compareIdentifiers(this.major, other.major) || compareIdentifiers(this.minor, other.minor) || compareIdentifiers(this.patch, other.patch);
      }
      comparePre(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        if (this.prerelease.length && !other.prerelease.length) {
          return -1;
        } else if (!this.prerelease.length && other.prerelease.length) {
          return 1;
        } else if (!this.prerelease.length && !other.prerelease.length) {
          return 0;
        }
        let i = 0;
        do {
          const a2 = this.prerelease[i];
          const b = other.prerelease[i];
          debug("prerelease compare", i, a2, b);
          if (a2 === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a2 === void 0) {
            return -1;
          } else if (a2 === b) {
            continue;
          } else {
            return compareIdentifiers(a2, b);
          }
        } while (++i);
      }
      compareBuild(other) {
        if (!(other instanceof SemVer)) {
          other = new SemVer(other, this.options);
        }
        let i = 0;
        do {
          const a2 = this.build[i];
          const b = other.build[i];
          debug("prerelease compare", i, a2, b);
          if (a2 === void 0 && b === void 0) {
            return 0;
          } else if (b === void 0) {
            return 1;
          } else if (a2 === void 0) {
            return -1;
          } else if (a2 === b) {
            continue;
          } else {
            return compareIdentifiers(a2, b);
          }
        } while (++i);
      }
      inc(release, identifier) {
        switch (release) {
          case "premajor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor = 0;
            this.major++;
            this.inc("pre", identifier);
            break;
          case "preminor":
            this.prerelease.length = 0;
            this.patch = 0;
            this.minor++;
            this.inc("pre", identifier);
            break;
          case "prepatch":
            this.prerelease.length = 0;
            this.inc("patch", identifier);
            this.inc("pre", identifier);
            break;
          case "prerelease":
            if (this.prerelease.length === 0) {
              this.inc("patch", identifier);
            }
            this.inc("pre", identifier);
            break;
          case "major":
            if (this.minor !== 0 || this.patch !== 0 || this.prerelease.length === 0) {
              this.major++;
            }
            this.minor = 0;
            this.patch = 0;
            this.prerelease = [];
            break;
          case "minor":
            if (this.patch !== 0 || this.prerelease.length === 0) {
              this.minor++;
            }
            this.patch = 0;
            this.prerelease = [];
            break;
          case "patch":
            if (this.prerelease.length === 0) {
              this.patch++;
            }
            this.prerelease = [];
            break;
          case "pre":
            if (this.prerelease.length === 0) {
              this.prerelease = [0];
            } else {
              let i = this.prerelease.length;
              while (--i >= 0) {
                if (typeof this.prerelease[i] === "number") {
                  this.prerelease[i]++;
                  i = -2;
                }
              }
              if (i === -1) {
                this.prerelease.push(0);
              }
            }
            if (identifier) {
              if (this.prerelease[0] === identifier) {
                if (isNaN(this.prerelease[1])) {
                  this.prerelease = [identifier, 0];
                }
              } else {
                this.prerelease = [identifier, 0];
              }
            }
            break;
          default:
            throw new Error(`invalid increment argument: ${release}`);
        }
        this.format();
        this.raw = this.version;
        return this;
      }
    };
    module2.exports = SemVer;
  }
});

// node_modules/semver/functions/parse.js
var require_parse = __commonJS({
  "node_modules/semver/functions/parse.js"(exports2, module2) {
    var { MAX_LENGTH } = require_constants();
    var { re, t } = require_re();
    var SemVer = require_semver();
    var parseOptions = require_parse_options();
    var parse2 = (version, options) => {
      options = parseOptions(options);
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version !== "string") {
        return null;
      }
      if (version.length > MAX_LENGTH) {
        return null;
      }
      const r = options.loose ? re[t.LOOSE] : re[t.FULL];
      if (!r.test(version)) {
        return null;
      }
      try {
        return new SemVer(version, options);
      } catch (er) {
        return null;
      }
    };
    module2.exports = parse2;
  }
});

// node_modules/semver/functions/valid.js
var require_valid = __commonJS({
  "node_modules/semver/functions/valid.js"(exports2, module2) {
    var parse2 = require_parse();
    var valid = (version, options) => {
      const v = parse2(version, options);
      return v ? v.version : null;
    };
    module2.exports = valid;
  }
});

// node_modules/semver/functions/clean.js
var require_clean = __commonJS({
  "node_modules/semver/functions/clean.js"(exports2, module2) {
    var parse2 = require_parse();
    var clean = (version, options) => {
      const s = parse2(version.trim().replace(/^[=v]+/, ""), options);
      return s ? s.version : null;
    };
    module2.exports = clean;
  }
});

// node_modules/semver/functions/inc.js
var require_inc = __commonJS({
  "node_modules/semver/functions/inc.js"(exports2, module2) {
    var SemVer = require_semver();
    var inc2 = (version, release, options, identifier) => {
      if (typeof options === "string") {
        identifier = options;
        options = void 0;
      }
      try {
        return new SemVer(version, options).inc(release, identifier).version;
      } catch (er) {
        return null;
      }
    };
    module2.exports = inc2;
  }
});

// node_modules/semver/functions/compare.js
var require_compare = __commonJS({
  "node_modules/semver/functions/compare.js"(exports2, module2) {
    var SemVer = require_semver();
    var compare2 = (a2, b, loose) => new SemVer(a2, loose).compare(new SemVer(b, loose));
    module2.exports = compare2;
  }
});

// node_modules/semver/functions/eq.js
var require_eq = __commonJS({
  "node_modules/semver/functions/eq.js"(exports2, module2) {
    var compare2 = require_compare();
    var eq = (a2, b, loose) => compare2(a2, b, loose) === 0;
    module2.exports = eq;
  }
});

// node_modules/semver/functions/diff.js
var require_diff = __commonJS({
  "node_modules/semver/functions/diff.js"(exports2, module2) {
    var parse2 = require_parse();
    var eq = require_eq();
    var diff = (version1, version2) => {
      if (eq(version1, version2)) {
        return null;
      } else {
        const v1 = parse2(version1);
        const v2 = parse2(version2);
        const hasPre = v1.prerelease.length || v2.prerelease.length;
        const prefix = hasPre ? "pre" : "";
        const defaultResult = hasPre ? "prerelease" : "";
        for (const key in v1) {
          if (key === "major" || key === "minor" || key === "patch") {
            if (v1[key] !== v2[key]) {
              return prefix + key;
            }
          }
        }
        return defaultResult;
      }
    };
    module2.exports = diff;
  }
});

// node_modules/semver/functions/major.js
var require_major = __commonJS({
  "node_modules/semver/functions/major.js"(exports2, module2) {
    var SemVer = require_semver();
    var major = (a2, loose) => new SemVer(a2, loose).major;
    module2.exports = major;
  }
});

// node_modules/semver/functions/minor.js
var require_minor = __commonJS({
  "node_modules/semver/functions/minor.js"(exports2, module2) {
    var SemVer = require_semver();
    var minor = (a2, loose) => new SemVer(a2, loose).minor;
    module2.exports = minor;
  }
});

// node_modules/semver/functions/patch.js
var require_patch = __commonJS({
  "node_modules/semver/functions/patch.js"(exports2, module2) {
    var SemVer = require_semver();
    var patch = (a2, loose) => new SemVer(a2, loose).patch;
    module2.exports = patch;
  }
});

// node_modules/semver/functions/prerelease.js
var require_prerelease = __commonJS({
  "node_modules/semver/functions/prerelease.js"(exports2, module2) {
    var parse2 = require_parse();
    var prerelease = (version, options) => {
      const parsed = parse2(version, options);
      return parsed && parsed.prerelease.length ? parsed.prerelease : null;
    };
    module2.exports = prerelease;
  }
});

// node_modules/semver/functions/rcompare.js
var require_rcompare = __commonJS({
  "node_modules/semver/functions/rcompare.js"(exports2, module2) {
    var compare2 = require_compare();
    var rcompare = (a2, b, loose) => compare2(b, a2, loose);
    module2.exports = rcompare;
  }
});

// node_modules/semver/functions/compare-loose.js
var require_compare_loose = __commonJS({
  "node_modules/semver/functions/compare-loose.js"(exports2, module2) {
    var compare2 = require_compare();
    var compareLoose = (a2, b) => compare2(a2, b, true);
    module2.exports = compareLoose;
  }
});

// node_modules/semver/functions/compare-build.js
var require_compare_build = __commonJS({
  "node_modules/semver/functions/compare-build.js"(exports2, module2) {
    var SemVer = require_semver();
    var compareBuild = (a2, b, loose) => {
      const versionA = new SemVer(a2, loose);
      const versionB = new SemVer(b, loose);
      return versionA.compare(versionB) || versionA.compareBuild(versionB);
    };
    module2.exports = compareBuild;
  }
});

// node_modules/semver/functions/sort.js
var require_sort = __commonJS({
  "node_modules/semver/functions/sort.js"(exports2, module2) {
    var compareBuild = require_compare_build();
    var sort3 = (list, loose) => list.sort((a2, b) => compareBuild(a2, b, loose));
    module2.exports = sort3;
  }
});

// node_modules/semver/functions/rsort.js
var require_rsort = __commonJS({
  "node_modules/semver/functions/rsort.js"(exports2, module2) {
    var compareBuild = require_compare_build();
    var rsort = (list, loose) => list.sort((a2, b) => compareBuild(b, a2, loose));
    module2.exports = rsort;
  }
});

// node_modules/semver/functions/gt.js
var require_gt = __commonJS({
  "node_modules/semver/functions/gt.js"(exports2, module2) {
    var compare2 = require_compare();
    var gt = (a2, b, loose) => compare2(a2, b, loose) > 0;
    module2.exports = gt;
  }
});

// node_modules/semver/functions/lt.js
var require_lt = __commonJS({
  "node_modules/semver/functions/lt.js"(exports2, module2) {
    var compare2 = require_compare();
    var lt = (a2, b, loose) => compare2(a2, b, loose) < 0;
    module2.exports = lt;
  }
});

// node_modules/semver/functions/neq.js
var require_neq = __commonJS({
  "node_modules/semver/functions/neq.js"(exports2, module2) {
    var compare2 = require_compare();
    var neq = (a2, b, loose) => compare2(a2, b, loose) !== 0;
    module2.exports = neq;
  }
});

// node_modules/semver/functions/gte.js
var require_gte = __commonJS({
  "node_modules/semver/functions/gte.js"(exports2, module2) {
    var compare2 = require_compare();
    var gte = (a2, b, loose) => compare2(a2, b, loose) >= 0;
    module2.exports = gte;
  }
});

// node_modules/semver/functions/lte.js
var require_lte = __commonJS({
  "node_modules/semver/functions/lte.js"(exports2, module2) {
    var compare2 = require_compare();
    var lte = (a2, b, loose) => compare2(a2, b, loose) <= 0;
    module2.exports = lte;
  }
});

// node_modules/semver/functions/cmp.js
var require_cmp = __commonJS({
  "node_modules/semver/functions/cmp.js"(exports2, module2) {
    var eq = require_eq();
    var neq = require_neq();
    var gt = require_gt();
    var gte = require_gte();
    var lt = require_lt();
    var lte = require_lte();
    var cmp2 = (a2, op, b, loose) => {
      switch (op) {
        case "===":
          if (typeof a2 === "object")
            a2 = a2.version;
          if (typeof b === "object")
            b = b.version;
          return a2 === b;
        case "!==":
          if (typeof a2 === "object")
            a2 = a2.version;
          if (typeof b === "object")
            b = b.version;
          return a2 !== b;
        case "":
        case "=":
        case "==":
          return eq(a2, b, loose);
        case "!=":
          return neq(a2, b, loose);
        case ">":
          return gt(a2, b, loose);
        case ">=":
          return gte(a2, b, loose);
        case "<":
          return lt(a2, b, loose);
        case "<=":
          return lte(a2, b, loose);
        default:
          throw new TypeError(`Invalid operator: ${op}`);
      }
    };
    module2.exports = cmp2;
  }
});

// node_modules/semver/functions/coerce.js
var require_coerce = __commonJS({
  "node_modules/semver/functions/coerce.js"(exports2, module2) {
    var SemVer = require_semver();
    var parse2 = require_parse();
    var { re, t } = require_re();
    var coerce = (version, options) => {
      if (version instanceof SemVer) {
        return version;
      }
      if (typeof version === "number") {
        version = String(version);
      }
      if (typeof version !== "string") {
        return null;
      }
      options = options || {};
      let match = null;
      if (!options.rtl) {
        match = version.match(re[t.COERCE]);
      } else {
        let next;
        while ((next = re[t.COERCERTL].exec(version)) && (!match || match.index + match[0].length !== version.length)) {
          if (!match || next.index + next[0].length !== match.index + match[0].length) {
            match = next;
          }
          re[t.COERCERTL].lastIndex = next.index + next[1].length + next[2].length;
        }
        re[t.COERCERTL].lastIndex = -1;
      }
      if (match === null)
        return null;
      return parse2(`${match[2]}.${match[3] || "0"}.${match[4] || "0"}`, options);
    };
    module2.exports = coerce;
  }
});

// node_modules/yallist/iterator.js
var require_iterator = __commonJS({
  "node_modules/yallist/iterator.js"(exports2, module2) {
    "use strict";
    module2.exports = function(Yallist) {
      Yallist.prototype[Symbol.iterator] = function* () {
        for (let walker = this.head; walker; walker = walker.next) {
          yield walker.value;
        }
      };
    };
  }
});

// node_modules/yallist/yallist.js
var require_yallist = __commonJS({
  "node_modules/yallist/yallist.js"(exports2, module2) {
    "use strict";
    module2.exports = Yallist;
    Yallist.Node = Node;
    Yallist.create = Yallist;
    function Yallist(list) {
      var self2 = this;
      if (!(self2 instanceof Yallist)) {
        self2 = new Yallist();
      }
      self2.tail = null;
      self2.head = null;
      self2.length = 0;
      if (list && typeof list.forEach === "function") {
        list.forEach(function(item) {
          self2.push(item);
        });
      } else if (arguments.length > 0) {
        for (var i = 0, l = arguments.length; i < l; i++) {
          self2.push(arguments[i]);
        }
      }
      return self2;
    }
    Yallist.prototype.removeNode = function(node) {
      if (node.list !== this) {
        throw new Error("removing node which does not belong to this list");
      }
      var next = node.next;
      var prev = node.prev;
      if (next) {
        next.prev = prev;
      }
      if (prev) {
        prev.next = next;
      }
      if (node === this.head) {
        this.head = next;
      }
      if (node === this.tail) {
        this.tail = prev;
      }
      node.list.length--;
      node.next = null;
      node.prev = null;
      node.list = null;
      return next;
    };
    Yallist.prototype.unshiftNode = function(node) {
      if (node === this.head) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var head2 = this.head;
      node.list = this;
      node.next = head2;
      if (head2) {
        head2.prev = node;
      }
      this.head = node;
      if (!this.tail) {
        this.tail = node;
      }
      this.length++;
    };
    Yallist.prototype.pushNode = function(node) {
      if (node === this.tail) {
        return;
      }
      if (node.list) {
        node.list.removeNode(node);
      }
      var tail = this.tail;
      node.list = this;
      node.prev = tail;
      if (tail) {
        tail.next = node;
      }
      this.tail = node;
      if (!this.head) {
        this.head = node;
      }
      this.length++;
    };
    Yallist.prototype.push = function() {
      for (var i = 0, l = arguments.length; i < l; i++) {
        push(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.unshift = function() {
      for (var i = 0, l = arguments.length; i < l; i++) {
        unshift(this, arguments[i]);
      }
      return this.length;
    };
    Yallist.prototype.pop = function() {
      if (!this.tail) {
        return void 0;
      }
      var res = this.tail.value;
      this.tail = this.tail.prev;
      if (this.tail) {
        this.tail.next = null;
      } else {
        this.head = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.shift = function() {
      if (!this.head) {
        return void 0;
      }
      var res = this.head.value;
      this.head = this.head.next;
      if (this.head) {
        this.head.prev = null;
      } else {
        this.tail = null;
      }
      this.length--;
      return res;
    };
    Yallist.prototype.forEach = function(fn3, thisp) {
      thisp = thisp || this;
      for (var walker = this.head, i = 0; walker !== null; i++) {
        fn3.call(thisp, walker.value, i, this);
        walker = walker.next;
      }
    };
    Yallist.prototype.forEachReverse = function(fn3, thisp) {
      thisp = thisp || this;
      for (var walker = this.tail, i = this.length - 1; walker !== null; i--) {
        fn3.call(thisp, walker.value, i, this);
        walker = walker.prev;
      }
    };
    Yallist.prototype.get = function(n) {
      for (var i = 0, walker = this.head; walker !== null && i < n; i++) {
        walker = walker.next;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.getReverse = function(n) {
      for (var i = 0, walker = this.tail; walker !== null && i < n; i++) {
        walker = walker.prev;
      }
      if (i === n && walker !== null) {
        return walker.value;
      }
    };
    Yallist.prototype.map = function(fn3, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.head; walker !== null; ) {
        res.push(fn3.call(thisp, walker.value, this));
        walker = walker.next;
      }
      return res;
    };
    Yallist.prototype.mapReverse = function(fn3, thisp) {
      thisp = thisp || this;
      var res = new Yallist();
      for (var walker = this.tail; walker !== null; ) {
        res.push(fn3.call(thisp, walker.value, this));
        walker = walker.prev;
      }
      return res;
    };
    Yallist.prototype.reduce = function(fn3, initial) {
      var acc;
      var walker = this.head;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.head) {
        walker = this.head.next;
        acc = this.head.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = 0; walker !== null; i++) {
        acc = fn3(acc, walker.value, i);
        walker = walker.next;
      }
      return acc;
    };
    Yallist.prototype.reduceReverse = function(fn3, initial) {
      var acc;
      var walker = this.tail;
      if (arguments.length > 1) {
        acc = initial;
      } else if (this.tail) {
        walker = this.tail.prev;
        acc = this.tail.value;
      } else {
        throw new TypeError("Reduce of empty list with no initial value");
      }
      for (var i = this.length - 1; walker !== null; i--) {
        acc = fn3(acc, walker.value, i);
        walker = walker.prev;
      }
      return acc;
    };
    Yallist.prototype.toArray = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.head; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.next;
      }
      return arr;
    };
    Yallist.prototype.toArrayReverse = function() {
      var arr = new Array(this.length);
      for (var i = 0, walker = this.tail; walker !== null; i++) {
        arr[i] = walker.value;
        walker = walker.prev;
      }
      return arr;
    };
    Yallist.prototype.slice = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = 0, walker = this.head; walker !== null && i < from; i++) {
        walker = walker.next;
      }
      for (; walker !== null && i < to; i++, walker = walker.next) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.sliceReverse = function(from, to) {
      to = to || this.length;
      if (to < 0) {
        to += this.length;
      }
      from = from || 0;
      if (from < 0) {
        from += this.length;
      }
      var ret = new Yallist();
      if (to < from || to < 0) {
        return ret;
      }
      if (from < 0) {
        from = 0;
      }
      if (to > this.length) {
        to = this.length;
      }
      for (var i = this.length, walker = this.tail; walker !== null && i > to; i--) {
        walker = walker.prev;
      }
      for (; walker !== null && i > from; i--, walker = walker.prev) {
        ret.push(walker.value);
      }
      return ret;
    };
    Yallist.prototype.splice = function(start, deleteCount, ...nodes) {
      if (start > this.length) {
        start = this.length - 1;
      }
      if (start < 0) {
        start = this.length + start;
      }
      for (var i = 0, walker = this.head; walker !== null && i < start; i++) {
        walker = walker.next;
      }
      var ret = [];
      for (var i = 0; walker && i < deleteCount; i++) {
        ret.push(walker.value);
        walker = this.removeNode(walker);
      }
      if (walker === null) {
        walker = this.tail;
      }
      if (walker !== this.head && walker !== this.tail) {
        walker = walker.prev;
      }
      for (var i = 0; i < nodes.length; i++) {
        walker = insert2(this, walker, nodes[i]);
      }
      return ret;
    };
    Yallist.prototype.reverse = function() {
      var head2 = this.head;
      var tail = this.tail;
      for (var walker = head2; walker !== null; walker = walker.prev) {
        var p = walker.prev;
        walker.prev = walker.next;
        walker.next = p;
      }
      this.head = tail;
      this.tail = head2;
      return this;
    };
    function insert2(self2, node, value) {
      var inserted = node === self2.head ? new Node(value, null, node, self2) : new Node(value, node, node.next, self2);
      if (inserted.next === null) {
        self2.tail = inserted;
      }
      if (inserted.prev === null) {
        self2.head = inserted;
      }
      self2.length++;
      return inserted;
    }
    function push(self2, item) {
      self2.tail = new Node(item, self2.tail, null, self2);
      if (!self2.head) {
        self2.head = self2.tail;
      }
      self2.length++;
    }
    function unshift(self2, item) {
      self2.head = new Node(item, null, self2.head, self2);
      if (!self2.tail) {
        self2.tail = self2.head;
      }
      self2.length++;
    }
    function Node(value, prev, next, list) {
      if (!(this instanceof Node)) {
        return new Node(value, prev, next, list);
      }
      this.list = list;
      this.value = value;
      if (prev) {
        prev.next = this;
        this.prev = prev;
      } else {
        this.prev = null;
      }
      if (next) {
        next.prev = this;
        this.next = next;
      } else {
        this.next = null;
      }
    }
    try {
      require_iterator()(Yallist);
    } catch (er) {
    }
  }
});

// node_modules/lru-cache/index.js
var require_lru_cache = __commonJS({
  "node_modules/lru-cache/index.js"(exports2, module2) {
    "use strict";
    var Yallist = require_yallist();
    var MAX = Symbol("max");
    var LENGTH = Symbol("length");
    var LENGTH_CALCULATOR = Symbol("lengthCalculator");
    var ALLOW_STALE = Symbol("allowStale");
    var MAX_AGE = Symbol("maxAge");
    var DISPOSE = Symbol("dispose");
    var NO_DISPOSE_ON_SET = Symbol("noDisposeOnSet");
    var LRU_LIST = Symbol("lruList");
    var CACHE = Symbol("cache");
    var UPDATE_AGE_ON_GET = Symbol("updateAgeOnGet");
    var naiveLength = () => 1;
    var LRUCache = class {
      constructor(options) {
        if (typeof options === "number")
          options = { max: options };
        if (!options)
          options = {};
        if (options.max && (typeof options.max !== "number" || options.max < 0))
          throw new TypeError("max must be a non-negative number");
        const max = this[MAX] = options.max || Infinity;
        const lc = options.length || naiveLength;
        this[LENGTH_CALCULATOR] = typeof lc !== "function" ? naiveLength : lc;
        this[ALLOW_STALE] = options.stale || false;
        if (options.maxAge && typeof options.maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        this[MAX_AGE] = options.maxAge || 0;
        this[DISPOSE] = options.dispose;
        this[NO_DISPOSE_ON_SET] = options.noDisposeOnSet || false;
        this[UPDATE_AGE_ON_GET] = options.updateAgeOnGet || false;
        this.reset();
      }
      set max(mL) {
        if (typeof mL !== "number" || mL < 0)
          throw new TypeError("max must be a non-negative number");
        this[MAX] = mL || Infinity;
        trim2(this);
      }
      get max() {
        return this[MAX];
      }
      set allowStale(allowStale) {
        this[ALLOW_STALE] = !!allowStale;
      }
      get allowStale() {
        return this[ALLOW_STALE];
      }
      set maxAge(mA) {
        if (typeof mA !== "number")
          throw new TypeError("maxAge must be a non-negative number");
        this[MAX_AGE] = mA;
        trim2(this);
      }
      get maxAge() {
        return this[MAX_AGE];
      }
      set lengthCalculator(lC) {
        if (typeof lC !== "function")
          lC = naiveLength;
        if (lC !== this[LENGTH_CALCULATOR]) {
          this[LENGTH_CALCULATOR] = lC;
          this[LENGTH] = 0;
          this[LRU_LIST].forEach((hit) => {
            hit.length = this[LENGTH_CALCULATOR](hit.value, hit.key);
            this[LENGTH] += hit.length;
          });
        }
        trim2(this);
      }
      get lengthCalculator() {
        return this[LENGTH_CALCULATOR];
      }
      get length() {
        return this[LENGTH];
      }
      get itemCount() {
        return this[LRU_LIST].length;
      }
      rforEach(fn3, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].tail; walker !== null; ) {
          const prev = walker.prev;
          forEachStep(this, fn3, walker, thisp);
          walker = prev;
        }
      }
      forEach(fn3, thisp) {
        thisp = thisp || this;
        for (let walker = this[LRU_LIST].head; walker !== null; ) {
          const next = walker.next;
          forEachStep(this, fn3, walker, thisp);
          walker = next;
        }
      }
      keys() {
        return this[LRU_LIST].toArray().map((k) => k.key);
      }
      values() {
        return this[LRU_LIST].toArray().map((k) => k.value);
      }
      reset() {
        if (this[DISPOSE] && this[LRU_LIST] && this[LRU_LIST].length) {
          this[LRU_LIST].forEach((hit) => this[DISPOSE](hit.key, hit.value));
        }
        this[CACHE] = /* @__PURE__ */ new Map();
        this[LRU_LIST] = new Yallist();
        this[LENGTH] = 0;
      }
      dump() {
        return this[LRU_LIST].map((hit) => isStale(this, hit) ? false : {
          k: hit.key,
          v: hit.value,
          e: hit.now + (hit.maxAge || 0)
        }).toArray().filter((h) => h);
      }
      dumpLru() {
        return this[LRU_LIST];
      }
      set(key, value, maxAge) {
        maxAge = maxAge || this[MAX_AGE];
        if (maxAge && typeof maxAge !== "number")
          throw new TypeError("maxAge must be a number");
        const now = maxAge ? Date.now() : 0;
        const len = this[LENGTH_CALCULATOR](value, key);
        if (this[CACHE].has(key)) {
          if (len > this[MAX]) {
            del(this, this[CACHE].get(key));
            return false;
          }
          const node = this[CACHE].get(key);
          const item = node.value;
          if (this[DISPOSE]) {
            if (!this[NO_DISPOSE_ON_SET])
              this[DISPOSE](key, item.value);
          }
          item.now = now;
          item.maxAge = maxAge;
          item.value = value;
          this[LENGTH] += len - item.length;
          item.length = len;
          this.get(key);
          trim2(this);
          return true;
        }
        const hit = new Entry(key, value, len, now, maxAge);
        if (hit.length > this[MAX]) {
          if (this[DISPOSE])
            this[DISPOSE](key, value);
          return false;
        }
        this[LENGTH] += hit.length;
        this[LRU_LIST].unshift(hit);
        this[CACHE].set(key, this[LRU_LIST].head);
        trim2(this);
        return true;
      }
      has(key) {
        if (!this[CACHE].has(key))
          return false;
        const hit = this[CACHE].get(key).value;
        return !isStale(this, hit);
      }
      get(key) {
        return get2(this, key, true);
      }
      peek(key) {
        return get2(this, key, false);
      }
      pop() {
        const node = this[LRU_LIST].tail;
        if (!node)
          return null;
        del(this, node);
        return node.value;
      }
      del(key) {
        del(this, this[CACHE].get(key));
      }
      load(arr) {
        this.reset();
        const now = Date.now();
        for (let l = arr.length - 1; l >= 0; l--) {
          const hit = arr[l];
          const expiresAt = hit.e || 0;
          if (expiresAt === 0)
            this.set(hit.k, hit.v);
          else {
            const maxAge = expiresAt - now;
            if (maxAge > 0) {
              this.set(hit.k, hit.v, maxAge);
            }
          }
        }
      }
      prune() {
        this[CACHE].forEach((value, key) => get2(this, key, false));
      }
    };
    var get2 = (self2, key, doUse) => {
      const node = self2[CACHE].get(key);
      if (node) {
        const hit = node.value;
        if (isStale(self2, hit)) {
          del(self2, node);
          if (!self2[ALLOW_STALE])
            return void 0;
        } else {
          if (doUse) {
            if (self2[UPDATE_AGE_ON_GET])
              node.value.now = Date.now();
            self2[LRU_LIST].unshiftNode(node);
          }
        }
        return hit.value;
      }
    };
    var isStale = (self2, hit) => {
      if (!hit || !hit.maxAge && !self2[MAX_AGE])
        return false;
      const diff = Date.now() - hit.now;
      return hit.maxAge ? diff > hit.maxAge : self2[MAX_AGE] && diff > self2[MAX_AGE];
    };
    var trim2 = (self2) => {
      if (self2[LENGTH] > self2[MAX]) {
        for (let walker = self2[LRU_LIST].tail; self2[LENGTH] > self2[MAX] && walker !== null; ) {
          const prev = walker.prev;
          del(self2, walker);
          walker = prev;
        }
      }
    };
    var del = (self2, node) => {
      if (node) {
        const hit = node.value;
        if (self2[DISPOSE])
          self2[DISPOSE](hit.key, hit.value);
        self2[LENGTH] -= hit.length;
        self2[CACHE].delete(hit.key);
        self2[LRU_LIST].removeNode(node);
      }
    };
    var Entry = class {
      constructor(key, value, length, now, maxAge) {
        this.key = key;
        this.value = value;
        this.length = length;
        this.now = now;
        this.maxAge = maxAge || 0;
      }
    };
    var forEachStep = (self2, fn3, node, thisp) => {
      let hit = node.value;
      if (isStale(self2, hit)) {
        del(self2, node);
        if (!self2[ALLOW_STALE])
          hit = void 0;
      }
      if (hit)
        fn3.call(thisp, hit.value, hit.key, self2);
    };
    module2.exports = LRUCache;
  }
});

// node_modules/semver/classes/range.js
var require_range = __commonJS({
  "node_modules/semver/classes/range.js"(exports2, module2) {
    var Range = class {
      constructor(range, options) {
        options = parseOptions(options);
        if (range instanceof Range) {
          if (range.loose === !!options.loose && range.includePrerelease === !!options.includePrerelease) {
            return range;
          } else {
            return new Range(range.raw, options);
          }
        }
        if (range instanceof Comparator) {
          this.raw = range.value;
          this.set = [[range]];
          this.format();
          return this;
        }
        this.options = options;
        this.loose = !!options.loose;
        this.includePrerelease = !!options.includePrerelease;
        this.raw = range;
        this.set = range.split(/\s*\|\|\s*/).map((range2) => this.parseRange(range2.trim())).filter((c) => c.length);
        if (!this.set.length) {
          throw new TypeError(`Invalid SemVer Range: ${range}`);
        }
        if (this.set.length > 1) {
          const first3 = this.set[0];
          this.set = this.set.filter((c) => !isNullSet(c[0]));
          if (this.set.length === 0)
            this.set = [first3];
          else if (this.set.length > 1) {
            for (const c of this.set) {
              if (c.length === 1 && isAny(c[0])) {
                this.set = [c];
                break;
              }
            }
          }
        }
        this.format();
      }
      format() {
        this.range = this.set.map((comps) => {
          return comps.join(" ").trim();
        }).join("||").trim();
        return this.range;
      }
      toString() {
        return this.range;
      }
      parseRange(range) {
        range = range.trim();
        const memoOpts = Object.keys(this.options).join(",");
        const memoKey = `parseRange:${memoOpts}:${range}`;
        const cached = cache.get(memoKey);
        if (cached)
          return cached;
        const loose = this.options.loose;
        const hr = loose ? re[t.HYPHENRANGELOOSE] : re[t.HYPHENRANGE];
        range = range.replace(hr, hyphenReplace(this.options.includePrerelease));
        debug("hyphen replace", range);
        range = range.replace(re[t.COMPARATORTRIM], comparatorTrimReplace);
        debug("comparator trim", range, re[t.COMPARATORTRIM]);
        range = range.replace(re[t.TILDETRIM], tildeTrimReplace);
        range = range.replace(re[t.CARETTRIM], caretTrimReplace);
        range = range.split(/\s+/).join(" ");
        const compRe = loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
        const rangeList = range.split(" ").map((comp) => parseComparator(comp, this.options)).join(" ").split(/\s+/).map((comp) => replaceGTE0(comp, this.options)).filter(this.options.loose ? (comp) => !!comp.match(compRe) : () => true).map((comp) => new Comparator(comp, this.options));
        const l = rangeList.length;
        const rangeMap = /* @__PURE__ */ new Map();
        for (const comp of rangeList) {
          if (isNullSet(comp))
            return [comp];
          rangeMap.set(comp.value, comp);
        }
        if (rangeMap.size > 1 && rangeMap.has(""))
          rangeMap.delete("");
        const result = [...rangeMap.values()];
        cache.set(memoKey, result);
        return result;
      }
      intersects(range, options) {
        if (!(range instanceof Range)) {
          throw new TypeError("a Range is required");
        }
        return this.set.some((thisComparators) => {
          return isSatisfiable(thisComparators, options) && range.set.some((rangeComparators) => {
            return isSatisfiable(rangeComparators, options) && thisComparators.every((thisComparator) => {
              return rangeComparators.every((rangeComparator) => {
                return thisComparator.intersects(rangeComparator, options);
              });
            });
          });
        });
      }
      test(version) {
        if (!version) {
          return false;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        for (let i = 0; i < this.set.length; i++) {
          if (testSet(this.set[i], version, this.options)) {
            return true;
          }
        }
        return false;
      }
    };
    module2.exports = Range;
    var LRU = require_lru_cache();
    var cache = new LRU({ max: 1e3 });
    var parseOptions = require_parse_options();
    var Comparator = require_comparator();
    var debug = require_debug2();
    var SemVer = require_semver();
    var {
      re,
      t,
      comparatorTrimReplace,
      tildeTrimReplace,
      caretTrimReplace
    } = require_re();
    var isNullSet = (c) => c.value === "<0.0.0-0";
    var isAny = (c) => c.value === "";
    var isSatisfiable = (comparators, options) => {
      let result = true;
      const remainingComparators = comparators.slice();
      let testComparator = remainingComparators.pop();
      while (result && remainingComparators.length) {
        result = remainingComparators.every((otherComparator) => {
          return testComparator.intersects(otherComparator, options);
        });
        testComparator = remainingComparators.pop();
      }
      return result;
    };
    var parseComparator = (comp, options) => {
      debug("comp", comp, options);
      comp = replaceCarets(comp, options);
      debug("caret", comp);
      comp = replaceTildes(comp, options);
      debug("tildes", comp);
      comp = replaceXRanges(comp, options);
      debug("xrange", comp);
      comp = replaceStars(comp, options);
      debug("stars", comp);
      return comp;
    };
    var isX = (id) => !id || id.toLowerCase() === "x" || id === "*";
    var replaceTildes = (comp, options) => comp.trim().split(/\s+/).map((comp2) => {
      return replaceTilde(comp2, options);
    }).join(" ");
    var replaceTilde = (comp, options) => {
      const r = options.loose ? re[t.TILDELOOSE] : re[t.TILDE];
      return comp.replace(r, (_, M, m, p, pr) => {
        debug("tilde", comp, _, M, m, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = `>=${M}.0.0 <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          ret = `>=${M}.${m}.0 <${M}.${+m + 1}.0-0`;
        } else if (pr) {
          debug("replaceTilde pr", pr);
          ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
        } else {
          ret = `>=${M}.${m}.${p} <${M}.${+m + 1}.0-0`;
        }
        debug("tilde return", ret);
        return ret;
      });
    };
    var replaceCarets = (comp, options) => comp.trim().split(/\s+/).map((comp2) => {
      return replaceCaret(comp2, options);
    }).join(" ");
    var replaceCaret = (comp, options) => {
      debug("caret", comp, options);
      const r = options.loose ? re[t.CARETLOOSE] : re[t.CARET];
      const z = options.includePrerelease ? "-0" : "";
      return comp.replace(r, (_, M, m, p, pr) => {
        debug("caret", comp, _, M, m, p, pr);
        let ret;
        if (isX(M)) {
          ret = "";
        } else if (isX(m)) {
          ret = `>=${M}.0.0${z} <${+M + 1}.0.0-0`;
        } else if (isX(p)) {
          if (M === "0") {
            ret = `>=${M}.${m}.0${z} <${M}.${+m + 1}.0-0`;
          } else {
            ret = `>=${M}.${m}.0${z} <${+M + 1}.0.0-0`;
          }
        } else if (pr) {
          debug("replaceCaret pr", pr);
          if (M === "0") {
            if (m === "0") {
              ret = `>=${M}.${m}.${p}-${pr} <${M}.${m}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m}.${p}-${pr} <${M}.${+m + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m}.${p}-${pr} <${+M + 1}.0.0-0`;
          }
        } else {
          debug("no pr");
          if (M === "0") {
            if (m === "0") {
              ret = `>=${M}.${m}.${p}${z} <${M}.${m}.${+p + 1}-0`;
            } else {
              ret = `>=${M}.${m}.${p}${z} <${M}.${+m + 1}.0-0`;
            }
          } else {
            ret = `>=${M}.${m}.${p} <${+M + 1}.0.0-0`;
          }
        }
        debug("caret return", ret);
        return ret;
      });
    };
    var replaceXRanges = (comp, options) => {
      debug("replaceXRanges", comp, options);
      return comp.split(/\s+/).map((comp2) => {
        return replaceXRange(comp2, options);
      }).join(" ");
    };
    var replaceXRange = (comp, options) => {
      comp = comp.trim();
      const r = options.loose ? re[t.XRANGELOOSE] : re[t.XRANGE];
      return comp.replace(r, (ret, gtlt, M, m, p, pr) => {
        debug("xRange", comp, ret, gtlt, M, m, p, pr);
        const xM = isX(M);
        const xm = xM || isX(m);
        const xp = xm || isX(p);
        const anyX = xp;
        if (gtlt === "=" && anyX) {
          gtlt = "";
        }
        pr = options.includePrerelease ? "-0" : "";
        if (xM) {
          if (gtlt === ">" || gtlt === "<") {
            ret = "<0.0.0-0";
          } else {
            ret = "*";
          }
        } else if (gtlt && anyX) {
          if (xm) {
            m = 0;
          }
          p = 0;
          if (gtlt === ">") {
            gtlt = ">=";
            if (xm) {
              M = +M + 1;
              m = 0;
              p = 0;
            } else {
              m = +m + 1;
              p = 0;
            }
          } else if (gtlt === "<=") {
            gtlt = "<";
            if (xm) {
              M = +M + 1;
            } else {
              m = +m + 1;
            }
          }
          if (gtlt === "<")
            pr = "-0";
          ret = `${gtlt + M}.${m}.${p}${pr}`;
        } else if (xm) {
          ret = `>=${M}.0.0${pr} <${+M + 1}.0.0-0`;
        } else if (xp) {
          ret = `>=${M}.${m}.0${pr} <${M}.${+m + 1}.0-0`;
        }
        debug("xRange return", ret);
        return ret;
      });
    };
    var replaceStars = (comp, options) => {
      debug("replaceStars", comp, options);
      return comp.trim().replace(re[t.STAR], "");
    };
    var replaceGTE0 = (comp, options) => {
      debug("replaceGTE0", comp, options);
      return comp.trim().replace(re[options.includePrerelease ? t.GTE0PRE : t.GTE0], "");
    };
    var hyphenReplace = (incPr) => ($0, from, fM, fm, fp, fpr, fb, to, tM, tm, tp, tpr, tb) => {
      if (isX(fM)) {
        from = "";
      } else if (isX(fm)) {
        from = `>=${fM}.0.0${incPr ? "-0" : ""}`;
      } else if (isX(fp)) {
        from = `>=${fM}.${fm}.0${incPr ? "-0" : ""}`;
      } else if (fpr) {
        from = `>=${from}`;
      } else {
        from = `>=${from}${incPr ? "-0" : ""}`;
      }
      if (isX(tM)) {
        to = "";
      } else if (isX(tm)) {
        to = `<${+tM + 1}.0.0-0`;
      } else if (isX(tp)) {
        to = `<${tM}.${+tm + 1}.0-0`;
      } else if (tpr) {
        to = `<=${tM}.${tm}.${tp}-${tpr}`;
      } else if (incPr) {
        to = `<${tM}.${tm}.${+tp + 1}-0`;
      } else {
        to = `<=${to}`;
      }
      return `${from} ${to}`.trim();
    };
    var testSet = (set, version, options) => {
      for (let i = 0; i < set.length; i++) {
        if (!set[i].test(version)) {
          return false;
        }
      }
      if (version.prerelease.length && !options.includePrerelease) {
        for (let i = 0; i < set.length; i++) {
          debug(set[i].semver);
          if (set[i].semver === Comparator.ANY) {
            continue;
          }
          if (set[i].semver.prerelease.length > 0) {
            const allowed = set[i].semver;
            if (allowed.major === version.major && allowed.minor === version.minor && allowed.patch === version.patch) {
              return true;
            }
          }
        }
        return false;
      }
      return true;
    };
  }
});

// node_modules/semver/classes/comparator.js
var require_comparator = __commonJS({
  "node_modules/semver/classes/comparator.js"(exports2, module2) {
    var ANY = Symbol("SemVer ANY");
    var Comparator = class {
      static get ANY() {
        return ANY;
      }
      constructor(comp, options) {
        options = parseOptions(options);
        if (comp instanceof Comparator) {
          if (comp.loose === !!options.loose) {
            return comp;
          } else {
            comp = comp.value;
          }
        }
        debug("comparator", comp, options);
        this.options = options;
        this.loose = !!options.loose;
        this.parse(comp);
        if (this.semver === ANY) {
          this.value = "";
        } else {
          this.value = this.operator + this.semver.version;
        }
        debug("comp", this);
      }
      parse(comp) {
        const r = this.options.loose ? re[t.COMPARATORLOOSE] : re[t.COMPARATOR];
        const m = comp.match(r);
        if (!m) {
          throw new TypeError(`Invalid comparator: ${comp}`);
        }
        this.operator = m[1] !== void 0 ? m[1] : "";
        if (this.operator === "=") {
          this.operator = "";
        }
        if (!m[2]) {
          this.semver = ANY;
        } else {
          this.semver = new SemVer(m[2], this.options.loose);
        }
      }
      toString() {
        return this.value;
      }
      test(version) {
        debug("Comparator.test", version, this.options.loose);
        if (this.semver === ANY || version === ANY) {
          return true;
        }
        if (typeof version === "string") {
          try {
            version = new SemVer(version, this.options);
          } catch (er) {
            return false;
          }
        }
        return cmp2(version, this.operator, this.semver, this.options);
      }
      intersects(comp, options) {
        if (!(comp instanceof Comparator)) {
          throw new TypeError("a Comparator is required");
        }
        if (!options || typeof options !== "object") {
          options = {
            loose: !!options,
            includePrerelease: false
          };
        }
        if (this.operator === "") {
          if (this.value === "") {
            return true;
          }
          return new Range(comp.value, options).test(this.value);
        } else if (comp.operator === "") {
          if (comp.value === "") {
            return true;
          }
          return new Range(this.value, options).test(comp.semver);
        }
        const sameDirectionIncreasing = (this.operator === ">=" || this.operator === ">") && (comp.operator === ">=" || comp.operator === ">");
        const sameDirectionDecreasing = (this.operator === "<=" || this.operator === "<") && (comp.operator === "<=" || comp.operator === "<");
        const sameSemVer = this.semver.version === comp.semver.version;
        const differentDirectionsInclusive = (this.operator === ">=" || this.operator === "<=") && (comp.operator === ">=" || comp.operator === "<=");
        const oppositeDirectionsLessThan = cmp2(this.semver, "<", comp.semver, options) && (this.operator === ">=" || this.operator === ">") && (comp.operator === "<=" || comp.operator === "<");
        const oppositeDirectionsGreaterThan = cmp2(this.semver, ">", comp.semver, options) && (this.operator === "<=" || this.operator === "<") && (comp.operator === ">=" || comp.operator === ">");
        return sameDirectionIncreasing || sameDirectionDecreasing || sameSemVer && differentDirectionsInclusive || oppositeDirectionsLessThan || oppositeDirectionsGreaterThan;
      }
    };
    module2.exports = Comparator;
    var parseOptions = require_parse_options();
    var { re, t } = require_re();
    var cmp2 = require_cmp();
    var debug = require_debug2();
    var SemVer = require_semver();
    var Range = require_range();
  }
});

// node_modules/semver/functions/satisfies.js
var require_satisfies = __commonJS({
  "node_modules/semver/functions/satisfies.js"(exports2, module2) {
    var Range = require_range();
    var satisfies = (version, range, options) => {
      try {
        range = new Range(range, options);
      } catch (er) {
        return false;
      }
      return range.test(version);
    };
    module2.exports = satisfies;
  }
});

// node_modules/semver/ranges/to-comparators.js
var require_to_comparators = __commonJS({
  "node_modules/semver/ranges/to-comparators.js"(exports2, module2) {
    var Range = require_range();
    var toComparators = (range, options) => new Range(range, options).set.map((comp) => comp.map((c) => c.value).join(" ").trim().split(" "));
    module2.exports = toComparators;
  }
});

// node_modules/semver/ranges/max-satisfying.js
var require_max_satisfying = __commonJS({
  "node_modules/semver/ranges/max-satisfying.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var maxSatisfying = (versions, range, options) => {
      let max = null;
      let maxSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!max || maxSV.compare(v) === -1) {
            max = v;
            maxSV = new SemVer(max, options);
          }
        }
      });
      return max;
    };
    module2.exports = maxSatisfying;
  }
});

// node_modules/semver/ranges/min-satisfying.js
var require_min_satisfying = __commonJS({
  "node_modules/semver/ranges/min-satisfying.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var minSatisfying = (versions, range, options) => {
      let min = null;
      let minSV = null;
      let rangeObj = null;
      try {
        rangeObj = new Range(range, options);
      } catch (er) {
        return null;
      }
      versions.forEach((v) => {
        if (rangeObj.test(v)) {
          if (!min || minSV.compare(v) === 1) {
            min = v;
            minSV = new SemVer(min, options);
          }
        }
      });
      return min;
    };
    module2.exports = minSatisfying;
  }
});

// node_modules/semver/ranges/min-version.js
var require_min_version = __commonJS({
  "node_modules/semver/ranges/min-version.js"(exports2, module2) {
    var SemVer = require_semver();
    var Range = require_range();
    var gt = require_gt();
    var minVersion = (range, loose) => {
      range = new Range(range, loose);
      let minver = new SemVer("0.0.0");
      if (range.test(minver)) {
        return minver;
      }
      minver = new SemVer("0.0.0-0");
      if (range.test(minver)) {
        return minver;
      }
      minver = null;
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let setMin = null;
        comparators.forEach((comparator) => {
          const compver = new SemVer(comparator.semver.version);
          switch (comparator.operator) {
            case ">":
              if (compver.prerelease.length === 0) {
                compver.patch++;
              } else {
                compver.prerelease.push(0);
              }
              compver.raw = compver.format();
            case "":
            case ">=":
              if (!setMin || gt(compver, setMin)) {
                setMin = compver;
              }
              break;
            case "<":
            case "<=":
              break;
            default:
              throw new Error(`Unexpected operation: ${comparator.operator}`);
          }
        });
        if (setMin && (!minver || gt(minver, setMin)))
          minver = setMin;
      }
      if (minver && range.test(minver)) {
        return minver;
      }
      return null;
    };
    module2.exports = minVersion;
  }
});

// node_modules/semver/ranges/valid.js
var require_valid2 = __commonJS({
  "node_modules/semver/ranges/valid.js"(exports2, module2) {
    var Range = require_range();
    var validRange = (range, options) => {
      try {
        return new Range(range, options).range || "*";
      } catch (er) {
        return null;
      }
    };
    module2.exports = validRange;
  }
});

// node_modules/semver/ranges/outside.js
var require_outside = __commonJS({
  "node_modules/semver/ranges/outside.js"(exports2, module2) {
    var SemVer = require_semver();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var Range = require_range();
    var satisfies = require_satisfies();
    var gt = require_gt();
    var lt = require_lt();
    var lte = require_lte();
    var gte = require_gte();
    var outside = (version, range, hilo, options) => {
      version = new SemVer(version, options);
      range = new Range(range, options);
      let gtfn, ltefn, ltfn, comp, ecomp;
      switch (hilo) {
        case ">":
          gtfn = gt;
          ltefn = lte;
          ltfn = lt;
          comp = ">";
          ecomp = ">=";
          break;
        case "<":
          gtfn = lt;
          ltefn = gte;
          ltfn = gt;
          comp = "<";
          ecomp = "<=";
          break;
        default:
          throw new TypeError('Must provide a hilo val of "<" or ">"');
      }
      if (satisfies(version, range, options)) {
        return false;
      }
      for (let i = 0; i < range.set.length; ++i) {
        const comparators = range.set[i];
        let high = null;
        let low = null;
        comparators.forEach((comparator) => {
          if (comparator.semver === ANY) {
            comparator = new Comparator(">=0.0.0");
          }
          high = high || comparator;
          low = low || comparator;
          if (gtfn(comparator.semver, high.semver, options)) {
            high = comparator;
          } else if (ltfn(comparator.semver, low.semver, options)) {
            low = comparator;
          }
        });
        if (high.operator === comp || high.operator === ecomp) {
          return false;
        }
        if ((!low.operator || low.operator === comp) && ltefn(version, low.semver)) {
          return false;
        } else if (low.operator === ecomp && ltfn(version, low.semver)) {
          return false;
        }
      }
      return true;
    };
    module2.exports = outside;
  }
});

// node_modules/semver/ranges/gtr.js
var require_gtr = __commonJS({
  "node_modules/semver/ranges/gtr.js"(exports2, module2) {
    var outside = require_outside();
    var gtr = (version, range, options) => outside(version, range, ">", options);
    module2.exports = gtr;
  }
});

// node_modules/semver/ranges/ltr.js
var require_ltr = __commonJS({
  "node_modules/semver/ranges/ltr.js"(exports2, module2) {
    var outside = require_outside();
    var ltr = (version, range, options) => outside(version, range, "<", options);
    module2.exports = ltr;
  }
});

// node_modules/semver/ranges/intersects.js
var require_intersects = __commonJS({
  "node_modules/semver/ranges/intersects.js"(exports2, module2) {
    var Range = require_range();
    var intersects = (r1, r2, options) => {
      r1 = new Range(r1, options);
      r2 = new Range(r2, options);
      return r1.intersects(r2);
    };
    module2.exports = intersects;
  }
});

// node_modules/semver/ranges/simplify.js
var require_simplify = __commonJS({
  "node_modules/semver/ranges/simplify.js"(exports2, module2) {
    var satisfies = require_satisfies();
    var compare2 = require_compare();
    module2.exports = (versions, range, options) => {
      const set = [];
      let min = null;
      let prev = null;
      const v = versions.sort((a2, b) => compare2(a2, b, options));
      for (const version of v) {
        const included = satisfies(version, range, options);
        if (included) {
          prev = version;
          if (!min)
            min = version;
        } else {
          if (prev) {
            set.push([min, prev]);
          }
          prev = null;
          min = null;
        }
      }
      if (min)
        set.push([min, null]);
      const ranges = [];
      for (const [min2, max] of set) {
        if (min2 === max)
          ranges.push(min2);
        else if (!max && min2 === v[0])
          ranges.push("*");
        else if (!max)
          ranges.push(`>=${min2}`);
        else if (min2 === v[0])
          ranges.push(`<=${max}`);
        else
          ranges.push(`${min2} - ${max}`);
      }
      const simplified = ranges.join(" || ");
      const original = typeof range.raw === "string" ? range.raw : String(range);
      return simplified.length < original.length ? simplified : range;
    };
  }
});

// node_modules/semver/ranges/subset.js
var require_subset = __commonJS({
  "node_modules/semver/ranges/subset.js"(exports2, module2) {
    var Range = require_range();
    var Comparator = require_comparator();
    var { ANY } = Comparator;
    var satisfies = require_satisfies();
    var compare2 = require_compare();
    var subset = (sub, dom, options = {}) => {
      if (sub === dom)
        return true;
      sub = new Range(sub, options);
      dom = new Range(dom, options);
      let sawNonNull = false;
      OUTER:
        for (const simpleSub of sub.set) {
          for (const simpleDom of dom.set) {
            const isSub = simpleSubset(simpleSub, simpleDom, options);
            sawNonNull = sawNonNull || isSub !== null;
            if (isSub)
              continue OUTER;
          }
          if (sawNonNull)
            return false;
        }
      return true;
    };
    var simpleSubset = (sub, dom, options) => {
      if (sub === dom)
        return true;
      if (sub.length === 1 && sub[0].semver === ANY) {
        if (dom.length === 1 && dom[0].semver === ANY)
          return true;
        else if (options.includePrerelease)
          sub = [new Comparator(">=0.0.0-0")];
        else
          sub = [new Comparator(">=0.0.0")];
      }
      if (dom.length === 1 && dom[0].semver === ANY) {
        if (options.includePrerelease)
          return true;
        else
          dom = [new Comparator(">=0.0.0")];
      }
      const eqSet = /* @__PURE__ */ new Set();
      let gt, lt;
      for (const c of sub) {
        if (c.operator === ">" || c.operator === ">=")
          gt = higherGT(gt, c, options);
        else if (c.operator === "<" || c.operator === "<=")
          lt = lowerLT(lt, c, options);
        else
          eqSet.add(c.semver);
      }
      if (eqSet.size > 1)
        return null;
      let gtltComp;
      if (gt && lt) {
        gtltComp = compare2(gt.semver, lt.semver, options);
        if (gtltComp > 0)
          return null;
        else if (gtltComp === 0 && (gt.operator !== ">=" || lt.operator !== "<="))
          return null;
      }
      for (const eq of eqSet) {
        if (gt && !satisfies(eq, String(gt), options))
          return null;
        if (lt && !satisfies(eq, String(lt), options))
          return null;
        for (const c of dom) {
          if (!satisfies(eq, String(c), options))
            return false;
        }
        return true;
      }
      let higher, lower;
      let hasDomLT, hasDomGT;
      let needDomLTPre = lt && !options.includePrerelease && lt.semver.prerelease.length ? lt.semver : false;
      let needDomGTPre = gt && !options.includePrerelease && gt.semver.prerelease.length ? gt.semver : false;
      if (needDomLTPre && needDomLTPre.prerelease.length === 1 && lt.operator === "<" && needDomLTPre.prerelease[0] === 0) {
        needDomLTPre = false;
      }
      for (const c of dom) {
        hasDomGT = hasDomGT || c.operator === ">" || c.operator === ">=";
        hasDomLT = hasDomLT || c.operator === "<" || c.operator === "<=";
        if (gt) {
          if (needDomGTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomGTPre.major && c.semver.minor === needDomGTPre.minor && c.semver.patch === needDomGTPre.patch) {
              needDomGTPre = false;
            }
          }
          if (c.operator === ">" || c.operator === ">=") {
            higher = higherGT(gt, c, options);
            if (higher === c && higher !== gt)
              return false;
          } else if (gt.operator === ">=" && !satisfies(gt.semver, String(c), options))
            return false;
        }
        if (lt) {
          if (needDomLTPre) {
            if (c.semver.prerelease && c.semver.prerelease.length && c.semver.major === needDomLTPre.major && c.semver.minor === needDomLTPre.minor && c.semver.patch === needDomLTPre.patch) {
              needDomLTPre = false;
            }
          }
          if (c.operator === "<" || c.operator === "<=") {
            lower = lowerLT(lt, c, options);
            if (lower === c && lower !== lt)
              return false;
          } else if (lt.operator === "<=" && !satisfies(lt.semver, String(c), options))
            return false;
        }
        if (!c.operator && (lt || gt) && gtltComp !== 0)
          return false;
      }
      if (gt && hasDomLT && !lt && gtltComp !== 0)
        return false;
      if (lt && hasDomGT && !gt && gtltComp !== 0)
        return false;
      if (needDomGTPre || needDomLTPre)
        return false;
      return true;
    };
    var higherGT = (a2, b, options) => {
      if (!a2)
        return b;
      const comp = compare2(a2.semver, b.semver, options);
      return comp > 0 ? a2 : comp < 0 ? b : b.operator === ">" && a2.operator === ">=" ? b : a2;
    };
    var lowerLT = (a2, b, options) => {
      if (!a2)
        return b;
      const comp = compare2(a2.semver, b.semver, options);
      return comp < 0 ? a2 : comp > 0 ? b : b.operator === "<" && a2.operator === "<=" ? b : a2;
    };
    module2.exports = subset;
  }
});

// node_modules/semver/index.js
var require_semver2 = __commonJS({
  "node_modules/semver/index.js"(exports2, module2) {
    var internalRe = require_re();
    module2.exports = {
      re: internalRe.re,
      src: internalRe.src,
      tokens: internalRe.t,
      SEMVER_SPEC_VERSION: require_constants().SEMVER_SPEC_VERSION,
      SemVer: require_semver(),
      compareIdentifiers: require_identifiers().compareIdentifiers,
      rcompareIdentifiers: require_identifiers().rcompareIdentifiers,
      parse: require_parse(),
      valid: require_valid(),
      clean: require_clean(),
      inc: require_inc(),
      diff: require_diff(),
      major: require_major(),
      minor: require_minor(),
      patch: require_patch(),
      prerelease: require_prerelease(),
      compare: require_compare(),
      rcompare: require_rcompare(),
      compareLoose: require_compare_loose(),
      compareBuild: require_compare_build(),
      sort: require_sort(),
      rsort: require_rsort(),
      gt: require_gt(),
      lt: require_lt(),
      eq: require_eq(),
      neq: require_neq(),
      gte: require_gte(),
      lte: require_lte(),
      cmp: require_cmp(),
      coerce: require_coerce(),
      Comparator: require_comparator(),
      Range: require_range(),
      satisfies: require_satisfies(),
      toComparators: require_to_comparators(),
      maxSatisfying: require_max_satisfying(),
      minSatisfying: require_min_satisfying(),
      minVersion: require_min_version(),
      validRange: require_valid2(),
      outside: require_outside(),
      gtr: require_gtr(),
      ltr: require_ltr(),
      intersects: require_intersects(),
      simplifyRange: require_simplify(),
      subset: require_subset()
    };
  }
});

// node_modules/package-json/index.js
var require_package_json = __commonJS({
  "node_modules/package-json/index.js"(exports2, module2) {
    "use strict";
    var { Agent: HttpAgent } = require("http");
    var { Agent: HttpsAgent } = require("https");
    var got = require_source6();
    var registryUrl = require_registry_url();
    var registryAuthToken = require_registry_auth_token();
    var semver = require_semver2();
    var agentOptions = {
      keepAlive: true,
      maxSockets: 50
    };
    var httpAgent = new HttpAgent(agentOptions);
    var httpsAgent = new HttpsAgent(agentOptions);
    var PackageNotFoundError = class extends Error {
      constructor(packageName) {
        super(`Package \`${packageName}\` could not be found`);
        this.name = "PackageNotFoundError";
      }
    };
    var VersionNotFoundError = class extends Error {
      constructor(packageName, version) {
        super(`Version \`${version}\` for package \`${packageName}\` could not be found`);
        this.name = "VersionNotFoundError";
      }
    };
    var packageJson2 = async (packageName, options) => {
      options = {
        version: "latest",
        ...options
      };
      const scope = packageName.split("/")[0];
      const registryUrl_ = options.registryUrl || registryUrl(scope);
      const packageUrl = new URL(encodeURIComponent(packageName).replace(/^%40/, "@"), registryUrl_);
      const authInfo = registryAuthToken(registryUrl_.toString(), { recursive: true });
      const headers = {
        accept: "application/vnd.npm.install-v1+json; q=1.0, application/json; q=0.8, */*"
      };
      if (options.fullMetadata) {
        delete headers.accept;
      }
      if (authInfo) {
        headers.authorization = `${authInfo.type} ${authInfo.token}`;
      }
      const gotOptions = {
        headers,
        agent: {
          http: httpAgent,
          https: httpsAgent
        }
      };
      if (options.agent) {
        gotOptions.agent = options.agent;
      }
      let data;
      try {
        data = await got(packageUrl, gotOptions).json();
      } catch (error) {
        if (error.response.statusCode === 404) {
          throw new PackageNotFoundError(packageName);
        }
        throw error;
      }
      if (options.allVersions) {
        return data;
      }
      let { version } = options;
      const versionError = new VersionNotFoundError(packageName, version);
      if (data["dist-tags"][version]) {
        data = data.versions[data["dist-tags"][version]];
      } else if (version) {
        if (!data.versions[version]) {
          const versions = Object.keys(data.versions);
          version = semver.maxSatisfying(versions, version);
          if (!version) {
            throw versionError;
          }
        }
        data = data.versions[version];
        if (!data) {
          throw versionError;
        }
      }
      return data;
    };
    module2.exports = packageJson2;
    module2.exports.default = packageJson2;
    module2.exports.PackageNotFoundError = PackageNotFoundError;
    module2.exports.VersionNotFoundError = VersionNotFoundError;
  }
});

// node_modules/prettysize/index.js
var require_prettysize = __commonJS({
  "node_modules/prettysize/index.js"(exports2, module2) {
    "use strict";
    var sizes = [
      "Bytes",
      "kB",
      "MB",
      "GB",
      "TB",
      "PB",
      "EB"
    ];
    module2.exports = function(size, nospace, one, places, numOnly) {
      if (typeof nospace === "object") {
        var opts = nospace;
        nospace = opts.nospace;
        one = opts.one;
        places = opts.places || 1;
        numOnly = opts.numOnly;
      } else {
        places = places || 1;
      }
      var mysize;
      for (var id = 0; id < sizes.length; ++id) {
        var unit = sizes[id];
        if (one) {
          unit = unit.slice(0, 1);
        }
        var s = Math.pow(1024, id);
        var fixed;
        if (size >= s) {
          fixed = String((size / s).toFixed(places));
          if (fixed.indexOf(".0") === fixed.length - 2) {
            fixed = fixed.slice(0, -2);
          }
          mysize = fixed + (nospace ? "" : " ") + unit;
        }
      }
      if (!mysize) {
        var _unit = one ? sizes[0].slice(0, 1) : sizes[0];
        mysize = "0" + (nospace ? "" : " ") + _unit;
      }
      if (numOnly) {
        mysize = Number.parseFloat(mysize);
      }
      return mysize;
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMode.js
var require_QRMode = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMode.js"(exports2, module2) {
    module2.exports = {
      MODE_NUMBER: 1 << 0,
      MODE_ALPHA_NUM: 1 << 1,
      MODE_8BIT_BYTE: 1 << 2,
      MODE_KANJI: 1 << 3
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QR8bitByte.js
var require_QR8bitByte = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QR8bitByte.js"(exports2, module2) {
    var QRMode = require_QRMode();
    function QR8bitByte(data) {
      this.mode = QRMode.MODE_8BIT_BYTE;
      this.data = data;
    }
    QR8bitByte.prototype = {
      getLength: function() {
        return this.data.length;
      },
      write: function(buffer) {
        for (var i = 0; i < this.data.length; i++) {
          buffer.put(this.data.charCodeAt(i), 8);
        }
      }
    };
    module2.exports = QR8bitByte;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMath.js
var require_QRMath = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMath.js"(exports2, module2) {
    var QRMath = {
      glog: function(n) {
        if (n < 1) {
          throw new Error("glog(" + n + ")");
        }
        return QRMath.LOG_TABLE[n];
      },
      gexp: function(n) {
        while (n < 0) {
          n += 255;
        }
        while (n >= 256) {
          n -= 255;
        }
        return QRMath.EXP_TABLE[n];
      },
      EXP_TABLE: new Array(256),
      LOG_TABLE: new Array(256)
    };
    for (i = 0; i < 8; i++) {
      QRMath.EXP_TABLE[i] = 1 << i;
    }
    var i;
    for (i = 8; i < 256; i++) {
      QRMath.EXP_TABLE[i] = QRMath.EXP_TABLE[i - 4] ^ QRMath.EXP_TABLE[i - 5] ^ QRMath.EXP_TABLE[i - 6] ^ QRMath.EXP_TABLE[i - 8];
    }
    var i;
    for (i = 0; i < 255; i++) {
      QRMath.LOG_TABLE[QRMath.EXP_TABLE[i]] = i;
    }
    var i;
    module2.exports = QRMath;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRPolynomial.js
var require_QRPolynomial = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRPolynomial.js"(exports2, module2) {
    var QRMath = require_QRMath();
    function QRPolynomial(num, shift) {
      if (num.length === void 0) {
        throw new Error(num.length + "/" + shift);
      }
      var offset = 0;
      while (offset < num.length && num[offset] === 0) {
        offset++;
      }
      this.num = new Array(num.length - offset + shift);
      for (var i = 0; i < num.length - offset; i++) {
        this.num[i] = num[i + offset];
      }
    }
    QRPolynomial.prototype = {
      get: function(index) {
        return this.num[index];
      },
      getLength: function() {
        return this.num.length;
      },
      multiply: function(e) {
        var num = new Array(this.getLength() + e.getLength() - 1);
        for (var i = 0; i < this.getLength(); i++) {
          for (var j = 0; j < e.getLength(); j++) {
            num[i + j] ^= QRMath.gexp(QRMath.glog(this.get(i)) + QRMath.glog(e.get(j)));
          }
        }
        return new QRPolynomial(num, 0);
      },
      mod: function(e) {
        if (this.getLength() - e.getLength() < 0) {
          return this;
        }
        var ratio = QRMath.glog(this.get(0)) - QRMath.glog(e.get(0));
        var num = new Array(this.getLength());
        for (var i = 0; i < this.getLength(); i++) {
          num[i] = this.get(i);
        }
        for (var x = 0; x < e.getLength(); x++) {
          num[x] ^= QRMath.gexp(QRMath.glog(e.get(x)) + ratio);
        }
        return new QRPolynomial(num, 0).mod(e);
      }
    };
    module2.exports = QRPolynomial;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRMaskPattern.js
var require_QRMaskPattern = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRMaskPattern.js"(exports2, module2) {
    module2.exports = {
      PATTERN000: 0,
      PATTERN001: 1,
      PATTERN010: 2,
      PATTERN011: 3,
      PATTERN100: 4,
      PATTERN101: 5,
      PATTERN110: 6,
      PATTERN111: 7
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRUtil.js
var require_QRUtil = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRUtil.js"(exports2, module2) {
    var QRMode = require_QRMode();
    var QRPolynomial = require_QRPolynomial();
    var QRMath = require_QRMath();
    var QRMaskPattern = require_QRMaskPattern();
    var QRUtil = {
      PATTERN_POSITION_TABLE: [
        [],
        [6, 18],
        [6, 22],
        [6, 26],
        [6, 30],
        [6, 34],
        [6, 22, 38],
        [6, 24, 42],
        [6, 26, 46],
        [6, 28, 50],
        [6, 30, 54],
        [6, 32, 58],
        [6, 34, 62],
        [6, 26, 46, 66],
        [6, 26, 48, 70],
        [6, 26, 50, 74],
        [6, 30, 54, 78],
        [6, 30, 56, 82],
        [6, 30, 58, 86],
        [6, 34, 62, 90],
        [6, 28, 50, 72, 94],
        [6, 26, 50, 74, 98],
        [6, 30, 54, 78, 102],
        [6, 28, 54, 80, 106],
        [6, 32, 58, 84, 110],
        [6, 30, 58, 86, 114],
        [6, 34, 62, 90, 118],
        [6, 26, 50, 74, 98, 122],
        [6, 30, 54, 78, 102, 126],
        [6, 26, 52, 78, 104, 130],
        [6, 30, 56, 82, 108, 134],
        [6, 34, 60, 86, 112, 138],
        [6, 30, 58, 86, 114, 142],
        [6, 34, 62, 90, 118, 146],
        [6, 30, 54, 78, 102, 126, 150],
        [6, 24, 50, 76, 102, 128, 154],
        [6, 28, 54, 80, 106, 132, 158],
        [6, 32, 58, 84, 110, 136, 162],
        [6, 26, 54, 82, 110, 138, 166],
        [6, 30, 58, 86, 114, 142, 170]
      ],
      G15: 1 << 10 | 1 << 8 | 1 << 5 | 1 << 4 | 1 << 2 | 1 << 1 | 1 << 0,
      G18: 1 << 12 | 1 << 11 | 1 << 10 | 1 << 9 | 1 << 8 | 1 << 5 | 1 << 2 | 1 << 0,
      G15_MASK: 1 << 14 | 1 << 12 | 1 << 10 | 1 << 4 | 1 << 1,
      getBCHTypeInfo: function(data) {
        var d = data << 10;
        while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15) >= 0) {
          d ^= QRUtil.G15 << QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G15);
        }
        return (data << 10 | d) ^ QRUtil.G15_MASK;
      },
      getBCHTypeNumber: function(data) {
        var d = data << 12;
        while (QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18) >= 0) {
          d ^= QRUtil.G18 << QRUtil.getBCHDigit(d) - QRUtil.getBCHDigit(QRUtil.G18);
        }
        return data << 12 | d;
      },
      getBCHDigit: function(data) {
        var digit = 0;
        while (data !== 0) {
          digit++;
          data >>>= 1;
        }
        return digit;
      },
      getPatternPosition: function(typeNumber) {
        return QRUtil.PATTERN_POSITION_TABLE[typeNumber - 1];
      },
      getMask: function(maskPattern, i, j) {
        switch (maskPattern) {
          case QRMaskPattern.PATTERN000:
            return (i + j) % 2 === 0;
          case QRMaskPattern.PATTERN001:
            return i % 2 === 0;
          case QRMaskPattern.PATTERN010:
            return j % 3 === 0;
          case QRMaskPattern.PATTERN011:
            return (i + j) % 3 === 0;
          case QRMaskPattern.PATTERN100:
            return (Math.floor(i / 2) + Math.floor(j / 3)) % 2 === 0;
          case QRMaskPattern.PATTERN101:
            return i * j % 2 + i * j % 3 === 0;
          case QRMaskPattern.PATTERN110:
            return (i * j % 2 + i * j % 3) % 2 === 0;
          case QRMaskPattern.PATTERN111:
            return (i * j % 3 + (i + j) % 2) % 2 === 0;
          default:
            throw new Error("bad maskPattern:" + maskPattern);
        }
      },
      getErrorCorrectPolynomial: function(errorCorrectLength) {
        var a2 = new QRPolynomial([1], 0);
        for (var i = 0; i < errorCorrectLength; i++) {
          a2 = a2.multiply(new QRPolynomial([1, QRMath.gexp(i)], 0));
        }
        return a2;
      },
      getLengthInBits: function(mode, type) {
        if (1 <= type && type < 10) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 10;
            case QRMode.MODE_ALPHA_NUM:
              return 9;
            case QRMode.MODE_8BIT_BYTE:
              return 8;
            case QRMode.MODE_KANJI:
              return 8;
            default:
              throw new Error("mode:" + mode);
          }
        } else if (type < 27) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 12;
            case QRMode.MODE_ALPHA_NUM:
              return 11;
            case QRMode.MODE_8BIT_BYTE:
              return 16;
            case QRMode.MODE_KANJI:
              return 10;
            default:
              throw new Error("mode:" + mode);
          }
        } else if (type < 41) {
          switch (mode) {
            case QRMode.MODE_NUMBER:
              return 14;
            case QRMode.MODE_ALPHA_NUM:
              return 13;
            case QRMode.MODE_8BIT_BYTE:
              return 16;
            case QRMode.MODE_KANJI:
              return 12;
            default:
              throw new Error("mode:" + mode);
          }
        } else {
          throw new Error("type:" + type);
        }
      },
      getLostPoint: function(qrCode) {
        var moduleCount = qrCode.getModuleCount();
        var lostPoint = 0;
        var row2 = 0;
        var col = 0;
        for (row2 = 0; row2 < moduleCount; row2++) {
          for (col = 0; col < moduleCount; col++) {
            var sameCount = 0;
            var dark = qrCode.isDark(row2, col);
            for (var r = -1; r <= 1; r++) {
              if (row2 + r < 0 || moduleCount <= row2 + r) {
                continue;
              }
              for (var c = -1; c <= 1; c++) {
                if (col + c < 0 || moduleCount <= col + c) {
                  continue;
                }
                if (r === 0 && c === 0) {
                  continue;
                }
                if (dark === qrCode.isDark(row2 + r, col + c)) {
                  sameCount++;
                }
              }
            }
            if (sameCount > 5) {
              lostPoint += 3 + sameCount - 5;
            }
          }
        }
        for (row2 = 0; row2 < moduleCount - 1; row2++) {
          for (col = 0; col < moduleCount - 1; col++) {
            var count2 = 0;
            if (qrCode.isDark(row2, col))
              count2++;
            if (qrCode.isDark(row2 + 1, col))
              count2++;
            if (qrCode.isDark(row2, col + 1))
              count2++;
            if (qrCode.isDark(row2 + 1, col + 1))
              count2++;
            if (count2 === 0 || count2 === 4) {
              lostPoint += 3;
            }
          }
        }
        for (row2 = 0; row2 < moduleCount; row2++) {
          for (col = 0; col < moduleCount - 6; col++) {
            if (qrCode.isDark(row2, col) && !qrCode.isDark(row2, col + 1) && qrCode.isDark(row2, col + 2) && qrCode.isDark(row2, col + 3) && qrCode.isDark(row2, col + 4) && !qrCode.isDark(row2, col + 5) && qrCode.isDark(row2, col + 6)) {
              lostPoint += 40;
            }
          }
        }
        for (col = 0; col < moduleCount; col++) {
          for (row2 = 0; row2 < moduleCount - 6; row2++) {
            if (qrCode.isDark(row2, col) && !qrCode.isDark(row2 + 1, col) && qrCode.isDark(row2 + 2, col) && qrCode.isDark(row2 + 3, col) && qrCode.isDark(row2 + 4, col) && !qrCode.isDark(row2 + 5, col) && qrCode.isDark(row2 + 6, col)) {
              lostPoint += 40;
            }
          }
        }
        var darkCount = 0;
        for (col = 0; col < moduleCount; col++) {
          for (row2 = 0; row2 < moduleCount; row2++) {
            if (qrCode.isDark(row2, col)) {
              darkCount++;
            }
          }
        }
        var ratio = Math.abs(100 * darkCount / moduleCount / moduleCount - 50) / 5;
        lostPoint += ratio * 10;
        return lostPoint;
      }
    };
    module2.exports = QRUtil;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRErrorCorrectLevel.js
var require_QRErrorCorrectLevel = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRErrorCorrectLevel.js"(exports2, module2) {
    module2.exports = {
      L: 1,
      M: 0,
      Q: 3,
      H: 2
    };
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRRSBlock.js
var require_QRRSBlock = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRRSBlock.js"(exports2, module2) {
    var QRErrorCorrectLevel = require_QRErrorCorrectLevel();
    function QRRSBlock(totalCount, dataCount) {
      this.totalCount = totalCount;
      this.dataCount = dataCount;
    }
    QRRSBlock.RS_BLOCK_TABLE = [
      [1, 26, 19],
      [1, 26, 16],
      [1, 26, 13],
      [1, 26, 9],
      [1, 44, 34],
      [1, 44, 28],
      [1, 44, 22],
      [1, 44, 16],
      [1, 70, 55],
      [1, 70, 44],
      [2, 35, 17],
      [2, 35, 13],
      [1, 100, 80],
      [2, 50, 32],
      [2, 50, 24],
      [4, 25, 9],
      [1, 134, 108],
      [2, 67, 43],
      [2, 33, 15, 2, 34, 16],
      [2, 33, 11, 2, 34, 12],
      [2, 86, 68],
      [4, 43, 27],
      [4, 43, 19],
      [4, 43, 15],
      [2, 98, 78],
      [4, 49, 31],
      [2, 32, 14, 4, 33, 15],
      [4, 39, 13, 1, 40, 14],
      [2, 121, 97],
      [2, 60, 38, 2, 61, 39],
      [4, 40, 18, 2, 41, 19],
      [4, 40, 14, 2, 41, 15],
      [2, 146, 116],
      [3, 58, 36, 2, 59, 37],
      [4, 36, 16, 4, 37, 17],
      [4, 36, 12, 4, 37, 13],
      [2, 86, 68, 2, 87, 69],
      [4, 69, 43, 1, 70, 44],
      [6, 43, 19, 2, 44, 20],
      [6, 43, 15, 2, 44, 16],
      [4, 101, 81],
      [1, 80, 50, 4, 81, 51],
      [4, 50, 22, 4, 51, 23],
      [3, 36, 12, 8, 37, 13],
      [2, 116, 92, 2, 117, 93],
      [6, 58, 36, 2, 59, 37],
      [4, 46, 20, 6, 47, 21],
      [7, 42, 14, 4, 43, 15],
      [4, 133, 107],
      [8, 59, 37, 1, 60, 38],
      [8, 44, 20, 4, 45, 21],
      [12, 33, 11, 4, 34, 12],
      [3, 145, 115, 1, 146, 116],
      [4, 64, 40, 5, 65, 41],
      [11, 36, 16, 5, 37, 17],
      [11, 36, 12, 5, 37, 13],
      [5, 109, 87, 1, 110, 88],
      [5, 65, 41, 5, 66, 42],
      [5, 54, 24, 7, 55, 25],
      [11, 36, 12],
      [5, 122, 98, 1, 123, 99],
      [7, 73, 45, 3, 74, 46],
      [15, 43, 19, 2, 44, 20],
      [3, 45, 15, 13, 46, 16],
      [1, 135, 107, 5, 136, 108],
      [10, 74, 46, 1, 75, 47],
      [1, 50, 22, 15, 51, 23],
      [2, 42, 14, 17, 43, 15],
      [5, 150, 120, 1, 151, 121],
      [9, 69, 43, 4, 70, 44],
      [17, 50, 22, 1, 51, 23],
      [2, 42, 14, 19, 43, 15],
      [3, 141, 113, 4, 142, 114],
      [3, 70, 44, 11, 71, 45],
      [17, 47, 21, 4, 48, 22],
      [9, 39, 13, 16, 40, 14],
      [3, 135, 107, 5, 136, 108],
      [3, 67, 41, 13, 68, 42],
      [15, 54, 24, 5, 55, 25],
      [15, 43, 15, 10, 44, 16],
      [4, 144, 116, 4, 145, 117],
      [17, 68, 42],
      [17, 50, 22, 6, 51, 23],
      [19, 46, 16, 6, 47, 17],
      [2, 139, 111, 7, 140, 112],
      [17, 74, 46],
      [7, 54, 24, 16, 55, 25],
      [34, 37, 13],
      [4, 151, 121, 5, 152, 122],
      [4, 75, 47, 14, 76, 48],
      [11, 54, 24, 14, 55, 25],
      [16, 45, 15, 14, 46, 16],
      [6, 147, 117, 4, 148, 118],
      [6, 73, 45, 14, 74, 46],
      [11, 54, 24, 16, 55, 25],
      [30, 46, 16, 2, 47, 17],
      [8, 132, 106, 4, 133, 107],
      [8, 75, 47, 13, 76, 48],
      [7, 54, 24, 22, 55, 25],
      [22, 45, 15, 13, 46, 16],
      [10, 142, 114, 2, 143, 115],
      [19, 74, 46, 4, 75, 47],
      [28, 50, 22, 6, 51, 23],
      [33, 46, 16, 4, 47, 17],
      [8, 152, 122, 4, 153, 123],
      [22, 73, 45, 3, 74, 46],
      [8, 53, 23, 26, 54, 24],
      [12, 45, 15, 28, 46, 16],
      [3, 147, 117, 10, 148, 118],
      [3, 73, 45, 23, 74, 46],
      [4, 54, 24, 31, 55, 25],
      [11, 45, 15, 31, 46, 16],
      [7, 146, 116, 7, 147, 117],
      [21, 73, 45, 7, 74, 46],
      [1, 53, 23, 37, 54, 24],
      [19, 45, 15, 26, 46, 16],
      [5, 145, 115, 10, 146, 116],
      [19, 75, 47, 10, 76, 48],
      [15, 54, 24, 25, 55, 25],
      [23, 45, 15, 25, 46, 16],
      [13, 145, 115, 3, 146, 116],
      [2, 74, 46, 29, 75, 47],
      [42, 54, 24, 1, 55, 25],
      [23, 45, 15, 28, 46, 16],
      [17, 145, 115],
      [10, 74, 46, 23, 75, 47],
      [10, 54, 24, 35, 55, 25],
      [19, 45, 15, 35, 46, 16],
      [17, 145, 115, 1, 146, 116],
      [14, 74, 46, 21, 75, 47],
      [29, 54, 24, 19, 55, 25],
      [11, 45, 15, 46, 46, 16],
      [13, 145, 115, 6, 146, 116],
      [14, 74, 46, 23, 75, 47],
      [44, 54, 24, 7, 55, 25],
      [59, 46, 16, 1, 47, 17],
      [12, 151, 121, 7, 152, 122],
      [12, 75, 47, 26, 76, 48],
      [39, 54, 24, 14, 55, 25],
      [22, 45, 15, 41, 46, 16],
      [6, 151, 121, 14, 152, 122],
      [6, 75, 47, 34, 76, 48],
      [46, 54, 24, 10, 55, 25],
      [2, 45, 15, 64, 46, 16],
      [17, 152, 122, 4, 153, 123],
      [29, 74, 46, 14, 75, 47],
      [49, 54, 24, 10, 55, 25],
      [24, 45, 15, 46, 46, 16],
      [4, 152, 122, 18, 153, 123],
      [13, 74, 46, 32, 75, 47],
      [48, 54, 24, 14, 55, 25],
      [42, 45, 15, 32, 46, 16],
      [20, 147, 117, 4, 148, 118],
      [40, 75, 47, 7, 76, 48],
      [43, 54, 24, 22, 55, 25],
      [10, 45, 15, 67, 46, 16],
      [19, 148, 118, 6, 149, 119],
      [18, 75, 47, 31, 76, 48],
      [34, 54, 24, 34, 55, 25],
      [20, 45, 15, 61, 46, 16]
    ];
    QRRSBlock.getRSBlocks = function(typeNumber, errorCorrectLevel) {
      var rsBlock = QRRSBlock.getRsBlockTable(typeNumber, errorCorrectLevel);
      if (rsBlock === void 0) {
        throw new Error("bad rs block @ typeNumber:" + typeNumber + "/errorCorrectLevel:" + errorCorrectLevel);
      }
      var length = rsBlock.length / 3;
      var list = [];
      for (var i = 0; i < length; i++) {
        var count2 = rsBlock[i * 3 + 0];
        var totalCount = rsBlock[i * 3 + 1];
        var dataCount = rsBlock[i * 3 + 2];
        for (var j = 0; j < count2; j++) {
          list.push(new QRRSBlock(totalCount, dataCount));
        }
      }
      return list;
    };
    QRRSBlock.getRsBlockTable = function(typeNumber, errorCorrectLevel) {
      switch (errorCorrectLevel) {
        case QRErrorCorrectLevel.L:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 0];
        case QRErrorCorrectLevel.M:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 1];
        case QRErrorCorrectLevel.Q:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 2];
        case QRErrorCorrectLevel.H:
          return QRRSBlock.RS_BLOCK_TABLE[(typeNumber - 1) * 4 + 3];
        default:
          return void 0;
      }
    };
    module2.exports = QRRSBlock;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/QRBitBuffer.js
var require_QRBitBuffer = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/QRBitBuffer.js"(exports2, module2) {
    function QRBitBuffer() {
      this.buffer = [];
      this.length = 0;
    }
    QRBitBuffer.prototype = {
      get: function(index) {
        var bufIndex = Math.floor(index / 8);
        return (this.buffer[bufIndex] >>> 7 - index % 8 & 1) == 1;
      },
      put: function(num, length) {
        for (var i = 0; i < length; i++) {
          this.putBit((num >>> length - i - 1 & 1) == 1);
        }
      },
      getLengthInBits: function() {
        return this.length;
      },
      putBit: function(bit) {
        var bufIndex = Math.floor(this.length / 8);
        if (this.buffer.length <= bufIndex) {
          this.buffer.push(0);
        }
        if (bit) {
          this.buffer[bufIndex] |= 128 >>> this.length % 8;
        }
        this.length++;
      }
    };
    module2.exports = QRBitBuffer;
  }
});

// node_modules/qrcode-terminal/vendor/QRCode/index.js
var require_QRCode = __commonJS({
  "node_modules/qrcode-terminal/vendor/QRCode/index.js"(exports2, module2) {
    var QR8bitByte = require_QR8bitByte();
    var QRUtil = require_QRUtil();
    var QRPolynomial = require_QRPolynomial();
    var QRRSBlock = require_QRRSBlock();
    var QRBitBuffer = require_QRBitBuffer();
    function QRCode(typeNumber, errorCorrectLevel) {
      this.typeNumber = typeNumber;
      this.errorCorrectLevel = errorCorrectLevel;
      this.modules = null;
      this.moduleCount = 0;
      this.dataCache = null;
      this.dataList = [];
    }
    QRCode.prototype = {
      addData: function(data) {
        var newData = new QR8bitByte(data);
        this.dataList.push(newData);
        this.dataCache = null;
      },
      isDark: function(row2, col) {
        if (row2 < 0 || this.moduleCount <= row2 || col < 0 || this.moduleCount <= col) {
          throw new Error(row2 + "," + col);
        }
        return this.modules[row2][col];
      },
      getModuleCount: function() {
        return this.moduleCount;
      },
      make: function() {
        if (this.typeNumber < 1) {
          var typeNumber = 1;
          for (typeNumber = 1; typeNumber < 40; typeNumber++) {
            var rsBlocks = QRRSBlock.getRSBlocks(typeNumber, this.errorCorrectLevel);
            var buffer = new QRBitBuffer();
            var totalDataCount = 0;
            for (var i = 0; i < rsBlocks.length; i++) {
              totalDataCount += rsBlocks[i].dataCount;
            }
            for (var x = 0; x < this.dataList.length; x++) {
              var data = this.dataList[x];
              buffer.put(data.mode, 4);
              buffer.put(data.getLength(), QRUtil.getLengthInBits(data.mode, typeNumber));
              data.write(buffer);
            }
            if (buffer.getLengthInBits() <= totalDataCount * 8)
              break;
          }
          this.typeNumber = typeNumber;
        }
        this.makeImpl(false, this.getBestMaskPattern());
      },
      makeImpl: function(test, maskPattern) {
        this.moduleCount = this.typeNumber * 4 + 17;
        this.modules = new Array(this.moduleCount);
        for (var row2 = 0; row2 < this.moduleCount; row2++) {
          this.modules[row2] = new Array(this.moduleCount);
          for (var col = 0; col < this.moduleCount; col++) {
            this.modules[row2][col] = null;
          }
        }
        this.setupPositionProbePattern(0, 0);
        this.setupPositionProbePattern(this.moduleCount - 7, 0);
        this.setupPositionProbePattern(0, this.moduleCount - 7);
        this.setupPositionAdjustPattern();
        this.setupTimingPattern();
        this.setupTypeInfo(test, maskPattern);
        if (this.typeNumber >= 7) {
          this.setupTypeNumber(test);
        }
        if (this.dataCache === null) {
          this.dataCache = QRCode.createData(this.typeNumber, this.errorCorrectLevel, this.dataList);
        }
        this.mapData(this.dataCache, maskPattern);
      },
      setupPositionProbePattern: function(row2, col) {
        for (var r = -1; r <= 7; r++) {
          if (row2 + r <= -1 || this.moduleCount <= row2 + r)
            continue;
          for (var c = -1; c <= 7; c++) {
            if (col + c <= -1 || this.moduleCount <= col + c)
              continue;
            if (0 <= r && r <= 6 && (c === 0 || c === 6) || 0 <= c && c <= 6 && (r === 0 || r === 6) || 2 <= r && r <= 4 && 2 <= c && c <= 4) {
              this.modules[row2 + r][col + c] = true;
            } else {
              this.modules[row2 + r][col + c] = false;
            }
          }
        }
      },
      getBestMaskPattern: function() {
        var minLostPoint = 0;
        var pattern = 0;
        for (var i = 0; i < 8; i++) {
          this.makeImpl(true, i);
          var lostPoint = QRUtil.getLostPoint(this);
          if (i === 0 || minLostPoint > lostPoint) {
            minLostPoint = lostPoint;
            pattern = i;
          }
        }
        return pattern;
      },
      createMovieClip: function(target_mc, instance_name, depth) {
        var qr_mc = target_mc.createEmptyMovieClip(instance_name, depth);
        var cs = 1;
        this.make();
        for (var row2 = 0; row2 < this.modules.length; row2++) {
          var y = row2 * cs;
          for (var col = 0; col < this.modules[row2].length; col++) {
            var x = col * cs;
            var dark = this.modules[row2][col];
            if (dark) {
              qr_mc.beginFill(0, 100);
              qr_mc.moveTo(x, y);
              qr_mc.lineTo(x + cs, y);
              qr_mc.lineTo(x + cs, y + cs);
              qr_mc.lineTo(x, y + cs);
              qr_mc.endFill();
            }
          }
        }
        return qr_mc;
      },
      setupTimingPattern: function() {
        for (var r = 8; r < this.moduleCount - 8; r++) {
          if (this.modules[r][6] !== null) {
            continue;
          }
          this.modules[r][6] = r % 2 === 0;
        }
        for (var c = 8; c < this.moduleCount - 8; c++) {
          if (this.modules[6][c] !== null) {
            continue;
          }
          this.modules[6][c] = c % 2 === 0;
        }
      },
      setupPositionAdjustPattern: function() {
        var pos = QRUtil.getPatternPosition(this.typeNumber);
        for (var i = 0; i < pos.length; i++) {
          for (var j = 0; j < pos.length; j++) {
            var row2 = pos[i];
            var col = pos[j];
            if (this.modules[row2][col] !== null) {
              continue;
            }
            for (var r = -2; r <= 2; r++) {
              for (var c = -2; c <= 2; c++) {
                if (Math.abs(r) === 2 || Math.abs(c) === 2 || r === 0 && c === 0) {
                  this.modules[row2 + r][col + c] = true;
                } else {
                  this.modules[row2 + r][col + c] = false;
                }
              }
            }
          }
        }
      },
      setupTypeNumber: function(test) {
        var bits = QRUtil.getBCHTypeNumber(this.typeNumber);
        var mod;
        for (var i = 0; i < 18; i++) {
          mod = !test && (bits >> i & 1) === 1;
          this.modules[Math.floor(i / 3)][i % 3 + this.moduleCount - 8 - 3] = mod;
        }
        for (var x = 0; x < 18; x++) {
          mod = !test && (bits >> x & 1) === 1;
          this.modules[x % 3 + this.moduleCount - 8 - 3][Math.floor(x / 3)] = mod;
        }
      },
      setupTypeInfo: function(test, maskPattern) {
        var data = this.errorCorrectLevel << 3 | maskPattern;
        var bits = QRUtil.getBCHTypeInfo(data);
        var mod;
        for (var v = 0; v < 15; v++) {
          mod = !test && (bits >> v & 1) === 1;
          if (v < 6) {
            this.modules[v][8] = mod;
          } else if (v < 8) {
            this.modules[v + 1][8] = mod;
          } else {
            this.modules[this.moduleCount - 15 + v][8] = mod;
          }
        }
        for (var h = 0; h < 15; h++) {
          mod = !test && (bits >> h & 1) === 1;
          if (h < 8) {
            this.modules[8][this.moduleCount - h - 1] = mod;
          } else if (h < 9) {
            this.modules[8][15 - h - 1 + 1] = mod;
          } else {
            this.modules[8][15 - h - 1] = mod;
          }
        }
        this.modules[this.moduleCount - 8][8] = !test;
      },
      mapData: function(data, maskPattern) {
        var inc2 = -1;
        var row2 = this.moduleCount - 1;
        var bitIndex = 7;
        var byteIndex = 0;
        for (var col = this.moduleCount - 1; col > 0; col -= 2) {
          if (col === 6)
            col--;
          while (true) {
            for (var c = 0; c < 2; c++) {
              if (this.modules[row2][col - c] === null) {
                var dark = false;
                if (byteIndex < data.length) {
                  dark = (data[byteIndex] >>> bitIndex & 1) === 1;
                }
                var mask = QRUtil.getMask(maskPattern, row2, col - c);
                if (mask) {
                  dark = !dark;
                }
                this.modules[row2][col - c] = dark;
                bitIndex--;
                if (bitIndex === -1) {
                  byteIndex++;
                  bitIndex = 7;
                }
              }
            }
            row2 += inc2;
            if (row2 < 0 || this.moduleCount <= row2) {
              row2 -= inc2;
              inc2 = -inc2;
              break;
            }
          }
        }
      }
    };
    QRCode.PAD0 = 236;
    QRCode.PAD1 = 17;
    QRCode.createData = function(typeNumber, errorCorrectLevel, dataList) {
      var rsBlocks = QRRSBlock.getRSBlocks(typeNumber, errorCorrectLevel);
      var buffer = new QRBitBuffer();
      for (var i = 0; i < dataList.length; i++) {
        var data = dataList[i];
        buffer.put(data.mode, 4);
        buffer.put(data.getLength(), QRUtil.getLengthInBits(data.mode, typeNumber));
        data.write(buffer);
      }
      var totalDataCount = 0;
      for (var x = 0; x < rsBlocks.length; x++) {
        totalDataCount += rsBlocks[x].dataCount;
      }
      if (buffer.getLengthInBits() > totalDataCount * 8) {
        throw new Error("code length overflow. (" + buffer.getLengthInBits() + ">" + totalDataCount * 8 + ")");
      }
      if (buffer.getLengthInBits() + 4 <= totalDataCount * 8) {
        buffer.put(0, 4);
      }
      while (buffer.getLengthInBits() % 8 !== 0) {
        buffer.putBit(false);
      }
      while (true) {
        if (buffer.getLengthInBits() >= totalDataCount * 8) {
          break;
        }
        buffer.put(QRCode.PAD0, 8);
        if (buffer.getLengthInBits() >= totalDataCount * 8) {
          break;
        }
        buffer.put(QRCode.PAD1, 8);
      }
      return QRCode.createBytes(buffer, rsBlocks);
    };
    QRCode.createBytes = function(buffer, rsBlocks) {
      var offset = 0;
      var maxDcCount = 0;
      var maxEcCount = 0;
      var dcdata = new Array(rsBlocks.length);
      var ecdata = new Array(rsBlocks.length);
      for (var r = 0; r < rsBlocks.length; r++) {
        var dcCount = rsBlocks[r].dataCount;
        var ecCount = rsBlocks[r].totalCount - dcCount;
        maxDcCount = Math.max(maxDcCount, dcCount);
        maxEcCount = Math.max(maxEcCount, ecCount);
        dcdata[r] = new Array(dcCount);
        for (var i = 0; i < dcdata[r].length; i++) {
          dcdata[r][i] = 255 & buffer.buffer[i + offset];
        }
        offset += dcCount;
        var rsPoly = QRUtil.getErrorCorrectPolynomial(ecCount);
        var rawPoly = new QRPolynomial(dcdata[r], rsPoly.getLength() - 1);
        var modPoly = rawPoly.mod(rsPoly);
        ecdata[r] = new Array(rsPoly.getLength() - 1);
        for (var x = 0; x < ecdata[r].length; x++) {
          var modIndex = x + modPoly.getLength() - ecdata[r].length;
          ecdata[r][x] = modIndex >= 0 ? modPoly.get(modIndex) : 0;
        }
      }
      var totalCodeCount = 0;
      for (var y = 0; y < rsBlocks.length; y++) {
        totalCodeCount += rsBlocks[y].totalCount;
      }
      var data = new Array(totalCodeCount);
      var index = 0;
      for (var z = 0; z < maxDcCount; z++) {
        for (var s = 0; s < rsBlocks.length; s++) {
          if (z < dcdata[s].length) {
            data[index++] = dcdata[s][z];
          }
        }
      }
      for (var xx = 0; xx < maxEcCount; xx++) {
        for (var t = 0; t < rsBlocks.length; t++) {
          if (xx < ecdata[t].length) {
            data[index++] = ecdata[t][xx];
          }
        }
      }
      return data;
    };
    module2.exports = QRCode;
  }
});

// node_modules/qrcode-terminal/lib/main.js
var require_main = __commonJS({
  "node_modules/qrcode-terminal/lib/main.js"(exports2, module2) {
    var QRCode = require_QRCode();
    var QRErrorCorrectLevel = require_QRErrorCorrectLevel();
    var black = "\x1B[40m  \x1B[0m";
    var white = "\x1B[47m  \x1B[0m";
    var toCell = function(isBlack) {
      return isBlack ? black : white;
    };
    var repeat = function(color) {
      return {
        times: function(count2) {
          return new Array(count2).join(color);
        }
      };
    };
    var fill = function(length, value) {
      var arr = new Array(length);
      for (var i = 0; i < length; i++) {
        arr[i] = value;
      }
      return arr;
    };
    module2.exports = {
      error: QRErrorCorrectLevel.L,
      generate: function(input, opts, cb) {
        if (typeof opts === "function") {
          cb = opts;
          opts = {};
        }
        var qrcode = new QRCode(-1, this.error);
        qrcode.addData(input);
        qrcode.make();
        var output = "";
        if (opts && opts.small) {
          var BLACK = true, WHITE = false;
          var moduleCount = qrcode.getModuleCount();
          var moduleData = qrcode.modules.slice();
          var oddRow = moduleCount % 2 === 1;
          if (oddRow) {
            moduleData.push(fill(moduleCount, WHITE));
          }
          var platte = {
            WHITE_ALL: "\u2588",
            WHITE_BLACK: "\u2580",
            BLACK_WHITE: "\u2584",
            BLACK_ALL: " "
          };
          var borderTop = repeat(platte.BLACK_WHITE).times(moduleCount + 3);
          var borderBottom = repeat(platte.WHITE_BLACK).times(moduleCount + 3);
          output += borderTop + "\n";
          for (var row2 = 0; row2 < moduleCount; row2 += 2) {
            output += platte.WHITE_ALL;
            for (var col = 0; col < moduleCount; col++) {
              if (moduleData[row2][col] === WHITE && moduleData[row2 + 1][col] === WHITE) {
                output += platte.WHITE_ALL;
              } else if (moduleData[row2][col] === WHITE && moduleData[row2 + 1][col] === BLACK) {
                output += platte.WHITE_BLACK;
              } else if (moduleData[row2][col] === BLACK && moduleData[row2 + 1][col] === WHITE) {
                output += platte.BLACK_WHITE;
              } else {
                output += platte.BLACK_ALL;
              }
            }
            output += platte.WHITE_ALL + "\n";
          }
          if (!oddRow) {
            output += borderBottom;
          }
        } else {
          var border = repeat(white).times(qrcode.getModuleCount() + 3);
          output += border + "\n";
          qrcode.modules.forEach(function(row3) {
            output += white;
            output += row3.map(toCell).join("");
            output += white + "\n";
          });
          output += border;
        }
        if (cb)
          cb(output);
        else
          console.log(output);
      },
      setErrorLevel: function(error) {
        this.error = QRErrorCorrectLevel[error] || this.error;
      }
    };
  }
});

// node_modules/depd/lib/compat/callsite-tostring.js
var require_callsite_tostring = __commonJS({
  "node_modules/depd/lib/compat/callsite-tostring.js"(exports2, module2) {
    "use strict";
    module2.exports = callSiteToString2;
    function callSiteFileLocation(callSite) {
      var fileName;
      var fileLocation = "";
      if (callSite.isNative()) {
        fileLocation = "native";
      } else if (callSite.isEval()) {
        fileName = callSite.getScriptNameOrSourceURL();
        if (!fileName) {
          fileLocation = callSite.getEvalOrigin();
        }
      } else {
        fileName = callSite.getFileName();
      }
      if (fileName) {
        fileLocation += fileName;
        var lineNumber = callSite.getLineNumber();
        if (lineNumber != null) {
          fileLocation += ":" + lineNumber;
          var columnNumber = callSite.getColumnNumber();
          if (columnNumber) {
            fileLocation += ":" + columnNumber;
          }
        }
      }
      return fileLocation || "unknown source";
    }
    function callSiteToString2(callSite) {
      var addSuffix = true;
      var fileLocation = callSiteFileLocation(callSite);
      var functionName = callSite.getFunctionName();
      var isConstructor = callSite.isConstructor();
      var isMethodCall = !(callSite.isToplevel() || isConstructor);
      var line = "";
      if (isMethodCall) {
        var methodName = callSite.getMethodName();
        var typeName = getConstructorName(callSite);
        if (functionName) {
          if (typeName && functionName.indexOf(typeName) !== 0) {
            line += typeName + ".";
          }
          line += functionName;
          if (methodName && functionName.lastIndexOf("." + methodName) !== functionName.length - methodName.length - 1) {
            line += " [as " + methodName + "]";
          }
        } else {
          line += typeName + "." + (methodName || "<anonymous>");
        }
      } else if (isConstructor) {
        line += "new " + (functionName || "<anonymous>");
      } else if (functionName) {
        line += functionName;
      } else {
        addSuffix = false;
        line += fileLocation;
      }
      if (addSuffix) {
        line += " (" + fileLocation + ")";
      }
      return line;
    }
    function getConstructorName(obj) {
      var receiver = obj.receiver;
      return receiver.constructor && receiver.constructor.name || null;
    }
  }
});

// node_modules/depd/lib/compat/event-listener-count.js
var require_event_listener_count = __commonJS({
  "node_modules/depd/lib/compat/event-listener-count.js"(exports2, module2) {
    "use strict";
    module2.exports = eventListenerCount2;
    function eventListenerCount2(emitter, type) {
      return emitter.listeners(type).length;
    }
  }
});

// node_modules/depd/lib/compat/index.js
var require_compat = __commonJS({
  "node_modules/depd/lib/compat/index.js"(exports2, module2) {
    "use strict";
    var EventEmitter = require("events").EventEmitter;
    lazyProperty(module2.exports, "callSiteToString", function callSiteToString2() {
      var limit = Error.stackTraceLimit;
      var obj = {};
      var prep = Error.prepareStackTrace;
      function prepareObjectStackTrace2(obj2, stack3) {
        return stack3;
      }
      Error.prepareStackTrace = prepareObjectStackTrace2;
      Error.stackTraceLimit = 2;
      Error.captureStackTrace(obj);
      var stack2 = obj.stack.slice();
      Error.prepareStackTrace = prep;
      Error.stackTraceLimit = limit;
      return stack2[0].toString ? toString2 : require_callsite_tostring();
    });
    lazyProperty(module2.exports, "eventListenerCount", function eventListenerCount2() {
      return EventEmitter.listenerCount || require_event_listener_count();
    });
    function lazyProperty(obj, prop, getter) {
      function get2() {
        var val = getter();
        Object.defineProperty(obj, prop, {
          configurable: true,
          enumerable: true,
          value: val
        });
        return val;
      }
      Object.defineProperty(obj, prop, {
        configurable: true,
        enumerable: true,
        get: get2
      });
    }
    function toString2(obj) {
      return obj.toString();
    }
  }
});

// node_modules/depd/index.js
var require_depd = __commonJS({
  "node_modules/depd/index.js"(exports, module) {
    var callSiteToString = require_compat().callSiteToString;
    var eventListenerCount = require_compat().eventListenerCount;
    var relative = require("path").relative;
    module.exports = depd;
    var basePath = process.cwd();
    function containsNamespace(str2, namespace) {
      var vals2 = str2.split(/[ ,]+/);
      var ns = String(namespace).toLowerCase();
      for (var i = 0; i < vals2.length; i++) {
        var val = vals2[i];
        if (val && (val === "*" || val.toLowerCase() === ns)) {
          return true;
        }
      }
      return false;
    }
    function convertDataDescriptorToAccessor(obj, prop, message2) {
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      var value = descriptor.value;
      descriptor.get = function getter() {
        return value;
      };
      if (descriptor.writable) {
        descriptor.set = function setter(val) {
          return value = val;
        };
      }
      delete descriptor.value;
      delete descriptor.writable;
      Object.defineProperty(obj, prop, descriptor);
      return descriptor;
    }
    function createArgumentsString(arity) {
      var str2 = "";
      for (var i = 0; i < arity; i++) {
        str2 += ", arg" + i;
      }
      return str2.substr(2);
    }
    function createStackString(stack2) {
      var str2 = this.name + ": " + this.namespace;
      if (this.message) {
        str2 += " deprecated " + this.message;
      }
      for (var i = 0; i < stack2.length; i++) {
        str2 += "\n    at " + callSiteToString(stack2[i]);
      }
      return str2;
    }
    function depd(namespace) {
      if (!namespace) {
        throw new TypeError("argument namespace is required");
      }
      var stack2 = getStack();
      var site2 = callSiteLocation(stack2[1]);
      var file = site2[0];
      function deprecate2(message2) {
        log.call(deprecate2, message2);
      }
      deprecate2._file = file;
      deprecate2._ignored = isignored(namespace);
      deprecate2._namespace = namespace;
      deprecate2._traced = istraced(namespace);
      deprecate2._warned = /* @__PURE__ */ Object.create(null);
      deprecate2.function = wrapfunction;
      deprecate2.property = wrapproperty;
      return deprecate2;
    }
    function isignored(namespace) {
      if (process.noDeprecation) {
        return true;
      }
      var str2 = process.env.NO_DEPRECATION || "";
      return containsNamespace(str2, namespace);
    }
    function istraced(namespace) {
      if (process.traceDeprecation) {
        return true;
      }
      var str2 = process.env.TRACE_DEPRECATION || "";
      return containsNamespace(str2, namespace);
    }
    function log(message2, site2) {
      var haslisteners = eventListenerCount(process, "deprecation") !== 0;
      if (!haslisteners && this._ignored) {
        return;
      }
      var caller;
      var callFile;
      var callSite;
      var depSite;
      var i = 0;
      var seen = false;
      var stack2 = getStack();
      var file = this._file;
      if (site2) {
        depSite = site2;
        callSite = callSiteLocation(stack2[1]);
        callSite.name = depSite.name;
        file = callSite[0];
      } else {
        i = 2;
        depSite = callSiteLocation(stack2[i]);
        callSite = depSite;
      }
      for (; i < stack2.length; i++) {
        caller = callSiteLocation(stack2[i]);
        callFile = caller[0];
        if (callFile === file) {
          seen = true;
        } else if (callFile === this._file) {
          file = this._file;
        } else if (seen) {
          break;
        }
      }
      var key = caller ? depSite.join(":") + "__" + caller.join(":") : void 0;
      if (key !== void 0 && key in this._warned) {
        return;
      }
      this._warned[key] = true;
      var msg = message2;
      if (!msg) {
        msg = callSite === depSite || !callSite.name ? defaultMessage(depSite) : defaultMessage(callSite);
      }
      if (haslisteners) {
        var err = DeprecationError(this._namespace, msg, stack2.slice(i));
        process.emit("deprecation", err);
        return;
      }
      var format = process.stderr.isTTY ? formatColor : formatPlain;
      var output = format.call(this, msg, caller, stack2.slice(i));
      process.stderr.write(output + "\n", "utf8");
    }
    function callSiteLocation(callSite) {
      var file = callSite.getFileName() || "<anonymous>";
      var line = callSite.getLineNumber();
      var colm = callSite.getColumnNumber();
      if (callSite.isEval()) {
        file = callSite.getEvalOrigin() + ", " + file;
      }
      var site2 = [file, line, colm];
      site2.callSite = callSite;
      site2.name = callSite.getFunctionName();
      return site2;
    }
    function defaultMessage(site2) {
      var callSite = site2.callSite;
      var funcName = site2.name;
      if (!funcName) {
        funcName = "<anonymous@" + formatLocation(site2) + ">";
      }
      var context = callSite.getThis();
      var typeName = context && callSite.getTypeName();
      if (typeName === "Object") {
        typeName = void 0;
      }
      if (typeName === "Function") {
        typeName = context.name || typeName;
      }
      return typeName && callSite.getMethodName() ? typeName + "." + funcName : funcName;
    }
    function formatPlain(msg, caller, stack2) {
      var timestamp = new Date().toUTCString();
      var formatted = timestamp + " " + this._namespace + " deprecated " + msg;
      if (this._traced) {
        for (var i = 0; i < stack2.length; i++) {
          formatted += "\n    at " + callSiteToString(stack2[i]);
        }
        return formatted;
      }
      if (caller) {
        formatted += " at " + formatLocation(caller);
      }
      return formatted;
    }
    function formatColor(msg, caller, stack2) {
      var formatted = "\x1B[36;1m" + this._namespace + "\x1B[22;39m \x1B[33;1mdeprecated\x1B[22;39m \x1B[0m" + msg + "\x1B[39m";
      if (this._traced) {
        for (var i = 0; i < stack2.length; i++) {
          formatted += "\n    \x1B[36mat " + callSiteToString(stack2[i]) + "\x1B[39m";
        }
        return formatted;
      }
      if (caller) {
        formatted += " \x1B[36m" + formatLocation(caller) + "\x1B[39m";
      }
      return formatted;
    }
    function formatLocation(callSite) {
      return relative(basePath, callSite[0]) + ":" + callSite[1] + ":" + callSite[2];
    }
    function getStack() {
      var limit = Error.stackTraceLimit;
      var obj = {};
      var prep = Error.prepareStackTrace;
      Error.prepareStackTrace = prepareObjectStackTrace;
      Error.stackTraceLimit = Math.max(10, limit);
      Error.captureStackTrace(obj);
      var stack2 = obj.stack.slice(1);
      Error.prepareStackTrace = prep;
      Error.stackTraceLimit = limit;
      return stack2;
    }
    function prepareObjectStackTrace(obj, stack2) {
      return stack2;
    }
    function wrapfunction(fn, message) {
      if (typeof fn !== "function") {
        throw new TypeError("argument fn must be a function");
      }
      var args = createArgumentsString(fn.length);
      var deprecate = this;
      var stack = getStack();
      var site = callSiteLocation(stack[1]);
      site.name = fn.name;
      var deprecatedfn = eval("(function (" + args + ') {\n"use strict"\nlog.call(deprecate, message, site)\nreturn fn.apply(this, arguments)\n})');
      return deprecatedfn;
    }
    function wrapproperty(obj, prop, message2) {
      if (!obj || typeof obj !== "object" && typeof obj !== "function") {
        throw new TypeError("argument obj must be object");
      }
      var descriptor = Object.getOwnPropertyDescriptor(obj, prop);
      if (!descriptor) {
        throw new TypeError("must call property on owner object");
      }
      if (!descriptor.configurable) {
        throw new TypeError("property must be configurable");
      }
      var deprecate2 = this;
      var stack2 = getStack();
      var site2 = callSiteLocation(stack2[1]);
      site2.name = prop;
      if ("value" in descriptor) {
        descriptor = convertDataDescriptorToAccessor(obj, prop, message2);
      }
      var get2 = descriptor.get;
      var set = descriptor.set;
      if (typeof get2 === "function") {
        descriptor.get = function getter() {
          log.call(deprecate2, message2, site2);
          return get2.apply(this, arguments);
        };
      }
      if (typeof set === "function") {
        descriptor.set = function setter() {
          log.call(deprecate2, message2, site2);
          return set.apply(this, arguments);
        };
      }
      Object.defineProperty(obj, prop, descriptor);
    }
    function DeprecationError(namespace, message2, stack2) {
      var error = new Error();
      var stackString;
      Object.defineProperty(error, "constructor", {
        value: DeprecationError
      });
      Object.defineProperty(error, "message", {
        configurable: true,
        enumerable: false,
        value: message2,
        writable: true
      });
      Object.defineProperty(error, "name", {
        enumerable: false,
        configurable: true,
        value: "DeprecationError",
        writable: true
      });
      Object.defineProperty(error, "namespace", {
        configurable: true,
        enumerable: false,
        value: namespace,
        writable: true
      });
      Object.defineProperty(error, "stack", {
        configurable: true,
        enumerable: false,
        get: function() {
          if (stackString !== void 0) {
            return stackString;
          }
          return stackString = createStackString.call(this, stack2);
        },
        set: function setter(val) {
          stackString = val;
        }
      });
      return error;
    }
  }
});

// node_modules/setprototypeof/index.js
var require_setprototypeof = __commonJS({
  "node_modules/setprototypeof/index.js"(exports2, module2) {
    "use strict";
    module2.exports = Object.setPrototypeOf || ({ __proto__: [] } instanceof Array ? setProtoOf : mixinProperties);
    function setProtoOf(obj, proto) {
      obj.__proto__ = proto;
      return obj;
    }
    function mixinProperties(obj, proto) {
      for (var prop in proto) {
        if (!Object.prototype.hasOwnProperty.call(obj, prop)) {
          obj[prop] = proto[prop];
        }
      }
      return obj;
    }
  }
});

// node_modules/inherits/inherits_browser.js
var require_inherits_browser = __commonJS({
  "node_modules/inherits/inherits_browser.js"(exports2, module2) {
    if (typeof Object.create === "function") {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          ctor.prototype = Object.create(superCtor.prototype, {
            constructor: {
              value: ctor,
              enumerable: false,
              writable: true,
              configurable: true
            }
          });
        }
      };
    } else {
      module2.exports = function inherits(ctor, superCtor) {
        if (superCtor) {
          ctor.super_ = superCtor;
          var TempCtor = function() {
          };
          TempCtor.prototype = superCtor.prototype;
          ctor.prototype = new TempCtor();
          ctor.prototype.constructor = ctor;
        }
      };
    }
  }
});

// node_modules/inherits/inherits.js
var require_inherits = __commonJS({
  "node_modules/inherits/inherits.js"(exports2, module2) {
    try {
      util = require("util");
      if (typeof util.inherits !== "function")
        throw "";
      module2.exports = util.inherits;
    } catch (e) {
      module2.exports = require_inherits_browser();
    }
    var util;
  }
});

// node_modules/toidentifier/index.js
var require_toidentifier = __commonJS({
  "node_modules/toidentifier/index.js"(exports2, module2) {
    "use strict";
    module2.exports = toIdentifier;
    function toIdentifier(str2) {
      return str2.split(" ").map(function(token) {
        return token.slice(0, 1).toUpperCase() + token.slice(1);
      }).join("").replace(/[^ _0-9a-z]/gi, "");
    }
  }
});

// node_modules/http-errors/index.js
var require_http_errors = __commonJS({
  "node_modules/http-errors/index.js"(exports2, module2) {
    "use strict";
    var deprecate2 = require_depd()("http-errors");
    var setPrototypeOf = require_setprototypeof();
    var statuses = require_statuses();
    var inherits = require_inherits();
    var toIdentifier = require_toidentifier();
    module2.exports = createError;
    module2.exports.HttpError = createHttpErrorConstructor();
    module2.exports.isHttpError = createIsHttpErrorFunction(module2.exports.HttpError);
    populateConstructorExports(module2.exports, statuses.codes, module2.exports.HttpError);
    function codeClass(status) {
      return Number(String(status).charAt(0) + "00");
    }
    function createError() {
      var err;
      var msg;
      var status = 500;
      var props = {};
      for (var i = 0; i < arguments.length; i++) {
        var arg = arguments[i];
        if (arg instanceof Error) {
          err = arg;
          status = err.status || err.statusCode || status;
          continue;
        }
        switch (typeof arg) {
          case "string":
            msg = arg;
            break;
          case "number":
            status = arg;
            if (i !== 0) {
              deprecate2("non-first-argument status code; replace with createError(" + arg + ", ...)");
            }
            break;
          case "object":
            props = arg;
            break;
        }
      }
      if (typeof status === "number" && (status < 400 || status >= 600)) {
        deprecate2("non-error status code; use only 4xx or 5xx status codes");
      }
      if (typeof status !== "number" || !statuses[status] && (status < 400 || status >= 600)) {
        status = 500;
      }
      var HttpError = createError[status] || createError[codeClass(status)];
      if (!err) {
        err = HttpError ? new HttpError(msg) : new Error(msg || statuses[status]);
        Error.captureStackTrace(err, createError);
      }
      if (!HttpError || !(err instanceof HttpError) || err.status !== status) {
        err.expose = status < 500;
        err.status = err.statusCode = status;
      }
      for (var key in props) {
        if (key !== "status" && key !== "statusCode") {
          err[key] = props[key];
        }
      }
      return err;
    }
    function createHttpErrorConstructor() {
      function HttpError() {
        throw new TypeError("cannot construct abstract class");
      }
      inherits(HttpError, Error);
      return HttpError;
    }
    function createClientErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ClientError(message2) {
        var msg = message2 != null ? message2 : statuses[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ClientError);
        setPrototypeOf(err, ClientError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ClientError, HttpError);
      nameFunc(ClientError, className);
      ClientError.prototype.status = code;
      ClientError.prototype.statusCode = code;
      ClientError.prototype.expose = true;
      return ClientError;
    }
    function createIsHttpErrorFunction(HttpError) {
      return function isHttpError(val) {
        if (!val || typeof val !== "object") {
          return false;
        }
        if (val instanceof HttpError) {
          return true;
        }
        return val instanceof Error && typeof val.expose === "boolean" && typeof val.statusCode === "number" && val.status === val.statusCode;
      };
    }
    function createServerErrorConstructor(HttpError, name, code) {
      var className = toClassName(name);
      function ServerError(message2) {
        var msg = message2 != null ? message2 : statuses[code];
        var err = new Error(msg);
        Error.captureStackTrace(err, ServerError);
        setPrototypeOf(err, ServerError.prototype);
        Object.defineProperty(err, "message", {
          enumerable: true,
          configurable: true,
          value: msg,
          writable: true
        });
        Object.defineProperty(err, "name", {
          enumerable: false,
          configurable: true,
          value: className,
          writable: true
        });
        return err;
      }
      inherits(ServerError, HttpError);
      nameFunc(ServerError, className);
      ServerError.prototype.status = code;
      ServerError.prototype.statusCode = code;
      ServerError.prototype.expose = false;
      return ServerError;
    }
    function nameFunc(func, name) {
      var desc = Object.getOwnPropertyDescriptor(func, "name");
      if (desc && desc.configurable) {
        desc.value = name;
        Object.defineProperty(func, "name", desc);
      }
    }
    function populateConstructorExports(exports3, codes, HttpError) {
      codes.forEach(function forEachCode(code) {
        var CodeError;
        var name = toIdentifier(statuses[code]);
        switch (codeClass(code)) {
          case 400:
            CodeError = createClientErrorConstructor(HttpError, name, code);
            break;
          case 500:
            CodeError = createServerErrorConstructor(HttpError, name, code);
            break;
        }
        if (CodeError) {
          exports3[code] = CodeError;
          exports3[name] = CodeError;
        }
      });
      exports3["I'mateapot"] = deprecate2.function(exports3.ImATeapot, `"I'mateapot"; use "ImATeapot" instead`);
    }
    function toClassName(name) {
      return name.substr(-5) !== "Error" ? name + "Error" : name;
    }
  }
});

// node_modules/destroy/index.js
var require_destroy = __commonJS({
  "node_modules/destroy/index.js"(exports2, module2) {
    "use strict";
    var ReadStream = require("fs").ReadStream;
    var Stream = require("stream");
    module2.exports = destroy;
    function destroy(stream) {
      if (stream instanceof ReadStream) {
        return destroyReadStream(stream);
      }
      if (!(stream instanceof Stream)) {
        return stream;
      }
      if (typeof stream.destroy === "function") {
        stream.destroy();
      }
      return stream;
    }
    function destroyReadStream(stream) {
      stream.destroy();
      if (typeof stream.close === "function") {
        stream.on("open", onOpenClose);
      }
      return stream;
    }
    function onOpenClose() {
      if (typeof this.fd === "number") {
        this.close();
      }
    }
  }
});

// node_modules/etag/index.js
var require_etag = __commonJS({
  "node_modules/etag/index.js"(exports2, module2) {
    "use strict";
    module2.exports = etag;
    var crypto = require("crypto");
    var Stats = require("fs").Stats;
    var toString2 = Object.prototype.toString;
    function entitytag(entity) {
      if (entity.length === 0) {
        return '"0-2jmj7l5rSw0yVb/vlWAYkK/YBwk"';
      }
      var hash = crypto.createHash("sha1").update(entity, "utf8").digest("base64").substring(0, 27);
      var len = typeof entity === "string" ? Buffer.byteLength(entity, "utf8") : entity.length;
      return '"' + len.toString(16) + "-" + hash + '"';
    }
    function etag(entity, options) {
      if (entity == null) {
        throw new TypeError("argument entity is required");
      }
      var isStats = isstats(entity);
      var weak = options && typeof options.weak === "boolean" ? options.weak : isStats;
      if (!isStats && typeof entity !== "string" && !Buffer.isBuffer(entity)) {
        throw new TypeError("argument entity must be string, Buffer, or fs.Stats");
      }
      var tag = isStats ? stattag(entity) : entitytag(entity);
      return weak ? "W/" + tag : tag;
    }
    function isstats(obj) {
      if (typeof Stats === "function" && obj instanceof Stats) {
        return true;
      }
      return obj && typeof obj === "object" && "ctime" in obj && toString2.call(obj.ctime) === "[object Date]" && "mtime" in obj && toString2.call(obj.mtime) === "[object Date]" && "ino" in obj && typeof obj.ino === "number" && "size" in obj && typeof obj.size === "number";
    }
    function stattag(stat2) {
      var mtime = stat2.mtime.getTime().toString(16);
      var size = stat2.size.toString(16);
      return '"' + size + "-" + mtime + '"';
    }
  }
});

// node_modules/fresh/index.js
var require_fresh = __commonJS({
  "node_modules/fresh/index.js"(exports2, module2) {
    "use strict";
    var CACHE_CONTROL_NO_CACHE_REGEXP = /(?:^|,)\s*?no-cache\s*?(?:,|$)/;
    module2.exports = fresh;
    function fresh(reqHeaders, resHeaders) {
      var modifiedSince = reqHeaders["if-modified-since"];
      var noneMatch = reqHeaders["if-none-match"];
      if (!modifiedSince && !noneMatch) {
        return false;
      }
      var cacheControl = reqHeaders["cache-control"];
      if (cacheControl && CACHE_CONTROL_NO_CACHE_REGEXP.test(cacheControl)) {
        return false;
      }
      if (noneMatch && noneMatch !== "*") {
        var etag = resHeaders["etag"];
        if (!etag) {
          return false;
        }
        var etagStale = true;
        var matches = parseTokenList(noneMatch);
        for (var i = 0; i < matches.length; i++) {
          var match = matches[i];
          if (match === etag || match === "W/" + etag || "W/" + match === etag) {
            etagStale = false;
            break;
          }
        }
        if (etagStale) {
          return false;
        }
      }
      if (modifiedSince) {
        var lastModified = resHeaders["last-modified"];
        var modifiedStale = !lastModified || !(parseHttpDate(lastModified) <= parseHttpDate(modifiedSince));
        if (modifiedStale) {
          return false;
        }
      }
      return true;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str2) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str2.length; i < len; i++) {
        switch (str2.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            list.push(str2.substring(start, end));
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      list.push(str2.substring(start, end));
      return list;
    }
  }
});

// node_modules/mime/types.json
var require_types5 = __commonJS({
  "node_modules/mime/types.json"(exports2, module2) {
    module2.exports = { "application/andrew-inset": ["ez"], "application/applixware": ["aw"], "application/atom+xml": ["atom"], "application/atomcat+xml": ["atomcat"], "application/atomsvc+xml": ["atomsvc"], "application/bdoc": ["bdoc"], "application/ccxml+xml": ["ccxml"], "application/cdmi-capability": ["cdmia"], "application/cdmi-container": ["cdmic"], "application/cdmi-domain": ["cdmid"], "application/cdmi-object": ["cdmio"], "application/cdmi-queue": ["cdmiq"], "application/cu-seeme": ["cu"], "application/dash+xml": ["mpd"], "application/davmount+xml": ["davmount"], "application/docbook+xml": ["dbk"], "application/dssc+der": ["dssc"], "application/dssc+xml": ["xdssc"], "application/ecmascript": ["ecma"], "application/emma+xml": ["emma"], "application/epub+zip": ["epub"], "application/exi": ["exi"], "application/font-tdpfr": ["pfr"], "application/font-woff": [], "application/font-woff2": [], "application/geo+json": ["geojson"], "application/gml+xml": ["gml"], "application/gpx+xml": ["gpx"], "application/gxf": ["gxf"], "application/gzip": ["gz"], "application/hyperstudio": ["stk"], "application/inkml+xml": ["ink", "inkml"], "application/ipfix": ["ipfix"], "application/java-archive": ["jar", "war", "ear"], "application/java-serialized-object": ["ser"], "application/java-vm": ["class"], "application/javascript": ["js", "mjs"], "application/json": ["json", "map"], "application/json5": ["json5"], "application/jsonml+json": ["jsonml"], "application/ld+json": ["jsonld"], "application/lost+xml": ["lostxml"], "application/mac-binhex40": ["hqx"], "application/mac-compactpro": ["cpt"], "application/mads+xml": ["mads"], "application/manifest+json": ["webmanifest"], "application/marc": ["mrc"], "application/marcxml+xml": ["mrcx"], "application/mathematica": ["ma", "nb", "mb"], "application/mathml+xml": ["mathml"], "application/mbox": ["mbox"], "application/mediaservercontrol+xml": ["mscml"], "application/metalink+xml": ["metalink"], "application/metalink4+xml": ["meta4"], "application/mets+xml": ["mets"], "application/mods+xml": ["mods"], "application/mp21": ["m21", "mp21"], "application/mp4": ["mp4s", "m4p"], "application/msword": ["doc", "dot"], "application/mxf": ["mxf"], "application/octet-stream": ["bin", "dms", "lrf", "mar", "so", "dist", "distz", "pkg", "bpk", "dump", "elc", "deploy", "exe", "dll", "deb", "dmg", "iso", "img", "msi", "msp", "msm", "buffer"], "application/oda": ["oda"], "application/oebps-package+xml": ["opf"], "application/ogg": ["ogx"], "application/omdoc+xml": ["omdoc"], "application/onenote": ["onetoc", "onetoc2", "onetmp", "onepkg"], "application/oxps": ["oxps"], "application/patch-ops-error+xml": ["xer"], "application/pdf": ["pdf"], "application/pgp-encrypted": ["pgp"], "application/pgp-signature": ["asc", "sig"], "application/pics-rules": ["prf"], "application/pkcs10": ["p10"], "application/pkcs7-mime": ["p7m", "p7c"], "application/pkcs7-signature": ["p7s"], "application/pkcs8": ["p8"], "application/pkix-attr-cert": ["ac"], "application/pkix-cert": ["cer"], "application/pkix-crl": ["crl"], "application/pkix-pkipath": ["pkipath"], "application/pkixcmp": ["pki"], "application/pls+xml": ["pls"], "application/postscript": ["ai", "eps", "ps"], "application/prs.cww": ["cww"], "application/pskc+xml": ["pskcxml"], "application/raml+yaml": ["raml"], "application/rdf+xml": ["rdf"], "application/reginfo+xml": ["rif"], "application/relax-ng-compact-syntax": ["rnc"], "application/resource-lists+xml": ["rl"], "application/resource-lists-diff+xml": ["rld"], "application/rls-services+xml": ["rs"], "application/rpki-ghostbusters": ["gbr"], "application/rpki-manifest": ["mft"], "application/rpki-roa": ["roa"], "application/rsd+xml": ["rsd"], "application/rss+xml": ["rss"], "application/rtf": ["rtf"], "application/sbml+xml": ["sbml"], "application/scvp-cv-request": ["scq"], "application/scvp-cv-response": ["scs"], "application/scvp-vp-request": ["spq"], "application/scvp-vp-response": ["spp"], "application/sdp": ["sdp"], "application/set-payment-initiation": ["setpay"], "application/set-registration-initiation": ["setreg"], "application/shf+xml": ["shf"], "application/smil+xml": ["smi", "smil"], "application/sparql-query": ["rq"], "application/sparql-results+xml": ["srx"], "application/srgs": ["gram"], "application/srgs+xml": ["grxml"], "application/sru+xml": ["sru"], "application/ssdl+xml": ["ssdl"], "application/ssml+xml": ["ssml"], "application/tei+xml": ["tei", "teicorpus"], "application/thraud+xml": ["tfi"], "application/timestamped-data": ["tsd"], "application/vnd.3gpp.pic-bw-large": ["plb"], "application/vnd.3gpp.pic-bw-small": ["psb"], "application/vnd.3gpp.pic-bw-var": ["pvb"], "application/vnd.3gpp2.tcap": ["tcap"], "application/vnd.3m.post-it-notes": ["pwn"], "application/vnd.accpac.simply.aso": ["aso"], "application/vnd.accpac.simply.imp": ["imp"], "application/vnd.acucobol": ["acu"], "application/vnd.acucorp": ["atc", "acutc"], "application/vnd.adobe.air-application-installer-package+zip": ["air"], "application/vnd.adobe.formscentral.fcdt": ["fcdt"], "application/vnd.adobe.fxp": ["fxp", "fxpl"], "application/vnd.adobe.xdp+xml": ["xdp"], "application/vnd.adobe.xfdf": ["xfdf"], "application/vnd.ahead.space": ["ahead"], "application/vnd.airzip.filesecure.azf": ["azf"], "application/vnd.airzip.filesecure.azs": ["azs"], "application/vnd.amazon.ebook": ["azw"], "application/vnd.americandynamics.acc": ["acc"], "application/vnd.amiga.ami": ["ami"], "application/vnd.android.package-archive": ["apk"], "application/vnd.anser-web-certificate-issue-initiation": ["cii"], "application/vnd.anser-web-funds-transfer-initiation": ["fti"], "application/vnd.antix.game-component": ["atx"], "application/vnd.apple.installer+xml": ["mpkg"], "application/vnd.apple.mpegurl": ["m3u8"], "application/vnd.apple.pkpass": ["pkpass"], "application/vnd.aristanetworks.swi": ["swi"], "application/vnd.astraea-software.iota": ["iota"], "application/vnd.audiograph": ["aep"], "application/vnd.blueice.multipass": ["mpm"], "application/vnd.bmi": ["bmi"], "application/vnd.businessobjects": ["rep"], "application/vnd.chemdraw+xml": ["cdxml"], "application/vnd.chipnuts.karaoke-mmd": ["mmd"], "application/vnd.cinderella": ["cdy"], "application/vnd.claymore": ["cla"], "application/vnd.cloanto.rp9": ["rp9"], "application/vnd.clonk.c4group": ["c4g", "c4d", "c4f", "c4p", "c4u"], "application/vnd.cluetrust.cartomobile-config": ["c11amc"], "application/vnd.cluetrust.cartomobile-config-pkg": ["c11amz"], "application/vnd.commonspace": ["csp"], "application/vnd.contact.cmsg": ["cdbcmsg"], "application/vnd.cosmocaller": ["cmc"], "application/vnd.crick.clicker": ["clkx"], "application/vnd.crick.clicker.keyboard": ["clkk"], "application/vnd.crick.clicker.palette": ["clkp"], "application/vnd.crick.clicker.template": ["clkt"], "application/vnd.crick.clicker.wordbank": ["clkw"], "application/vnd.criticaltools.wbs+xml": ["wbs"], "application/vnd.ctc-posml": ["pml"], "application/vnd.cups-ppd": ["ppd"], "application/vnd.curl.car": ["car"], "application/vnd.curl.pcurl": ["pcurl"], "application/vnd.dart": ["dart"], "application/vnd.data-vision.rdz": ["rdz"], "application/vnd.dece.data": ["uvf", "uvvf", "uvd", "uvvd"], "application/vnd.dece.ttml+xml": ["uvt", "uvvt"], "application/vnd.dece.unspecified": ["uvx", "uvvx"], "application/vnd.dece.zip": ["uvz", "uvvz"], "application/vnd.denovo.fcselayout-link": ["fe_launch"], "application/vnd.dna": ["dna"], "application/vnd.dolby.mlp": ["mlp"], "application/vnd.dpgraph": ["dpg"], "application/vnd.dreamfactory": ["dfac"], "application/vnd.ds-keypoint": ["kpxx"], "application/vnd.dvb.ait": ["ait"], "application/vnd.dvb.service": ["svc"], "application/vnd.dynageo": ["geo"], "application/vnd.ecowin.chart": ["mag"], "application/vnd.enliven": ["nml"], "application/vnd.epson.esf": ["esf"], "application/vnd.epson.msf": ["msf"], "application/vnd.epson.quickanime": ["qam"], "application/vnd.epson.salt": ["slt"], "application/vnd.epson.ssf": ["ssf"], "application/vnd.eszigno3+xml": ["es3", "et3"], "application/vnd.ezpix-album": ["ez2"], "application/vnd.ezpix-package": ["ez3"], "application/vnd.fdf": ["fdf"], "application/vnd.fdsn.mseed": ["mseed"], "application/vnd.fdsn.seed": ["seed", "dataless"], "application/vnd.flographit": ["gph"], "application/vnd.fluxtime.clip": ["ftc"], "application/vnd.framemaker": ["fm", "frame", "maker", "book"], "application/vnd.frogans.fnc": ["fnc"], "application/vnd.frogans.ltf": ["ltf"], "application/vnd.fsc.weblaunch": ["fsc"], "application/vnd.fujitsu.oasys": ["oas"], "application/vnd.fujitsu.oasys2": ["oa2"], "application/vnd.fujitsu.oasys3": ["oa3"], "application/vnd.fujitsu.oasysgp": ["fg5"], "application/vnd.fujitsu.oasysprs": ["bh2"], "application/vnd.fujixerox.ddd": ["ddd"], "application/vnd.fujixerox.docuworks": ["xdw"], "application/vnd.fujixerox.docuworks.binder": ["xbd"], "application/vnd.fuzzysheet": ["fzs"], "application/vnd.genomatix.tuxedo": ["txd"], "application/vnd.geogebra.file": ["ggb"], "application/vnd.geogebra.tool": ["ggt"], "application/vnd.geometry-explorer": ["gex", "gre"], "application/vnd.geonext": ["gxt"], "application/vnd.geoplan": ["g2w"], "application/vnd.geospace": ["g3w"], "application/vnd.gmx": ["gmx"], "application/vnd.google-apps.document": ["gdoc"], "application/vnd.google-apps.presentation": ["gslides"], "application/vnd.google-apps.spreadsheet": ["gsheet"], "application/vnd.google-earth.kml+xml": ["kml"], "application/vnd.google-earth.kmz": ["kmz"], "application/vnd.grafeq": ["gqf", "gqs"], "application/vnd.groove-account": ["gac"], "application/vnd.groove-help": ["ghf"], "application/vnd.groove-identity-message": ["gim"], "application/vnd.groove-injector": ["grv"], "application/vnd.groove-tool-message": ["gtm"], "application/vnd.groove-tool-template": ["tpl"], "application/vnd.groove-vcard": ["vcg"], "application/vnd.hal+xml": ["hal"], "application/vnd.handheld-entertainment+xml": ["zmm"], "application/vnd.hbci": ["hbci"], "application/vnd.hhe.lesson-player": ["les"], "application/vnd.hp-hpgl": ["hpgl"], "application/vnd.hp-hpid": ["hpid"], "application/vnd.hp-hps": ["hps"], "application/vnd.hp-jlyt": ["jlt"], "application/vnd.hp-pcl": ["pcl"], "application/vnd.hp-pclxl": ["pclxl"], "application/vnd.hydrostatix.sof-data": ["sfd-hdstx"], "application/vnd.ibm.minipay": ["mpy"], "application/vnd.ibm.modcap": ["afp", "listafp", "list3820"], "application/vnd.ibm.rights-management": ["irm"], "application/vnd.ibm.secure-container": ["sc"], "application/vnd.iccprofile": ["icc", "icm"], "application/vnd.igloader": ["igl"], "application/vnd.immervision-ivp": ["ivp"], "application/vnd.immervision-ivu": ["ivu"], "application/vnd.insors.igm": ["igm"], "application/vnd.intercon.formnet": ["xpw", "xpx"], "application/vnd.intergeo": ["i2g"], "application/vnd.intu.qbo": ["qbo"], "application/vnd.intu.qfx": ["qfx"], "application/vnd.ipunplugged.rcprofile": ["rcprofile"], "application/vnd.irepository.package+xml": ["irp"], "application/vnd.is-xpr": ["xpr"], "application/vnd.isac.fcs": ["fcs"], "application/vnd.jam": ["jam"], "application/vnd.jcp.javame.midlet-rms": ["rms"], "application/vnd.jisp": ["jisp"], "application/vnd.joost.joda-archive": ["joda"], "application/vnd.kahootz": ["ktz", "ktr"], "application/vnd.kde.karbon": ["karbon"], "application/vnd.kde.kchart": ["chrt"], "application/vnd.kde.kformula": ["kfo"], "application/vnd.kde.kivio": ["flw"], "application/vnd.kde.kontour": ["kon"], "application/vnd.kde.kpresenter": ["kpr", "kpt"], "application/vnd.kde.kspread": ["ksp"], "application/vnd.kde.kword": ["kwd", "kwt"], "application/vnd.kenameaapp": ["htke"], "application/vnd.kidspiration": ["kia"], "application/vnd.kinar": ["kne", "knp"], "application/vnd.koan": ["skp", "skd", "skt", "skm"], "application/vnd.kodak-descriptor": ["sse"], "application/vnd.las.las+xml": ["lasxml"], "application/vnd.llamagraphics.life-balance.desktop": ["lbd"], "application/vnd.llamagraphics.life-balance.exchange+xml": ["lbe"], "application/vnd.lotus-1-2-3": ["123"], "application/vnd.lotus-approach": ["apr"], "application/vnd.lotus-freelance": ["pre"], "application/vnd.lotus-notes": ["nsf"], "application/vnd.lotus-organizer": ["org"], "application/vnd.lotus-screencam": ["scm"], "application/vnd.lotus-wordpro": ["lwp"], "application/vnd.macports.portpkg": ["portpkg"], "application/vnd.mcd": ["mcd"], "application/vnd.medcalcdata": ["mc1"], "application/vnd.mediastation.cdkey": ["cdkey"], "application/vnd.mfer": ["mwf"], "application/vnd.mfmp": ["mfm"], "application/vnd.micrografx.flo": ["flo"], "application/vnd.micrografx.igx": ["igx"], "application/vnd.mif": ["mif"], "application/vnd.mobius.daf": ["daf"], "application/vnd.mobius.dis": ["dis"], "application/vnd.mobius.mbk": ["mbk"], "application/vnd.mobius.mqy": ["mqy"], "application/vnd.mobius.msl": ["msl"], "application/vnd.mobius.plc": ["plc"], "application/vnd.mobius.txf": ["txf"], "application/vnd.mophun.application": ["mpn"], "application/vnd.mophun.certificate": ["mpc"], "application/vnd.mozilla.xul+xml": ["xul"], "application/vnd.ms-artgalry": ["cil"], "application/vnd.ms-cab-compressed": ["cab"], "application/vnd.ms-excel": ["xls", "xlm", "xla", "xlc", "xlt", "xlw"], "application/vnd.ms-excel.addin.macroenabled.12": ["xlam"], "application/vnd.ms-excel.sheet.binary.macroenabled.12": ["xlsb"], "application/vnd.ms-excel.sheet.macroenabled.12": ["xlsm"], "application/vnd.ms-excel.template.macroenabled.12": ["xltm"], "application/vnd.ms-fontobject": ["eot"], "application/vnd.ms-htmlhelp": ["chm"], "application/vnd.ms-ims": ["ims"], "application/vnd.ms-lrm": ["lrm"], "application/vnd.ms-officetheme": ["thmx"], "application/vnd.ms-outlook": ["msg"], "application/vnd.ms-pki.seccat": ["cat"], "application/vnd.ms-pki.stl": ["stl"], "application/vnd.ms-powerpoint": ["ppt", "pps", "pot"], "application/vnd.ms-powerpoint.addin.macroenabled.12": ["ppam"], "application/vnd.ms-powerpoint.presentation.macroenabled.12": ["pptm"], "application/vnd.ms-powerpoint.slide.macroenabled.12": ["sldm"], "application/vnd.ms-powerpoint.slideshow.macroenabled.12": ["ppsm"], "application/vnd.ms-powerpoint.template.macroenabled.12": ["potm"], "application/vnd.ms-project": ["mpp", "mpt"], "application/vnd.ms-word.document.macroenabled.12": ["docm"], "application/vnd.ms-word.template.macroenabled.12": ["dotm"], "application/vnd.ms-works": ["wps", "wks", "wcm", "wdb"], "application/vnd.ms-wpl": ["wpl"], "application/vnd.ms-xpsdocument": ["xps"], "application/vnd.mseq": ["mseq"], "application/vnd.musician": ["mus"], "application/vnd.muvee.style": ["msty"], "application/vnd.mynfc": ["taglet"], "application/vnd.neurolanguage.nlu": ["nlu"], "application/vnd.nitf": ["ntf", "nitf"], "application/vnd.noblenet-directory": ["nnd"], "application/vnd.noblenet-sealer": ["nns"], "application/vnd.noblenet-web": ["nnw"], "application/vnd.nokia.n-gage.data": ["ngdat"], "application/vnd.nokia.n-gage.symbian.install": ["n-gage"], "application/vnd.nokia.radio-preset": ["rpst"], "application/vnd.nokia.radio-presets": ["rpss"], "application/vnd.novadigm.edm": ["edm"], "application/vnd.novadigm.edx": ["edx"], "application/vnd.novadigm.ext": ["ext"], "application/vnd.oasis.opendocument.chart": ["odc"], "application/vnd.oasis.opendocument.chart-template": ["otc"], "application/vnd.oasis.opendocument.database": ["odb"], "application/vnd.oasis.opendocument.formula": ["odf"], "application/vnd.oasis.opendocument.formula-template": ["odft"], "application/vnd.oasis.opendocument.graphics": ["odg"], "application/vnd.oasis.opendocument.graphics-template": ["otg"], "application/vnd.oasis.opendocument.image": ["odi"], "application/vnd.oasis.opendocument.image-template": ["oti"], "application/vnd.oasis.opendocument.presentation": ["odp"], "application/vnd.oasis.opendocument.presentation-template": ["otp"], "application/vnd.oasis.opendocument.spreadsheet": ["ods"], "application/vnd.oasis.opendocument.spreadsheet-template": ["ots"], "application/vnd.oasis.opendocument.text": ["odt"], "application/vnd.oasis.opendocument.text-master": ["odm"], "application/vnd.oasis.opendocument.text-template": ["ott"], "application/vnd.oasis.opendocument.text-web": ["oth"], "application/vnd.olpc-sugar": ["xo"], "application/vnd.oma.dd2+xml": ["dd2"], "application/vnd.openofficeorg.extension": ["oxt"], "application/vnd.openxmlformats-officedocument.presentationml.presentation": ["pptx"], "application/vnd.openxmlformats-officedocument.presentationml.slide": ["sldx"], "application/vnd.openxmlformats-officedocument.presentationml.slideshow": ["ppsx"], "application/vnd.openxmlformats-officedocument.presentationml.template": ["potx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet": ["xlsx"], "application/vnd.openxmlformats-officedocument.spreadsheetml.template": ["xltx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.document": ["docx"], "application/vnd.openxmlformats-officedocument.wordprocessingml.template": ["dotx"], "application/vnd.osgeo.mapguide.package": ["mgp"], "application/vnd.osgi.dp": ["dp"], "application/vnd.osgi.subsystem": ["esa"], "application/vnd.palm": ["pdb", "pqa", "oprc"], "application/vnd.pawaafile": ["paw"], "application/vnd.pg.format": ["str"], "application/vnd.pg.osasli": ["ei6"], "application/vnd.picsel": ["efif"], "application/vnd.pmi.widget": ["wg"], "application/vnd.pocketlearn": ["plf"], "application/vnd.powerbuilder6": ["pbd"], "application/vnd.previewsystems.box": ["box"], "application/vnd.proteus.magazine": ["mgz"], "application/vnd.publishare-delta-tree": ["qps"], "application/vnd.pvi.ptid1": ["ptid"], "application/vnd.quark.quarkxpress": ["qxd", "qxt", "qwd", "qwt", "qxl", "qxb"], "application/vnd.realvnc.bed": ["bed"], "application/vnd.recordare.musicxml": ["mxl"], "application/vnd.recordare.musicxml+xml": ["musicxml"], "application/vnd.rig.cryptonote": ["cryptonote"], "application/vnd.rim.cod": ["cod"], "application/vnd.rn-realmedia": ["rm"], "application/vnd.rn-realmedia-vbr": ["rmvb"], "application/vnd.route66.link66+xml": ["link66"], "application/vnd.sailingtracker.track": ["st"], "application/vnd.seemail": ["see"], "application/vnd.sema": ["sema"], "application/vnd.semd": ["semd"], "application/vnd.semf": ["semf"], "application/vnd.shana.informed.formdata": ["ifm"], "application/vnd.shana.informed.formtemplate": ["itp"], "application/vnd.shana.informed.interchange": ["iif"], "application/vnd.shana.informed.package": ["ipk"], "application/vnd.simtech-mindmapper": ["twd", "twds"], "application/vnd.smaf": ["mmf"], "application/vnd.smart.teacher": ["teacher"], "application/vnd.solent.sdkm+xml": ["sdkm", "sdkd"], "application/vnd.spotfire.dxp": ["dxp"], "application/vnd.spotfire.sfs": ["sfs"], "application/vnd.stardivision.calc": ["sdc"], "application/vnd.stardivision.draw": ["sda"], "application/vnd.stardivision.impress": ["sdd"], "application/vnd.stardivision.math": ["smf"], "application/vnd.stardivision.writer": ["sdw", "vor"], "application/vnd.stardivision.writer-global": ["sgl"], "application/vnd.stepmania.package": ["smzip"], "application/vnd.stepmania.stepchart": ["sm"], "application/vnd.sun.wadl+xml": ["wadl"], "application/vnd.sun.xml.calc": ["sxc"], "application/vnd.sun.xml.calc.template": ["stc"], "application/vnd.sun.xml.draw": ["sxd"], "application/vnd.sun.xml.draw.template": ["std"], "application/vnd.sun.xml.impress": ["sxi"], "application/vnd.sun.xml.impress.template": ["sti"], "application/vnd.sun.xml.math": ["sxm"], "application/vnd.sun.xml.writer": ["sxw"], "application/vnd.sun.xml.writer.global": ["sxg"], "application/vnd.sun.xml.writer.template": ["stw"], "application/vnd.sus-calendar": ["sus", "susp"], "application/vnd.svd": ["svd"], "application/vnd.symbian.install": ["sis", "sisx"], "application/vnd.syncml+xml": ["xsm"], "application/vnd.syncml.dm+wbxml": ["bdm"], "application/vnd.syncml.dm+xml": ["xdm"], "application/vnd.tao.intent-module-archive": ["tao"], "application/vnd.tcpdump.pcap": ["pcap", "cap", "dmp"], "application/vnd.tmobile-livetv": ["tmo"], "application/vnd.trid.tpt": ["tpt"], "application/vnd.triscape.mxs": ["mxs"], "application/vnd.trueapp": ["tra"], "application/vnd.ufdl": ["ufd", "ufdl"], "application/vnd.uiq.theme": ["utz"], "application/vnd.umajin": ["umj"], "application/vnd.unity": ["unityweb"], "application/vnd.uoml+xml": ["uoml"], "application/vnd.vcx": ["vcx"], "application/vnd.visio": ["vsd", "vst", "vss", "vsw"], "application/vnd.visionary": ["vis"], "application/vnd.vsf": ["vsf"], "application/vnd.wap.wbxml": ["wbxml"], "application/vnd.wap.wmlc": ["wmlc"], "application/vnd.wap.wmlscriptc": ["wmlsc"], "application/vnd.webturbo": ["wtb"], "application/vnd.wolfram.player": ["nbp"], "application/vnd.wordperfect": ["wpd"], "application/vnd.wqd": ["wqd"], "application/vnd.wt.stf": ["stf"], "application/vnd.xara": ["xar"], "application/vnd.xfdl": ["xfdl"], "application/vnd.yamaha.hv-dic": ["hvd"], "application/vnd.yamaha.hv-script": ["hvs"], "application/vnd.yamaha.hv-voice": ["hvp"], "application/vnd.yamaha.openscoreformat": ["osf"], "application/vnd.yamaha.openscoreformat.osfpvg+xml": ["osfpvg"], "application/vnd.yamaha.smaf-audio": ["saf"], "application/vnd.yamaha.smaf-phrase": ["spf"], "application/vnd.yellowriver-custom-menu": ["cmp"], "application/vnd.zul": ["zir", "zirz"], "application/vnd.zzazz.deck+xml": ["zaz"], "application/voicexml+xml": ["vxml"], "application/wasm": ["wasm"], "application/widget": ["wgt"], "application/winhlp": ["hlp"], "application/wsdl+xml": ["wsdl"], "application/wspolicy+xml": ["wspolicy"], "application/x-7z-compressed": ["7z"], "application/x-abiword": ["abw"], "application/x-ace-compressed": ["ace"], "application/x-apple-diskimage": [], "application/x-arj": ["arj"], "application/x-authorware-bin": ["aab", "x32", "u32", "vox"], "application/x-authorware-map": ["aam"], "application/x-authorware-seg": ["aas"], "application/x-bcpio": ["bcpio"], "application/x-bdoc": [], "application/x-bittorrent": ["torrent"], "application/x-blorb": ["blb", "blorb"], "application/x-bzip": ["bz"], "application/x-bzip2": ["bz2", "boz"], "application/x-cbr": ["cbr", "cba", "cbt", "cbz", "cb7"], "application/x-cdlink": ["vcd"], "application/x-cfs-compressed": ["cfs"], "application/x-chat": ["chat"], "application/x-chess-pgn": ["pgn"], "application/x-chrome-extension": ["crx"], "application/x-cocoa": ["cco"], "application/x-conference": ["nsc"], "application/x-cpio": ["cpio"], "application/x-csh": ["csh"], "application/x-debian-package": ["udeb"], "application/x-dgc-compressed": ["dgc"], "application/x-director": ["dir", "dcr", "dxr", "cst", "cct", "cxt", "w3d", "fgd", "swa"], "application/x-doom": ["wad"], "application/x-dtbncx+xml": ["ncx"], "application/x-dtbook+xml": ["dtb"], "application/x-dtbresource+xml": ["res"], "application/x-dvi": ["dvi"], "application/x-envoy": ["evy"], "application/x-eva": ["eva"], "application/x-font-bdf": ["bdf"], "application/x-font-ghostscript": ["gsf"], "application/x-font-linux-psf": ["psf"], "application/x-font-pcf": ["pcf"], "application/x-font-snf": ["snf"], "application/x-font-type1": ["pfa", "pfb", "pfm", "afm"], "application/x-freearc": ["arc"], "application/x-futuresplash": ["spl"], "application/x-gca-compressed": ["gca"], "application/x-glulx": ["ulx"], "application/x-gnumeric": ["gnumeric"], "application/x-gramps-xml": ["gramps"], "application/x-gtar": ["gtar"], "application/x-hdf": ["hdf"], "application/x-httpd-php": ["php"], "application/x-install-instructions": ["install"], "application/x-iso9660-image": [], "application/x-java-archive-diff": ["jardiff"], "application/x-java-jnlp-file": ["jnlp"], "application/x-latex": ["latex"], "application/x-lua-bytecode": ["luac"], "application/x-lzh-compressed": ["lzh", "lha"], "application/x-makeself": ["run"], "application/x-mie": ["mie"], "application/x-mobipocket-ebook": ["prc", "mobi"], "application/x-ms-application": ["application"], "application/x-ms-shortcut": ["lnk"], "application/x-ms-wmd": ["wmd"], "application/x-ms-wmz": ["wmz"], "application/x-ms-xbap": ["xbap"], "application/x-msaccess": ["mdb"], "application/x-msbinder": ["obd"], "application/x-mscardfile": ["crd"], "application/x-msclip": ["clp"], "application/x-msdos-program": [], "application/x-msdownload": ["com", "bat"], "application/x-msmediaview": ["mvb", "m13", "m14"], "application/x-msmetafile": ["wmf", "emf", "emz"], "application/x-msmoney": ["mny"], "application/x-mspublisher": ["pub"], "application/x-msschedule": ["scd"], "application/x-msterminal": ["trm"], "application/x-mswrite": ["wri"], "application/x-netcdf": ["nc", "cdf"], "application/x-ns-proxy-autoconfig": ["pac"], "application/x-nzb": ["nzb"], "application/x-perl": ["pl", "pm"], "application/x-pilot": [], "application/x-pkcs12": ["p12", "pfx"], "application/x-pkcs7-certificates": ["p7b", "spc"], "application/x-pkcs7-certreqresp": ["p7r"], "application/x-rar-compressed": ["rar"], "application/x-redhat-package-manager": ["rpm"], "application/x-research-info-systems": ["ris"], "application/x-sea": ["sea"], "application/x-sh": ["sh"], "application/x-shar": ["shar"], "application/x-shockwave-flash": ["swf"], "application/x-silverlight-app": ["xap"], "application/x-sql": ["sql"], "application/x-stuffit": ["sit"], "application/x-stuffitx": ["sitx"], "application/x-subrip": ["srt"], "application/x-sv4cpio": ["sv4cpio"], "application/x-sv4crc": ["sv4crc"], "application/x-t3vm-image": ["t3"], "application/x-tads": ["gam"], "application/x-tar": ["tar"], "application/x-tcl": ["tcl", "tk"], "application/x-tex": ["tex"], "application/x-tex-tfm": ["tfm"], "application/x-texinfo": ["texinfo", "texi"], "application/x-tgif": ["obj"], "application/x-ustar": ["ustar"], "application/x-virtualbox-hdd": ["hdd"], "application/x-virtualbox-ova": ["ova"], "application/x-virtualbox-ovf": ["ovf"], "application/x-virtualbox-vbox": ["vbox"], "application/x-virtualbox-vbox-extpack": ["vbox-extpack"], "application/x-virtualbox-vdi": ["vdi"], "application/x-virtualbox-vhd": ["vhd"], "application/x-virtualbox-vmdk": ["vmdk"], "application/x-wais-source": ["src"], "application/x-web-app-manifest+json": ["webapp"], "application/x-x509-ca-cert": ["der", "crt", "pem"], "application/x-xfig": ["fig"], "application/x-xliff+xml": ["xlf"], "application/x-xpinstall": ["xpi"], "application/x-xz": ["xz"], "application/x-zmachine": ["z1", "z2", "z3", "z4", "z5", "z6", "z7", "z8"], "application/xaml+xml": ["xaml"], "application/xcap-diff+xml": ["xdf"], "application/xenc+xml": ["xenc"], "application/xhtml+xml": ["xhtml", "xht"], "application/xml": ["xml", "xsl", "xsd", "rng"], "application/xml-dtd": ["dtd"], "application/xop+xml": ["xop"], "application/xproc+xml": ["xpl"], "application/xslt+xml": ["xslt"], "application/xspf+xml": ["xspf"], "application/xv+xml": ["mxml", "xhvml", "xvml", "xvm"], "application/yang": ["yang"], "application/yin+xml": ["yin"], "application/zip": ["zip"], "audio/3gpp": [], "audio/adpcm": ["adp"], "audio/basic": ["au", "snd"], "audio/midi": ["mid", "midi", "kar", "rmi"], "audio/mp3": [], "audio/mp4": ["m4a", "mp4a"], "audio/mpeg": ["mpga", "mp2", "mp2a", "mp3", "m2a", "m3a"], "audio/ogg": ["oga", "ogg", "spx"], "audio/s3m": ["s3m"], "audio/silk": ["sil"], "audio/vnd.dece.audio": ["uva", "uvva"], "audio/vnd.digital-winds": ["eol"], "audio/vnd.dra": ["dra"], "audio/vnd.dts": ["dts"], "audio/vnd.dts.hd": ["dtshd"], "audio/vnd.lucent.voice": ["lvp"], "audio/vnd.ms-playready.media.pya": ["pya"], "audio/vnd.nuera.ecelp4800": ["ecelp4800"], "audio/vnd.nuera.ecelp7470": ["ecelp7470"], "audio/vnd.nuera.ecelp9600": ["ecelp9600"], "audio/vnd.rip": ["rip"], "audio/wav": ["wav"], "audio/wave": [], "audio/webm": ["weba"], "audio/x-aac": ["aac"], "audio/x-aiff": ["aif", "aiff", "aifc"], "audio/x-caf": ["caf"], "audio/x-flac": ["flac"], "audio/x-m4a": [], "audio/x-matroska": ["mka"], "audio/x-mpegurl": ["m3u"], "audio/x-ms-wax": ["wax"], "audio/x-ms-wma": ["wma"], "audio/x-pn-realaudio": ["ram", "ra"], "audio/x-pn-realaudio-plugin": ["rmp"], "audio/x-realaudio": [], "audio/x-wav": [], "audio/xm": ["xm"], "chemical/x-cdx": ["cdx"], "chemical/x-cif": ["cif"], "chemical/x-cmdf": ["cmdf"], "chemical/x-cml": ["cml"], "chemical/x-csml": ["csml"], "chemical/x-xyz": ["xyz"], "font/collection": ["ttc"], "font/otf": ["otf"], "font/ttf": ["ttf"], "font/woff": ["woff"], "font/woff2": ["woff2"], "image/apng": ["apng"], "image/bmp": ["bmp"], "image/cgm": ["cgm"], "image/g3fax": ["g3"], "image/gif": ["gif"], "image/ief": ["ief"], "image/jp2": ["jp2", "jpg2"], "image/jpeg": ["jpeg", "jpg", "jpe"], "image/jpm": ["jpm"], "image/jpx": ["jpx", "jpf"], "image/ktx": ["ktx"], "image/png": ["png"], "image/prs.btif": ["btif"], "image/sgi": ["sgi"], "image/svg+xml": ["svg", "svgz"], "image/tiff": ["tiff", "tif"], "image/vnd.adobe.photoshop": ["psd"], "image/vnd.dece.graphic": ["uvi", "uvvi", "uvg", "uvvg"], "image/vnd.djvu": ["djvu", "djv"], "image/vnd.dvb.subtitle": [], "image/vnd.dwg": ["dwg"], "image/vnd.dxf": ["dxf"], "image/vnd.fastbidsheet": ["fbs"], "image/vnd.fpx": ["fpx"], "image/vnd.fst": ["fst"], "image/vnd.fujixerox.edmics-mmr": ["mmr"], "image/vnd.fujixerox.edmics-rlc": ["rlc"], "image/vnd.ms-modi": ["mdi"], "image/vnd.ms-photo": ["wdp"], "image/vnd.net-fpx": ["npx"], "image/vnd.wap.wbmp": ["wbmp"], "image/vnd.xiff": ["xif"], "image/webp": ["webp"], "image/x-3ds": ["3ds"], "image/x-cmu-raster": ["ras"], "image/x-cmx": ["cmx"], "image/x-freehand": ["fh", "fhc", "fh4", "fh5", "fh7"], "image/x-icon": ["ico"], "image/x-jng": ["jng"], "image/x-mrsid-image": ["sid"], "image/x-ms-bmp": [], "image/x-pcx": ["pcx"], "image/x-pict": ["pic", "pct"], "image/x-portable-anymap": ["pnm"], "image/x-portable-bitmap": ["pbm"], "image/x-portable-graymap": ["pgm"], "image/x-portable-pixmap": ["ppm"], "image/x-rgb": ["rgb"], "image/x-tga": ["tga"], "image/x-xbitmap": ["xbm"], "image/x-xpixmap": ["xpm"], "image/x-xwindowdump": ["xwd"], "message/rfc822": ["eml", "mime"], "model/gltf+json": ["gltf"], "model/gltf-binary": ["glb"], "model/iges": ["igs", "iges"], "model/mesh": ["msh", "mesh", "silo"], "model/vnd.collada+xml": ["dae"], "model/vnd.dwf": ["dwf"], "model/vnd.gdl": ["gdl"], "model/vnd.gtw": ["gtw"], "model/vnd.mts": ["mts"], "model/vnd.vtu": ["vtu"], "model/vrml": ["wrl", "vrml"], "model/x3d+binary": ["x3db", "x3dbz"], "model/x3d+vrml": ["x3dv", "x3dvz"], "model/x3d+xml": ["x3d", "x3dz"], "text/cache-manifest": ["appcache", "manifest"], "text/calendar": ["ics", "ifb"], "text/coffeescript": ["coffee", "litcoffee"], "text/css": ["css"], "text/csv": ["csv"], "text/hjson": ["hjson"], "text/html": ["html", "htm", "shtml"], "text/jade": ["jade"], "text/jsx": ["jsx"], "text/less": ["less"], "text/markdown": ["markdown", "md"], "text/mathml": ["mml"], "text/n3": ["n3"], "text/plain": ["txt", "text", "conf", "def", "list", "log", "in", "ini"], "text/prs.lines.tag": ["dsc"], "text/richtext": ["rtx"], "text/rtf": [], "text/sgml": ["sgml", "sgm"], "text/slim": ["slim", "slm"], "text/stylus": ["stylus", "styl"], "text/tab-separated-values": ["tsv"], "text/troff": ["t", "tr", "roff", "man", "me", "ms"], "text/turtle": ["ttl"], "text/uri-list": ["uri", "uris", "urls"], "text/vcard": ["vcard"], "text/vnd.curl": ["curl"], "text/vnd.curl.dcurl": ["dcurl"], "text/vnd.curl.mcurl": ["mcurl"], "text/vnd.curl.scurl": ["scurl"], "text/vnd.dvb.subtitle": ["sub"], "text/vnd.fly": ["fly"], "text/vnd.fmi.flexstor": ["flx"], "text/vnd.graphviz": ["gv"], "text/vnd.in3d.3dml": ["3dml"], "text/vnd.in3d.spot": ["spot"], "text/vnd.sun.j2me.app-descriptor": ["jad"], "text/vnd.wap.wml": ["wml"], "text/vnd.wap.wmlscript": ["wmls"], "text/vtt": ["vtt"], "text/x-asm": ["s", "asm"], "text/x-c": ["c", "cc", "cxx", "cpp", "h", "hh", "dic"], "text/x-component": ["htc"], "text/x-fortran": ["f", "for", "f77", "f90"], "text/x-handlebars-template": ["hbs"], "text/x-java-source": ["java"], "text/x-lua": ["lua"], "text/x-markdown": ["mkd"], "text/x-nfo": ["nfo"], "text/x-opml": ["opml"], "text/x-org": [], "text/x-pascal": ["p", "pas"], "text/x-processing": ["pde"], "text/x-sass": ["sass"], "text/x-scss": ["scss"], "text/x-setext": ["etx"], "text/x-sfv": ["sfv"], "text/x-suse-ymp": ["ymp"], "text/x-uuencode": ["uu"], "text/x-vcalendar": ["vcs"], "text/x-vcard": ["vcf"], "text/xml": [], "text/yaml": ["yaml", "yml"], "video/3gpp": ["3gp", "3gpp"], "video/3gpp2": ["3g2"], "video/h261": ["h261"], "video/h263": ["h263"], "video/h264": ["h264"], "video/jpeg": ["jpgv"], "video/jpm": ["jpgm"], "video/mj2": ["mj2", "mjp2"], "video/mp2t": ["ts"], "video/mp4": ["mp4", "mp4v", "mpg4"], "video/mpeg": ["mpeg", "mpg", "mpe", "m1v", "m2v"], "video/ogg": ["ogv"], "video/quicktime": ["qt", "mov"], "video/vnd.dece.hd": ["uvh", "uvvh"], "video/vnd.dece.mobile": ["uvm", "uvvm"], "video/vnd.dece.pd": ["uvp", "uvvp"], "video/vnd.dece.sd": ["uvs", "uvvs"], "video/vnd.dece.video": ["uvv", "uvvv"], "video/vnd.dvb.file": ["dvb"], "video/vnd.fvt": ["fvt"], "video/vnd.mpegurl": ["mxu", "m4u"], "video/vnd.ms-playready.media.pyv": ["pyv"], "video/vnd.uvvu.mp4": ["uvu", "uvvu"], "video/vnd.vivo": ["viv"], "video/webm": ["webm"], "video/x-f4v": ["f4v"], "video/x-fli": ["fli"], "video/x-flv": ["flv"], "video/x-m4v": ["m4v"], "video/x-matroska": ["mkv", "mk3d", "mks"], "video/x-mng": ["mng"], "video/x-ms-asf": ["asf", "asx"], "video/x-ms-vob": ["vob"], "video/x-ms-wm": ["wm"], "video/x-ms-wmv": ["wmv"], "video/x-ms-wmx": ["wmx"], "video/x-ms-wvx": ["wvx"], "video/x-msvideo": ["avi"], "video/x-sgi-movie": ["movie"], "video/x-smv": ["smv"], "x-conference/x-cooltalk": ["ice"] };
  }
});

// node_modules/mime/mime.js
var require_mime = __commonJS({
  "node_modules/mime/mime.js"(exports2, module2) {
    var path = require("path");
    var fs = require("fs");
    function Mime() {
      this.types = /* @__PURE__ */ Object.create(null);
      this.extensions = /* @__PURE__ */ Object.create(null);
    }
    Mime.prototype.define = function(map2) {
      for (var type in map2) {
        var exts = map2[type];
        for (var i = 0; i < exts.length; i++) {
          if (process.env.DEBUG_MIME && this.types[exts[i]]) {
            console.warn((this._loading || "define()").replace(/.*\//, ""), 'changes "' + exts[i] + '" extension type from ' + this.types[exts[i]] + " to " + type);
          }
          this.types[exts[i]] = type;
        }
        if (!this.extensions[type]) {
          this.extensions[type] = exts[0];
        }
      }
    };
    Mime.prototype.load = function(file) {
      this._loading = file;
      var map2 = {}, content = fs.readFileSync(file, "ascii"), lines = content.split(/[\r\n]+/);
      lines.forEach(function(line) {
        var fields = line.replace(/\s*#.*|^\s*|\s*$/g, "").split(/\s+/);
        map2[fields.shift()] = fields;
      });
      this.define(map2);
      this._loading = null;
    };
    Mime.prototype.lookup = function(path2, fallback) {
      var ext = path2.replace(/^.*[\.\/\\]/, "").toLowerCase();
      return this.types[ext] || fallback || this.default_type;
    };
    Mime.prototype.extension = function(mimeType) {
      var type = mimeType.match(/^\s*([^;\s]*)(?:;|\s|$)/)[1].toLowerCase();
      return this.extensions[type];
    };
    var mime = new Mime();
    mime.define(require_types5());
    mime.default_type = mime.lookup("bin");
    mime.Mime = Mime;
    mime.charsets = {
      lookup: function(mimeType, fallback) {
        return /^text\/|^application\/(javascript|json)/.test(mimeType) ? "UTF-8" : fallback;
      }
    };
    module2.exports = mime;
  }
});

// node_modules/ms/index.js
var require_ms2 = __commonJS({
  "node_modules/ms/index.js"(exports2, module2) {
    var s = 1e3;
    var m = s * 60;
    var h = m * 60;
    var d = h * 24;
    var w = d * 7;
    var y = d * 365.25;
    module2.exports = function(val, options) {
      options = options || {};
      var type = typeof val;
      if (type === "string" && val.length > 0) {
        return parse2(val);
      } else if (type === "number" && isFinite(val)) {
        return options.long ? fmtLong(val) : fmtShort(val);
      }
      throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(val));
    };
    function parse2(str2) {
      str2 = String(str2);
      if (str2.length > 100) {
        return;
      }
      var match = /^(-?(?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|weeks?|w|years?|yrs?|y)?$/i.exec(str2);
      if (!match) {
        return;
      }
      var n = parseFloat(match[1]);
      var type = (match[2] || "ms").toLowerCase();
      switch (type) {
        case "years":
        case "year":
        case "yrs":
        case "yr":
        case "y":
          return n * y;
        case "weeks":
        case "week":
        case "w":
          return n * w;
        case "days":
        case "day":
        case "d":
          return n * d;
        case "hours":
        case "hour":
        case "hrs":
        case "hr":
        case "h":
          return n * h;
        case "minutes":
        case "minute":
        case "mins":
        case "min":
        case "m":
          return n * m;
        case "seconds":
        case "second":
        case "secs":
        case "sec":
        case "s":
          return n * s;
        case "milliseconds":
        case "millisecond":
        case "msecs":
        case "msec":
        case "ms":
          return n;
        default:
          return void 0;
      }
    }
    function fmtShort(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return Math.round(ms / d) + "d";
      }
      if (msAbs >= h) {
        return Math.round(ms / h) + "h";
      }
      if (msAbs >= m) {
        return Math.round(ms / m) + "m";
      }
      if (msAbs >= s) {
        return Math.round(ms / s) + "s";
      }
      return ms + "ms";
    }
    function fmtLong(ms) {
      var msAbs = Math.abs(ms);
      if (msAbs >= d) {
        return plural(ms, msAbs, d, "day");
      }
      if (msAbs >= h) {
        return plural(ms, msAbs, h, "hour");
      }
      if (msAbs >= m) {
        return plural(ms, msAbs, m, "minute");
      }
      if (msAbs >= s) {
        return plural(ms, msAbs, s, "second");
      }
      return ms + " ms";
    }
    function plural(ms, msAbs, n, name) {
      var isPlural = msAbs >= n * 1.5;
      return Math.round(ms / n) + " " + name + (isPlural ? "s" : "");
    }
  }
});

// node_modules/range-parser/index.js
var require_range_parser = __commonJS({
  "node_modules/range-parser/index.js"(exports2, module2) {
    "use strict";
    module2.exports = rangeParser;
    function rangeParser(size, str2, options) {
      if (typeof str2 !== "string") {
        throw new TypeError("argument str must be a string");
      }
      var index = str2.indexOf("=");
      if (index === -1) {
        return -2;
      }
      var arr = str2.slice(index + 1).split(",");
      var ranges = [];
      ranges.type = str2.slice(0, index);
      for (var i = 0; i < arr.length; i++) {
        var range = arr[i].split("-");
        var start = parseInt(range[0], 10);
        var end = parseInt(range[1], 10);
        if (isNaN(start)) {
          start = size - end;
          end = size - 1;
        } else if (isNaN(end)) {
          end = size - 1;
        }
        if (end > size - 1) {
          end = size - 1;
        }
        if (isNaN(start) || isNaN(end) || start > end || start < 0) {
          continue;
        }
        ranges.push({
          start,
          end
        });
      }
      if (ranges.length < 1) {
        return -1;
      }
      return options && options.combine ? combineRanges(ranges) : ranges;
    }
    function combineRanges(ranges) {
      var ordered = ranges.map(mapWithIndex).sort(sortByRangeStart);
      for (var j = 0, i = 1; i < ordered.length; i++) {
        var range = ordered[i];
        var current = ordered[j];
        if (range.start > current.end + 1) {
          ordered[++j] = range;
        } else if (range.end > current.end) {
          current.end = range.end;
          current.index = Math.min(current.index, range.index);
        }
      }
      ordered.length = j + 1;
      var combined = ordered.sort(sortByRangeIndex).map(mapWithoutIndex);
      combined.type = ranges.type;
      return combined;
    }
    function mapWithIndex(range, index) {
      return {
        start: range.start,
        end: range.end,
        index
      };
    }
    function mapWithoutIndex(range) {
      return {
        start: range.start,
        end: range.end
      };
    }
    function sortByRangeIndex(a2, b) {
      return a2.index - b.index;
    }
    function sortByRangeStart(a2, b) {
      return a2.start - b.start;
    }
  }
});

// node_modules/send/index.js
var require_send = __commonJS({
  "node_modules/send/index.js"(exports2, module2) {
    "use strict";
    var createError = require_http_errors();
    var debug = require_src()("send");
    var deprecate2 = require_depd()("send");
    var destroy = require_destroy();
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var etag = require_etag();
    var fresh = require_fresh();
    var fs = require("fs");
    var mime = require_mime();
    var ms = require_ms2();
    var onFinished = require_on_finished();
    var parseRange = require_range_parser();
    var path = require("path");
    var statuses = require_statuses();
    var Stream = require("stream");
    var util = require("util");
    var extname = path.extname;
    var join3 = path.join;
    var normalize = path.normalize;
    var resolve = path.resolve;
    var sep = path.sep;
    var BYTES_RANGE_REGEXP = /^ *bytes=/;
    var MAX_MAXAGE = 60 * 60 * 24 * 365 * 1e3;
    var UP_PATH_REGEXP = /(?:^|[\\/])\.\.(?:[\\/]|$)/;
    module2.exports = send;
    module2.exports.mime = mime;
    function send(req, path2, options) {
      return new SendStream(req, path2, options);
    }
    function SendStream(req, path2, options) {
      Stream.call(this);
      var opts = options || {};
      this.options = opts;
      this.path = path2;
      this.req = req;
      this._acceptRanges = opts.acceptRanges !== void 0 ? Boolean(opts.acceptRanges) : true;
      this._cacheControl = opts.cacheControl !== void 0 ? Boolean(opts.cacheControl) : true;
      this._etag = opts.etag !== void 0 ? Boolean(opts.etag) : true;
      this._dotfiles = opts.dotfiles !== void 0 ? opts.dotfiles : "ignore";
      if (this._dotfiles !== "ignore" && this._dotfiles !== "allow" && this._dotfiles !== "deny") {
        throw new TypeError('dotfiles option must be "allow", "deny", or "ignore"');
      }
      this._hidden = Boolean(opts.hidden);
      if (opts.hidden !== void 0) {
        deprecate2("hidden: use dotfiles: '" + (this._hidden ? "allow" : "ignore") + "' instead");
      }
      if (opts.dotfiles === void 0) {
        this._dotfiles = void 0;
      }
      this._extensions = opts.extensions !== void 0 ? normalizeList(opts.extensions, "extensions option") : [];
      this._immutable = opts.immutable !== void 0 ? Boolean(opts.immutable) : false;
      this._index = opts.index !== void 0 ? normalizeList(opts.index, "index option") : ["index.html"];
      this._lastModified = opts.lastModified !== void 0 ? Boolean(opts.lastModified) : true;
      this._maxage = opts.maxAge || opts.maxage;
      this._maxage = typeof this._maxage === "string" ? ms(this._maxage) : Number(this._maxage);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      this._root = opts.root ? resolve(opts.root) : null;
      if (!this._root && opts.from) {
        this.from(opts.from);
      }
    }
    util.inherits(SendStream, Stream);
    SendStream.prototype.etag = deprecate2.function(function etag2(val) {
      this._etag = Boolean(val);
      debug("etag %s", this._etag);
      return this;
    }, "send.etag: pass etag as option");
    SendStream.prototype.hidden = deprecate2.function(function hidden(val) {
      this._hidden = Boolean(val);
      this._dotfiles = void 0;
      debug("hidden %s", this._hidden);
      return this;
    }, "send.hidden: use dotfiles option");
    SendStream.prototype.index = deprecate2.function(function index(paths) {
      var index2 = !paths ? [] : normalizeList(paths, "paths argument");
      debug("index %o", paths);
      this._index = index2;
      return this;
    }, "send.index: pass index as option");
    SendStream.prototype.root = function root(path2) {
      this._root = resolve(String(path2));
      debug("root %s", this._root);
      return this;
    };
    SendStream.prototype.from = deprecate2.function(SendStream.prototype.root, "send.from: pass root as option");
    SendStream.prototype.root = deprecate2.function(SendStream.prototype.root, "send.root: pass root as option");
    SendStream.prototype.maxage = deprecate2.function(function maxage(maxAge) {
      this._maxage = typeof maxAge === "string" ? ms(maxAge) : Number(maxAge);
      this._maxage = !isNaN(this._maxage) ? Math.min(Math.max(0, this._maxage), MAX_MAXAGE) : 0;
      debug("max-age %d", this._maxage);
      return this;
    }, "send.maxage: pass maxAge as option");
    SendStream.prototype.error = function error(status, err) {
      if (hasListeners(this, "error")) {
        return this.emit("error", createError(status, err, {
          expose: false
        }));
      }
      var res = this.res;
      var msg = statuses[status] || String(status);
      var doc = createHtmlDocument("Error", escapeHtml(msg));
      clearHeaders(res);
      if (err && err.headers) {
        setHeaders(res, err.headers);
      }
      res.statusCode = status;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.end(doc);
    };
    SendStream.prototype.hasTrailingSlash = function hasTrailingSlash() {
      return this.path[this.path.length - 1] === "/";
    };
    SendStream.prototype.isConditionalGET = function isConditionalGET() {
      return this.req.headers["if-match"] || this.req.headers["if-unmodified-since"] || this.req.headers["if-none-match"] || this.req.headers["if-modified-since"];
    };
    SendStream.prototype.isPreconditionFailure = function isPreconditionFailure() {
      var req = this.req;
      var res = this.res;
      var match = req.headers["if-match"];
      if (match) {
        var etag2 = res.getHeader("ETag");
        return !etag2 || match !== "*" && parseTokenList(match).every(function(match2) {
          return match2 !== etag2 && match2 !== "W/" + etag2 && "W/" + match2 !== etag2;
        });
      }
      var unmodifiedSince = parseHttpDate(req.headers["if-unmodified-since"]);
      if (!isNaN(unmodifiedSince)) {
        var lastModified = parseHttpDate(res.getHeader("Last-Modified"));
        return isNaN(lastModified) || lastModified > unmodifiedSince;
      }
      return false;
    };
    SendStream.prototype.removeContentHeaderFields = function removeContentHeaderFields() {
      var res = this.res;
      var headers = getHeaderNames(res);
      for (var i = 0; i < headers.length; i++) {
        var header = headers[i];
        if (header.substr(0, 8) === "content-" && header !== "content-location") {
          res.removeHeader(header);
        }
      }
    };
    SendStream.prototype.notModified = function notModified() {
      var res = this.res;
      debug("not modified");
      this.removeContentHeaderFields();
      res.statusCode = 304;
      res.end();
    };
    SendStream.prototype.headersAlreadySent = function headersAlreadySent() {
      var err = new Error("Can't set headers after they are sent.");
      debug("headers already sent");
      this.error(500, err);
    };
    SendStream.prototype.isCachable = function isCachable() {
      var statusCode = this.res.statusCode;
      return statusCode >= 200 && statusCode < 300 || statusCode === 304;
    };
    SendStream.prototype.onStatError = function onStatError(error) {
      switch (error.code) {
        case "ENAMETOOLONG":
        case "ENOENT":
        case "ENOTDIR":
          this.error(404, error);
          break;
        default:
          this.error(500, error);
          break;
      }
    };
    SendStream.prototype.isFresh = function isFresh() {
      return fresh(this.req.headers, {
        etag: this.res.getHeader("ETag"),
        "last-modified": this.res.getHeader("Last-Modified")
      });
    };
    SendStream.prototype.isRangeFresh = function isRangeFresh() {
      var ifRange = this.req.headers["if-range"];
      if (!ifRange) {
        return true;
      }
      if (ifRange.indexOf('"') !== -1) {
        var etag2 = this.res.getHeader("ETag");
        return Boolean(etag2 && ifRange.indexOf(etag2) !== -1);
      }
      var lastModified = this.res.getHeader("Last-Modified");
      return parseHttpDate(lastModified) <= parseHttpDate(ifRange);
    };
    SendStream.prototype.redirect = function redirect(path2) {
      var res = this.res;
      if (hasListeners(this, "directory")) {
        this.emit("directory", res, path2);
        return;
      }
      if (this.hasTrailingSlash()) {
        this.error(403);
        return;
      }
      var loc = encodeUrl(collapseLeadingSlashes(this.path + "/"));
      var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
      res.statusCode = 301;
      res.setHeader("Content-Type", "text/html; charset=UTF-8");
      res.setHeader("Content-Length", Buffer.byteLength(doc));
      res.setHeader("Content-Security-Policy", "default-src 'none'");
      res.setHeader("X-Content-Type-Options", "nosniff");
      res.setHeader("Location", loc);
      res.end(doc);
    };
    SendStream.prototype.pipe = function pipe(res) {
      var root = this._root;
      this.res = res;
      var path2 = decode(this.path);
      if (path2 === -1) {
        this.error(400);
        return res;
      }
      if (~path2.indexOf("\0")) {
        this.error(400);
        return res;
      }
      var parts;
      if (root !== null) {
        if (path2) {
          path2 = normalize("." + sep + path2);
        }
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = path2.split(sep);
        path2 = normalize(join3(root, path2));
      } else {
        if (UP_PATH_REGEXP.test(path2)) {
          debug('malicious path "%s"', path2);
          this.error(403);
          return res;
        }
        parts = normalize(path2).split(sep);
        path2 = resolve(path2);
      }
      if (containsDotFile(parts)) {
        var access = this._dotfiles;
        if (access === void 0) {
          access = parts[parts.length - 1][0] === "." ? this._hidden ? "allow" : "ignore" : "allow";
        }
        debug('%s dotfile "%s"', access, path2);
        switch (access) {
          case "allow":
            break;
          case "deny":
            this.error(403);
            return res;
          case "ignore":
          default:
            this.error(404);
            return res;
        }
      }
      if (this._index.length && this.hasTrailingSlash()) {
        this.sendIndex(path2);
        return res;
      }
      this.sendFile(path2);
      return res;
    };
    SendStream.prototype.send = function send2(path2, stat2) {
      var len = stat2.size;
      var options = this.options;
      var opts = {};
      var res = this.res;
      var req = this.req;
      var ranges = req.headers.range;
      var offset = options.start || 0;
      if (headersSent(res)) {
        this.headersAlreadySent();
        return;
      }
      debug('pipe "%s"', path2);
      this.setHeader(path2, stat2);
      this.type(path2);
      if (this.isConditionalGET()) {
        if (this.isPreconditionFailure()) {
          this.error(412);
          return;
        }
        if (this.isCachable() && this.isFresh()) {
          this.notModified();
          return;
        }
      }
      len = Math.max(0, len - offset);
      if (options.end !== void 0) {
        var bytes = options.end - offset + 1;
        if (len > bytes)
          len = bytes;
      }
      if (this._acceptRanges && BYTES_RANGE_REGEXP.test(ranges)) {
        ranges = parseRange(len, ranges, {
          combine: true
        });
        if (!this.isRangeFresh()) {
          debug("range stale");
          ranges = -2;
        }
        if (ranges === -1) {
          debug("range unsatisfiable");
          res.setHeader("Content-Range", contentRange("bytes", len));
          return this.error(416, {
            headers: { "Content-Range": res.getHeader("Content-Range") }
          });
        }
        if (ranges !== -2 && ranges.length === 1) {
          debug("range %j", ranges);
          res.statusCode = 206;
          res.setHeader("Content-Range", contentRange("bytes", len, ranges[0]));
          offset += ranges[0].start;
          len = ranges[0].end - ranges[0].start + 1;
        }
      }
      for (var prop in options) {
        opts[prop] = options[prop];
      }
      opts.start = offset;
      opts.end = Math.max(offset, offset + len - 1);
      res.setHeader("Content-Length", len);
      if (req.method === "HEAD") {
        res.end();
        return;
      }
      this.stream(path2, opts);
    };
    SendStream.prototype.sendFile = function sendFile(path2) {
      var i = 0;
      var self2 = this;
      debug('stat "%s"', path2);
      fs.stat(path2, function onstat(err, stat2) {
        if (err && err.code === "ENOENT" && !extname(path2) && path2[path2.length - 1] !== sep) {
          return next(err);
        }
        if (err)
          return self2.onStatError(err);
        if (stat2.isDirectory())
          return self2.redirect(path2);
        self2.emit("file", path2, stat2);
        self2.send(path2, stat2);
      });
      function next(err) {
        if (self2._extensions.length <= i) {
          return err ? self2.onStatError(err) : self2.error(404);
        }
        var p = path2 + "." + self2._extensions[i++];
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat2) {
          if (err2)
            return next(err2);
          if (stat2.isDirectory())
            return next();
          self2.emit("file", p, stat2);
          self2.send(p, stat2);
        });
      }
    };
    SendStream.prototype.sendIndex = function sendIndex(path2) {
      var i = -1;
      var self2 = this;
      function next(err) {
        if (++i >= self2._index.length) {
          if (err)
            return self2.onStatError(err);
          return self2.error(404);
        }
        var p = join3(path2, self2._index[i]);
        debug('stat "%s"', p);
        fs.stat(p, function(err2, stat2) {
          if (err2)
            return next(err2);
          if (stat2.isDirectory())
            return next();
          self2.emit("file", p, stat2);
          self2.send(p, stat2);
        });
      }
      next();
    };
    SendStream.prototype.stream = function stream(path2, options) {
      var finished = false;
      var self2 = this;
      var res = this.res;
      var stream2 = fs.createReadStream(path2, options);
      this.emit("stream", stream2);
      stream2.pipe(res);
      onFinished(res, function onfinished() {
        finished = true;
        destroy(stream2);
      });
      stream2.on("error", function onerror(err) {
        if (finished)
          return;
        finished = true;
        destroy(stream2);
        self2.onStatError(err);
      });
      stream2.on("end", function onend() {
        self2.emit("end");
      });
    };
    SendStream.prototype.type = function type(path2) {
      var res = this.res;
      if (res.getHeader("Content-Type"))
        return;
      var type2 = mime.lookup(path2);
      if (!type2) {
        debug("no content-type");
        return;
      }
      var charset = mime.charsets.lookup(type2);
      debug("content-type %s", type2);
      res.setHeader("Content-Type", type2 + (charset ? "; charset=" + charset : ""));
    };
    SendStream.prototype.setHeader = function setHeader(path2, stat2) {
      var res = this.res;
      this.emit("headers", res, path2, stat2);
      if (this._acceptRanges && !res.getHeader("Accept-Ranges")) {
        debug("accept ranges");
        res.setHeader("Accept-Ranges", "bytes");
      }
      if (this._cacheControl && !res.getHeader("Cache-Control")) {
        var cacheControl = "public, max-age=" + Math.floor(this._maxage / 1e3);
        if (this._immutable) {
          cacheControl += ", immutable";
        }
        debug("cache-control %s", cacheControl);
        res.setHeader("Cache-Control", cacheControl);
      }
      if (this._lastModified && !res.getHeader("Last-Modified")) {
        var modified = stat2.mtime.toUTCString();
        debug("modified %s", modified);
        res.setHeader("Last-Modified", modified);
      }
      if (this._etag && !res.getHeader("ETag")) {
        var val = etag(stat2);
        debug("etag %s", val);
        res.setHeader("ETag", val);
      }
    };
    function clearHeaders(res) {
      var headers = getHeaderNames(res);
      for (var i = 0; i < headers.length; i++) {
        res.removeHeader(headers[i]);
      }
    }
    function collapseLeadingSlashes(str2) {
      for (var i = 0; i < str2.length; i++) {
        if (str2[i] !== "/") {
          break;
        }
      }
      return i > 1 ? "/" + str2.substr(i) : str2;
    }
    function containsDotFile(parts) {
      for (var i = 0; i < parts.length; i++) {
        var part = parts[i];
        if (part.length > 1 && part[0] === ".") {
          return true;
        }
      }
      return false;
    }
    function contentRange(type, size, range) {
      return type + " " + (range ? range.start + "-" + range.end : "*") + "/" + size;
    }
    function createHtmlDocument(title, body2) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body2 + "</pre>\n</body>\n</html>\n";
    }
    function decode(path2) {
      try {
        return decodeURIComponent(path2);
      } catch (err) {
        return -1;
      }
    }
    function getHeaderNames(res) {
      return typeof res.getHeaderNames !== "function" ? Object.keys(res._headers || {}) : res.getHeaderNames();
    }
    function hasListeners(emitter, type) {
      var count2 = typeof emitter.listenerCount !== "function" ? emitter.listeners(type).length : emitter.listenerCount(type);
      return count2 > 0;
    }
    function headersSent(res) {
      return typeof res.headersSent !== "boolean" ? Boolean(res._header) : res.headersSent;
    }
    function normalizeList(val, name) {
      var list = [].concat(val || []);
      for (var i = 0; i < list.length; i++) {
        if (typeof list[i] !== "string") {
          throw new TypeError(name + " must be array of strings or false");
        }
      }
      return list;
    }
    function parseHttpDate(date) {
      var timestamp = date && Date.parse(date);
      return typeof timestamp === "number" ? timestamp : NaN;
    }
    function parseTokenList(str2) {
      var end = 0;
      var list = [];
      var start = 0;
      for (var i = 0, len = str2.length; i < len; i++) {
        switch (str2.charCodeAt(i)) {
          case 32:
            if (start === end) {
              start = end = i + 1;
            }
            break;
          case 44:
            if (start !== end) {
              list.push(str2.substring(start, end));
            }
            start = end = i + 1;
            break;
          default:
            end = i + 1;
            break;
        }
      }
      if (start !== end) {
        list.push(str2.substring(start, end));
      }
      return list;
    }
    function setHeaders(res, headers) {
      var keys2 = Object.keys(headers);
      for (var i = 0; i < keys2.length; i++) {
        var key = keys2[i];
        res.setHeader(key, headers[key]);
      }
    }
  }
});

// node_modules/serve-static/index.js
var require_serve_static = __commonJS({
  "node_modules/serve-static/index.js"(exports2, module2) {
    "use strict";
    var encodeUrl = require_encodeurl();
    var escapeHtml = require_escape_html();
    var parseUrl = require_parseurl();
    var resolve = require("path").resolve;
    var send = require_send();
    var url = require("url");
    module2.exports = serveStatic;
    module2.exports.mime = send.mime;
    function serveStatic(root, options) {
      if (!root) {
        throw new TypeError("root path required");
      }
      if (typeof root !== "string") {
        throw new TypeError("root path must be a string");
      }
      var opts = Object.create(options || null);
      var fallthrough = opts.fallthrough !== false;
      var redirect = opts.redirect !== false;
      var setHeaders = opts.setHeaders;
      if (setHeaders && typeof setHeaders !== "function") {
        throw new TypeError("option setHeaders must be function");
      }
      opts.maxage = opts.maxage || opts.maxAge || 0;
      opts.root = resolve(root);
      var onDirectory = redirect ? createRedirectDirectoryListener() : createNotFoundDirectoryListener();
      return function serveStatic2(req, res, next) {
        if (req.method !== "GET" && req.method !== "HEAD") {
          if (fallthrough) {
            return next();
          }
          res.statusCode = 405;
          res.setHeader("Allow", "GET, HEAD");
          res.setHeader("Content-Length", "0");
          res.end();
          return;
        }
        var forwardError = !fallthrough;
        var originalUrl = parseUrl.original(req);
        var path = parseUrl(req).pathname;
        if (path === "/" && originalUrl.pathname.substr(-1) !== "/") {
          path = "";
        }
        var stream = send(req, path, opts);
        stream.on("directory", onDirectory);
        if (setHeaders) {
          stream.on("headers", setHeaders);
        }
        if (fallthrough) {
          stream.on("file", function onFile() {
            forwardError = true;
          });
        }
        stream.on("error", function error(err) {
          if (forwardError || !(err.statusCode < 500)) {
            next(err);
            return;
          }
          next();
        });
        stream.pipe(res);
      };
    }
    function collapseLeadingSlashes(str2) {
      for (var i = 0; i < str2.length; i++) {
        if (str2.charCodeAt(i) !== 47) {
          break;
        }
      }
      return i > 1 ? "/" + str2.substr(i) : str2;
    }
    function createHtmlDocument(title, body2) {
      return '<!DOCTYPE html>\n<html lang="en">\n<head>\n<meta charset="utf-8">\n<title>' + title + "</title>\n</head>\n<body>\n<pre>" + body2 + "</pre>\n</body>\n</html>\n";
    }
    function createNotFoundDirectoryListener() {
      return function notFound() {
        this.error(404);
      };
    }
    function createRedirectDirectoryListener() {
      return function redirect(res) {
        if (this.hasTrailingSlash()) {
          this.error(404);
          return;
        }
        var originalUrl = parseUrl.original(this.req);
        originalUrl.path = null;
        originalUrl.pathname = collapseLeadingSlashes(originalUrl.pathname + "/");
        var loc = encodeUrl(url.format(originalUrl));
        var doc = createHtmlDocument("Redirecting", 'Redirecting to <a href="' + escapeHtml(loc) + '">' + escapeHtml(loc) + "</a>");
        res.statusCode = 301;
        res.setHeader("Content-Type", "text/html; charset=UTF-8");
        res.setHeader("Content-Length", Buffer.byteLength(doc));
        res.setHeader("Content-Security-Policy", "default-src 'none'");
        res.setHeader("X-Content-Type-Options", "nosniff");
        res.setHeader("Location", loc);
        res.end(doc);
      };
    }
  }
});

// node_modules/@calcit/ternary-tree/lib/types.js
var TernaryTreeKind;
(function(TernaryTreeKind2) {
  TernaryTreeKind2[TernaryTreeKind2["ternaryTreeBranch"] = 0] = "ternaryTreeBranch";
  TernaryTreeKind2[TernaryTreeKind2["ternaryTreeLeaf"] = 1] = "ternaryTreeLeaf";
})(TernaryTreeKind || (TernaryTreeKind = {}));
var valueHash = (x) => {
  if (typeof x === "number") {
    return x;
  } else if (typeof x === "string") {
    let h = 0;
    for (var i = 0; i < x.length; i++) {
      h = Math.imul(31, h) + (x[i].charCodeAt(0) | 0);
    }
    return h;
  }
  throw new Error("Hash solution not provided for this type(other than number and string)");
};
var hashGenerator = valueHash;
var overwriteHashGenerator = (f) => {
  hashGenerator = f;
};
var mergeValueHash = (base, x) => {
  if (typeof x === "number") {
    return Math.imul(31, base) + x;
  } else if (typeof x === "string") {
    let h = base;
    for (var i = 0; i < x.length; i++) {
      h = Math.imul(31, h) + (x[i].charCodeAt(0) | 0);
    }
    return h;
  }
  throw new Error("Hash solution not provided for this type(other than number and string)");
};

// node_modules/@calcit/ternary-tree/lib/utils.js
var dataEqual = (x, y) => {
  return x === y;
};
var overwriteComparator = (f) => {
  dataEqual = f;
};
var roughIntPow = (x, times) => {
  if (times < 1) {
    return x;
  }
  let result = 1;
  for (let idx = 0; idx < times; idx++) {
    result = result * x;
  }
  return result;
};
var divideTernarySizes = (size) => {
  if (size < 0) {
    throw new Error("Unexpected negative size");
  }
  let extra = size % 3;
  let groupSize = Math.floor(size / 3);
  var leftSize = groupSize;
  var middleSize = groupSize;
  var rightSize = groupSize;
  switch (extra) {
    case 0:
      break;
    case 1:
      middleSize = middleSize + 1;
      break;
    case 2:
      leftSize = leftSize + 1;
      rightSize = rightSize + 1;
      break;
    default:
      throw new Error(`Unexpected mod result ${extra}`);
  }
  return { left: leftSize, middle: middleSize, right: rightSize };
};
var cmp = (x, y) => {
  if (x < y) {
    return -1;
  }
  if (x > y) {
    return 1;
  }
  return 0;
};

// node_modules/@calcit/ternary-tree/lib/map.js
var emptyBranch = null;
function getMax(tree) {
  if (tree == null) {
    throw new Error("Cannot find max hash of nil");
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.hash;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.maxHash;
    default:
      throw new Error("Unknown");
  }
}
function getMin(tree) {
  if (tree == null) {
    throw new Error("Cannot find min hash of nil");
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.hash;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.minHash;
    default:
      throw new Error("Unknown");
  }
}
function getMapDepth(tree) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return 1;
    case TernaryTreeKind.ternaryTreeBranch:
      return Math.max(getMapDepth(tree.left), getMapDepth(tree.middle), getMapDepth(tree.right)) + 1;
    default:
      throw new Error("Unknown");
  }
}
function createLeaf(k, v) {
  let result = {
    kind: TernaryTreeKind.ternaryTreeLeaf,
    hash: hashGenerator(k),
    elements: [[k, v]]
  };
  return result;
}
function createLeafFromHashEntry(item) {
  let result = {
    kind: TernaryTreeKind.ternaryTreeLeaf,
    hash: item.hash,
    elements: item.pairs
  };
  return result;
}
function makeTernaryTreeMap(size, offset, xs) {
  switch (size) {
    case 0: {
      let result = emptyBranch;
      return result;
    }
    case 1: {
      let leftPair = xs[offset];
      let result = createLeafFromHashEntry(leftPair);
      return result;
    }
    case 2: {
      let leftPair = xs[offset];
      let middlePair = xs[offset + 1];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: middlePair.hash,
        minHash: leftPair.hash,
        left: createLeafFromHashEntry(leftPair),
        middle: createLeafFromHashEntry(middlePair),
        right: emptyBranch,
        depth: 1
      };
      return result;
    }
    case 3: {
      let leftPair = xs[offset];
      let middlePair = xs[offset + 1];
      let rightPair = xs[offset + 2];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: rightPair.hash,
        minHash: leftPair.hash,
        left: createLeafFromHashEntry(leftPair),
        middle: createLeafFromHashEntry(middlePair),
        right: createLeafFromHashEntry(rightPair),
        depth: 1
      };
      return result;
    }
    default: {
      let divided = divideTernarySizes(size);
      let left = makeTernaryTreeMap(divided.left, offset, xs);
      let middle = makeTernaryTreeMap(divided.middle, offset + divided.left, xs);
      let right = makeTernaryTreeMap(divided.right, offset + divided.left + divided.middle, xs);
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(right),
        minHash: getMin(left),
        left,
        middle,
        right,
        depth: Math.max(getMapDepth(left), getMapDepth(middle), getMapDepth(right)) + 1
      };
      return result;
    }
  }
}
function initTernaryTreeMapFromHashEntries(xs) {
  return makeTernaryTreeMap(xs.length, 0, xs);
}
function initTernaryTreeMapFromArray(t) {
  let groupBuffers = {};
  let xs = [];
  for (let idx = 0; idx < t.length; idx++) {
    let k = t[idx][0];
    let v = t[idx][1];
    let h = hashGenerator(k);
    if (groupBuffers[h] != null) {
      let branch = groupBuffers[h];
      if (branch != null) {
        branch.push([k, v]);
      } else {
        throw new Error("Expected referece to pairs");
      }
    } else {
      let pairs = [[k, v]];
      groupBuffers[h] = pairs;
      xs.push({
        hash: h,
        pairs
      });
    }
  }
  xs.sort((a2, b) => cmp(a2.hash, b.hash));
  let result = initTernaryTreeMapFromHashEntries(xs);
  return result;
}
function initEmptyTernaryTreeMap() {
  let result = emptyBranch;
  return result;
}
function mapLen(tree) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.elements.length;
    case TernaryTreeKind.ternaryTreeBranch:
      return mapLen(tree.left) + mapLen(tree.middle) + mapLen(tree.right);
    default:
      throw new Error("Unknown");
  }
}
function mapLenBound(tree, bound) {
  if (tree == null) {
    return 0;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree.elements.length;
    case TernaryTreeKind.ternaryTreeBranch:
      let ret = mapLenBound(tree.left, bound);
      if (ret > bound) {
        return ret;
      }
      ret = ret + mapLenBound(tree.middle, bound);
      if (ret > bound) {
        return ret;
      }
      ret = ret + mapLenBound(tree.right, bound);
      return ret;
    default:
      throw new Error("Unknown");
  }
}
function isMapEmpty(tree) {
  if (tree == null) {
    return true;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return false;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.left == null && tree.middle == null && tree.right == null;
    default:
      throw new Error("Unknown");
  }
}
function collectOrderedHashEntries(tree, acc, idx) {
  if (tree == null || isMapEmpty(tree)) {
  } else {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        acc[idx.value] = { hash: tree.hash, pairs: tree.elements };
        idx.value = idx.value + 1;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        collectOrderedHashEntries(tree.left, acc, idx);
        collectOrderedHashEntries(tree.middle, acc, idx);
        collectOrderedHashEntries(tree.right, acc, idx);
        break;
      }
      default: {
        throw new Error("Unknown");
      }
    }
  }
}
function toOrderedHashEntries(tree) {
  let acc = new Array(mapLen(tree));
  let idx = { value: 0 };
  collectOrderedHashEntries(tree, acc, idx);
  return acc;
}
function contains(originalTree, item) {
  if (originalTree == null) {
    return false;
  }
  let hx = hashGenerator(item);
  let tree = originalTree;
  whileLoop:
    while (tree != null) {
      if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx === tree.hash) {
          let size = tree.elements.length;
          for (let idx = 0; idx < size; idx++) {
            let pair = tree.elements[idx];
            if (dataEqual(pair[0], item)) {
              return true;
            }
          }
        }
        return false;
      }
      if (tree.left == null) {
        return false;
      }
      if (tree.left.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.left.hash) {
          return false;
        }
        if (tree.left.hash === hx) {
          tree = tree.left;
          continue whileLoop;
        }
      } else {
        if (hx < tree.left.minHash) {
          return false;
        }
        if (hx <= tree.left.maxHash) {
          tree = tree.left;
          continue whileLoop;
        }
      }
      if (tree.middle == null) {
        return false;
      }
      if (tree.middle.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.middle.hash) {
          return false;
        }
        if (tree.middle.hash === hx) {
          tree = tree.middle;
          continue whileLoop;
        }
      } else {
        if (hx < tree.middle.minHash) {
          return false;
        }
        if (hx <= tree.middle.maxHash) {
          tree = tree.middle;
          continue whileLoop;
        }
      }
      if (tree.right == null) {
        return false;
      }
      if (tree.right.kind === TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.right.hash) {
          return false;
        }
        if (tree.right.hash === hx) {
          tree = tree.right;
          continue whileLoop;
        }
      } else {
        if (hx < tree.right.minHash) {
          return false;
        }
        if (hx <= tree.right.maxHash) {
          tree = tree.right;
          continue whileLoop;
        }
      }
      return false;
    }
  return false;
}
function mapGetDefault(originalTree, item, v0) {
  let hx = hashGenerator(item);
  let tree = originalTree;
  whileLoop:
    while (tree != null) {
      if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
        let size = tree.elements.length;
        for (let i = 0; i < size; i++) {
          let pair = tree.elements[i];
          if (dataEqual(pair[0], item)) {
            return pair[1];
          }
        }
        return v0;
      }
      if (tree.left == null) {
        return v0;
      }
      if (tree.left.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.left.hash) {
          return v0;
        }
        if (tree.left.hash === hx) {
          tree = tree.left;
          continue whileLoop;
        }
      } else {
        if (hx < tree.left.minHash) {
          return v0;
        }
        if (hx <= tree.left.maxHash) {
          tree = tree.left;
          continue whileLoop;
        }
      }
      if (tree.middle == null) {
        return v0;
      }
      if (tree.middle.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.middle.hash) {
          return v0;
        }
        if (tree.middle.hash === hx) {
          tree = tree.middle;
          continue whileLoop;
        }
      } else {
        if (hx < tree.middle.minHash) {
          return v0;
        }
        if (hx <= tree.middle.maxHash) {
          tree = tree.middle;
          continue whileLoop;
        }
      }
      if (tree.right == null) {
        return v0;
      }
      if (tree.right.kind == TernaryTreeKind.ternaryTreeLeaf) {
        if (hx < tree.right.hash) {
          return v0;
        }
        if (tree.right.hash === hx) {
          tree = tree.right;
          continue whileLoop;
        }
      } else {
        if (hx < tree.right.minHash) {
          return v0;
        }
        if (hx <= tree.right.maxHash) {
          tree = tree.right;
          continue whileLoop;
        }
      }
      return v0;
    }
  return v0;
}
function rangeContainsHash(tree, thisHash) {
  if (tree == null) {
    return false;
  } else if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    return tree.hash === thisHash;
  } else {
    return thisHash >= tree.minHash && thisHash <= tree.maxHash;
  }
}
function assocExisted(tree, key, item, thisHash = null) {
  if (tree == null || isMapEmpty(tree)) {
    throw new Error("Cannot call assoc on nil");
  }
  thisHash = thisHash !== null && thisHash !== void 0 ? thisHash : hashGenerator(key);
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (tree.hash !== thisHash) {
      throw new Error("Expected hashes to be identical, otherwise element is missing");
    }
    let newPairs = new Array(tree.elements.length);
    let replaced = false;
    let size = tree.elements.length;
    for (let idx = 0; idx < size; idx++) {
      let pair = tree.elements[idx];
      if (dataEqual(pair[0], key)) {
        newPairs[idx] = [key, item];
        replaced = true;
      } else {
        newPairs[idx] = pair;
      }
    }
    if (replaced) {
      let result = { kind: TernaryTreeKind.ternaryTreeLeaf, hash: thisHash, elements: newPairs };
      return result;
    } else {
      throw new Error("Unexpected missing hash in assoc, invalid branch");
    }
  }
  if (thisHash < tree.minHash)
    throw new Error("Unexpected missing hash in assoc, hash too small");
  else if (thisHash > tree.maxHash)
    throw new Error("Unexpected missing hash in assoc, hash too large");
  if (tree.left == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.left, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: assocExisted(tree.left, key, item, thisHash),
      middle: tree.middle,
      right: tree.right,
      depth: 0
    };
    return result;
  }
  if (tree.middle == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.middle, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: tree.left,
      middle: assocExisted(tree.middle, key, item, thisHash),
      right: tree.right,
      depth: 0
    };
    return result;
  }
  if (tree.right == null) {
    throw new Error("Unexpected missing hash in assoc, found not branch");
  }
  if (rangeContainsHash(tree.right, thisHash)) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      maxHash: tree.maxHash,
      minHash: tree.minHash,
      left: tree.left,
      middle: tree.middle,
      right: assocExisted(tree.right, key, item, thisHash),
      depth: 0
    };
    return result;
  }
  throw new Error("Unexpected missing hash in assoc, found not branch");
}
function assocNew(tree, key, item, thisHash = null) {
  if (tree == null || isMapEmpty(tree)) {
    return createLeaf(key, item);
  }
  thisHash = thisHash !== null && thisHash !== void 0 ? thisHash : hashGenerator(key);
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (thisHash > tree.hash) {
      let childBranch = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: thisHash,
        elements: [[key, item]]
      };
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: thisHash,
        minHash: tree.hash,
        left: tree,
        middle: childBranch,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else if (thisHash < tree.hash) {
      let childBranch = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: thisHash,
        elements: [[key, item]]
      };
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.hash,
        minHash: thisHash,
        left: childBranch,
        middle: tree,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let size = tree.elements.length;
      for (let i = 0; i < size; i++) {
        let pair = tree.elements[i];
        if (dataEqual(pair[0], key)) {
          throw new Error("Unexpected existed key in assoc");
        }
      }
      let newPairs = new Array(tree.elements.length + 1);
      for (let idx = 0; idx < size; idx++) {
        let pair = tree.elements[idx];
        newPairs[idx] = pair;
      }
      newPairs[tree.elements.length] = [key, item];
      let result = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        hash: tree.hash,
        elements: newPairs
      };
      return result;
    }
  } else {
    if (thisHash < tree.minHash) {
      if (tree.right == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: tree.maxHash,
          minHash: thisHash,
          left: childBranch,
          middle: tree.left,
          right: tree.middle,
          depth: 0
        };
        return result;
      } else {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: tree.maxHash,
          minHash: thisHash,
          left: childBranch,
          middle: tree,
          right: emptyBranch,
          depth: 0
        };
        return result;
      }
    }
    if (thisHash > tree.maxHash) {
      if (tree.middle == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree.left,
          middle: childBranch,
          right: emptyBranch,
          depth: 0
        };
        return result;
      } else if (tree.right == null) {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree.left,
          middle: tree.middle,
          right: childBranch,
          depth: 0
        };
        return result;
      } else {
        let childBranch = {
          kind: TernaryTreeKind.ternaryTreeLeaf,
          hash: thisHash,
          elements: [[key, item]]
        };
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          maxHash: thisHash,
          minHash: tree.minHash,
          left: tree,
          middle: childBranch,
          right: emptyBranch,
          depth: 0
        };
        return result;
      }
    }
    if (rangeContainsHash(tree.left, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: assocNew(tree.left, key, item, thisHash),
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    }
    if (rangeContainsHash(tree.middle, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: assocNew(tree.middle, key, item, thisHash),
        right: tree.right,
        depth: 0
      };
      return result;
    }
    if (rangeContainsHash(tree.right, thisHash)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: assocNew(tree.right, key, item, thisHash),
        depth: 0
      };
      return result;
    }
    if (tree.middle == null) {
      throw new Error("unreachable. if inside range, then middle should be here");
    }
    if (thisHash < getMin(tree.middle)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: assocNew(tree.left, key, item, thisHash),
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: assocNew(tree.right, key, item, thisHash),
        depth: 0
      };
      return result;
    }
  }
}
function assocMap(tree, key, item, disableBalancing = false) {
  if (tree == null || isMapEmpty(tree)) {
    return createLeaf(key, item);
  }
  if (contains(tree, key)) {
    return assocExisted(tree, key, item);
  } else {
    return assocNew(tree, key, item);
  }
}
function dissocExisted(tree, key) {
  if (tree == null) {
    throw new Error("Unexpected missing key in dissoc");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (tree.hash === hashGenerator(key)) {
      let size = tree.elements.length;
      if (size === 1 && dataEqual(key, tree.elements[0][0])) {
        return emptyBranch;
      } else {
        let newPairs = [];
        for (let i = 0; i < size; i++) {
          let pair = tree.elements[i];
          if (!dataEqual(pair[0], key)) {
            newPairs.push(pair);
          }
        }
        let result = { kind: TernaryTreeKind.ternaryTreeLeaf, hash: tree.hash, elements: newPairs };
        return result;
      }
    } else {
      throw new Error("Unexpected missing key in dissoc on leaf");
    }
  }
  if (mapLenBound(tree, 2) === 1) {
    if (!contains(tree, key)) {
      throw new Error("Unexpected missing key in dissoc single branch");
    }
    return emptyBranch;
  }
  let thisHash = hashGenerator(key);
  if (rangeContainsHash(tree.left, thisHash)) {
    let changedBranch = dissocExisted(tree.left, key);
    if (isMapEmpty(changedBranch)) {
      if (isMapEmpty(tree.right)) {
        return tree.middle;
      }
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: getMin(tree.middle),
        left: tree.middle,
        middle: tree.right,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: getMin(changedBranch),
        left: changedBranch,
        middle: tree.middle,
        right: tree.right,
        depth: 0
      };
      return result;
    }
  }
  if (rangeContainsHash(tree.middle, thisHash)) {
    let changedBranch = dissocExisted(tree.middle, key);
    if (isMapEmpty(changedBranch)) {
      if (isMapEmpty(tree.right)) {
        return tree.left;
      }
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.right,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: tree.maxHash,
        minHash: tree.minHash,
        left: tree.left,
        middle: changedBranch,
        right: tree.right,
        depth: 0
      };
      return result;
    }
  }
  if (rangeContainsHash(tree.right, thisHash)) {
    let changedBranch = dissocExisted(tree.right, key);
    if (changedBranch == null) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(tree.middle),
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: emptyBranch,
        depth: 0
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        maxHash: getMax(changedBranch),
        minHash: tree.minHash,
        left: tree.left,
        middle: tree.middle,
        right: changedBranch,
        depth: 0
      };
      return result;
    }
  }
  throw new Error("Cannot find branch in dissoc");
}
function dissocMap(tree, key) {
  if (contains(tree, key)) {
    return dissocExisted(tree, key);
  } else {
    return tree;
  }
}
function collectToPairsArray(acc, tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let i = 0; i < tree.elements.length; i++) {
        let pair = tree.elements[i];
        acc.push(pair);
      }
    } else {
      if (tree.left != null) {
        collectToPairsArray(acc, tree.left);
      }
      if (tree.middle != null) {
        collectToPairsArray(acc, tree.middle);
      }
      if (tree.right != null) {
        collectToPairsArray(acc, tree.right);
      }
    }
  }
}
function toPairsArray(tree) {
  let result = [];
  collectToPairsArray(result, tree);
  return result;
}
function* toPairs(tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let pair of tree.elements) {
        yield pair;
      }
    } else {
      if (tree.left != null) {
        for (let item of toPairs(tree.left)) {
          yield item;
        }
      }
      if (tree.middle != null) {
        for (let item of toPairs(tree.middle)) {
          yield item;
        }
      }
      if (tree.right != null) {
        for (let item of toPairs(tree.right)) {
          yield item;
        }
      }
    }
  }
}
function* toKeys(tree) {
  if (tree != null) {
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      for (let i = 0; i < tree.elements.length; i++) {
        let pair = tree.elements[i];
        yield pair[0];
      }
    } else {
      if (tree.left != null) {
        for (let item of toKeys(tree.left)) {
          yield item;
        }
      }
      if (tree.middle != null) {
        for (let item of toKeys(tree.middle)) {
          yield item;
        }
      }
      if (tree.right != null) {
        for (let item of toKeys(tree.right)) {
          yield item;
        }
      }
    }
  }
}
function mergeSkip(xs, ys, skipped) {
  let ret = xs;
  let counted = 0;
  for (let [key, item] of toPairs(ys)) {
    if (dataEqual(item, skipped)) {
      continue;
    }
    ret = assocMap(ret, key, item);
    if (counted > 700) {
      forceMapInplaceBalancing(ret);
      counted = 0;
    } else {
      counted = counted + 1;
    }
  }
  return ret;
}
function forceMapInplaceBalancing(tree) {
  if (tree.kind === TernaryTreeKind.ternaryTreeBranch) {
    let xs = toOrderedHashEntries(tree);
    let newTree = makeTernaryTreeMap(xs.length, 0, xs);
    tree.left = newTree.left;
    tree.middle = newTree.middle;
    tree.right = newTree.right;
  } else {
  }
}

// node_modules/@calcit/ternary-tree/lib/list.js
function getDepth(tree) {
  if (tree == null)
    return 0;
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return 1;
    case TernaryTreeKind.ternaryTreeBranch:
      return tree.depth;
  }
}
var emptyBranch2 = null;
function decideParentDepth(...xs) {
  let depth = 0;
  for (let i = 0; i < xs.length; i++) {
    let x = xs[i];
    let y = getDepth(x);
    if (y > depth) {
      depth = y;
    }
  }
  return depth + 1;
}
function makeTernaryTreeList(size, offset, xs) {
  switch (size) {
    case 0: {
      return { kind: TernaryTreeKind.ternaryTreeBranch, size: 0, depth: 1, left: emptyBranch2, middle: emptyBranch2, right: emptyBranch2 };
    }
    case 1:
      return xs[offset];
    case 2: {
      let left = xs[offset];
      let middle = xs[offset + 1];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle),
        left,
        middle,
        right: emptyBranch2,
        depth: decideParentDepth(left, middle)
      };
      return result;
    }
    case 3: {
      let left = xs[offset];
      let middle = xs[offset + 1];
      let right = xs[offset + 2];
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle) + listLen(right),
        left,
        middle,
        right,
        depth: decideParentDepth(left, middle, right)
      };
      return result;
    }
    default: {
      let divided = divideTernarySizes(size);
      let left = makeTernaryTreeList(divided.left, offset, xs);
      let middle = makeTernaryTreeList(divided.middle, offset + divided.left, xs);
      let right = makeTernaryTreeList(divided.right, offset + divided.left + divided.middle, xs);
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: listLen(left) + listLen(middle) + listLen(right),
        depth: decideParentDepth(left, middle, right),
        left,
        middle,
        right
      };
      return result;
    }
  }
}
function initTernaryTreeList(xs) {
  let ys = new Array(xs.length);
  let size = xs.length;
  for (let idx = 0; idx < size; idx++) {
    let x = xs[idx];
    ys[idx] = { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: x };
  }
  return makeTernaryTreeList(xs.length, 0, ys);
}
function initTernaryTreeListFromRange(xs, from, to) {
  let ys = new Array(xs.length);
  for (let idx = from; idx < to; idx++) {
    let x = xs[idx];
    ys[idx] = { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: x };
  }
  return makeTernaryTreeList(xs.length, 0, ys);
}
function listLen(tree) {
  if (tree == null) {
    return 0;
  } else {
    return tree.size;
  }
}
function* listToItems(tree) {
  if (tree != null) {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        yield tree.value;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        if (tree.left != null) {
          for (let x of listToItems(tree.left)) {
            yield x;
          }
        }
        if (tree.middle != null) {
          for (let x of listToItems(tree.middle)) {
            yield x;
          }
        }
        if (tree.right != null) {
          for (let x of listToItems(tree.right)) {
            yield x;
          }
        }
        break;
      }
    }
  }
}
function writeLeavesArray(tree, acc, idx) {
  if (tree == null) {
  } else {
    switch (tree.kind) {
      case TernaryTreeKind.ternaryTreeLeaf: {
        acc[idx.value] = tree;
        idx.value = idx.value + 1;
        break;
      }
      case TernaryTreeKind.ternaryTreeBranch: {
        if (tree.left != null) {
          writeLeavesArray(tree.left, acc, idx);
        }
        if (tree.middle != null) {
          writeLeavesArray(tree.middle, acc, idx);
        }
        if (tree.right != null) {
          writeLeavesArray(tree.right, acc, idx);
        }
        break;
      }
      default: {
        throw new Error("Unknown");
      }
    }
  }
}
function toLeavesArray(tree) {
  let acc = new Array(listLen(tree));
  let counter = { value: 0 };
  writeLeavesArray(tree, acc, counter);
  return acc;
}
function listGet(originalTree, originalIdx) {
  let tree = originalTree;
  let idx = originalIdx;
  while (tree != null) {
    if (idx < 0) {
      throw new Error("Cannot index negative number");
    }
    if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
      if (idx === 0) {
        return tree.value;
      } else {
        throw new Error(`Cannot get from leaf with index ${idx}`);
      }
    }
    if (idx > tree.size - 1) {
      throw new Error("Index too large");
    }
    let leftSize = tree.left == null ? 0 : tree.left.size;
    let middleSize = tree.middle == null ? 0 : tree.middle.size;
    let rightSize = tree.right == null ? 0 : tree.right.size;
    if (leftSize + middleSize + rightSize !== tree.size) {
      throw new Error("tree.size does not match sum case branch sizes");
    }
    if (idx <= leftSize - 1) {
      tree = tree.left;
    } else if (idx <= leftSize + middleSize - 1) {
      tree = tree.middle;
      idx = idx - leftSize;
    } else {
      tree = tree.right;
      idx = idx - leftSize - middleSize;
    }
  }
  throw new Error(`Failed to get ${idx}`);
}
function first(tree) {
  if (listLen(tree) > 0) {
    return listGet(tree, 0);
  } else {
    throw new Error("Cannot get from empty list");
  }
}
function assocList(tree, idx, item) {
  if (idx < 0) {
    throw new Error("Cannot index negative number");
  }
  if (idx > tree.size - 1) {
    throw new Error("Index too large");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (idx === 0) {
      return { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item };
    } else {
      throw new Error(`Cannot get from leaf with index ${idx}`);
    }
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size)
    throw new Error("tree.size does not match sum case branch sizes");
  if (idx <= leftSize - 1) {
    let changedBranch = assocList(tree.left, idx, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(changedBranch, tree.middle, tree.right),
      left: changedBranch,
      middle: tree.middle,
      right: tree.right
    };
    return result;
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = assocList(tree.middle, idx - leftSize, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(tree.left, changedBranch, tree.right),
      left: tree.left,
      middle: changedBranch,
      right: tree.right
    };
    return result;
  } else {
    let changedBranch = assocList(tree.right, idx - leftSize - middleSize, item);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
    return result;
  }
}
function dissocList(tree, idx) {
  if (tree == null) {
    throw new Error("dissoc does not work on null");
  }
  if (idx < 0) {
    throw new Error(`Index is negative ${idx}`);
  }
  if (listLen(tree) === 0) {
    throw new Error("Cannot remove from empty list");
  }
  if (idx > listLen(tree) - 1) {
    throw new Error(`Index too large ${idx}`);
  }
  if (listLen(tree) === 1) {
    return emptyBranch2;
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    throw new Error("dissoc should be handled at branches");
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size) {
    throw new Error("tree.size does not match sum from branch sizes");
  }
  let result = emptyBranch2;
  if (idx <= leftSize - 1) {
    let changedBranch = dissocList(tree.left, idx);
    if (changedBranch == null || changedBranch.size === 0) {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.middle, tree.right),
        left: tree.middle,
        middle: tree.right,
        right: emptyBranch2
      };
    } else {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(changedBranch, tree.middle, tree.right),
        left: changedBranch,
        middle: tree.middle,
        right: tree.right
      };
    }
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = dissocList(tree.middle, idx - leftSize);
    if (changedBranch == null || changedBranch.size === 0) {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.left, changedBranch, tree.right),
        left: tree.left,
        middle: tree.right,
        right: emptyBranch2
      };
    } else {
      result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size - 1,
        depth: decideParentDepth(tree.left, changedBranch, tree.right),
        left: tree.left,
        middle: changedBranch,
        right: tree.right
      };
    }
  } else {
    let changedBranch = dissocList(tree.right, idx - leftSize - middleSize);
    if (changedBranch == null || changedBranch.size === 0) {
      changedBranch = emptyBranch2;
    }
    result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size - 1,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
  }
  if (result.middle == null) {
    return result.left;
  }
  return result;
}
function rest(tree) {
  if (tree == null) {
    throw new Error("Cannot call rest on null");
  }
  if (listLen(tree) < 1) {
    throw new Error("Cannot call rest on empty list");
  }
  return dissocList(tree, 0);
}
function insert(tree, idx, item, after = false) {
  if (tree == null) {
    throw new Error("Cannot insert into null");
  }
  if (listLen(tree) === 0) {
    throw new Error("Empty node is not a correct position for inserting");
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf) {
    if (after) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        depth: getDepth(tree) + 1,
        size: 2,
        left: tree,
        middle: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        right: emptyBranch2
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        depth: getDepth(tree) + 1,
        size: 2,
        left: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        middle: tree,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (listLen(tree) === 1) {
    if (after) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: 2,
        depth: 2,
        left: tree.left,
        middle: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        right: emptyBranch2
      };
      return result;
    } else {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: 2,
        depth: getDepth(tree.middle) + 1,
        left: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        middle: tree.left,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (listLen(tree) === 2 && tree.middle != null) {
    if (after) {
      if (idx === 0) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
          right: tree.middle
        };
        return result;
      }
      if (idx === 1) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: tree.middle,
          right: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item }
        };
        return result;
      } else {
        throw new Error("cannot insert after position 2 since only 2 elements here");
      }
    } else {
      if (idx === 0) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
          middle: tree.left,
          right: tree.middle
        };
        return result;
      } else if (idx === 1) {
        let result = {
          kind: TernaryTreeKind.ternaryTreeBranch,
          size: 3,
          depth: 2,
          left: tree.left,
          middle: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
          right: tree.middle
        };
        return result;
      } else {
        throw new Error("cannot insert before position 2 since only 2 elements here");
      }
    }
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (leftSize + middleSize + rightSize !== tree.size) {
    throw new Error("tree.size does not match sum case branch sizes");
  }
  if (idx === 0 && !after) {
    if (listLen(tree.left) >= listLen(tree.middle) && listLen(tree.left) >= listLen(tree.right)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size + 1,
        depth: tree.depth + 1,
        left: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        middle: tree,
        right: emptyBranch2
      };
      return result;
    }
  }
  if (idx === listLen(tree) - 1 && after) {
    if (listLen(tree.right) >= listLen(tree.middle) && listLen(tree.right) >= listLen(tree.left)) {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size + 1,
        depth: tree.depth + 1,
        left: tree,
        middle: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
        right: emptyBranch2
      };
      return result;
    }
  }
  if (after && idx === listLen(tree) - 1 && rightSize === 0 && middleSize >= leftSize) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: tree.depth,
      left: tree.left,
      middle: tree.middle,
      right: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item }
    };
    return result;
  }
  if (!after && idx === 0 && rightSize === 0 && middleSize >= rightSize) {
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: tree.depth,
      left: { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item },
      middle: tree.left,
      right: tree.middle
    };
    return result;
  }
  if (idx <= leftSize - 1) {
    let changedBranch = insert(tree.left, idx, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(changedBranch, tree.middle, tree.right),
      left: changedBranch,
      middle: tree.middle,
      right: tree.right
    };
    return result;
  } else if (idx <= leftSize + middleSize - 1) {
    let changedBranch = insert(tree.middle, idx - leftSize, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(tree.left, changedBranch, tree.right),
      left: tree.left,
      middle: changedBranch,
      right: tree.right
    };
    return result;
  } else {
    let changedBranch = insert(tree.right, idx - leftSize - middleSize, item, after);
    let result = {
      kind: TernaryTreeKind.ternaryTreeBranch,
      size: tree.size + 1,
      depth: decideParentDepth(tree.left, tree.middle, changedBranch),
      left: tree.left,
      middle: tree.middle,
      right: changedBranch
    };
    return result;
  }
}
function assocBefore(tree, idx, item, after = false) {
  return insert(tree, idx, item, false);
}
function assocAfter(tree, idx, item, after = false) {
  return insert(tree, idx, item, true);
}
function forceListInplaceBalancing(tree) {
  if (tree.kind === TernaryTreeKind.ternaryTreeBranch) {
    let ys = toLeavesArray(tree);
    let newTree = makeTernaryTreeList(ys.length, 0, ys);
    tree.left = newTree.left;
    tree.middle = newTree.middle;
    tree.right = newTree.right;
    tree.depth = decideParentDepth(tree.left, tree.middle, tree.right);
  } else {
  }
}
function maybeReblance(tree) {
  let currentDepth = getDepth(tree);
  if (currentDepth > 50) {
    if (roughIntPow(3, currentDepth - 50) > tree.size) {
      forceListInplaceBalancing(tree);
    }
  }
}
function prepend(tree, item, disableBalancing = false) {
  if (tree == null || listLen(tree) === 0) {
    return { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item };
  }
  let result = insert(tree, 0, item, false);
  if (!disableBalancing) {
    maybeReblance(result);
  }
  return result;
}
function append(tree, item, disableBalancing = false) {
  if (tree == null || listLen(tree) === 0) {
    return { kind: TernaryTreeKind.ternaryTreeLeaf, size: 1, value: item };
  }
  let result = insert(tree, listLen(tree) - 1, item, true);
  if (!disableBalancing) {
    maybeReblance(result);
  }
  return result;
}
function concat(...xsGroups) {
  xsGroups = xsGroups.filter((xs) => listLen(xs) > 0);
  let result = makeTernaryTreeList(xsGroups.length, 0, xsGroups);
  maybeReblance(result);
  return result;
}
function slice(tree, startIdx, endIdx) {
  if (endIdx > listLen(tree)) {
    throw new Error("Slice range too large {endIdx} for {tree}");
  }
  if (startIdx < 0) {
    throw new Error("Slice range too small {startIdx} for {tree}");
  }
  if (startIdx > endIdx) {
    throw new Error("Invalid slice range {startIdx}..{endIdx} for {tree}");
  }
  if (startIdx === endIdx) {
    return { kind: TernaryTreeKind.ternaryTreeBranch, size: 0, depth: 0 };
  }
  if (tree.kind === TernaryTreeKind.ternaryTreeLeaf)
    if (startIdx === 0 && endIdx === 1) {
      return tree;
    } else {
      throw new Error(`Invalid slice range for a leaf: ${startIdx} ${endIdx}`);
    }
  if (startIdx === 0 && endIdx === listLen(tree)) {
    return tree;
  }
  let leftSize = listLen(tree.left);
  let middleSize = listLen(tree.middle);
  let rightSize = listLen(tree.right);
  if (startIdx >= leftSize + middleSize) {
    return slice(tree.right, startIdx - leftSize - middleSize, endIdx - leftSize - middleSize);
  }
  if (startIdx >= leftSize)
    if (endIdx <= leftSize + middleSize) {
      return slice(tree.middle, startIdx - leftSize, endIdx - leftSize);
    } else {
      let middleCut = slice(tree.middle, startIdx - leftSize, middleSize);
      let rightCut = slice(tree.right, 0, endIdx - leftSize - middleSize);
      return concat(middleCut, rightCut);
    }
  if (endIdx <= leftSize) {
    return slice(tree.left, startIdx, endIdx);
  }
  if (endIdx <= leftSize + middleSize) {
    let leftCut = slice(tree.left, startIdx, leftSize);
    let middleCut = slice(tree.middle, 0, endIdx - leftSize);
    return concat(leftCut, middleCut);
  }
  if (endIdx <= leftSize + middleSize + rightSize) {
    let leftCut = slice(tree.left, startIdx, leftSize);
    let rightCut = slice(tree.right, 0, endIdx - leftSize - middleSize);
    return concat(concat(leftCut, tree.middle), rightCut);
  }
  throw new Error("Unknown");
}
function reverse(tree) {
  if (tree == null) {
    return tree;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf:
      return tree;
    case TernaryTreeKind.ternaryTreeBranch: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size,
        depth: tree.depth,
        left: reverse(tree.right),
        middle: reverse(tree.middle),
        right: reverse(tree.left)
      };
      return result;
    }
  }
}
function listMapValues(tree, f) {
  if (tree == null) {
    return tree;
  }
  switch (tree.kind) {
    case TernaryTreeKind.ternaryTreeLeaf: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeLeaf,
        size: tree.size,
        value: f(tree.value)
      };
      return result;
    }
    case TernaryTreeKind.ternaryTreeBranch: {
      let result = {
        kind: TernaryTreeKind.ternaryTreeBranch,
        size: tree.size,
        depth: tree.depth,
        left: tree.left == null ? emptyBranch2 : listMapValues(tree.left, f),
        middle: tree.middle == null ? emptyBranch2 : listMapValues(tree.middle, f),
        right: tree.right == null ? emptyBranch2 : listMapValues(tree.right, f)
      };
      return result;
    }
  }
}

// node_modules/@calcit/procs/lib/calcit.procs.js
var import_parser = __toESM(require_lib());
var import_writer2 = __toESM(require_writer());

// node_modules/@calcit/procs/lib/js-set.js
var DATA_EQUAL = (x, y) => {
  return x === y;
};
var overwriteSetComparator = (f) => {
  DATA_EQUAL = f;
};
var CalcitSet = class {
  constructor(value) {
    this.cachedHash = null;
    if (Array.isArray(value)) {
      let pairs = [];
      outer:
        for (let idx = 0; idx < value.length; idx++) {
          for (let j = 0; j < pairs.length; j++) {
            if (DATA_EQUAL(pairs[j][0], value[idx])) {
              continue outer;
            }
          }
          pairs.push([value[idx], true]);
        }
      this.value = initTernaryTreeMapFromArray(pairs);
    } else {
      this.value = value;
    }
  }
  len() {
    return mapLen(this.value);
  }
  contains(y) {
    return contains(this.value, y);
  }
  include(y) {
    var result = this.value;
    result = assocMap(result, y, true);
    return new CalcitSet(result);
  }
  exclude(y) {
    var result = this.value;
    result = dissocMap(result, y);
    return new CalcitSet(result);
  }
  difference(ys) {
    let result = this.value;
    for (let k of toKeys(ys.value)) {
      result = dissocMap(result, k);
    }
    return new CalcitSet(result);
  }
  union(ys) {
    let result = this.value;
    for (let k of toKeys(ys.value)) {
      result = assocMap(result, k, true);
    }
    return new CalcitSet(result);
  }
  intersection(ys) {
    let result = initEmptyTernaryTreeMap();
    for (let k of toKeys(this.value)) {
      if (ys.contains(k)) {
        result = assocMap(result, k, true);
      }
    }
    return new CalcitSet(result);
  }
  first() {
    if (mapLen(this.value) === 0) {
      return null;
    }
    return toPairsArray(this.value)[0][0];
  }
  rest() {
    if (mapLen(this.value) === 0) {
      return null;
    }
    let x0 = this.first();
    let result = dissocMap(this.value, x0);
    return new CalcitSet(result);
  }
  toString() {
    let itemsCode = "";
    for (let k of toKeys(this.value)) {
      itemsCode = `${itemsCode} ${toString(k, true)}`;
    }
    return `(#{}${itemsCode})`;
  }
  values() {
    return [...toKeys(this.value)];
  }
};

// node_modules/@calcit/procs/lib/js-map.js
var DATA_EQUAL2 = (x, y) => {
  return x === y;
};
var overwriteMapComparator = (f) => {
  DATA_EQUAL2 = f;
};
var fakeUniqueSymbol = [];
var CalcitMap = class {
  constructor(value) {
    if (value == null) {
      this.value = initEmptyTernaryTreeMap();
    } else {
      this.value = value;
    }
  }
  len() {
    return mapLen(this.value);
  }
  get(k) {
    return mapGetDefault(this.value, k, null);
  }
  assoc(...args2) {
    if (args2.length % 2 !== 0)
      throw new Error("expected even arguments");
    let size = Math.floor(args2.length / 2);
    let result = this.value;
    for (let idx = 0; idx < size; idx++) {
      let k = args2[idx << 1];
      let v = args2[(idx << 1) + 1];
      result = assocMap(result, k, v);
    }
    return new CalcitMap(result);
  }
  dissoc(...args2) {
    let ret = this.value;
    for (let idx = 0; idx < args2.length; idx++) {
      ret = dissocMap(ret, args2[idx]);
    }
    return new CalcitMap(ret);
  }
  toString(shorter = false) {
    let itemsCode = "";
    for (let [k, v] of this.pairs()) {
      if (shorter) {
        let keyPart = isNestedCalcitData(k) ? tipNestedCalcitData(k) : toString(k, true);
        let valuePart = isNestedCalcitData(v) ? tipNestedCalcitData(v) : toString(v, true);
        itemsCode = `${itemsCode} (${keyPart} ${valuePart})`;
      } else {
        itemsCode = `${itemsCode} (${toString(k, true)} ${toString(v, true)})`;
      }
    }
    return `({}${itemsCode})`;
  }
  isEmpty() {
    return isMapEmpty(this.value);
  }
  pairs() {
    return toPairsArray(this.value);
  }
  keysArray() {
    return [...toKeys(this.value)];
  }
  contains(k) {
    return contains(this.value, k);
  }
  merge(ys) {
    return this.mergeSkip(ys, fakeUniqueSymbol);
  }
  mergeSkip(ys, v) {
    if (ys == null) {
      return this;
    }
    if (!(ys instanceof CalcitMap || ys instanceof CalcitSliceMap)) {
      console.error("value:", v);
      throw new Error("Expected map to merge");
    }
    if (ys instanceof CalcitSliceMap) {
      let ret = this.value;
      let size = ys.chunk.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (ys.chunk[pos + 1] === v) {
          continue;
        }
        ret = assocMap(ret, ys.chunk[pos], ys.chunk[pos + 1]);
      }
      return new CalcitMap(ret);
    } else {
      return new CalcitMap(mergeSkip(this.value, ys.value, v));
    }
  }
  diffNew(ys) {
    let zs = this.value;
    if (ys instanceof CalcitSliceMap) {
      let size = ys.chunk.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        let k = ys.chunk[pos];
        if (contains(zs, k)) {
          zs = dissocMap(zs, k);
        }
      }
      return new CalcitMap(zs);
    } else if (ys instanceof CalcitMap) {
      let ysKeys = ys.keysArray();
      for (let i = 0; i < ysKeys.length; i++) {
        let k = ysKeys[i];
        if (contains(zs, k)) {
          zs = dissocMap(zs, k);
        }
      }
      return new CalcitMap(zs);
    } else {
      throw new Error("unknown data to diff");
    }
  }
  diffKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (!ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
  commonKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
};
var CalcitSliceMap = class {
  constructor(value) {
    if (value == null) {
      this.chunk = [];
    } else if (Array.isArray(value)) {
      this.chunk = value;
    } else {
      throw new Error("unknown data for map");
    }
  }
  turnMap() {
    var dict = [];
    let halfLength = this.chunk.length >> 1;
    for (let idx = 0; idx < halfLength; idx++) {
      dict.push([this.chunk[idx << 1], this.chunk[(idx << 1) + 1]]);
    }
    let value = initTernaryTreeMapFromArray(dict);
    return new CalcitMap(value);
  }
  len() {
    return this.chunk.length >> 1;
  }
  get(k) {
    if (this.chunk.length <= 16) {
      let size = this.chunk.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (DATA_EQUAL2(this.chunk[pos], k)) {
          return this.chunk[pos + 1];
        }
      }
      return null;
    } else {
      return this.turnMap().get(k);
    }
  }
  assoc(...args2) {
    if (args2.length % 2 !== 0)
      throw new Error("expected even arguments");
    let size = Math.floor(args2.length / 2);
    if (this.chunk.length <= 16) {
      let ret = this.chunk.slice(0);
      outer:
        for (let j = 0; j < size; j++) {
          let k = args2[j << 1];
          let v = args2[(j << 1) + 1];
          for (let i = 0; i < ret.length; i += 2) {
            if (DATA_EQUAL2(k, ret[i])) {
              ret[i + 1] = v;
              continue outer;
            }
          }
          ret.push(k, v);
        }
      return new CalcitSliceMap(ret);
    } else {
      return this.turnMap().assoc(...args2);
    }
  }
  dissoc(...args2) {
    if (this.chunk.length <= 16) {
      let ret = [];
      outer:
        for (let i = 0; i < this.chunk.length; i += 2) {
          for (let j = 0; j < args2.length; j++) {
            let k = args2[j];
            if (DATA_EQUAL2(k, this.chunk[i])) {
              continue outer;
            }
          }
          ret.push(this.chunk[i], this.chunk[i + 1]);
        }
      return new CalcitSliceMap(ret);
    } else {
      return this.turnMap().dissoc(...args2);
    }
  }
  toString(shorter = false) {
    let itemsCode = "";
    for (let [k, v] of this.pairs()) {
      if (shorter) {
        let keyPart = isNestedCalcitData(k) ? tipNestedCalcitData(k) : toString(k, true);
        let valuePart = isNestedCalcitData(v) ? tipNestedCalcitData(v) : toString(v, true);
        itemsCode = `${itemsCode} (${keyPart} ${valuePart})`;
      } else {
        itemsCode = `${itemsCode} (${toString(k, true)} ${toString(v, true)})`;
      }
    }
    return `({}${itemsCode})`;
  }
  isEmpty() {
    return this.chunk.length === 0;
  }
  pairs() {
    let ret = [];
    let size = this.chunk.length >> 1;
    for (let i = 0; i < size; i++) {
      let pos = i << 1;
      ret.push([this.chunk[pos], this.chunk[pos + 1]]);
    }
    return ret;
  }
  keysArray() {
    let ret = [];
    let size = this.chunk.length >> 1;
    for (let i = 0; i < size; i++) {
      let pos = i << 1;
      ret.push(this.chunk[pos]);
    }
    return ret;
  }
  contains(k) {
    if (this.chunk.length <= 16) {
      let size = this.chunk.length >> 1;
      for (let i = 0; i < size; i++) {
        let pos = i << 1;
        if (DATA_EQUAL2(this.chunk[pos], k)) {
          return true;
        }
      }
      return false;
    } else {
      return this.turnMap().contains(k);
    }
  }
  merge(ys) {
    return this.mergeSkip(ys, fakeUniqueSymbol);
  }
  mergeSkip(ys, v) {
    if (ys == null) {
      return this;
    }
    if (!(ys instanceof CalcitMap || ys instanceof CalcitSliceMap)) {
      console.error("value:", v);
      throw new Error("Expected map to merge");
    }
    if (ys instanceof CalcitSliceMap && this.chunk.length + ys.len() <= 24) {
      let ret = this.chunk.slice(0);
      outer:
        for (let i = 0; i < ys.chunk.length; i = i + 2) {
          if (ys.chunk[i + 1] === v) {
            continue;
          }
          for (let k = 0; k < ret.length; k = k + 2) {
            if (DATA_EQUAL2(ys.chunk[i], ret[k])) {
              ret[k + 1] = ys.chunk[i + 1];
              continue outer;
            }
          }
          ret.push(ys.chunk[i], ys.chunk[i + 1]);
        }
      return new CalcitSliceMap(ret);
    }
    return this.turnMap().mergeSkip(ys, v);
  }
  diffNew(ys) {
    return this.turnMap().diffNew(ys);
  }
  diffKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (!ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
  commonKeys(ys) {
    let ret = [];
    let ks = this.keysArray();
    for (let i = 0; i < ks.length; i++) {
      let k = ks[i];
      if (ys.contains(k)) {
        ret.push(k);
      }
    }
    return new CalcitSet(ret);
  }
};

// node_modules/@calcit/procs/lib/js-record.js
var CalcitRecord = class {
  constructor(name, fields, values) {
    this.name = name;
    let fieldNames = fields.map(castKwd);
    this.fields = fields;
    if (values != null) {
      if (values.length !== fields.length) {
        throw new Error("fields/values length not match");
      }
      this.values = values;
    } else {
      this.values = new Array(fieldNames.length);
    }
    this.cachedHash = null;
  }
  get(k) {
    let field = castKwd(k);
    let idx = findInFields(this.fields, field);
    if (idx >= 0) {
      return this.values[idx];
    } else {
      throw new Error(`Cannot find :${field} among (${this.fields.join(",")})`);
    }
  }
  assoc(k, v) {
    let values = new Array(this.fields.length);
    let k_id = castKwd(k);
    for (let idx = 0; idx < this.fields.length; idx++) {
      if (this.fields[idx] === k_id) {
        values[idx] = v;
      } else {
        values[idx] = this.values[idx];
      }
    }
    return new CalcitRecord(this.name, this.fields, values);
  }
  findIndex(k) {
    let field = castKwd(k);
    let idx = findInFields(this.fields, field);
    return idx;
  }
  contains(k) {
    let idx = this.findIndex(k);
    return idx >= 0;
  }
  toString() {
    let ret = "(%{} " + this.name;
    for (let idx = 0; idx < this.fields.length; idx++) {
      ret += " (" + this.fields[idx] + " " + toString(this.values[idx], true) + ")";
    }
    return ret + ")";
  }
};
var new_record = (name, ...fields) => {
  let fieldNames = fields.map(castKwd).sort((x, y) => {
    if (x.idx < y.idx) {
      return -1;
    } else if (x.idx > y.idx) {
      return 1;
    } else {
      throw new Error(`Unexpected duplication in record fields: ${x.toString()}`);
    }
  });
  return new CalcitRecord(castKwd(name), fieldNames);
};
var fieldsEqual = (xs, ys) => {
  if (xs === ys) {
    return true;
  }
  if (xs.length !== ys.length) {
    return false;
  }
  for (let idx = 0; idx < xs.length; idx++) {
    if (xs[idx] !== ys[idx]) {
      return false;
    }
  }
  return true;
};
var _$n__PCT__$M_ = (proto, ...xs) => {
  if (proto instanceof CalcitRecord) {
    if (xs.length % 2 !== 0) {
      throw new Error("Expected even number of key/value");
    }
    if (xs.length !== proto.fields.length * 2) {
      throw new Error("fields size does not match");
    }
    let values = new Array(proto.fields.length);
    for (let i = 0; i < proto.fields.length; i++) {
      let idx = -1;
      let k = proto.fields[i];
      for (let j = 0; j < proto.fields.length; j++) {
        if (k === castKwd(xs[j * 2])) {
          idx = j;
          break;
        }
      }
      if (idx < 0) {
        throw new Error("invalid field name for this record");
      }
      if (values[i] != null) {
        throw new Error("record field already has value, probably duplicated key");
      }
      values[i] = xs[idx * 2 + 1];
    }
    return new CalcitRecord(proto.name, proto.fields, values);
  } else {
    throw new Error("Expected prototype to be a record");
  }
};
var _$n_record_$o_get_name = (x) => {
  if (x instanceof CalcitRecord) {
    return x.name;
  } else {
    throw new Error("Expected a record");
  }
};
var _$n_record_$o_from_map = (proto, data) => {
  if (!(proto instanceof CalcitRecord))
    throw new Error("Expected prototype to be record");
  if (data instanceof CalcitRecord) {
    if (fieldsEqual(proto.fields, data.fields)) {
      return new CalcitRecord(proto.name, proto.fields, data.values);
    } else {
      let values = [];
      for (let field of proto.fields) {
        let idx = findInFields(data.fields, field);
        if (idx < 0) {
          throw new Error(`Cannot find field ${field} among ${data.fields}`);
        }
        values.push(data.values[idx]);
      }
      return new CalcitRecord(proto.name, proto.fields, values);
    }
  } else if (data instanceof CalcitMap || data instanceof CalcitSliceMap) {
    let pairs = [];
    for (let [k, v] of data.pairs()) {
      pairs.push([castKwd(k), v]);
    }
    pairs.sort((pair1, pair2) => pair1[0].cmp(pair2[0]));
    let values = [];
    outerLoop:
      for (let field of proto.fields) {
        for (let idx = 0; idx < pairs.length; idx++) {
          let pair = pairs[idx];
          if (pair[0] === field) {
            values.push(pair[1]);
            continue outerLoop;
          }
        }
        throw new Error(`Cannot find field ${field} among ${pairs}`);
      }
    return new CalcitRecord(proto.name, proto.fields, values);
  } else {
    throw new Error("Expected record or data for making a record");
  }
};
var _$n_record_$o_to_map = (x) => {
  if (x instanceof CalcitRecord) {
    var dict = [];
    for (let idx = 0; idx < x.fields.length; idx++) {
      dict.push(x.fields[idx], x.values[idx]);
    }
    return new CalcitSliceMap(dict);
  } else {
    throw new Error("Expected record");
  }
};
var _$n_record_$o_matches_$q_ = (x, y) => {
  if (!(x instanceof CalcitRecord)) {
    throw new Error("Expected first argument to be record");
  }
  if (!(y instanceof CalcitRecord)) {
    throw new Error("Expected second argument to be record");
  }
  if (x.name !== y.name) {
    return false;
  }
  return fieldsEqual(x.fields, y.fields);
};
function _$n_record_$o_extend_as(obj, new_name, new_key, new_value) {
  if (arguments.length !== 4)
    throw new Error(`Expected 4 arguments, got ${arguments.length}`);
  if (!(obj instanceof CalcitRecord))
    throw new Error("Expected record");
  let field = castKwd(new_key);
  let new_name_kwd = castKwd(new_name);
  let new_fields = [];
  let new_values = [];
  let inserted = false;
  for (let i = 0; i < new_fields.length; i++) {
    let k = new_fields[i];
    if (inserted) {
      new_fields.push(k);
      new_values.push(obj.values[i]);
    } else {
      let ordering = field.cmp(k);
      if (ordering === -1) {
        new_fields.push(field);
        new_values.push(new_value);
        new_fields.push(k);
        new_values.push(obj.values[i]);
      } else if (ordering === 1) {
        new_fields.push(k);
        new_values.push(obj.values[i]);
      } else {
        throw new Error("Does not extend existed record field");
      }
    }
  }
  if (!inserted) {
    new_fields.push(field);
    new_values.push(new_value);
  }
  return new CalcitRecord(new_name_kwd, new_fields, new_values);
}

// node_modules/@calcit/procs/lib/js-tuple.js
var CalcitTuple = class {
  constructor(a2, b) {
    this.fst = a2;
    this.snd = b;
    this.cachedHash = null;
  }
  get(n) {
    if (n === 0) {
      return this.fst;
    } else if (n === 1) {
      return this.snd;
    } else {
      throw new Error("Tuple only have 2 elements");
    }
  }
  assoc(n, v) {
    if (n === 0) {
      return new CalcitTuple(v, this.snd);
    } else if (n === 1) {
      return new CalcitTuple(this.fst, v);
    } else {
      throw new Error("Tuple only have 2 elements");
    }
  }
  toString() {
    return `(&tuple ${this.fst.toString()} ${this.snd.toString()})`;
  }
};

// node_modules/@calcit/procs/lib/js-list.js
var CalcitList = class {
  constructor(value) {
    this.cachedHash = null;
    if (value == null) {
      this.value = initTernaryTreeList([]);
    } else {
      this.value = value;
    }
  }
  len() {
    return listLen(this.value);
  }
  get(idx) {
    if (this.len() === 0) {
      return null;
    }
    return listGet(this.value, idx);
  }
  assoc(idx, v) {
    return new CalcitList(assocList(this.value, idx, v));
  }
  assocBefore(idx, v) {
    return new CalcitList(assocBefore(this.value, idx, v));
  }
  assocAfter(idx, v) {
    return new CalcitList(assocAfter(this.value, idx, v));
  }
  dissoc(idx) {
    return new CalcitList(dissocList(this.value, idx));
  }
  slice(from, to) {
    return new CalcitList(slice(this.value, from, to));
  }
  toString(shorter = false) {
    let result = "";
    for (let item of this.items()) {
      if (shorter && isNestedCalcitData(item)) {
        result = `${result} ${tipNestedCalcitData(item)}`;
      } else {
        result = `${result} ${toString(item, true)}`;
      }
    }
    return `([]${result})`;
  }
  isEmpty() {
    return this.len() === 0;
  }
  items() {
    return listToItems(this.value);
  }
  append(v) {
    return new CalcitList(append(this.value, v));
  }
  prepend(v) {
    return new CalcitList(prepend(this.value, v));
  }
  first() {
    return first(this.value);
  }
  rest() {
    return new CalcitList(rest(this.value));
  }
  concat(ys) {
    if (ys instanceof CalcitSliceList) {
      return new CalcitList(concat(this.value, ys.turnListMode().value));
    } else if (ys instanceof CalcitList) {
      return new CalcitList(concat(this.value, ys.value));
    } else {
      throw new Error(`Unknown data to concat: ${ys}`);
    }
  }
  map(f) {
    return new CalcitList(listMapValues(this.value, f));
  }
  toArray() {
    return [...listToItems(this.value)];
  }
  reverse() {
    return new CalcitList(reverse(this.value));
  }
};
var CalcitSliceList = class {
  constructor(value) {
    if (value == null) {
      value = [];
    }
    this.cachedHash = null;
    this.value = value;
    this.start = 0;
    this.end = value.length;
  }
  turnListMode() {
    return new CalcitList(initTernaryTreeListFromRange(this.value, this.start, this.end));
  }
  len() {
    return this.end - this.start;
  }
  get(idx) {
    return this.value[this.start + idx];
  }
  assoc(idx, v) {
    return this.turnListMode().assoc(idx, v);
  }
  assocBefore(idx, v) {
    return this.turnListMode().assocBefore(idx, v);
  }
  assocAfter(idx, v) {
    if (idx === this.len() - 1) {
      return this.append(v);
    } else {
      return this.turnListMode().assocAfter(idx, v);
    }
  }
  dissoc(idx) {
    if (idx === 0) {
      return this.rest();
    } else if (idx === this.len() - 1) {
      return this.slice(0, idx);
    } else {
      return this.turnListMode().dissoc(idx);
    }
  }
  slice(from, to) {
    if (from < 0) {
      throw new Error(`from index too small: ${from}`);
    }
    if (to > this.len()) {
      throw new Error(`end index too large: ${to}`);
    }
    if (to < from) {
      throw new Error("end index too small");
    }
    let result = new CalcitSliceList(this.value);
    result.start = this.start + from;
    result.end = this.start + to;
    return result;
  }
  toString(shorter = false) {
    let result = "";
    for (let item of this.items()) {
      if (shorter && isNestedCalcitData(item)) {
        result = `${result} ${tipNestedCalcitData(item)}`;
      } else {
        result = `${result} ${toString(item, true)}`;
      }
    }
    return `([]${result})`;
  }
  isEmpty() {
    return this.len() === 0;
  }
  items() {
    return sliceGenerator(this.value, this.start, this.end);
  }
  append(v) {
    if (this.end === this.value.length && this.start < 32) {
      this.value.push(v);
      let newList = new CalcitSliceList(this.value);
      newList.start = this.start;
      newList.end = this.end + 1;
      return newList;
    } else {
      return this.turnListMode().append(v);
    }
  }
  prepend(v) {
    return this.turnListMode().prepend(v);
  }
  first() {
    if (this.value.length > this.start) {
      return this.value[this.start];
    } else {
      return null;
    }
  }
  rest() {
    return this.slice(1, this.end - this.start);
  }
  concat(ys) {
    if (ys instanceof CalcitSliceList) {
      let size = this.end - this.start;
      let otherSize = ys.end - ys.start;
      let combined = new Array(size + otherSize);
      for (let i = 0; i < size; i++) {
        combined[i] = this.get(i);
      }
      for (let i = 0; i < otherSize; i++) {
        combined[i + size] = ys.get(i);
      }
      return new CalcitSliceList(combined);
    } else if (ys instanceof CalcitList) {
      return this.turnListMode().concat(ys);
    } else {
      throw new Error("Expected list");
    }
  }
  map(f) {
    let ys = [];
    for (let x in sliceGenerator(this.value, this.start, this.end)) {
      ys.push(f(x));
    }
    return new CalcitSliceList(ys);
  }
  toArray() {
    return this.value.slice(this.start, this.end);
  }
  reverse() {
    return this.turnListMode().reverse();
  }
};
function* sliceGenerator(xs, start, end) {
  if (xs == null) {
    if (end <= start) {
      throw new Error("invalid list to slice");
    }
  } else {
    for (let idx = start; idx < end; idx++) {
      yield xs[idx];
    }
  }
}
var foldl = function(xs, acc, f) {
  if (arguments.length !== 3) {
    throw new Error("foldl takes 3 arguments");
  }
  if (f == null) {
    throw new Error("Expected function for folding");
  }
  if (xs instanceof CalcitSliceList || xs instanceof CalcitList) {
    var result = acc;
    for (let idx = 0; idx < xs.len(); idx++) {
      let item = xs.get(idx);
      result = f(result, item);
    }
    return result;
  }
  if (xs instanceof CalcitSet) {
    let result2 = acc;
    xs.values().forEach((item) => {
      result2 = f(result2, item);
    });
    return result2;
  }
  if (xs instanceof CalcitSliceMap) {
    let result2 = acc;
    let size = xs.chunk.length >> 1;
    for (let i = 0; i < size; i++) {
      let pos = i << 1;
      result2 = f(result2, new CalcitSliceList([xs.chunk[pos], xs.chunk[pos + 1]]));
    }
    return result2;
  }
  if (xs instanceof CalcitMap) {
    let result2 = acc;
    xs.pairs().forEach((pair) => {
      result2 = f(result2, new CalcitSliceList(pair));
    });
    return result2;
  }
  throw new Error("Unknow data for foldl");
};
var foldl_shortcut = function(xs, acc, v0, f) {
  if (arguments.length !== 4) {
    throw new Error("foldl-shortcut takes 4 arguments");
  }
  if (f == null) {
    throw new Error("Expected function for folding");
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    var state = acc;
    for (let idx = 0; idx < xs.len(); idx++) {
      let item = xs.get(idx);
      let pair = f(state, item);
      if (pair instanceof CalcitTuple) {
        if (typeof pair.fst === "boolean") {
          if (pair.fst) {
            return pair.snd;
          } else {
            state = pair.snd;
          }
        }
      } else {
        throw new Error("Expected return value in `:: bool acc` structure");
      }
    }
    return v0;
  }
  if (xs instanceof CalcitSet) {
    let state2 = acc;
    for (let item of xs.values()) {
      let pair = f(state2, item);
      if (pair instanceof CalcitTuple) {
        if (typeof pair.fst === "boolean") {
          if (pair.fst) {
            return pair.snd;
          } else {
            state2 = pair.snd;
          }
        }
      } else {
        throw new Error("Expected return value in `:: bool acc` structure");
      }
    }
    return v0;
  }
  if (xs instanceof CalcitSliceMap) {
    let state2 = acc;
    let size = xs.chunk.length >> 1;
    for (let i = 0; i < size; i++) {
      let pos = i << 1;
      let pair = f(state2, new CalcitSliceList([xs.chunk[pos], xs.chunk[pos + 1]]));
      if (pair instanceof CalcitTuple) {
        if (typeof pair.fst === "boolean") {
          if (pair.fst) {
            return pair.snd;
          } else {
            state2 = pair.snd;
          }
        }
      } else {
        throw new Error("Expected return value in `:: bool acc` structure");
      }
    }
    return v0;
  }
  if (xs instanceof CalcitMap) {
    let state2 = acc;
    for (let item of xs.pairs()) {
      let pair = f(state2, new CalcitSliceList(item));
      if (pair instanceof CalcitTuple) {
        if (typeof pair.fst === "boolean") {
          if (pair.fst) {
            return pair.snd;
          } else {
            state2 = pair.snd;
          }
        }
      } else {
        throw new Error("Expected return value in `:: bool acc` structure");
      }
    }
    return v0;
  }
  throw new Error("Unknow data for foldl-shortcut");
};
var foldr_shortcut = function(xs, acc, v0, f) {
  if (arguments.length !== 4) {
    throw new Error("foldr-shortcut takes 4 arguments");
  }
  if (f == null) {
    throw new Error("Expected function for folding");
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    var state = acc;
    for (let idx = xs.len() - 1; idx >= 0; idx--) {
      let item = xs.get(idx);
      let pair = f(state, item);
      if (pair instanceof CalcitTuple) {
        if (typeof pair.fst === "boolean") {
          if (pair.fst) {
            return pair.snd;
          } else {
            state = pair.snd;
          }
        }
      } else {
        throw new Error("Expected return value in `:: bool acc` structure");
      }
    }
    return v0;
  }
  throw new Error("Unknow data for foldr-shortcut, expected only list");
};

// node_modules/@calcit/procs/lib/calcit-data.js
var calcit_dirty_hash_key = "_calcit_cached_hash";
var keywordIdx = 0;
var CalcitKeyword = class {
  constructor(x) {
    this.value = x;
    this.idx = keywordIdx;
    keywordIdx++;
    this.cachedHash = null;
  }
  toString() {
    return `:${this.value}`;
  }
  cmp(other) {
    if (this.idx < other.idx) {
      return -1;
    } else if (this.idx > other.idx) {
      return 1;
    } else {
      return 0;
    }
  }
};
var CalcitSymbol = class {
  constructor(x) {
    this.value = x;
    this.cachedHash = null;
  }
  toString() {
    return `'${this.value}`;
  }
};
var CalcitRecur = class {
  constructor(xs) {
    this.args = xs;
    this.cachedHash = null;
  }
  toString() {
    return `(&recur ...)`;
  }
};
var isNestedCalcitData = (x) => {
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    return x.len() > 0;
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    return x.len() > 0;
  }
  if (x instanceof CalcitRecord) {
    return x.fields.length > 0;
  }
  if (x instanceof CalcitSet) {
    return false;
  }
  return false;
};
var tipNestedCalcitData = (x) => {
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    return "'[]...";
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    return "'{}...";
  }
  if (x instanceof CalcitRecord) {
    return "'%{}...";
  }
  if (x instanceof CalcitSet) {
    return "'#{}...";
  }
  return x.toString();
};
var CalcitRef = class {
  constructor(x, path) {
    this.value = x;
    this.path = path;
    this.listeners = /* @__PURE__ */ new Map();
    this.cachedHash = null;
  }
  toString() {
    return `(&ref ${this.value.toString()})`;
  }
};
var getStringName = (x) => {
  if (typeof x === "string") {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return x.value;
  }
  if (x instanceof CalcitSymbol) {
    return x.value;
  }
  throw new Error("Cannot get string as name");
};
function findInFields(xs, y) {
  let lower = 0;
  let upper = xs.length - 1;
  while (upper - lower > 1) {
    let pos = lower + upper >> 1;
    let v = xs[pos];
    if (y.idx < v.idx) {
      upper = pos - 1;
    } else if (y.idx > v.idx) {
      lower = pos + 1;
    } else {
      return pos;
    }
  }
  if (y === xs[lower])
    return lower;
  if (y === xs[upper])
    return upper;
  return -1;
}
var keywordRegistery = {};
var kwd = (content) => {
  let item = keywordRegistery[content];
  if (item != null) {
    return item;
  } else {
    let v = new CalcitKeyword(content);
    keywordRegistery[content] = v;
    return v;
  }
};
var castKwd = (x) => {
  if (x instanceof CalcitKeyword) {
    return x;
  }
  if (typeof x === "string") {
    return kwd(x);
  }
  if (x instanceof CalcitSymbol) {
    return kwd(x.value);
  }
  throw new Error(`Cannot cast this to keyword: ${x}`);
};
var refsRegistry = /* @__PURE__ */ new Map();
var defaultHash_nil = valueHash("nil:");
var defaultHash_number = valueHash("number:");
var defaultHash_string = valueHash("string:");
var defaultHash_keyword = valueHash("keyword:");
var defaultHash_true = valueHash("bool:true");
var defaultHash_false = valueHash("bool:false");
var defaultHash_symbol = valueHash("symbol:");
var defaultHash_fn = valueHash("fn:");
var defaultHash_ref = valueHash("ref:");
var defaultHash_tuple = valueHash("tuple:");
var defaultHash_set = valueHash("set:");
var defaultHash_list = valueHash("list:");
var defaultHash_map = valueHash("map:");
var defaultHash_record = valueHash("record:");
var defaultHash_unknown = valueHash("unknown:");
var fnHashCounter = 0;
var jsObjectHashCounter = 0;
var hashFunction = (x) => {
  if (x == null) {
    return defaultHash_nil;
  }
  if (typeof x === "number") {
    return mergeValueHash(defaultHash_number, x);
  }
  if (typeof x === "string") {
    return mergeValueHash(defaultHash_string, x);
  }
  if (x.cachedHash != null) {
    return x.cachedHash;
  }
  if (x[calcit_dirty_hash_key] != null) {
    return x[calcit_dirty_hash_key];
  }
  if (x instanceof CalcitKeyword) {
    let h = mergeValueHash(defaultHash_keyword, x.idx);
    x.cachedHash = h;
    return h;
  }
  if (x === true) {
    return defaultHash_true;
  }
  if (x === false) {
    return defaultHash_false;
  }
  if (x instanceof CalcitSymbol) {
    let h = mergeValueHash(defaultHash_symbol, x.value);
    x.cachedHash = h;
    return h;
  }
  if (typeof x === "function") {
    fnHashCounter = fnHashCounter + 1;
    let h = mergeValueHash(defaultHash_fn, fnHashCounter);
    x[calcit_dirty_hash_key] = h;
    return h;
  }
  if (x instanceof CalcitRef) {
    let h = mergeValueHash(defaultHash_ref, x.path);
    x.cachedHash = h;
    return h;
  }
  if (x instanceof CalcitTuple) {
    let base = defaultHash_tuple;
    base = mergeValueHash(base, hashFunction(x.fst));
    base = mergeValueHash(base, hashFunction(x.snd));
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitSet) {
    let base = defaultHash_set;
    let values = x.values();
    for (let idx = 0; idx < values.length; idx++) {
      let item = values[idx];
      base = mergeValueHash(base, hashFunction(item));
    }
    return base;
  }
  if (x instanceof CalcitSliceList) {
    let base = defaultHash_list;
    for (let idx = x.start; idx < x.end; idx++) {
      let item = x.value[idx];
      base = mergeValueHash(base, hashFunction(item));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitList) {
    let base = defaultHash_list;
    for (let item of x.items()) {
      base = mergeValueHash(base, hashFunction(item));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitSliceMap) {
    let base = defaultHash_map;
    for (let [k, v] of x.pairs()) {
      base = mergeValueHash(base, hashFunction(k));
      base = mergeValueHash(base, hashFunction(v));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitMap) {
    let base = defaultHash_map;
    for (let [k, v] of x.pairs()) {
      base = mergeValueHash(base, hashFunction(k));
      base = mergeValueHash(base, hashFunction(v));
    }
    x.cachedHash = base;
    return base;
  }
  if (x instanceof CalcitRecord) {
    let base = defaultHash_record;
    for (let idx = 0; idx < x.fields.length; idx++) {
      base = mergeValueHash(base, hashFunction(x.fields[idx]));
      base = mergeValueHash(base, hashFunction(x.values[idx]));
    }
    x.cachedHash = base;
    return base;
  }
  console.warn(`[warn] calcit-js has no method for hashing this: ${x}`);
  let hashJsObject = defaultHash_unknown;
  jsObjectHashCounter = jsObjectHashCounter + 1;
  hashJsObject = mergeValueHash(hashJsObject, jsObjectHashCounter);
  x[calcit_dirty_hash_key] = hashJsObject;
  return hashJsObject;
};
overwriteHashGenerator(hashFunction);
var toString = (x, escaped) => {
  if (x == null) {
    return "nil";
  }
  if (typeof x === "string") {
    if (escaped) {
      if (/[\)\(\s\"]/.test(x)) {
        return JSON.stringify("|" + x);
      } else {
        return "|" + x;
      }
    } else {
      return x;
    }
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  if (typeof x === "function") {
    return `(&fn ...)`;
  }
  if (x instanceof CalcitSymbol) {
    return x.toString();
  }
  if (x instanceof CalcitKeyword) {
    return x.toString();
  }
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    return x.toString();
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    return x.toString();
  }
  if (x instanceof CalcitSet) {
    return x.toString();
  }
  if (x instanceof CalcitRecord) {
    return x.toString();
  }
  if (x instanceof CalcitRef) {
    return x.toString();
  }
  if (x instanceof CalcitTuple) {
    return x.toString();
  }
  console.warn("Unknown structure to string, better use `console.log`", x);
  return `${x}`;
};
var _$n_map_$o_get = function(xs, k) {
  if (arguments.length !== 2) {
    throw new Error("map &get takes 2 arguments");
  }
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap)
    return xs.get(k);
  throw new Error("Does not support `&get` on this type");
};
var _$n__$e_ = (x, y) => {
  if (x === y) {
    return true;
  }
  if (x == null) {
    if (y == null) {
      return true;
    }
    return false;
  }
  let tx = typeof x;
  let ty = typeof y;
  if (tx !== ty) {
    return false;
  }
  if (tx === "string") {
    return x === y;
  }
  if (tx === "boolean") {
    return x === y;
  }
  if (tx === "number") {
    return x === y;
  }
  if (tx === "function") {
    return x === y;
  }
  if (x instanceof CalcitKeyword) {
    if (y instanceof CalcitKeyword) {
      return x === y;
    }
    return false;
  }
  if (x instanceof CalcitSymbol) {
    if (y instanceof CalcitSymbol) {
      return x.value === y.value;
    }
    return false;
  }
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    if (y instanceof CalcitList || y instanceof CalcitSliceList) {
      if (x.len() !== y.len()) {
        return false;
      }
      let size = x.len();
      for (let idx = 0; idx < size; idx++) {
        let xItem = x.get(idx);
        let yItem = y.get(idx);
        if (!_$n__$e_(xItem, yItem)) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    if (y instanceof CalcitMap || y instanceof CalcitSliceMap) {
      if (x.len() !== y.len()) {
        return false;
      }
      for (let [k, v] of x.pairs()) {
        if (!y.contains(k)) {
          return false;
        }
        if (!_$n__$e_(v, _$n_map_$o_get(y, k))) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitRef) {
    if (y instanceof CalcitRef) {
      return x.path === y.path;
    }
    return false;
  }
  if (x instanceof CalcitTuple) {
    if (y instanceof CalcitTuple) {
      return _$n__$e_(x.fst, y.fst) && _$n__$e_(x.snd, y.snd);
    }
    return false;
  }
  if (x instanceof CalcitSet) {
    if (y instanceof CalcitSet) {
      if (x.len() !== y.len()) {
        return false;
      }
      let values = x.values();
      for (let idx = 0; idx < values.length; idx++) {
        let v = values[idx];
        let found = false;
        let yValues = y.values();
        for (let idx2 = 0; idx2 < yValues.length; idx2++) {
          let yv = yValues[idx2];
          if (_$n__$e_(v, yv)) {
            found = true;
            break;
          }
        }
        if (found) {
          continue;
        } else {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  if (x instanceof CalcitRecur) {
    if (y instanceof CalcitRecur) {
      console.warn("Do not compare Recur");
      return false;
    }
    return false;
  }
  if (x instanceof CalcitRecord) {
    if (y instanceof CalcitRecord) {
      if (x.name !== y.name) {
        return false;
      }
      if (!fieldsEqual(x.fields, y.fields)) {
        return false;
      }
      if (x.values.length !== y.values.length) {
        return false;
      }
      for (let idx = 0; idx < x.fields.length; idx++) {
        if (!_$n__$e_(x.values[idx], y.values[idx])) {
          return false;
        }
      }
      return true;
    }
    return false;
  }
  throw new Error("Missing handler for this type");
};
overwriteComparator(_$n__$e_);
overwriteMapComparator(_$n__$e_);
overwriteSetComparator(_$n__$e_);

// node_modules/@calcit/procs/lib/js-cirru.js
var import_writer = __toESM(require_writer());
var to_cirru_edn = (x) => {
  if (x == null) {
    return "nil";
  }
  if (typeof x === "string") {
    return `|${x}`;
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  if (x instanceof CalcitKeyword) {
    return x.toString();
  }
  if (x instanceof CalcitSymbol) {
    return x.toString();
  }
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    return ["[]"].concat(x.toArray().map(to_cirru_edn));
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    let buffer = ["{}"];
    for (let [k, v] of x.pairs()) {
      buffer.push([to_cirru_edn(k), to_cirru_edn(v)]);
    }
    return buffer;
  }
  if (x instanceof CalcitRecord) {
    let buffer = ["%{}", x.name.toString()];
    for (let idx = 0; idx < x.fields.length; idx++) {
      buffer.push([x.fields[idx].toString(), to_cirru_edn(x.values[idx])]);
    }
    return buffer;
  }
  if (x instanceof CalcitSet) {
    let buffer = ["#{}"];
    let values = x.values();
    for (let idx = 0; idx < values.length; idx++) {
      let y = values[idx];
      buffer.push(to_cirru_edn(y));
    }
    return buffer;
  }
  if (x instanceof CalcitTuple) {
    if (x.fst instanceof CalcitSymbol && x.fst.value === "quote") {
      return ["quote", toWriterNode(x.snd)];
    } else if (x.fst instanceof CalcitRecord) {
      return ["::", x.fst.name.toString(), to_cirru_edn(x.snd)];
    } else {
      throw new Error(`Unsupported tag for EDN: ${x.fst}`);
    }
  }
  console.error(x);
  throw new Error("Unexpected data to to-cirru-edn");
};
var format_cirru_edn = (data, useInline = true) => {
  if (data == null) {
    return "\ndo nil\n";
  }
  if (typeof data === "string") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (typeof data === "boolean") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (typeof data === "string") {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (data instanceof CalcitSymbol) {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  if (data instanceof CalcitKeyword) {
    return "\ndo " + to_cirru_edn(data) + "\n";
  }
  return (0, import_writer.writeCirruCode)([to_cirru_edn(data)], { useInline });
};
var to_calcit_data = (x, noKeyword = false) => {
  if (x == null)
    return null;
  if (typeof x === "number")
    return x;
  if (typeof x === "string") {
    if (!noKeyword && x[0] === ":" && x.slice(1).match(/^[\w\d_\?\!\-]+$/)) {
      return kwd(x.slice(1));
    }
    return x;
  }
  if (x === true || x === false)
    return x;
  if (typeof x === "function")
    return x;
  if (Array.isArray(x)) {
    var result = [];
    x.forEach((v) => {
      result.push(to_calcit_data(v, noKeyword));
    });
    return new CalcitSliceList(result);
  }
  if (x instanceof Set) {
    let result2 = [];
    x.forEach((v) => {
      result2.push(to_calcit_data(v, noKeyword));
    });
    return new CalcitSet(result2);
  }
  if (x instanceof CalcitList || x instanceof CalcitSliceList)
    return x;
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap)
    return x;
  if (x instanceof CalcitSet)
    return x;
  if (x instanceof CalcitRecord)
    return x;
  if (x instanceof CalcitRecur)
    return x;
  if (x instanceof CalcitRef)
    return x;
  if (x instanceof CalcitKeyword)
    return x;
  if (x instanceof CalcitSymbol)
    return x;
  if (x instanceof CalcitTuple)
    return x;
  if (x === Object(x)) {
    let result2 = [];
    Object.keys(x).forEach((k) => {
      result2.push(to_calcit_data(k, noKeyword), to_calcit_data(x[k], noKeyword));
    });
    return new CalcitSliceMap(result2);
  }
  console.error(x);
  throw new Error("Unexpected data for converting");
};
var toWriterNode = (xs) => {
  if (typeof xs === "string") {
    return xs;
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    return xs.toArray().map(toWriterNode);
  } else {
    throw new Error("Unexpected type for CirruWriteNode");
  }
};

// node_modules/@calcit/procs/lib/calcit.procs.js
var _a;
var calcit_version = "0.5.16";
var inNodeJs = typeof process !== "undefined" && ((_a = process === null || process === void 0 ? void 0 : process.release) === null || _a === void 0 ? void 0 : _a.name) === "node";
var type_of = (x) => {
  if (typeof x === "string") {
    return kwd("string");
  }
  if (typeof x === "number") {
    return kwd("number");
  }
  if (x instanceof CalcitKeyword) {
    return kwd("keyword");
  }
  if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    return kwd("list");
  }
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap) {
    return kwd("map");
  }
  if (x == null) {
    return kwd("nil");
  }
  if (x instanceof CalcitRef) {
    return kwd("ref");
  }
  if (x instanceof CalcitTuple) {
    return kwd("tuple");
  }
  if (x instanceof CalcitSymbol) {
    return kwd("symbol");
  }
  if (x instanceof CalcitSet) {
    return kwd("set");
  }
  if (x instanceof CalcitRecord) {
    return kwd("record");
  }
  if (x === true || x === false) {
    return kwd("bool");
  }
  if (typeof x === "function") {
    if (x.isMacro) {
      return kwd("macro");
    }
    return kwd("fn");
  }
  if (typeof x === "object") {
    return kwd("js-object");
  }
  throw new Error(`Unknown data ${x}`);
};
function _$n_list_$o_count(x) {
  if (x instanceof CalcitList || x instanceof CalcitSliceList)
    return x.len();
  throw new Error(`expected a list ${x}`);
}
function _$n_str_$o_count(x) {
  if (typeof x === "string")
    return x.length;
  throw new Error(`expected a string ${x}`);
}
function _$n_map_$o_count(x) {
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap)
    return x.len();
  throw new Error(`expected a map ${x}`);
}
function _$n_record_$o_count(x) {
  if (x instanceof CalcitRecord)
    return x.fields.length;
  throw new Error(`expected a record ${x}`);
}
function _$n_set_$o_count(x) {
  if (x instanceof CalcitSet)
    return x.len();
  throw new Error(`expected a set ${x}`);
}
var _$L_ = (...xs) => {
  return new CalcitSliceList(xs);
};
var _$n__$M_ = (...xs) => {
  if (xs.length % 2 !== 0) {
    throw new Error("&map expects even number of arguments");
  }
  return new CalcitSliceMap(xs);
};
var defatom = (path, x) => {
  let v = new CalcitRef(x, path);
  refsRegistry.set(path, v);
  return v;
};
var peekDefatom = (path) => {
  return refsRegistry.get(path);
};
var deref = (x) => {
  let a2 = refsRegistry.get(x.path);
  if (!(a2 instanceof CalcitRef)) {
    console.warn("Can not find ref:", x);
  }
  return a2.value;
};
var _$n__ADD_ = (x, y) => {
  return x + y;
};
var _$n__$s_ = (x, y) => {
  return x * y;
};
var _$n_str_$o_contains_$q_ = (xs, x) => {
  if (typeof xs === "string") {
    if (typeof x != "number") {
      throw new Error("Expected number index for detecting");
    }
    let size = xs.length;
    if (x >= 0 && x < size) {
      return true;
    }
    return false;
  }
  throw new Error("string `contains?` expected a string");
};
var _$n_list_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (typeof x != "number") {
      throw new Error("Expected number index for detecting");
    }
    let size = xs.len();
    if (x >= 0 && x < size) {
      return true;
    }
    return false;
  }
  throw new Error("list `contains?` expected a list");
};
var _$n_map_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap)
    return xs.contains(x);
  throw new Error("map `contains?` expected a map");
};
var _$n_record_$o_contains_$q_ = (xs, x) => {
  if (xs instanceof CalcitRecord)
    return xs.contains(x);
  throw new Error("record `contains?` expected a record");
};
var _$n_str_$o_includes_$q_ = (xs, x) => {
  if (typeof xs === "string") {
    if (typeof x !== "string") {
      throw new Error("Expected string");
    }
    return xs.includes(x);
  }
  throw new Error("string includes? expected a string");
};
var _$n_list_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    let size = xs.len();
    for (let v of xs.items()) {
      if (_$n__$e_(v, x)) {
        return true;
      }
    }
    return false;
  }
  throw new Error("list includes? expected a list");
};
var _$n_map_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap) {
    for (let [k, v] of xs.pairs()) {
      if (_$n__$e_(v, x)) {
        return true;
      }
    }
    return false;
  }
  throw new Error("map includes? expected a map");
};
var _$n_set_$o_includes_$q_ = (xs, x) => {
  if (xs instanceof CalcitSet) {
    return xs.contains(x);
  }
  throw new Error("set includes? expected a set");
};
var _$n_str_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (typeof xs === "string")
    return xs[k];
  throw new Error("Does not support `nth` on this type");
};
var _$n_list_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList)
    return xs.get(k);
  throw new Error("Does not support `nth` on this type");
};
var _$n_tuple_$o_nth = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("nth takes 2 arguments");
  if (typeof k !== "number")
    throw new Error("Expected number index for a list");
  if (xs instanceof CalcitTuple)
    return xs.get(k);
  throw new Error("Does not support `nth` on this type");
};
var _$n_record_$o_get = function(xs, k) {
  if (arguments.length !== 2) {
    throw new Error("record &get takes 2 arguments");
  }
  if (xs instanceof CalcitRecord)
    return xs.get(k);
  throw new Error("Does not support `&get` on this type");
};
var _$n_list_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assoc(k, v);
  }
  throw new Error("list `assoc` expected a list");
};
var _$n_tuple_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitTuple) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assoc(k, v);
  }
  throw new Error("tuple `assoc` expected a tuple");
};
var _$n_map_$o_assoc = function(xs, ...args2) {
  if (arguments.length < 3)
    throw new Error("assoc takes at least 3 arguments");
  if (args2.length % 2 !== 0)
    throw new Error("assoc expected odd arguments");
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap)
    return xs.assoc(...args2);
  throw new Error("map `assoc` expected a map");
};
var _$n_record_$o_assoc = function(xs, k, v) {
  if (arguments.length !== 3)
    throw new Error("assoc takes 3 arguments");
  if (xs instanceof CalcitRecord)
    return xs.assoc(k, v);
  throw new Error("record `assoc` expected a record");
};
var _$n_list_$o_assoc_before = function(xs, k, v) {
  if (arguments.length !== 3) {
    throw new Error("assoc takes 3 arguments");
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assocBefore(k, v);
  }
  throw new Error("Does not support `assoc-before` on this type");
};
var _$n_list_$o_assoc_after = function(xs, k, v) {
  if (arguments.length !== 3) {
    throw new Error("assoc takes 3 arguments");
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (typeof k !== "number") {
      throw new Error("Expected number index for lists");
    }
    return xs.assocAfter(k, v);
  }
  throw new Error("Does not support `assoc-after` on this type");
};
var _$n_list_$o_dissoc = function(xs, k) {
  if (arguments.length !== 2)
    throw new Error("dissoc takes 2 arguments");
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (typeof k !== "number")
      throw new Error("Expected number index for lists");
    return xs.dissoc(k);
  }
  throw new Error("`dissoc` expected a list");
};
var _$n_map_$o_dissoc = function(xs, ...args2) {
  if (args2.length < 1)
    throw new Error("dissoc takes at least 2 arguments");
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap) {
    return xs.dissoc(...args2);
  }
  throw new Error("`dissoc` expected a map");
};
var reset_$x_ = (a2, v) => {
  if (!(a2 instanceof CalcitRef)) {
    throw new Error("Expected ref for reset!");
  }
  let prev = a2.value;
  a2.value = v;
  for (let [k, f] of a2.listeners) {
    f(v, prev);
  }
  return null;
};
function _$n_list_$o_empty_$q_(xs) {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList)
    return xs.isEmpty();
  throw new Error(`expected a list ${xs}`);
}
function _$n_str_$o_empty_$q_(xs) {
  if (typeof xs === "string")
    return xs.length === 0;
  throw new Error(`expected a string ${xs}`);
}
function _$n_map_$o_empty_$q_(xs) {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap)
    return xs.isEmpty();
  throw new Error(`expected a list ${xs}`);
}
function _$n_set_$o_empty_$q_(xs) {
  if (xs instanceof CalcitSet)
    return xs.len() === 0;
  throw new Error(`expected a list ${xs}`);
}
var _$n_list_$o_first = (xs) => {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (xs.isEmpty()) {
      return null;
    }
    return xs.first();
  }
  console.error(xs);
  throw new Error("Expected a list");
};
var _$n_str_$o_first = (xs) => {
  if (typeof xs === "string") {
    return xs[0];
  }
  console.error(xs);
  throw new Error("Expected a string");
};
var _$n_map_$o_first = (xs) => {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap) {
    let ys = xs.pairs();
    if (ys.length > 0) {
      return new CalcitSliceList(ys[0]);
    } else {
      return null;
    }
  }
  console.error(xs);
  throw new Error("Expected a map");
};
var _$n_set_$o_first = (xs) => {
  if (xs instanceof CalcitSet) {
    return xs.first();
  }
  console.error(xs);
  throw new Error("Expected a set");
};
var _$n_list_$o_rest = (xs) => {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (xs.len() === 0) {
      return null;
    }
    return xs.rest();
  }
  console.error(xs);
  throw new Error("Expected a list");
};
var _$n_str_$o_rest = (xs) => {
  if (typeof xs === "string")
    return xs.substr(1);
  console.error(xs);
  throw new Error("Expects a string");
};
var _$n_set_$o_rest = (xs) => {
  if (xs instanceof CalcitSet)
    return xs.rest();
  console.error(xs);
  throw new Error("Expect a set");
};
var _$n_map_$o_rest = (xs) => {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap) {
    if (xs.len() > 0) {
      let k0 = xs.pairs()[0][0];
      return xs.dissoc(k0);
    } else {
      return new CalcitSliceMap([]);
    }
  }
  console.error(xs);
  throw new Error("Expected map");
};
var recur = (...xs) => {
  return new CalcitRecur(xs);
};
var not = (x) => {
  return !x;
};
var prepend2 = (xs, v) => {
  if (!(xs instanceof CalcitList || xs instanceof CalcitSliceList)) {
    throw new Error("Expected array");
  }
  return xs.prepend(v);
};
var append2 = (xs, v) => {
  if (!(xs instanceof CalcitList || xs instanceof CalcitSliceList)) {
    throw new Error("Expected array");
  }
  return xs.append(v);
};
var butlast = (xs) => {
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    if (xs.len() === 0) {
      return null;
    }
    return xs.slice(0, xs.len() - 1);
  }
  if (typeof xs === "string") {
    return xs.substr(0, xs.length - 1);
  }
  console.error(xs);
  throw new Error("Data not ready for butlast");
};
var _SHA__$M_ = (...xs) => {
  var result = [];
  for (let idx = 0; idx < xs.length; idx++) {
    result.push(xs[idx]);
  }
  return new CalcitSet(result);
};
var _$n_list_$o_slice = (xs, from, to) => {
  if (xs == null) {
    return null;
  }
  let size = xs.len();
  if (to == null) {
    to = size;
  } else if (to <= from) {
    return new CalcitSliceList([]);
  } else if (to > size) {
    to = size;
  }
  return xs.slice(from, to);
};
var _$n_list_$o_concat = (...lists) => {
  let result = new CalcitSliceList([]);
  for (let item of lists) {
    if (item == null) {
      continue;
    }
    if (item instanceof CalcitList || item instanceof CalcitSliceList) {
      if (result.isEmpty()) {
        result = item;
      } else {
        result = result.concat(item);
      }
    } else {
      throw new Error("Expected list for concatenation");
    }
  }
  return result;
};
var _$n_list_$o_reverse = (xs) => {
  if (xs == null) {
    return null;
  }
  return xs.reverse();
};
var _$n__GT_ = (a2, b) => {
  return a2 > b;
};
var _$n__LT_ = (a2, b) => {
  return a2 < b;
};
var _$n__ = (a2, b) => {
  return a2 - b;
};
var _$n_number_$o_rem = (a2, b) => {
  return a2 % b;
};
var round_$q_ = (a2) => {
  return a2 === Math.round(a2);
};
var _$n_str_$o_concat = (a2, b) => {
  let buffer = "";
  if (a2 != null) {
    buffer += toString(a2, false);
  }
  if (b != null) {
    buffer += toString(b, false);
  }
  return buffer;
};
var sort = (xs, f) => {
  if (xs == null) {
    return null;
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    let ys = xs.toArray();
    return new CalcitSliceList(ys.sort(f));
  }
  throw new Error("Expected list");
};
var floor = (n) => {
  return Math.floor(n);
};
var _$n_merge = (a2, b) => {
  if (a2 == null) {
    return b;
  }
  if (b == null) {
    return a2;
  }
  if (a2 instanceof CalcitMap || a2 instanceof CalcitSliceMap) {
    if (b instanceof CalcitMap || b instanceof CalcitSliceMap) {
      return a2.merge(b);
    } else {
      throw new Error("Expected an argument of map");
    }
  }
  if (a2 instanceof CalcitRecord) {
    if (b instanceof CalcitMap || b instanceof CalcitSliceMap) {
      let values = [];
      for (let item of a2.values) {
        values.push(item);
      }
      for (let [k, v] of b.pairs()) {
        let field;
        if (k instanceof CalcitKeyword) {
          field = k;
        } else {
          field = kwd(getStringName(k));
        }
        let idx = a2.findIndex(field);
        if (idx >= 0) {
          values[idx] = v;
        } else {
          throw new Error(`Cannot find field ${field} among (${a2.fields.join(", ")})`);
        }
      }
      return new CalcitRecord(a2.name, a2.fields, values);
    }
  }
  throw new Error("Expected map or record");
};
var to_pairs = (xs) => {
  if (xs instanceof CalcitMap || xs instanceof CalcitSliceMap) {
    let result = [];
    for (let [k, v] of xs.pairs()) {
      result.push(new CalcitSliceList([k, v]));
    }
    return new CalcitSet(result);
  } else if (xs instanceof CalcitRecord) {
    let arr_result = [];
    for (let idx = 0; idx < xs.fields.length; idx++) {
      arr_result.push(new CalcitSliceList([xs.fields[idx], xs.values[idx]]));
    }
    return new CalcitSet(arr_result);
  } else {
    throw new Error("Expected a map");
  }
};
var pow = (n, m) => {
  return Math.pow(n, m);
};
var ceil = (n) => {
  return Math.ceil(n);
};
var round = (n) => {
  return Math.round(n);
};
var _$n_number_$o_fract = (n) => {
  return n - Math.floor(n);
};
var sqrt = (n) => {
  return Math.sqrt(n);
};
var _$n_include = (xs, y) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (y == null) {
    return xs;
  }
  return xs.include(y);
};
var _$n_exclude = (xs, y) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (y == null) {
    return xs;
  }
  return xs.exclude(y);
};
var _$n_difference = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.difference(ys);
};
var _$n_union = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.union(ys);
};
var _$n_set_$o_intersection = (xs, ys) => {
  if (!(xs instanceof CalcitSet)) {
    throw new Error("Expected a set");
  }
  if (!(ys instanceof CalcitSet)) {
    throw new Error("Expected a set for ys");
  }
  return xs.intersection(ys);
};
var _$n_str_$o_replace = (x, y, z) => {
  var result = x;
  while (result.indexOf(y) >= 0) {
    result = result.replace(y, z);
  }
  return result;
};
var split = (xs, x) => {
  return new CalcitSliceList(xs.split(x));
};
var split_lines = (xs) => {
  return new CalcitSliceList(xs.split("\n"));
};
var _$n_str_$o_slice = (xs, m, n) => {
  if (n <= m) {
    console.warn("endIndex too small");
    return "";
  }
  return xs.substring(m, n);
};
var _$n_str_$o_find_index = (x, y) => {
  return x.indexOf(y);
};
var parse_float = (x) => {
  return parseFloat(x);
};
var trim = (x, c) => {
  if (c != null) {
    if (c.length !== 1) {
      throw new Error("Expceted c of a character");
    }
    var buffer = x;
    var size = buffer.length;
    var idx = 0;
    while (idx < size && buffer[idx] === c) {
      idx = idx + 1;
    }
    buffer = buffer.substring(idx);
    var size = buffer.length;
    var idx = size;
    while (idx > 1 && buffer[idx - 1] === c) {
      idx = idx - 1;
    }
    buffer = buffer.substring(0, idx);
    return buffer;
  }
  return x.trim();
};
var _$n_number_$o_format = (x, n) => {
  return x.toFixed(n);
};
var get_char_code = (c) => {
  if (typeof c !== "string" || c.length !== 1) {
    throw new Error("Expected a character");
  }
  return c.charCodeAt(0);
};
var _$n_set_$o_to_list = (x) => {
  return new CalcitSliceList(x.values());
};
var aget = (x, name) => {
  return x[name];
};
var turn_keyword = (x) => {
  if (typeof x === "string") {
    return kwd(x);
  }
  if (x instanceof CalcitKeyword) {
    return x;
  }
  if (x instanceof CalcitSymbol) {
    return kwd(x.value);
  }
  console.error(x);
  throw new Error("Unexpected data for keyword");
};
var turn_symbol = (x) => {
  if (typeof x === "string") {
    return new CalcitSymbol(x);
  }
  if (x instanceof CalcitSymbol) {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return new CalcitSymbol(x.value);
  }
  console.error(x);
  throw new Error("Unexpected data for symbol");
};
var pr_str = (...args2) => {
  return args2.map((x) => toString(x, true)).join(" ");
};
var printable = (...args2) => {
  return args2.map((x) => toString(x, false)).join(" ");
};
var quit_$x_ = () => {
  if (inNodeJs) {
    process.exit(1);
  } else {
    throw new Error("quit!()");
  }
};
var turn_string = (x) => {
  if (x == null) {
    return "";
  }
  if (typeof x === "string") {
    return x;
  }
  if (x instanceof CalcitKeyword) {
    return x.value;
  }
  if (x instanceof CalcitSymbol) {
    return x.value;
  }
  if (typeof x === "number") {
    return x.toString();
  }
  if (typeof x === "boolean") {
    return x.toString();
  }
  console.error(x);
  throw new Error("Unexpected data to turn string");
};
var starts_with_$q_ = (xs, y) => {
  if (typeof xs === "string" && typeof y === "string") {
    return xs.startsWith(y);
  }
  if (xs instanceof CalcitKeyword && y instanceof CalcitKeyword) {
    return xs.value.startsWith(y.value);
  }
  throw new Error("expected strings or keywords");
};
var ends_with_$q_ = (xs, y) => {
  return xs.endsWith(y);
};
var blank_$q_ = (x) => {
  if (x == null) {
    return true;
  }
  if (typeof x === "string") {
    return x.trim() === "";
  } else {
    throw new Error("Expected a string");
  }
};
var arrayToList = (xs) => {
  return new CalcitSliceList(xs !== null && xs !== void 0 ? xs : []);
};
var listToArray = (xs) => {
  if (xs == null) {
    return null;
  }
  if (xs instanceof CalcitList || xs instanceof CalcitSliceList) {
    return xs.toArray();
  } else {
    throw new Error("Expected list");
  }
};
var number_$q_ = (x) => {
  return typeof x === "number";
};
var string_$q_ = (x) => {
  return typeof x === "string";
};
var bool_$q_ = (x) => {
  return typeof x === "boolean";
};
var nil_$q_ = (x) => {
  return x == null;
};
var keyword_$q_ = (x) => {
  return x instanceof CalcitKeyword;
};
var map_$q_ = (x) => {
  return x instanceof CalcitSliceMap || x instanceof CalcitMap;
};
var list_$q_ = (x) => {
  return x instanceof CalcitSliceList || x instanceof CalcitList;
};
var set_$q_ = (x) => {
  return x instanceof CalcitSet;
};
var fn_$q_ = (x) => {
  return typeof x === "function";
};
var record_$q_ = (x) => {
  return x instanceof CalcitRecord;
};
var tuple_$q_ = (x) => {
  return x instanceof CalcitTuple;
};
var _$n_str_$o_escape = (x) => JSON.stringify(x);
var format_to_lisp = (x) => {
  if (x == null) {
    return "nil";
  } else if (x instanceof CalcitSymbol) {
    return x.value;
  } else if (x instanceof CalcitList || x instanceof CalcitSliceList) {
    let chunk = "(";
    for (let item of x.items()) {
      if (chunk != "(") {
        chunk += " ";
      }
      chunk += format_to_lisp(item);
    }
    chunk += ")";
    return chunk;
  } else if (typeof x === "string") {
    return JSON.stringify("|" + x);
  } else {
    return x.toString();
  }
};
var js_array = (...xs) => {
  return xs;
};
var _$n_js_object = (...xs) => {
  if (xs.length % 2 !== 0) {
    throw new Error("&js-object expects even number of arguments");
  }
  var ret = {};
  let halfLength = xs.length >> 1;
  for (let idx = 0; idx < halfLength; idx++) {
    let k = xs[idx << 1];
    let v = xs[(idx << 1) + 1];
    if (typeof k === "string") {
      ret[k] = v;
    } else if (k instanceof CalcitKeyword) {
      ret[turn_string(k)] = v;
    } else {
      throw new Error("Invalid key for js Object");
    }
  }
  return ret;
};
var _$o__$o_ = (a2, b) => {
  return new CalcitTuple(a2, b);
};
var calcit_builtin_classes = {
  number: null,
  string: null,
  set: null,
  list: null,
  map: null,
  record: null,
  nil: null,
  fn: null
};
var register_calcit_builtin_classes = (options) => {
  Object.assign(calcit_builtin_classes, options);
};
function invoke_method(p) {
  return (obj, ...args2) => {
    let klass;
    let value = obj;
    if (obj == null) {
      klass = calcit_builtin_classes.nil;
    } else if (obj instanceof CalcitTuple) {
      if (obj.fst instanceof CalcitRecord) {
        klass = obj.fst;
      } else {
        throw new Error("Method invoking expected a record as class");
      }
    } else if (typeof obj === "number") {
      klass = calcit_builtin_classes.number;
    } else if (typeof obj === "string") {
      klass = calcit_builtin_classes.string;
    } else if (typeof obj === "function") {
      klass = calcit_builtin_classes.fn;
    } else if (obj instanceof CalcitSet) {
      klass = calcit_builtin_classes.set;
    } else if (obj instanceof CalcitList || obj instanceof CalcitSliceList) {
      klass = calcit_builtin_classes.list;
    } else if (obj instanceof CalcitRecord) {
      klass = calcit_builtin_classes.record;
    } else if (obj instanceof CalcitMap || obj instanceof CalcitSliceMap) {
      klass = calcit_builtin_classes.map;
    } else {
      if (obj[p] == null) {
        throw new Error(`Missing method \`${p}\` on object`);
      }
      return obj[p](...args2);
    }
    if (klass == null)
      throw new Error("Cannot find class for this object for invoking");
    if (!klass.contains(p))
      throw new Error(`Missing method '${p}' for object: ${obj}`);
    let method = klass.get(p);
    if (typeof method === "function") {
      return method(value, ...args2);
    } else {
      throw new Error("Method for invoking is not a function");
    }
  };
}
var _$n_map_$o_to_list = (m) => {
  if (m instanceof CalcitMap || m instanceof CalcitSliceMap) {
    let ys = [];
    for (let pair of m.pairs()) {
      ys.push(new CalcitSliceList(pair));
    }
    return new CalcitSliceList(ys);
  } else {
    throw new Error("&map:to-list expected a Map");
  }
};
var PseudoTypeIndex;
(function(PseudoTypeIndex2) {
  PseudoTypeIndex2[PseudoTypeIndex2["nil"] = 0] = "nil";
  PseudoTypeIndex2[PseudoTypeIndex2["bool"] = 1] = "bool";
  PseudoTypeIndex2[PseudoTypeIndex2["number"] = 2] = "number";
  PseudoTypeIndex2[PseudoTypeIndex2["symbol"] = 3] = "symbol";
  PseudoTypeIndex2[PseudoTypeIndex2["keyword"] = 4] = "keyword";
  PseudoTypeIndex2[PseudoTypeIndex2["string"] = 5] = "string";
  PseudoTypeIndex2[PseudoTypeIndex2["ref"] = 6] = "ref";
  PseudoTypeIndex2[PseudoTypeIndex2["tuple"] = 7] = "tuple";
  PseudoTypeIndex2[PseudoTypeIndex2["recur"] = 8] = "recur";
  PseudoTypeIndex2[PseudoTypeIndex2["list"] = 9] = "list";
  PseudoTypeIndex2[PseudoTypeIndex2["set"] = 10] = "set";
  PseudoTypeIndex2[PseudoTypeIndex2["map"] = 11] = "map";
  PseudoTypeIndex2[PseudoTypeIndex2["record"] = 12] = "record";
  PseudoTypeIndex2[PseudoTypeIndex2["fn"] = 13] = "fn";
})(PseudoTypeIndex || (PseudoTypeIndex = {}));
var typeAsInt = (x) => {
  if (x == null)
    return PseudoTypeIndex.nil;
  let t = typeof x;
  if (t === "boolean")
    return PseudoTypeIndex.bool;
  if (t === "number")
    return PseudoTypeIndex.number;
  if (x instanceof CalcitSymbol)
    return PseudoTypeIndex.symbol;
  if (x instanceof CalcitKeyword)
    return PseudoTypeIndex.keyword;
  if (t === "string")
    return PseudoTypeIndex.string;
  if (x instanceof CalcitRef)
    return PseudoTypeIndex.ref;
  if (x instanceof CalcitTuple)
    return PseudoTypeIndex.tuple;
  if (x instanceof CalcitRecur)
    return PseudoTypeIndex.recur;
  if (x instanceof CalcitList || x instanceof CalcitSliceList)
    return PseudoTypeIndex.list;
  if (x instanceof CalcitSet)
    return PseudoTypeIndex.set;
  if (x instanceof CalcitMap || x instanceof CalcitSliceMap)
    return PseudoTypeIndex.map;
  if (x instanceof CalcitRecord)
    return PseudoTypeIndex.record;
  if (t === "function")
    return PseudoTypeIndex.fn;
  throw new Error("unknown type to compare");
};
var rawCompare = (x, y) => {
  if (x < y) {
    return -1;
  } else if (x > y) {
    return 1;
  } else {
    return 0;
  }
};
var _$n_compare = (a2, b) => {
  if (a2 === b)
    return 0;
  let ta = typeAsInt(a2);
  let tb = typeAsInt(b);
  if (ta === tb) {
    switch (ta) {
      case PseudoTypeIndex.nil:
        return 0;
      case PseudoTypeIndex.bool:
        return rawCompare(a2, b);
      case PseudoTypeIndex.number:
        return rawCompare(a2, b);
      case PseudoTypeIndex.keyword:
        return a2.cmp(b);
      case PseudoTypeIndex.symbol:
        return rawCompare(a2, b);
      case PseudoTypeIndex.string:
        return rawCompare(a2, b);
      case PseudoTypeIndex.ref:
        return rawCompare(a2.path, b.path);
      default:
        if (a2 < b) {
          return -1;
        } else if (a2 > b) {
          return 1;
        } else {
          return 0;
        }
    }
  } else {
    return rawCompare(ta, tb);
  }
};
var _$n_map_$o_diff_new = (a2, b) => {
  if ((a2 instanceof CalcitMap || a2 instanceof CalcitSliceMap) && (b instanceof CalcitMap || b instanceof CalcitSliceMap)) {
    return a2.diffNew(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_map_$o_diff_keys = (a2, b) => {
  if ((a2 instanceof CalcitMap || a2 instanceof CalcitSliceMap) && (b instanceof CalcitMap || b instanceof CalcitSliceMap)) {
    return a2.diffKeys(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_map_$o_common_keys = (a2, b) => {
  if ((a2 instanceof CalcitMap || a2 instanceof CalcitSliceMap) && (b instanceof CalcitMap || b instanceof CalcitSliceMap)) {
    return a2.commonKeys(b);
  } else {
    throw new Error("expected 2 maps");
  }
};
var _$n_list_$o_to_set = (xs) => {
  var result = [];
  let data = xs.toArray();
  for (let idx = 0; idx < data.length; idx++) {
    result.push(data[idx]);
  }
  return new CalcitSet(result);
};
var _$n_str_$o_pad_left = (s, size, pattern) => {
  return s.padStart(size, pattern);
};
var _$n_str_$o_pad_right = (s, size, pattern) => {
  return s.padEnd(size, pattern);
};

// server-out/calcit.core.js
var _kwd = {};
["&core-fn-class", "call", "call-args", "map", "bind", "mappend", "apply", "call", "call-args", "map", "bind", "mappend", "apply", "&core-list-class", "any?", "add", "append", "assoc", "assoc-after", "assoc-before", "bind", "butlast", "concat", "contains?", "includes?", "count", "drop", "each", "empty", "empty?", "filter", "filter-not", "find", "find-index", "find-last", "find-last-index", "foldl", "get", "get-in", "group-by", "index-of", "join", "join-str", "last-index-of", "map", "map-indexed", "mappend", "max", "min", "nth", "pairs-map", "prepend", "reduce", "reverse", "slice", "sort", "sort-by", "take", "take-last", "to-set", "first", "rest", "dissoc", "to-list", "map-pair", "filter-pair", "apply", "flatten", "any?", "add", "append", "assoc", "assoc-after", "assoc-before", "bind", "butlast", "concat", "contains?", "includes?", "count", "drop", "each", "empty", "empty?", "filter", "filter-not", "find", "find-index", "find-last", "find-last-index", "foldl", "get", "get-in", "group-by", "index-of", "join", "join-str", "last-index-of", "map", "map-indexed", "mappend", "max", "min", "nth", "pairs-map", "prepend", "reduce", "reverse", "slice", "sort", "sort-by", "take", "take-last", "to-set", "first", "rest", "dissoc", "to-list", "map-pair", "filter-pair", "apply", "flatten", "&core-map-class", "add", "assoc", "contains?", "count", "dissoc", "empty", "empty?", "filter", "filter-kv", "get", "get-in", "includes?", "keys", "map", "map-kv", "map-list", "mappend", "merge", "to-list", "to-pairs", "values", "first", "rest", "diff-new", "diff-keys", "common-keys", "to-map", "add", "assoc", "contains?", "count", "dissoc", "empty", "empty?", "filter", "filter-kv", "get", "get-in", "includes?", "keys", "map", "map-kv", "map-list", "mappend", "merge", "to-list", "to-pairs", "values", "first", "rest", "diff-new", "diff-keys", "common-keys", "to-map", "&core-nil-class", "to-list", "to-map", "pairs-map", "to-set", "to-string", "to-number", "map", "filter", "bind", "mappend", "apply", "to-list", "to-map", "pairs-map", "to-set", "to-string", "to-number", "map", "filter", "bind", "mappend", "apply", "&core-number-class", "ceil", "empty", "floor", "format", "inc", "pow", "round", "round?", "fract", "sqrt", "negate", "rem", "ceil", "empty", "floor", "format", "inc", "pow", "round", "round?", "fract", "sqrt", "negate", "rem", "&core-record-class", "get", "get-name", "matches?", "to-map", "count", "contains?", "assoc", "from-map", "extend-as", "get", "get-name", "matches?", "to-map", "count", "contains?", "assoc", "from-map", "extend-as", "&core-set-class", "add", "count", "difference", "exclude", "empty", "empty?", "filter", "include", "includes?", "contains?", "intersection", "max", "min", "to-list", "union", "first", "rest", "to-set", "mappend", "add", "count", "difference", "exclude", "empty", "empty?", "filter", "include", "includes?", "contains?", "intersection", "max", "min", "to-list", "union", "first", "rest", "to-set", "mappend", "&core-string-class", "blank?", "count", "empty", "ends-with?", "get", "parse-float", "replace", "split", "split-lines", "starts-with?", "strip-prefix", "strip-suffix", "slice", "trim", "empty?", "contains?", "includes?", "nth", "first", "rest", "pad-left", "pad-right", "find-index", "get-char-code", "escape", "mappend", "blank?", "count", "empty", "ends-with?", "get", "parse-float", "replace", "split", "split-lines", "starts-with?", "strip-prefix", "strip-suffix", "slice", "trim", "empty?", "contains?", "includes?", "nth", "first", "rest", "pad-left", "pad-right", "find-index", "get-char-code", "escape", "mappend", "symbol"].forEach((x) => {
  _kwd[x] = kwd(x);
});
var _PCT__$M_ = () => {
};
_PCT__$M_.isMacro = true;
function _$n__LT__$e_(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_$n__LT_(a2, b)) {
    return true;
  } else {
    return _$n__$e_(a2, b);
  }
}
function _$n__GT__$e_(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_$n__GT_(a2, b)) {
    return true;
  } else {
    return _$n__$e_(a2, b);
  }
}
var _$n_case = () => {
};
_$n_case.isMacro = true;
function reduce(xs, x0, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  return foldl(xs, x0, f);
}
function _$n_list_$o_filter(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return reduce(xs, _$L_(), function _PCT__$n_list_$o_filter(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return append2(acc, x);
    } else {
      return acc;
    }
  });
}
var foldl_compare = function foldl_compare2(xs, acc, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let times_AUTO_3 = 0;
  while (true) {
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 1e5)
      throw new Error("tail recursion not stopping");
    if (_$n_list_$o_empty_$q_(xs)) {
      ret_AUTO_2 = true;
    } else if (f(acc, _$n_list_$o_first(xs))) {
      ret_AUTO_2 = recur(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), f);
    } else {
      ret_AUTO_2 = false;
    }
    if (ret_AUTO_2 instanceof CalcitRecur) {
      if (ret_AUTO_2.args.length !== 3)
        throw new Error("argument sizes do not match");
      [xs, acc, f] = ret_AUTO_2.args;
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
};
function _$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__$e_);
  }
}
var and = () => {
};
and.isMacro = true;
var list_$q_2 = list_$q_;
var nil_$q_2 = nil_$q_;
var tuple_$q_2 = tuple_$q_;
function count(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return 0;
  } else if (tuple_$q_2(x)) {
    return 2;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_count(x);
  } else {
    return invoke_method("count")(x);
  }
}
function nth(x, i) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (tuple_$q_2(x)) {
    return _$n_tuple_$o_nth(x, i);
  } else if (list_$q_2(x)) {
    return _$n_list_$o_nth(x, i);
  } else {
    return invoke_method("nth")(x, i);
  }
}
var string_$q_2 = string_$q_;
function _$n_list_$o_filter_pair(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return _$n_list_$o_filter(xs, function _PCT_filter_pair(pair) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      (function __fn__() {
        not(string_$q_2("expected a pair")) ? function __fn__2() {
          let err_AUTO_4 = new Error("expects 1st argument to be string");
          err_AUTO_4.data = null;
          throw err_AUTO_4;
        }() : null;
        if (list_$q_2(pair) ? function __fn__2() {
          let v1__4 = _$e_(2, count(pair));
          if (v1__4) {
            return v1__4;
          } else {
            return false;
          }
        }() : false) {
          return null;
        } else {
          console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
          let err_AUTO_5 = new Error("expected a pair (and (list? pair) (= 2 (count pair)))");
          err_AUTO_5.data = null;
          throw err_AUTO_5;
        }
      })();
      return f(nth(pair, 0), nth(pair, 1));
    });
  } else {
    let err_AUTO_6 = new Error("expected list or map from `filter-pair`");
    err_AUTO_6.data = null;
    throw err_AUTO_6;
  }
}
function _$n_list_$o_find_last(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldr_shortcut(xs, null, null, function f_PCT_2(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(true, x);
    } else {
      return _$o__$o_(false, null);
    }
  });
}
function dec(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__(x, 1);
}
function _$n_list_$o_find_last_index(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldr_shortcut(xs, dec(count(xs)), null, function f_PCT_2(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(true, idx);
    } else {
      return _$o__$o_(false, _$n__(1, idx));
    }
  });
}
function _$n_list_$o_map(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, _$L_(), function _PCT__$n_list_$o_map(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return append2(acc, f(x));
  });
}
function _$n_map_$o_map(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, _$n__$M_(), function _$n_map_$o_map2(acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let result = f(pair);
    (function __fn__() {
      not(string_$q_2("expected pair returned when mapping hashmap")) ? function __fn__2() {
        let err_AUTO_7 = new Error("expects 1st argument to be string");
        err_AUTO_7.data = null;
        throw err_AUTO_7;
      }() : null;
      if (list_$q_2(result) ? function __fn__2() {
        let v1__1 = _$n__$e_(2, _$n_list_$o_count(result));
        if (v1__1) {
          return v1__1;
        } else {
          return false;
        }
      }() : false) {
        return null;
      } else {
        console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("result")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])])]))));
        let err_AUTO_8 = new Error("expected pair returned when mapping hashmap (and (list? result) (&= 2 (&list:count result)))");
        err_AUTO_8.data = null;
        throw err_AUTO_8;
      }
    })();
    return _$n_map_$o_assoc(acc, nth(result, 0), nth(result, 1));
  });
}
function include(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_include(acc, item);
  });
}
var map_$q_2 = map_$q_;
var set_$q_2 = set_$q_;
function map(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return _$n_list_$o_map(xs, f);
  } else if (set_$q_2(xs)) {
    return foldl(xs, _SHA__$M_(), function _PCT_map(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return include(acc, f(x));
    });
  } else if (map_$q_2(xs)) {
    return _$n_map_$o_map(xs, f);
  } else {
    console.log(printable("value:", xs));
    let err_AUTO_9 = new Error("expected list or set for map function");
    err_AUTO_9.data = null;
    throw err_AUTO_9;
  }
}
function _$n_list_$o_flatten(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return _$n_list_$o_concat(...listToArray(map(xs, _$n_list_$o_flatten)));
  } else {
    return _$L_(xs);
  }
}
function _$n_list_$o_last_index_of(xs, item) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldr_shortcut(xs, dec(count(xs)), null, function f_PCT_2(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (_$n__$e_(item, x)) {
      return _$o__$o_(true, idx);
    } else {
      return _$o__$o_(false, _$n__(1, idx));
    }
  });
}
function _$n_list_$o_map_pair(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (list_$q_2(xs)) {
    return map(xs, function _PCT_map_pair(pair) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      (function __fn__() {
        not(string_$q_2("expected a pair")) ? function __fn__2() {
          let err_AUTO_10 = new Error("expects 1st argument to be string");
          err_AUTO_10.data = null;
          throw err_AUTO_10;
        }() : null;
        if (list_$q_2(pair) ? function __fn__2() {
          let v1__3 = _$e_(2, count(pair));
          if (v1__3) {
            return v1__3;
          } else {
            return false;
          }
        }() : false) {
          return null;
        } else {
          console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
          let err_AUTO_11 = new Error("expected a pair (and (list? pair) (= 2 (count pair)))");
          err_AUTO_11.data = null;
          throw err_AUTO_11;
        }
      })();
      return f(nth(pair, 0), nth(pair, 1));
    });
  } else {
    let err_AUTO_12 = new Error("expected list or map from `map-pair`");
    err_AUTO_12.data = null;
    throw err_AUTO_12;
  }
}
var number_$q_2 = number_$q_;
function _$n_max(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects numbers for &max")) ? function __fn__2() {
      let err_AUTO_13 = new Error("expects 1st argument to be string");
      err_AUTO_13.data = null;
      throw err_AUTO_13;
    }() : null;
    if (function __fn__2() {
      if (number_$q_2(a2)) {
        return number_$q_2(b);
      } else if (string_$q_2(a2)) {
        return string_$q_2(b);
      } else {
        return false;
      }
    }()) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("b")]), false])]))));
      let err_AUTO_14 = new Error("expects numbers for &max (if (number? a) (number? b) (if (string? a) (string? b) false))");
      err_AUTO_14.data = null;
      throw err_AUTO_14;
    }
  })();
  if (_$n__GT_(a2, b)) {
    return a2;
  } else {
    return b;
  }
}
function _$n_list_$o_max(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_list_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), function _PCT_max(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_max(acc, x);
    });
  }
}
function _$n_min(a2, b) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects numbers for &min")) ? function __fn__2() {
      let err_AUTO_15 = new Error("expects 1st argument to be string");
      err_AUTO_15.data = null;
      throw err_AUTO_15;
    }() : null;
    if (function __fn__2() {
      if (number_$q_2(a2)) {
        return number_$q_2(b);
      } else if (string_$q_2(a2)) {
        return string_$q_2(b);
      } else {
        return false;
      }
    }()) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("b")]), false])]))));
      let err_AUTO_16 = new Error("expects numbers for &min (if (number? a) (number? b) (if (string? a) (string? b) false))");
      err_AUTO_16.data = null;
      throw err_AUTO_16;
    }
  })();
  if (_$n__LT_(a2, b)) {
    return a2;
  } else {
    return b;
  }
}
function _$n_list_$o_min(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_list_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_list_$o_rest(xs), _$n_list_$o_first(xs), function _PCT_min(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_min(acc, x);
    });
  }
}
var record_$q_2 = record_$q_;
function get(base, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(base)) {
    return null;
  } else if (string_$q_2(base)) {
    return _$n_str_$o_nth(base, k);
  } else if (map_$q_2(base)) {
    return _$n_map_$o_get(base, k);
  } else if (list_$q_2(base)) {
    return _$n_list_$o_nth(base, k);
  } else if (tuple_$q_2(base)) {
    return _$n_tuple_$o_nth(base, k);
  } else if (record_$q_2(base)) {
    return _$n_record_$o_get(base, k);
  } else {
    console.log(printable("Value:", base, k));
    let err_AUTO_17 = new Error("Expected map or list for get");
    err_AUTO_17.data = null;
    throw err_AUTO_17;
  }
}
var keyword_$q_2 = keyword_$q_;
function _$n_list_$o_sort_by(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (keyword_$q_2(f)) {
    return sort(xs, function _PCT__$n_list_$o_sort_by(a2, b) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_compare(get(a2, f), get(b, f));
    });
  } else {
    return sort(xs, function _PCT__$n_list_$o_sort_by(a2, b) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_compare(f(a2), f(b));
    });
  }
}
function _SUB_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n_list_$o_empty_$q_(ys)) {
    return _$n__(0, x);
  } else {
    return reduce(ys, x, _$n__);
  }
}
function _GT__$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__GT__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__GT__$e_);
  }
}
function any_$q_(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, null, false, function _PCT_any_$q_(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(true, true);
    } else {
      return _$o__$o_(false, null);
    }
  });
}
function assoc(x, ...args2) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  args2 = arrayToList(args2);
  if (nil_$q_2(x)) {
    let err_AUTO_18 = new Error("assoc does not work on nil");
    err_AUTO_18.data = null;
    throw err_AUTO_18;
  } else if (tuple_$q_2(x)) {
    return _$n_tuple_$o_assoc(x, ...listToArray(args2));
  } else if (list_$q_2(x)) {
    return _$n_list_$o_assoc(x, ...listToArray(args2));
  } else {
    return invoke_method("assoc")(x, ...listToArray(args2));
  }
}
function contains_$q_(x, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return false;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_contains_$q_(x, k);
  } else {
    return invoke_method("contains?")(x, k);
  }
}
function slice2(xs, n, m) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  if (nil_$q_2(xs)) {
    return null;
  } else {
    return invoke_method("slice")(xs, n, m);
  }
}
function drop(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return slice2(xs, n, _$n_list_$o_count(xs));
}
function each(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, null, function _PCT_each(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return f(x);
  });
}
function empty_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return true;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_empty_$q_(x);
  } else {
    return invoke_method("empty?")(x);
  }
}
function filter_not(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return invoke_method("filter")(xs, function _PCT_filter_not(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return not(f(x));
  });
}
function find(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, 0, null, function _PCT_find(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(true, x);
    } else {
      return _$o__$o_(false, null);
    }
  });
}
function find_index(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, 0, null, function _PCT_find_index(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(true, idx);
    } else {
      return _$o__$o_(false, _$n__ADD_(1, idx));
    }
  });
}
function rest2(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return null;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_rest(x);
  } else {
    return invoke_method("rest")(x);
  }
}
var get_in = function get_in2(base, path) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let times_AUTO_23 = 0;
  while (true) {
    let ret_AUTO_22 = null;
    if (times_AUTO_23 > 1e5)
      throw new Error("tail recursion not stopping");
    (function __fn__() {
      not(string_$q_2("expects path in a list")) ? function __fn__2() {
        let err_AUTO_20 = new Error("expects 1st argument to be string");
        err_AUTO_20.data = null;
        throw err_AUTO_20;
      }() : null;
      if (list_$q_2(path)) {
        return null;
      } else {
        console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("path")]))));
        let err_AUTO_21 = new Error("expects path in a list (list? path)");
        err_AUTO_21.data = null;
        throw err_AUTO_21;
      }
    })();
    if (nil_$q_2(base)) {
      ret_AUTO_22 = null;
    } else if (_$n_list_$o_empty_$q_(path)) {
      ret_AUTO_22 = base;
    } else {
      ret_AUTO_22 = recur(get(base, _$n_list_$o_first(path)), rest2(path));
    }
    if (ret_AUTO_22 instanceof CalcitRecur) {
      if (ret_AUTO_22.args.length !== 2)
        throw new Error("argument sizes do not match");
      [base, path] = ret_AUTO_22.args;
      times_AUTO_23 += 1;
      continue;
    } else {
      return ret_AUTO_22;
    }
  }
};
function update(x, k, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  if (map_$q_2(x)) {
    if (contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_map_$o_get(x, k)));
    } else {
      return x;
    }
  } else if (list_$q_2(x)) {
    if (_$n_list_$o_contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_list_$o_nth(x, k)));
    } else {
      return x;
    }
  } else if (tuple_$q_2(x)) {
    if (function __fn__() {
      let v1__2 = _$n__$e_(k, 1);
      if (nil_$q_2(v1__2)) {
        return _$n__$e_(k, 2);
      } else if (_$e_(false, v1__2)) {
        return _$n__$e_(k, 2);
      } else {
        return v1__2;
      }
    }()) {
      return assoc(x, k, f(_$n_tuple_$o_nth(x, k)));
    } else {
      let err_AUTO_24 = new Error(_$n_str_$o_concat("tuple only has 0,1 fields, unknown field: ", k));
      err_AUTO_24.data = null;
      throw err_AUTO_24;
    }
  } else if (record_$q_2(x)) {
    if (contains_$q_(x, k)) {
      return assoc(x, k, f(_$n_record_$o_get(x, k)));
    } else {
      return x;
    }
  } else {
    let err_AUTO_25 = new Error(_$n_str_$o_concat("Cannot update key on item: ", pr_str(x)));
    err_AUTO_25.data = null;
    throw err_AUTO_25;
  }
}
function group_by(xs0, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT_group_by(acc, xs) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let times_AUTO_28 = 0;
    while (true) {
      let ret_AUTO_27 = null;
      if (times_AUTO_28 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_27 = acc;
      } else {
        let x0 = _$n_list_$o_first(xs);
        let key = f(x0);
        ret_AUTO_27 = recur(contains_$q_(acc, key) ? update(acc, key, function _PCT__BSL_(_PCT_, _PCT_2) {
          if (arguments.length < 0)
            throw new Error("too few arguments");
          if (arguments.length > 2)
            throw new Error("too many arguments");
          return append2(_PCT_, x0);
        }) : _$n_map_$o_assoc(acc, key, _$L_(x0)), rest2(xs));
      }
      if (ret_AUTO_27 instanceof CalcitRecur) {
        if (ret_AUTO_27.args.length !== 2)
          throw new Error("argument sizes do not match");
        [acc, xs] = ret_AUTO_27.args;
        times_AUTO_28 += 1;
        continue;
      } else {
        return ret_AUTO_27;
      }
    }
  }(_$n__$M_(), xs0);
}
function identity(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return x;
}
function index_of(xs, item) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, 0, null, function _PCT_index_of(idx, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (_$n__$e_(item, x)) {
      return _$o__$o_(true, idx);
    } else {
      return _$o__$o_(false, _$n__ADD_(1, idx));
    }
  });
}
function join(xs0, sep) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT_join(acc, xs, beginning_$q_) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let times_AUTO_31 = 0;
    while (true) {
      let ret_AUTO_30 = null;
      if (times_AUTO_31 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_30 = acc;
      } else {
        ret_AUTO_30 = recur(append2(beginning_$q_ ? acc : append2(acc, sep), _$n_list_$o_first(xs)), _$n_list_$o_rest(xs), false);
      }
      if (ret_AUTO_30 instanceof CalcitRecur) {
        if (ret_AUTO_30.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, beginning_$q_] = ret_AUTO_30.args;
        times_AUTO_31 += 1;
        continue;
      } else {
        return ret_AUTO_30;
      }
    }
  }(_$L_(), xs0, true);
}
function join_str(xs0, sep) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT_join_str(acc, xs, beginning_$q_) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    let times_AUTO_34 = 0;
    while (true) {
      let ret_AUTO_33 = null;
      if (times_AUTO_34 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$n_list_$o_empty_$q_(xs)) {
        ret_AUTO_33 = acc;
      } else {
        ret_AUTO_33 = recur(_$n_str_$o_concat(beginning_$q_ ? acc : _$n_str_$o_concat(acc, sep), _$n_list_$o_first(xs)), _$n_list_$o_rest(xs), false);
      }
      if (ret_AUTO_33 instanceof CalcitRecur) {
        if (ret_AUTO_33.args.length !== 3)
          throw new Error("argument sizes do not match");
        [acc, xs, beginning_$q_] = ret_AUTO_33.args;
        times_AUTO_34 += 1;
        continue;
      } else {
        return ret_AUTO_33;
      }
    }
  }("", xs0, true);
}
function last(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (empty_$q_(xs)) {
    return null;
  } else {
    return nth(xs, _$n__(count(xs), 1));
  }
}
function map_indexed(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl(xs, _$L_(), function _PCT_map_indexed(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return append2(acc, f(count(acc), x));
  });
}
function mapcat(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return _$n_list_$o_concat(...listToArray(map(xs, f)));
}
function pairs_map(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return reduce(xs, _$n__$M_(), function _PCT_pairs_map(acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    (function __fn__() {
      not(string_$q_2("expects pair for pairs-map")) ? function __fn__2() {
        let err_AUTO_35 = new Error("expects 1st argument to be string");
        err_AUTO_35.data = null;
        throw err_AUTO_35;
      }() : null;
      if (list_$q_2(pair) ? _$n__$e_(2, _$n_list_$o_count(pair)) : false) {
        return null;
      } else {
        console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("pair")])]), false]))));
        let err_AUTO_36 = new Error("expects pair for pairs-map (if (list? pair) (&= 2 (&list:count pair)) false)");
        err_AUTO_36.data = null;
        throw err_AUTO_36;
      }
    })();
    return _$n_map_$o_assoc(acc, _$n_list_$o_first(pair), last(pair));
  });
}
function take(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_GT__$e_(n, _$n_list_$o_count(xs))) {
    return xs;
  } else {
    return slice2(xs, 0, n);
  }
}
function take_last(xs, n) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_GT__$e_(n, _$n_list_$o_count(xs))) {
    return xs;
  } else {
    return slice2(xs, _SUB_(_$n_list_$o_count(xs), n), _$n_list_$o_count(xs));
  }
}
function _$n_map_$o_add_entry(xs, pair) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("&map:add-entry expected value in a pair")) ? function __fn__2() {
      let err_AUTO_37 = new Error("expects 1st argument to be string");
      err_AUTO_37.data = null;
      throw err_AUTO_37;
    }() : null;
    if (list_$q_2(pair) ? function __fn__2() {
      let v1__5 = _$n__$e_(2, count(pair));
      if (v1__5) {
        return v1__5;
      } else {
        return false;
      }
    }() : false) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
      let err_AUTO_38 = new Error("&map:add-entry expected value in a pair (and (list? pair) (&= 2 (count pair)))");
      err_AUTO_38.data = null;
      throw err_AUTO_38;
    }
  })();
  return _$n_map_$o_assoc(xs, nth(pair, 0), nth(pair, 1));
}
function _$n_map_$o_filter(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return reduce(xs, _$n__$M_(), function _PCT__$n_map_$o_filter(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$n_map_$o_assoc(acc, nth(x, 0), nth(x, 1));
    } else {
      return acc;
    }
  });
}
function _$n_map_$o_filter_kv(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return reduce(xs, _$n__$M_(), function _PCT_map_$o_filter_kv(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(nth(x, 0), nth(x, 1))) {
      return _$n_map_$o_assoc(acc, nth(x, 0), nth(x, 1));
    } else {
      return acc;
    }
  });
}
function _$n_map_$o_map_list(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (map_$q_2(xs)) {
    return foldl(xs, _$L_(), function _PCT__$n_map_$o_map_list(acc, pair) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return append2(acc, f(pair));
    });
  } else {
    let err_AUTO_39 = new Error("&map:map-list expected a map");
    err_AUTO_39.data = null;
    throw err_AUTO_39;
  }
}
function keys(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(to_pairs(x), _$n_list_$o_first);
}
function map_kv(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  (function __fn__() {
    not(string_$q_2("expects a map")) ? function __fn__2() {
      let err_AUTO_40 = new Error("expects 1st argument to be string");
      err_AUTO_40.data = null;
      throw err_AUTO_40;
    }() : null;
    if (map_$q_2(xs)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("map?"), new CalcitSymbol("xs")]))));
      let err_AUTO_41 = new Error("expects a map (map? xs)");
      err_AUTO_41.data = null;
      throw err_AUTO_41;
    }
  })();
  return foldl(xs, _$n__$M_(), function _PCT_map_kv(acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let result = f(nth(pair, 0), nth(pair, 1));
    if (list_$q_2(result)) {
      (function __fn__() {
        not(string_$q_2("expected pair returned when mapping hashmap")) ? function __fn__2() {
          let err_AUTO_42 = new Error("expects 1st argument to be string");
          err_AUTO_42.data = null;
          throw err_AUTO_42;
        }() : null;
        if (_$n__$e_(2, _$n_list_$o_count(result))) {
          return null;
        } else {
          console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])]))));
          let err_AUTO_43 = new Error("expected pair returned when mapping hashmap (&= 2 (&list:count result))");
          err_AUTO_43.data = null;
          throw err_AUTO_43;
        }
      })();
      return _$n_map_$o_assoc(acc, nth(result, 0), nth(result, 1));
    } else if (nil_$q_2(result)) {
      return acc;
    } else {
      let err_AUTO_44 = new Error(_$n_str_$o_concat("map-kv expected list or nil, got: ", _$n_str_$o_concat(result, "")));
      err_AUTO_44.data = null;
      throw err_AUTO_44;
    }
  });
}
function merge(x0, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, x0, _$n_merge);
}
function vals(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(to_pairs(x), last);
}
function inc(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__ADD_(x, 1);
}
function negate(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__(0, x);
}
function _$n_set_$o_filter(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return reduce(xs, _SHA__$M_(), function _PCT__$n_set_$o_filter(acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$n_include(acc, x);
    } else {
      return acc;
    }
  });
}
function _$n_set_$o_max(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_set_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_set_$o_rest(xs), _$n_set_$o_first(xs), function _PCT_max(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_max(acc, x);
    });
  }
}
function _$n_set_$o_min(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (_$n_set_$o_empty_$q_(xs)) {
    return null;
  } else {
    return reduce(_$n_set_$o_rest(xs), _$n_set_$o_first(xs), function _PCT_min(acc, x) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return _$n_min(acc, x);
    });
  }
}
function difference(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_difference(acc, item);
  });
}
function exclude(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_exclude(acc, item);
  });
}
function intersection(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_set_$o_intersection(acc, item);
  });
}
function union(base, ...xs) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  xs = arrayToList(xs);
  return reduce(xs, base, function f_PCT_2(acc, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$n_union(acc, item);
  });
}
function strip_prefix(s, piece) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (starts_with_$q_(s, piece)) {
    return _$n_str_$o_slice(s, _$n_str_$o_count(piece));
  } else {
    return s;
  }
}
function strip_suffix(s, piece) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (ends_with_$q_(s, piece)) {
    return _$n_str_$o_slice(s, 0, _$n__(_$n_str_$o_count(s), _$n_str_$o_count(piece)));
  } else {
    return s;
  }
}
var _$n_doseq = () => {
};
_$n_doseq.isMacro = true;
function _$s_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  return reduce(ys, x, _$n__$s_);
}
var __GT_ = () => {
};
__GT_.isMacro = true;
var _SCOL_nil = () => {
};
_SCOL_nil.isMacro = true;
function _LT_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__LT_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__LT_);
  }
}
function _LT__$e_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__LT__$e_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__LT__$e_);
  }
}
function _GT_(x, ...ys) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  if (_$n__$e_(1, _$n_list_$o_count(ys))) {
    return _$n__GT_(x, _$n_list_$o_first(ys));
  } else {
    return foldl_compare(ys, x, _$n__GT_);
  }
}
var _BSL_ = () => {
};
_BSL_.isMacro = true;
function apply(f, args2) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return f(...listToArray(args2));
}
var apply_args = () => {
};
apply_args.isMacro = true;
var assert = () => {
};
assert.isMacro = true;
var _CASE_ = () => {
};
_CASE_.isMacro = true;
var case_default = () => {
};
case_default.isMacro = true;
var cond = () => {
};
cond.isMacro = true;
var conj = function conj2(xs, y0, ...ys) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  ys = arrayToList(ys);
  let times_AUTO_47 = 0;
  while (true) {
    let ret_AUTO_46 = null;
    if (times_AUTO_47 > 1e5)
      throw new Error("tail recursion not stopping");
    if (empty_$q_(ys)) {
      ret_AUTO_46 = append2(xs, y0);
    } else {
      ret_AUTO_46 = recur(append2(xs, y0), ...listToArray(ys));
    }
    if (ret_AUTO_46 instanceof CalcitRecur) {
      if (ret_AUTO_46.args.length < 2)
        throw new Error("too few arguments");
      [xs, y0, ...ys] = ret_AUTO_46.args;
      ys = arrayToList(ys);
      times_AUTO_47 += 1;
      continue;
    } else {
      return ret_AUTO_46;
    }
  }
};
var def = () => {
};
def.isMacro = true;
var defrecord = () => {
};
defrecord.isMacro = true;
var defrecord_$x_ = () => {
};
defrecord_$x_.isMacro = true;
function dissoc(x, ...args2) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  args2 = arrayToList(args2);
  if (nil_$q_2(x)) {
    return null;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_dissoc(x, ...listToArray(args2));
  } else {
    return invoke_method("dissoc")(x, ...listToArray(args2));
  }
}
var _DO_ = () => {
};
_DO_.isMacro = true;
var either = () => {
};
either.isMacro = true;
function every_$q_(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return foldl_shortcut(xs, null, true, function _PCT_every_$q_(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    if (f(x)) {
      return _$o__$o_(false, null);
    } else {
      return _$o__$o_(true, false);
    }
  });
}
function filter(xs, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return invoke_method("filter")(xs, f);
}
function first2(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return null;
  } else if (tuple_$q_2(x)) {
    return _$n_tuple_$o_nth(x, 0);
  } else if (list_$q_2(x)) {
    return _$n_list_$o_nth(x, 0);
  } else {
    return invoke_method("first")(x);
  }
}
var fn2 = () => {
};
fn2.isMacro = true;
function includes_$q_(x, k) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (nil_$q_2(x)) {
    return false;
  } else if (list_$q_2(x)) {
    return _$n_list_$o_includes_$q_(x, k);
  } else {
    return invoke_method("includes?")(x, k);
  }
}
var js_object = () => {
};
js_object.isMacro = true;
var _LET_ = () => {
};
_LET_.isMacro = true;
var let_$L_ = () => {
};
let_$L_.isMacro = true;
var loop = () => {
};
loop.isMacro = true;
var or = () => {
};
or.isMacro = true;
function some_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return not(nil_$q_2(x));
}
var str = () => {
};
str.isMacro = true;
function symbol_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$e_(type_of(x), _kwd["symbol"]);
}
var when = () => {
};
when.isMacro = true;
var when_not = () => {
};
when_not.isMacro = true;
var _$M_ = () => {
};
_$M_.isMacro = true;
var _$n_core_fn_class = _$n__PCT__$M_(new_record(_kwd["&core-fn-class"], _kwd["call"], _kwd["call-args"], _kwd["map"], _kwd["bind"], _kwd["mappend"], _kwd["apply"]), _kwd["call"], function _$n_fn_$o_call(f, ...args2) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  args2 = arrayToList(args2);
  return f(...listToArray(args2));
}, _kwd["call-args"], function _$n_fn_$o_call_args(f, args2) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return f(...listToArray(args2));
}, _kwd["map"], function _$n_fn_$o_map(f, g) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _$n_fn_$o_map2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return f(g(x));
  };
}, _kwd["bind"], function _$n_fn_$o_bind(m, f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT__$n_fn_$o_bind(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return f(m(x), x);
  };
}, _kwd["mappend"], function _$n_fn_$o_mappend(f, g) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT__$n_fn_$o_mappend(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return invoke_method("mappend")(f(x), g(x));
  };
}, _kwd["apply"], function _$n_fn_$o_apply(f, g) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return function _PCT__$s_fn_$o_apply(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return g(x, f(x));
  };
});
var _$n_core_list_class = _$n__PCT__$M_(new_record(_kwd["&core-list-class"], _kwd["any?"], _kwd["add"], _kwd["append"], _kwd["assoc"], _kwd["assoc-after"], _kwd["assoc-before"], _kwd["bind"], _kwd["butlast"], _kwd["concat"], _kwd["contains?"], _kwd["includes?"], _kwd["count"], _kwd["drop"], _kwd["each"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["filter-not"], _kwd["find"], _kwd["find-index"], _kwd["find-last"], _kwd["find-last-index"], _kwd["foldl"], _kwd["get"], _kwd["get-in"], _kwd["group-by"], _kwd["index-of"], _kwd["join"], _kwd["join-str"], _kwd["last-index-of"], _kwd["map"], _kwd["map-indexed"], _kwd["mappend"], _kwd["max"], _kwd["min"], _kwd["nth"], _kwd["pairs-map"], _kwd["prepend"], _kwd["reduce"], _kwd["reverse"], _kwd["slice"], _kwd["sort"], _kwd["sort-by"], _kwd["take"], _kwd["take-last"], _kwd["to-set"], _kwd["first"], _kwd["rest"], _kwd["dissoc"], _kwd["to-list"], _kwd["map-pair"], _kwd["filter-pair"], _kwd["apply"], _kwd["flatten"]), _kwd["any?"], any_$q_, _kwd["add"], append2, _kwd["append"], append2, _kwd["assoc"], _$n_list_$o_assoc, _kwd["assoc-after"], _$n_list_$o_assoc_after, _kwd["assoc-before"], _$n_list_$o_assoc_before, _kwd["bind"], mapcat, _kwd["butlast"], butlast, _kwd["concat"], _$n_list_$o_concat, _kwd["contains?"], _$n_list_$o_contains_$q_, _kwd["includes?"], _$n_list_$o_includes_$q_, _kwd["count"], _$n_list_$o_count, _kwd["drop"], drop, _kwd["each"], each, _kwd["empty"], function _$n_list_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$L_();
}, _kwd["empty?"], _$n_list_$o_empty_$q_, _kwd["filter"], _$n_list_$o_filter, _kwd["filter-not"], filter_not, _kwd["find"], find, _kwd["find-index"], find_index, _kwd["find-last"], _$n_list_$o_find_last, _kwd["find-last-index"], _$n_list_$o_find_last_index, _kwd["foldl"], function foldl2(xs, v0, f) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  return foldl(xs, v0, f);
}, _kwd["get"], _$n_list_$o_nth, _kwd["get-in"], get_in, _kwd["group-by"], group_by, _kwd["index-of"], index_of, _kwd["join"], join, _kwd["join-str"], join_str, _kwd["last-index-of"], _$n_list_$o_last_index_of, _kwd["map"], _$n_list_$o_map, _kwd["map-indexed"], map_indexed, _kwd["mappend"], function _$n_list_$o_mappend(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return _$n_list_$o_concat(x, y);
}, _kwd["max"], _$n_list_$o_max, _kwd["min"], _$n_list_$o_min, _kwd["nth"], _$n_list_$o_nth, _kwd["pairs-map"], pairs_map, _kwd["prepend"], prepend2, _kwd["reduce"], reduce, _kwd["reverse"], _$n_list_$o_reverse, _kwd["slice"], _$n_list_$o_slice, _kwd["sort"], function sort2(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return sort(x, y);
}, _kwd["sort-by"], _$n_list_$o_sort_by, _kwd["take"], take, _kwd["take-last"], take_last, _kwd["to-set"], _$n_list_$o_to_set, _kwd["first"], _$n_list_$o_first, _kwd["rest"], _$n_list_$o_rest, _kwd["dissoc"], _$n_list_$o_dissoc, _kwd["to-list"], identity, _kwd["map-pair"], _$n_list_$o_map_pair, _kwd["filter-pair"], _$n_list_$o_filter_pair, _kwd["apply"], function _$n_fn_$o_apply2(xs, fs) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return _$n_list_$o_concat(...listToArray(map(fs, function _$n_fn_$o_ap_gen(f) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return map(xs, function _$n_fn_$o_ap_gen2(x) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return f(x);
    });
  })));
}, _kwd["flatten"], _$n_list_$o_flatten);
var _$n_core_map_class = _$n__PCT__$M_(new_record(_kwd["&core-map-class"], _kwd["add"], _kwd["assoc"], _kwd["contains?"], _kwd["count"], _kwd["dissoc"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["filter-kv"], _kwd["get"], _kwd["get-in"], _kwd["includes?"], _kwd["keys"], _kwd["map"], _kwd["map-kv"], _kwd["map-list"], _kwd["mappend"], _kwd["merge"], _kwd["to-list"], _kwd["to-pairs"], _kwd["values"], _kwd["first"], _kwd["rest"], _kwd["diff-new"], _kwd["diff-keys"], _kwd["common-keys"], _kwd["to-map"]), _kwd["add"], _$n_map_$o_add_entry, _kwd["assoc"], _$n_map_$o_assoc, _kwd["contains?"], _$n_map_$o_contains_$q_, _kwd["count"], _$n_map_$o_count, _kwd["dissoc"], _$n_map_$o_dissoc, _kwd["empty"], function _$n_map_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_();
}, _kwd["empty?"], _$n_map_$o_empty_$q_, _kwd["filter"], _$n_map_$o_filter, _kwd["filter-kv"], _$n_map_$o_filter_kv, _kwd["get"], _$n_map_$o_get, _kwd["get-in"], get_in, _kwd["includes?"], _$n_map_$o_includes_$q_, _kwd["keys"], keys, _kwd["map"], _$n_map_$o_map, _kwd["map-kv"], map_kv, _kwd["map-list"], _$n_map_$o_map_list, _kwd["mappend"], merge, _kwd["merge"], merge, _kwd["to-list"], _$n_map_$o_to_list, _kwd["to-pairs"], to_pairs, _kwd["values"], vals, _kwd["first"], _$n_map_$o_first, _kwd["rest"], _$n_map_$o_rest, _kwd["diff-new"], _$n_map_$o_diff_new, _kwd["diff-keys"], _$n_map_$o_diff_keys, _kwd["common-keys"], _$n_map_$o_common_keys, _kwd["to-map"], identity);
var _$n_core_nil_class = _$n__PCT__$M_(new_record(_kwd["&core-nil-class"], _kwd["to-list"], _kwd["to-map"], _kwd["pairs-map"], _kwd["to-set"], _kwd["to-string"], _kwd["to-number"], _kwd["map"], _kwd["filter"], _kwd["bind"], _kwd["mappend"], _kwd["apply"]), _kwd["to-list"], function _$n_nil_$o_to_list(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$L_();
}, _kwd["to-map"], function _$n_nil_$o_to_map(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_();
}, _kwd["pairs-map"], function _$n_nil_$o_pairs_map(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_();
}, _kwd["to-set"], function _$n_nil_$o_to_set(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _SHA__$M_();
}, _kwd["to-string"], function _$n_nil_$o_to_string(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return "";
}, _kwd["to-number"], function _$n_nil_$o_to_number(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return 0;
}, _kwd["map"], function _$n_nil_$o_map(_, _f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return null;
}, _kwd["filter"], function _$n_nil_$o_filter(_, _f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return null;
}, _kwd["bind"], function _$n_nil_$o_bind(_, _f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return null;
}, _kwd["mappend"], function _$n_nil_$o_mappend(_, x) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return x;
}, _kwd["apply"], function _$n_nil_$o_apply(_, _f) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return null;
});
var _$n_core_number_class = _$n__PCT__$M_(new_record(_kwd["&core-number-class"], _kwd["ceil"], _kwd["empty"], _kwd["floor"], _kwd["format"], _kwd["inc"], _kwd["pow"], _kwd["round"], _kwd["round?"], _kwd["fract"], _kwd["sqrt"], _kwd["negate"], _kwd["rem"]), _kwd["ceil"], ceil, _kwd["empty"], function _$n_number_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return 0;
}, _kwd["floor"], floor, _kwd["format"], _$n_number_$o_format, _kwd["inc"], inc, _kwd["pow"], pow, _kwd["round"], round, _kwd["round?"], round_$q_, _kwd["fract"], _$n_number_$o_fract, _kwd["sqrt"], sqrt, _kwd["negate"], negate, _kwd["rem"], _$n_number_$o_rem);
var _$n_core_record_class = _$n__PCT__$M_(new_record(_kwd["&core-record-class"], _kwd["get"], _kwd["get-name"], _kwd["matches?"], _kwd["to-map"], _kwd["count"], _kwd["contains?"], _kwd["assoc"], _kwd["from-map"], _kwd["extend-as"]), _kwd["get"], _$n_record_$o_get, _kwd["get-name"], _$n_record_$o_get_name, _kwd["matches?"], _$n_record_$o_matches_$q_, _kwd["to-map"], _$n_record_$o_to_map, _kwd["count"], _$n_record_$o_count, _kwd["contains?"], _$n_record_$o_contains_$q_, _kwd["assoc"], _$n_record_$o_assoc, _kwd["from-map"], _$n_record_$o_from_map, _kwd["extend-as"], _$n_record_$o_extend_as);
var _$n_core_set_class = _$n__PCT__$M_(new_record(_kwd["&core-set-class"], _kwd["add"], _kwd["count"], _kwd["difference"], _kwd["exclude"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["include"], _kwd["includes?"], _kwd["contains?"], _kwd["intersection"], _kwd["max"], _kwd["min"], _kwd["to-list"], _kwd["union"], _kwd["first"], _kwd["rest"], _kwd["to-set"], _kwd["mappend"]), _kwd["add"], include, _kwd["count"], _$n_set_$o_count, _kwd["difference"], difference, _kwd["exclude"], exclude, _kwd["empty"], function _$n_set_$o_empty(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _SHA__$M_();
}, _kwd["empty?"], _$n_set_$o_empty_$q_, _kwd["filter"], _$n_set_$o_filter, _kwd["include"], include, _kwd["includes?"], _$n_set_$o_includes_$q_, _kwd["contains?"], _$n_set_$o_includes_$q_, _kwd["intersection"], intersection, _kwd["max"], _$n_set_$o_max, _kwd["min"], _$n_set_$o_min, _kwd["to-list"], _$n_set_$o_to_list, _kwd["union"], union, _kwd["first"], _$n_set_$o_first, _kwd["rest"], _$n_set_$o_rest, _kwd["to-set"], identity, _kwd["mappend"], union);
var _$n_core_string_class = _$n__PCT__$M_(new_record(_kwd["&core-string-class"], _kwd["blank?"], _kwd["count"], _kwd["empty"], _kwd["ends-with?"], _kwd["get"], _kwd["parse-float"], _kwd["replace"], _kwd["split"], _kwd["split-lines"], _kwd["starts-with?"], _kwd["strip-prefix"], _kwd["strip-suffix"], _kwd["slice"], _kwd["trim"], _kwd["empty?"], _kwd["contains?"], _kwd["includes?"], _kwd["nth"], _kwd["first"], _kwd["rest"], _kwd["pad-left"], _kwd["pad-right"], _kwd["find-index"], _kwd["get-char-code"], _kwd["escape"], _kwd["mappend"]), _kwd["blank?"], blank_$q_, _kwd["count"], _$n_str_$o_count, _kwd["empty"], function _$n_str_$o_empty(_) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return "";
}, _kwd["ends-with?"], ends_with_$q_, _kwd["get"], _$n_str_$o_nth, _kwd["parse-float"], parse_float, _kwd["replace"], _$n_str_$o_replace, _kwd["split"], split, _kwd["split-lines"], split_lines, _kwd["starts-with?"], starts_with_$q_, _kwd["strip-prefix"], strip_prefix, _kwd["strip-suffix"], strip_suffix, _kwd["slice"], _$n_str_$o_slice, _kwd["trim"], trim, _kwd["empty?"], _$n_str_$o_empty_$q_, _kwd["contains?"], _$n_str_$o_contains_$q_, _kwd["includes?"], _$n_str_$o_includes_$q_, _kwd["nth"], _$n_str_$o_nth, _kwd["first"], _$n_str_$o_first, _kwd["rest"], _$n_str_$o_rest, _kwd["pad-left"], _$n_str_$o_pad_left, _kwd["pad-right"], _$n_str_$o_pad_right, _kwd["find-index"], _$n_str_$o_find_index, _kwd["get-char-code"], get_char_code, _kwd["escape"], _$n_str_$o_escape, _kwd["mappend"], _$n_str_$o_concat);
register_calcit_builtin_classes({
  list: _$n_core_list_class,
  map: _$n_core_map_class,
  number: _$n_core_number_class,
  record: _$n_core_record_class,
  set: _$n_core_set_class,
  string: _$n_core_string_class,
  nil: _$n_core_nil_class,
  fn: _$n_core_fn_class
});
var runtimeVersion = calcit_version;
var cli_version = "0.5.16";
if (runtimeVersion !== cli_version) {
  console.warn(`[Warning] versions mismatch, CLI using: ${cli_version}, runtime using: ${runtimeVersion}`);
}

// server-out/respo.util.comparator.js
var _kwd2 = {};
[].forEach((x) => {
  _kwd2[x] = kwd(x);
});
function compare(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (_LT_(x, y)) {
    return -1;
  } else if (_GT_(x, y)) {
    return 1;
  } else {
    return 0;
  }
}
function type_as_int(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (number_$q_(x)) {
    return 0;
  } else if (keyword_$q_(x)) {
    return 1;
  } else if (string_$q_(x)) {
    return 2;
  } else {
    let err_AUTO_1 = new Error("use number, keyword or string in coord!");
    err_AUTO_1.data = null;
    throw err_AUTO_1;
  }
}
function compare_xy(x, y) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let type_x = type_as_int(x);
  let type_y = type_as_int(y);
  if (_$e_(type_x, type_y)) {
    if (keyword_$q_(x)) {
      return compare(turn_string(x), turn_string(y));
    } else {
      return compare(x, y);
    }
  } else {
    return compare(type_x, type_y);
  }
}

// server-out/respo.schema.js
var _kwd3 = {};
["Component", "name", "effects", "tree", "Effect", "name", "coord", "args", "method", "Element", "name", "coord", "attrs", "style", "event", "children"].forEach((x) => {
  _kwd3[x] = kwd(x);
});
var Component = new_record(_kwd3["Component"], _kwd3["name"], _kwd3["effects"], _kwd3["tree"]);
var Effect = new_record(_kwd3["Effect"], _kwd3["name"], _kwd3["coord"], _kwd3["args"], _kwd3["method"]);
var Element = new_record(_kwd3["Element"], _kwd3["name"], _kwd3["coord"], _kwd3["attrs"], _kwd3["style"], _kwd3["event"], _kwd3["children"]);

// server-out/respo.util.detect.js
var _kwd4 = {};
[].forEach((x) => {
  _kwd4[x] = kwd(x);
});
function component_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    return invoke_method("matches?")(Component, x);
  } else {
    return false;
  }
}
function effect_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    let v1__66 = invoke_method("matches?")(Effect, x);
    if (v1__66) {
      return v1__66;
    } else {
      return false;
    }
  } else {
    return false;
  }
}
function element_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (record_$q_(x)) {
    return invoke_method("matches?")(Element, x);
  } else {
    return false;
  }
}

// server-out/respo.util.list.js
var _kwd5 = {};
["on", "event", "style", "on"].forEach((x) => {
  _kwd5[x] = kwd(x);
});
function filter_first(f, xs) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return first2(filter(nil_$q_(xs) ? _$L_() : xs, function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return f(x);
  }));
}
function pick_attrs(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(props)) {
    return _$L_();
  } else {
    return sort(filter(invoke_method("to-list")(dissoc(dissoc(dissoc(props, _kwd5["on"]), _kwd5["event"]), _kwd5["style"])), function f_PCT_2(pair) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let k = get(pair, 0);
      let v = get(pair, 1);
      return not(starts_with_$q_(turn_string(k), "on-"));
    }), function f_PCT_2(x, y) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return compare_xy(first2(x), first2(y));
    });
  }
}
function pick_event(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(props)) {
    return _$n__$M_();
  } else {
    return merge(function __fn__() {
      let v1__59 = get(props, _kwd5["on"]);
      if (nil_$q_(v1__59)) {
        return _$n__$M_();
      } else {
        return v1__59;
      }
    }(), map_kv(props, function f_PCT_2(k, v) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      if (starts_with_$q_(turn_string(k), "on-")) {
        return _$L_(turn_keyword(_$n_str_$o_slice(turn_string(k), 3)), v);
      } else {
        return null;
      }
    }));
  }
}
function val_exists_$q_(pair) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return some_$q_(last(pair));
}

// server-out/respo.core.js
var _kwd6 = {};
["style", "name", "coord", "attrs", "style", "event", "children", "span", "inner-text", "style", "a", "body", "style", "name", "coord", "attrs", "style", "event", "children", "div", "tree", "effects", "head", "html", "link", "div"].forEach((x) => {
  _kwd6[x] = kwd(x);
});
function confirm_child(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  not(function __fn__() {
    let v1__60 = nil_$q_(x);
    if (nil_$q_(v1__60)) {
      let v1__61 = element_$q_(x);
      if (nil_$q_(v1__61)) {
        return component_$q_(x);
      } else if (_$e_(false, v1__61)) {
        return component_$q_(x);
      } else {
        return v1__61;
      }
    } else if (_$e_(false, v1__60)) {
      let v1__62 = element_$q_(x);
      if (nil_$q_(v1__62)) {
        return component_$q_(x);
      } else if (_$e_(false, v1__62)) {
        return component_$q_(x);
      } else {
        return v1__62;
      }
    } else {
      return v1__60;
    }
  }()) ? function __fn__() {
    let err_AUTO_1 = new Error(_$n_str_$o_concat("Invalid data in elements tree: ", _$n_str_$o_concat(pr_str(x), "")));
    err_AUTO_1.data = null;
    throw err_AUTO_1;
  }() : null;
  return x;
}
function create_element(tag_name, props, ...children) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  children = arrayToList(children);
  let attrs = pick_attrs(props);
  let styles = sort(invoke_method("to-list")(function __fn__() {
    let v1__58 = get(props, _kwd6["style"]);
    if (nil_$q_(v1__58)) {
      return _$n__$M_();
    } else {
      return v1__58;
    }
  }()), function f_PCT_2(x, y) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return compare_xy(first2(x), first2(y));
  });
  let event = pick_event(props);
  let children_nodes = filter(map_indexed(children, function f_PCT_2(idx, item) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$L_(idx, item);
  }), val_exists_$q_);
  return _$n__PCT__$M_(Element, _kwd6["name"], tag_name, _kwd6["coord"], null, _kwd6["attrs"], attrs, _kwd6["style"], styles, _kwd6["event"], event, _kwd6["children"], children_nodes);
}
function span(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["span"], props, ...listToArray(map(children, confirm_child)));
}
function _LT__GT_(content, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let style = arg;
  return span(_$n__$M_(_kwd6["inner-text"], content, _kwd6["style"], style));
}
function a(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["a"], props, ...listToArray(map(children, confirm_child)));
}
function body(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["body"], props, ...listToArray(map(children, confirm_child)));
}
function create_list_element(tag_name, props, child_map) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let attrs = pick_attrs(props);
  let styles = sort(invoke_method("to-list")(function __fn__() {
    let v1__63 = get(props, _kwd6["style"]);
    if (nil_$q_(v1__63)) {
      return _$n__$M_();
    } else {
      return v1__63;
    }
  }()), function f_PCT_2(x, y) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return compare_xy(first2(x), first2(y));
  });
  let event = pick_event(props);
  return _$n__PCT__$M_(Element, _kwd6["name"], tag_name, _kwd6["coord"], null, _kwd6["attrs"], attrs, _kwd6["style"], styles, _kwd6["event"], event, _kwd6["children"], child_map);
}
var defcomp = () => {
};
defcomp.isMacro = true;
function div(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["div"], props, ...listToArray(map(children, confirm_child)));
}
function extract_effects_list(markup) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let markup_tree = get(markup, _kwd6["tree"]);
  if (nil_$q_(markup_tree)) {
    return assoc(markup, _kwd6["tree"], span(null));
  } else if (list_$q_(markup_tree)) {
    let node_tree = filter_first(function f_PCT_2(x) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      if (record_$q_(x)) {
        let v1__64 = function __fn__() {
          let v1__65 = component_$q_(x);
          if (nil_$q_(v1__65)) {
            return element_$q_(x);
          } else if (_$e_(false, v1__65)) {
            return element_$q_(x);
          } else {
            return v1__65;
          }
        }();
        if (v1__64) {
          return v1__64;
        } else {
          return false;
        }
      } else {
        return false;
      }
    }, markup_tree);
    let effects_list = filter(markup_tree, effect_$q_);
    return merge(markup, _$n__$M_(_kwd6["tree"], node_tree, _kwd6["effects"], effects_list));
  } else {
    return markup;
  }
}
function head(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["head"], props, ...listToArray(map(children, confirm_child)));
}
function html(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["html"], props, ...listToArray(map(children, confirm_child)));
}
function link(props, ...children) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  children = arrayToList(children);
  return create_element(_kwd6["link"], props, ...listToArray(map(children, confirm_child)));
}
function list__GT_(props, children) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return create_list_element(_kwd6["div"], props, children);
}

// server-out/respo.comp.space.js
var _kwd7 = {};
["height", "width", "display", "inline-block", "effects", "name", "comp-space", "tree", "style", "height", "width"].forEach((x) => {
  _kwd7[x] = kwd(x);
});
function comp_space(w, h) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return extract_effects_list(_$n__PCT__$M_(Component, _kwd7["effects"], _$L_(), _kwd7["name"], _kwd7["comp-space"], _kwd7["tree"], function __fn__() {
    return div(_$n__$M_(_kwd7["style"], some_$q_(w) ? assoc(style_space, _kwd7["width"], w) : assoc(style_space, _kwd7["height"], h)));
  }()));
}
function _$e__LT_(w, x) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return comp_space(w, x);
}
var style_space = _$n__$M_(_kwd7["height"], 1, _kwd7["width"], 1, _kwd7["display"], _kwd7["inline-block"]);

// server-out/app.server.js
var $chalk = __toESM(require_source());
var import_dayjs = __toESM(require_dayjs_min());
var import_finalhandler = __toESM(require_finalhandler());
var $formidable = __toESM(require_lib2());
var $fs = __toESM(require("fs"));

// server-out/respo-ui.core.js
var _kwd8 = {};
["display", "flex-direction", "justify-content", "align-items", "display", "align-items", "flex-direction"].forEach((x) => {
  _kwd8[x] = kwd(x);
});
function hsl(h, s, l, a2) {
  if (arguments.length < 3)
    throw new Error("too few arguments");
  if (arguments.length > 4)
    throw new Error("too many arguments");
  if (some_$q_(a2)) {
    return _$n_str_$o_concat("hsl(", _$n_str_$o_concat(h, _$n_str_$o_concat(",", _$n_str_$o_concat(s, _$n_str_$o_concat("%,", _$n_str_$o_concat(l, _$n_str_$o_concat("%,", _$n_str_$o_concat(a2, _$n_str_$o_concat(")", "")))))))));
  } else {
    return _$n_str_$o_concat("hsl(", _$n_str_$o_concat(h, _$n_str_$o_concat(",", _$n_str_$o_concat(s, _$n_str_$o_concat("%,", _$n_str_$o_concat(l, _$n_str_$o_concat("%)", "")))))));
  }
}
var center = _$n__$M_(_kwd8["display"], "flex", _kwd8["flex-direction"], "column", _kwd8["justify-content"], "center", _kwd8["align-items"], "center");
var font_fancy = "Josefin Sans, Helvetica neue, Arial, sans-serif";
var row = _$n__$M_(_kwd8["display"], "flex", _kwd8["align-items"], "stretch", _kwd8["flex-direction"], "row");

// server-out/app.server.js
var $ip = __toESM(require_ip());

// node_modules/latest-version/index.js
var import_package_json = __toESM(require_package_json(), 1);
async function latestVersion(packageName, options) {
  const { version } = await (0, import_package_json.default)(packageName.toLowerCase(), options);
  return version;
}

// server-out/respo.util.format.js
var _kwd9 = {};
["tree", "event", "children", "tree", "event", "children"].forEach((x) => {
  _kwd9[x] = kwd(x);
});
function dashed__GT_camel(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return x.replace(dashed_letter_pattern, function f_PCT_2(cc, pos, prop) {
    if (arguments.length !== 3)
      throw new Error("argument sizes do not match");
    return aget(cc, 1).toUpperCase();
  });
}
function get_style_value(x, prop) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (string_$q_(x)) {
    return x;
  } else if (keyword_$q_(x)) {
    return turn_string(x);
  } else if (number_$q_(x)) {
    if (pattern_non_dimension_props.test(prop)) {
      return _$n_str_$o_concat(x, "");
    } else {
      return _$n_str_$o_concat(x, _$n_str_$o_concat("px", ""));
    }
  } else {
    return _$n_str_$o_concat(x, "");
  }
}
function mute_element(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (component_$q_(element)) {
    return update(element, _kwd9["tree"], mute_element);
  } else {
    return update(update(element, _kwd9["event"], function f_PCT_2(events) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$n__$M_();
    }), _kwd9["children"], function f_PCT_2(children) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return map(children, function f_PCT_3(entry) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return _$L_(first2(entry), mute_element(last(entry)));
      });
    });
  }
}
function prop__GT_attr(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  includes_$q_(x, "?") ? function __fn__() {
    console.log(printable("[Respo] warning: property includes `?` in", x));
  }() : null;
  let v__57 = x;
  if (_$n__$e_(v__57, "class-name")) {
    return "class";
  } else if (_$n__$e_(v__57, "tab-index")) {
    return "tabindex";
  } else if (_$n__$e_(v__57, "read-only")) {
    return "readonly";
  } else if (_$n__$e_(v__57, x)) {
    return x;
  } else {
    return null;
  }
}
function purify_events(events) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return map(filter(to_pairs(events), function f_PCT_2(pair) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(pair);
    let v = first2(pair);
    return some_$q_(v);
  }), first2);
}
function purify_element(markup) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(markup)) {
    return null;
  } else if (component_$q_(markup)) {
    return purify_element(function __fn__() {
      let t = get(markup, _kwd9["tree"]);
      nil_$q_(t) ? function __fn__2() {
        let err_AUTO_1 = new Error("tree is empty");
        err_AUTO_1.data = null;
        throw err_AUTO_1;
      }() : null;
      return t;
    }());
  } else if (element_$q_(markup)) {
    return update(update(markup, _kwd9["event"], purify_events), _kwd9["children"], function f_PCT_2(children) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return map(children, function f_PCT_3(pair) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        let k = first2(pair);
        let child = last(pair);
        return _$L_(k, purify_element(child));
      });
    });
  } else {
    console.warn("Unknown markup during purify:", markup);
    return null;
  }
}
function text__GT_html(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (some_$q_(x)) {
    return invoke_method("replace")(invoke_method("replace")(_$n_str_$o_concat(x, ""), ">", "&gt;"), "<", "&lt;");
  } else {
    return null;
  }
}
var dashed_letter_pattern = new RegExp("-[a-z]", "g");
var pattern_non_dimension_props = new RegExp("acit|ex(?:s|g|n|p|$)|rph|grid|ows|mnc|ntw|ine[ch]|zoo|^ord|itera", "i");

// server-out/respo.render.html.js
var _kwd10 = {};
["style", "name", "attrs", "style", "innerHTML", "inner-text", "name", "textarea", "value", "innerHTML", "inner-text", "style", "children"].forEach((x) => {
  _kwd10[x] = kwd(x);
});
function escape_html(text) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (nil_$q_(text)) {
    return "";
  } else {
    return invoke_method("replace")(invoke_method("replace")(invoke_method("replace")(invoke_method("replace")(text, '"', "&quot;"), "<", "&lt;"), ">", "&gt;"), "\n", "&#13;&#10;");
  }
}
function style__GT_string(styles) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return join_str(map(styles, function f_PCT_2(entry) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(entry);
    let style_name = turn_string(k);
    let v = get_style_value(last(entry), dashed__GT_camel(style_name));
    return _$n_str_$o_concat(style_name, _$n_str_$o_concat(":", _$n_str_$o_concat(escape_html(v), _$n_str_$o_concat(";", ""))));
  }), "");
}
function entry__GT_string(entry) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let k = first2(entry);
  let v = last(entry);
  return _$n_str_$o_concat(prop__GT_attr(turn_string(k)), _$n_str_$o_concat("=", _$n_str_$o_concat(invoke_method("escape")(function __fn__() {
    if (_$e_(k, _kwd10["style"])) {
      return style__GT_string(v);
    } else if (bool_$q_(v)) {
      return _$n_str_$o_concat(v, "");
    } else if (number_$q_(v)) {
      return _$n_str_$o_concat(v, "");
    } else if (keyword_$q_(v)) {
      return turn_string(v);
    } else if (string_$q_(v)) {
      return escape_html(v);
    } else {
      return _$n_str_$o_concat(v, "");
    }
  }()), "")));
}
function props__GT_string(props) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return join_str(map(filter(invoke_method("to-list")(props), function f_PCT_2(pair) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let k = first2(pair);
    let v = last(pair);
    if (some_$q_(v)) {
      let v1__56 = not(starts_with_$q_(turn_string(k), "on-"));
      if (v1__56) {
        return v1__56;
      } else {
        return false;
      }
    } else {
      return false;
    }
  }), entry__GT_string), " ");
}
function element__GT_string(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let tag_name = turn_string(get(element, _kwd10["name"]));
  let attrs = pairs_map(get(element, _kwd10["attrs"]));
  let styles = function __fn__() {
    let v1__54 = get(element, _kwd10["style"]);
    if (nil_$q_(v1__54)) {
      return _$n__$M_();
    } else {
      return v1__54;
    }
  }();
  let text_inside = _$e_(get(element, _kwd10["name"]), _kwd10["textarea"]) ? escape_html(get(attrs, _kwd10["value"])) : function __fn__() {
    let v1__55 = get(attrs, _kwd10["innerHTML"]);
    if (nil_$q_(v1__55)) {
      return text__GT_html(get(attrs, _kwd10["inner-text"]));
    } else {
      return v1__55;
    }
  }();
  let tailored_props = function f_PCT_2(props) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    if (empty_$q_(styles)) {
      return props;
    } else {
      return assoc(props, _kwd10["style"], styles);
    }
  }(dissoc(dissoc(attrs, _kwd10["innerHTML"]), _kwd10["inner-text"]));
  let props_in_string = props__GT_string(tailored_props);
  if (_$n_set_$o_includes_$q_(self_closing, tag_name)) {
    return _$n_str_$o_concat("<", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(_GT_(count(props_in_string), 0) ? " " : "", _$n_str_$o_concat(props_in_string, _$n_str_$o_concat(" >", "")))));
  } else {
    let children = map(get(element, _kwd10["children"]), function f_PCT_2(entry) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let child = last(entry);
      return element__GT_string(child);
    });
    return _$n_str_$o_concat("<", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(_GT_(count(props_in_string), 0) ? " " : "", _$n_str_$o_concat(props_in_string, _$n_str_$o_concat(">", _$n_str_$o_concat(nil_$q_(text_inside) ? join_str(children, "") : text_inside, _$n_str_$o_concat("</", _$n_str_$o_concat(tag_name, _$n_str_$o_concat(">", "")))))))));
  }
}
function make_string(element) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return element__GT_string(purify_element(mute_element(element)));
}
var self_closing = _SHA__$M_("area", "base", "br", "col", "embed", "hr", "img", "input", "link", "meta", "param", "source", "track", "wbr");

// server-out/app.server.js
var $path = __toESM(require("path"));
var import_prettysize = __toESM(require_prettysize());
var $qrcode = __toESM(require_main());
var import_serve_static = __toESM(require_serve_static());

// server-out/lilac.util.js
var _kwd11 = {};
[].forEach((x) => {
  _kwd11[x] = kwd(x);
});
function check_keys(message2, data, xs) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let real_keys = keys(data);
  return apply(function f_PCT_2(xs2) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let times_AUTO_3 = 0;
    while (true) {
      let ret_AUTO_2 = null;
      if (times_AUTO_3 > 1e5)
        throw new Error("tail recursion not stopping");
      if (not(empty_$q_(xs2))) {
        let k = first2(xs2);
        not(any_$q_(xs2, function f_PCT_3(x) {
          if (arguments.length !== 1)
            throw new Error("argument sizes do not match");
          return _$e_(k, x);
        })) ? function __fn__() {
          console.log(printable("Lilac warning:", message2, "unexpected key", pr_str(k), ", expect", pr_str(xs2)));
        }() : null;
        ret_AUTO_2 = recur(rest2(xs2));
      } else {
        ret_AUTO_2 = null;
      }
      if (ret_AUTO_2 instanceof CalcitRecur) {
        if (ret_AUTO_2.args.length !== 1)
          throw new Error("argument sizes do not match");
        [xs2] = ret_AUTO_2.args;
        times_AUTO_3 += 1;
        continue;
      } else {
        return ret_AUTO_2;
      }
    }
  }, _$L_(real_keys));
}
function preview_data(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (string_$q_(x)) {
    return pr_str(x);
  } else if (bool_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (number_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (keyword_$q_(x)) {
    return _$n_str_$o_concat(x, "");
  } else if (symbol_$q_(x)) {
    return _$n_str_$o_concat("'", _$n_str_$o_concat(x, ""));
  } else if (map_$q_(x)) {
    return "a map";
  } else if (set_$q_(x)) {
    return "a set";
  } else if (list_$q_(x)) {
    return "a list";
  } else if (nil_$q_(x)) {
    return "nil";
  } else {
    return _$n_str_$o_concat("Unknown: ", _$n_str_$o_concat(_$n_str_$o_slice(_$n_str_$o_concat(x, ""), 0, 10), ""));
  }
}
function seq_difference(xs, ys) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  return filter_not(xs, function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return any_$q_(ys, function f_PCT_3(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$e_(x, y);
    });
  });
}
function seq_equal(xs, ys) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  if (every_$q_(xs, function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return any_$q_(ys, function f_PCT_3(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return _$e_(x, y);
    });
  })) {
    let v1__29 = every_$q_(ys, function f_PCT_2(y) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      return any_$q_(xs, function f_PCT_3(x) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return _$e_(x, y);
      });
    });
    if (v1__29) {
      return v1__29;
    } else {
      return false;
    }
  } else {
    return false;
  }
}

// server-out/lilac.core.js
var _kwd12 = {};
["some?", "lilac-type", "any", "options", "some?", "lilac-type", "boolean", "message", "coord", "next", "ok?", "some?", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "fn", "ok?", "data", "rule", "coord", "message", "options", "message", "items", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "min", "max", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "re", "nonblank?", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "options", "message", "items", "check-size?", "ok?", "coord", "rule", "data", "message", "options", "message", "ok?", "coord", "rule", "data", "message", "options", "message", "next", "ok?", "data", "rule", "coord", "message", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "pairs", "exact-keys?", "check-keys?", "all-optional?", "options", "message", "ok?", "proto", "ok?", "data", "rule", "coord", "message", "options", "message", "ok?", "data", "rule", "coord", "message", "ok?", "data", "rule", "coord", "message", "dict", "type-field", "ok?", "coord", "rule", "data", "message", "options", "message", "ok?", "coord", "rule", "data", "message", "options", "message", "next", "items", "ok?", "coord", "rule", "data", "message", "options", "message", "branches", "next", "ok?", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "next", "key-shape", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "item", "ok?", "data", "rule", "coord", "message", "options", "message", "lilac-type", "ok?", "formatted-message", "fn", "name", "args", "items", "ok?", "coord", "rule", "data", "message", "options", "message", "next", "boolean", "string", "nil", "fn", "keyword", "symbol", "number", "record", "map", "list", "set", "not", "or", "and", "custom", "component", "is", "optional", "tuple", "any", "enum", "pick-type", "lilac-type", "keyword", "options", "lilac-type", "map", "key-shape", "item", "options", "lilac-type", "nil", "max", "min", "lilac-type", "number", "max", "min", "options", "lilac-type", "optional", "item", "options", "lilac-type", "or", "items", "options", "exact-keys?", "check-keys?", "all-optional?", "proto", "lilac-type", "record", "pairs", "options", "exact-keys?", "check-keys?", "all-optional?", "proto", "nonblank?", "re", "lilac-type", "string", "re", "nonblank?", "options"].forEach((x) => {
  _kwd12[x] = kwd(x);
});
function any_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  check_keys("checking any+", options, _$L_(_kwd12["some?"]));
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["any"], _kwd12["options"], options, _kwd12["some?"], get(options, _kwd12["some?"]));
}
function boolean_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["boolean"]);
}
var format_message = function format_message2(acc, result) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let times_AUTO_3 = 0;
  while (true) {
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 1e5)
      throw new Error("tail recursion not stopping");
    if (nil_$q_(result)) {
      ret_AUTO_2 = acc;
    } else {
      let message2 = _$n_str_$o_concat(get(result, _kwd12["message"]), _$n_str_$o_concat(" at ", _$n_str_$o_concat(filter_not(get(result, _kwd12["coord"]), symbol_$q_), "")));
      ret_AUTO_2 = recur(_$n_str_$o_concat(acc, _$n_str_$o_concat(some_$q_(acc) ? "\n" : "", _$n_str_$o_concat(message2, ""))), get(result, _kwd12["next"]));
    }
    if (ret_AUTO_2 instanceof CalcitRecur) {
      if (ret_AUTO_2.args.length !== 2)
        throw new Error("argument sizes do not match");
      [acc, result] = ret_AUTO_2.args;
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
};
function validate_any(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("number"));
  let something_$q_ = function __fn__() {
    let v1__43 = get(rule, _kwd12["some?"]);
    if (nil_$q_(v1__43)) {
      return false;
    } else {
      return v1__43;
    }
  }();
  if (something_$q_) {
    if (some_$q_(data)) {
      return ok_result;
    } else {
      return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
        let v1__44 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
        if (nil_$q_(v1__44)) {
          return _$n_str_$o_concat("expects something, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else {
          return v1__44;
        }
      }());
    }
  } else {
    return ok_result;
  }
}
function validate_boolean(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  if (bool_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], append2(coord, new CalcitSymbol("boolean")), _kwd12["message"], function __fn__() {
      let v1__8 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__8)) {
        return _$n_str_$o_concat("expects a boolean, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__8;
      }
    }());
  }
}
function validate_custom(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let method = get(rule, _kwd12["fn"]);
  let next_coord = append2(coord, new CalcitSymbol("custom"));
  let result = method(data, rule, coord);
  if (get(result, _kwd12["ok?"])) {
    return result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], next_coord, _kwd12["message"], function __fn__() {
      let v1__36 = function __fn__2() {
        let v1__37 = get(result, _kwd12["message"]);
        if (nil_$q_(v1__37)) {
          return get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
        } else {
          return v1__37;
        }
      }();
      if (nil_$q_(v1__36)) {
        return "failed to validate with custom method";
      } else {
        return v1__36;
      }
    }());
  }
}
function validate_enum(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("enum"));
  let items = get(rule, _kwd12["items"]);
  if (includes_$q_(items, data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__45 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__45)) {
        return _$n_str_$o_concat("expects value of ", _$n_str_$o_concat(pr_str(items), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else {
        return v1__45;
      }
    }());
  }
}
function validate_fn(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("fn"));
  if (fn_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], next_coord, _kwd12["message"], function __fn__() {
      let v1__14 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__14)) {
        return _$n_str_$o_concat("expects a function, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__14;
      }
    }());
  }
}
function validate_is(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("is"));
  if (_$e_(data, get(rule, _kwd12["item"]))) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__38 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__38)) {
        return _$n_str_$o_concat("expects just ", _$n_str_$o_concat(preview_data(get(rule, _kwd12["item"])), _$n_str_$o_concat(", got ", _$n_str_$o_concat(preview_data(data), ""))));
      } else {
        return v1__38;
      }
    }());
  }
}
function validate_keyword(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("keyword"));
  if (keyword_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], next_coord, _kwd12["message"], function __fn__() {
      let v1__15 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__15)) {
        return _$n_str_$o_concat("expects a keyword, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__15;
      }
    }());
  }
}
function validate_nil(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let next_coord = append2(coord, new CalcitSymbol("nil"));
  if (nil_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], next_coord, _kwd12["message"], function __fn__() {
      let v1__13 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__13)) {
        return _$n_str_$o_concat("expects a nil, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__13;
      }
    }());
  }
}
function validate_number(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("number"));
  let min_v = get(rule, _kwd12["min"]);
  let max_v = get(rule, _kwd12["max"]);
  if (number_$q_(data)) {
    if ((some_$q_(min_v) ? _GT__$e_(data, min_v) : true) ? function __fn__() {
      let v1__17 = some_$q_(max_v) ? _LT__$e_(data, max_v) : true;
      if (v1__17) {
        return v1__17;
      } else {
        return false;
      }
    }() : false) {
      return ok_result;
    } else {
      return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
        let v1__18 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
        if (nil_$q_(v1__18)) {
          return _$n_str_$o_concat("expects number not in the range, got ", _$n_str_$o_concat(preview_data(data), ""));
        } else {
          return v1__18;
        }
      }());
    }
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__19 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__19)) {
        return _$n_str_$o_concat("expects a number, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__19;
      }
    }());
  }
}
function validate_string(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("string"));
  let re = get(rule, _kwd12["re"]);
  let nonblank_$q_ = function __fn__() {
    let v1__9 = get(rule, _kwd12["nonblank?"]);
    if (nil_$q_(v1__9)) {
      return false;
    } else {
      return v1__9;
    }
  }();
  if (string_$q_(data)) {
    if (some_$q_(re)) {
      console.log(printable("re-matches is not supported"));
    } else if (some_$q_(nonblank_$q_)) {
      if (nonblank_$q_ ? function __fn__() {
        let v1__10 = _$e_("", trim(data));
        if (v1__10) {
          return v1__10;
        } else {
          return false;
        }
      }() : false) {
        return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
          let v1__11 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
          if (nil_$q_(v1__11)) {
            return _$n_str_$o_concat("expects nonblank string , got ", _$n_str_$o_concat(preview_data(data), ""));
          } else {
            return v1__11;
          }
        }());
      } else {
        return ok_result;
      }
    } else {
      return ok_result;
    }
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__12 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__12)) {
        return _$n_str_$o_concat("expected a string, but got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__12;
      }
    }());
  }
}
function validate_symbol(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("symbol"));
  if (symbol_$q_(data)) {
    return ok_result;
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__16 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__16)) {
        return _$n_str_$o_concat("expects a symbol, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__16;
      }
    }());
  }
}
function validate_tuple(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, _kwd12["items"]);
  let next_coord = append2(coord, new CalcitSymbol("tuple"));
  let check_size_$q_ = function __fn__() {
    let v1__39 = get(rule, _kwd12["check-size?"]);
    if (nil_$q_(v1__39)) {
      return false;
    } else {
      return v1__39;
    }
  }();
  let check_values = function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return apply(function generated_loop(xs, ys, idx) {
      if (arguments.length !== 3)
        throw new Error("argument sizes do not match");
      let times_AUTO_6 = 0;
      while (true) {
        let ret_AUTO_5 = null;
        if (times_AUTO_6 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          if (check_size_$q_) {
            if (empty_$q_(ys) ? function __fn__() {
              let v1__40 = _$e_(count(items), count(data));
              if (v1__40) {
                return v1__40;
              } else {
                return false;
              }
            }() : false) {
              ret_AUTO_5 = _$n__$M_(_kwd12["ok?"], true);
            } else {
              ret_AUTO_5 = _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], ys, _kwd12["message"], function __fn__() {
                let v1__41 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
                if (nil_$q_(v1__41)) {
                  return _$n_str_$o_concat("expects tuple of ", _$n_str_$o_concat(count(items), _$n_str_$o_concat(" items, got ", _$n_str_$o_concat(count(data), ""))));
                } else {
                  return v1__41;
                }
              }());
            }
          } else {
            ret_AUTO_5 = ok_result;
          }
        } else {
          let r0 = first2(xs);
          let y0 = first2(ys);
          let child_coord = append2(next_coord, idx);
          let result = validate_lilac(y0, r0, child_coord);
          if (get(result, _kwd12["ok?"])) {
            ret_AUTO_5 = recur(rest2(xs), rest2(ys), inc(idx));
          } else {
            ret_AUTO_5 = _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], y0, _kwd12["message"], function __fn__() {
              let v1__42 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
              if (nil_$q_(v1__42)) {
                return 'failed validating in "tuple"';
              } else {
                return v1__42;
              }
            }(), _kwd12["next"], result);
          }
        }
        if (ret_AUTO_5 instanceof CalcitRecur) {
          if (ret_AUTO_5.args.length !== 3)
            throw new Error("argument sizes do not match");
          [xs, ys, idx] = ret_AUTO_5.args;
          times_AUTO_6 += 1;
          continue;
        } else {
          return ret_AUTO_5;
        }
      }
    }, _$L_(items, data, 0));
  };
  if (list_$q_(data)) {
    return check_values();
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], _$n_str_$o_concat("expects a vector for tuple, got ", _$n_str_$o_concat(preview_data(data), "")));
  }
}
function validate_set(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item_rule = get(rule, _kwd12["item"]);
  let coord = append2(base_coord, new CalcitSymbol("set"));
  if (set_$q_(data)) {
    return apply(function generated_loop(xs, idx) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let times_AUTO_9 = 0;
      while (true) {
        let ret_AUTO_8 = null;
        if (times_AUTO_9 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_8 = ok_result;
        } else {
          let x0 = first2(xs);
          let child_coord = append2(coord, idx);
          let result = validate_lilac(x0, item_rule, child_coord);
          if (get(result, _kwd12["ok?"])) {
            ret_AUTO_8 = recur(rest2(xs), inc(idx));
          } else {
            ret_AUTO_8 = result;
          }
        }
        if (ret_AUTO_8 instanceof CalcitRecur) {
          if (ret_AUTO_8.args.length !== 2)
            throw new Error("argument sizes do not match");
          [xs, idx] = ret_AUTO_8.args;
          times_AUTO_9 += 1;
          continue;
        } else {
          return ret_AUTO_8;
        }
      }
    }, _$L_(data, 0));
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__32 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__32)) {
        return _$n_str_$o_concat("expects a set, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__32;
      }
    }());
  }
}
function validate_record(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("record"));
  let pairs = get(rule, _kwd12["pairs"]);
  let exact_keys_$q_ = function __fn__() {
    let v1__20 = get(rule, _kwd12["exact-keys?"]);
    if (nil_$q_(v1__20)) {
      return false;
    } else {
      return v1__20;
    }
  }();
  let check_keys_$q_ = function __fn__() {
    let v1__21 = get(rule, _kwd12["check-keys?"]);
    if (nil_$q_(v1__21)) {
      return false;
    } else {
      return v1__21;
    }
  }();
  let all_optional_$q_ = function __fn__() {
    let v1__22 = get(rule, _kwd12["all-optional?"]);
    if (nil_$q_(v1__22)) {
      return false;
    } else {
      return v1__22;
    }
  }();
  let default_message = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
  let wanted_keys = keys(pairs);
  let existed_keys = function __fn__() {
    let v1__23 = map_$q_(data);
    if (nil_$q_(v1__23)) {
      return record_$q_(data);
    } else if (_$e_(false, v1__23)) {
      return record_$q_(data);
    } else {
      return v1__23;
    }
  }() ? keys(data) : null;
  let check_values = function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return apply(function generated_loop(xs) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let times_AUTO_12 = 0;
      while (true) {
        let ret_AUTO_11 = null;
        if (times_AUTO_12 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_11 = ok_result;
        } else {
          let x0 = first2(xs);
          let k0 = first2(x0);
          let r0 = last(x0);
          let child_coord = append2(coord, k0);
          let v = get(data, k0);
          if (all_optional_$q_ ? function __fn__() {
            let v1__24 = nil_$q_(v);
            if (v1__24) {
              return v1__24;
            } else {
              return false;
            }
          }() : false) {
            ret_AUTO_11 = recur(rest2(xs));
          } else {
            let result = validate_lilac(v, r0, child_coord);
            if (get(result, _kwd12["ok?"])) {
              ret_AUTO_11 = recur(rest2(xs));
            } else {
              ret_AUTO_11 = result;
            }
          }
        }
        if (ret_AUTO_11 instanceof CalcitRecur) {
          if (ret_AUTO_11.args.length !== 1)
            throw new Error("argument sizes do not match");
          [xs] = ret_AUTO_11.args;
          times_AUTO_12 += 1;
          continue;
        } else {
          return ret_AUTO_11;
        }
      }
    }, _$L_(to_pairs(pairs)));
  };
  if (not(function __fn__() {
    let v1__25 = map_$q_(data);
    if (nil_$q_(v1__25)) {
      if (record_$q_(data)) {
        let v1__26 = some_$q_(get(rule, _kwd12["proto"])) ? invoke_method("matches?")(get(rule, _kwd12["proto"]), data) : true;
        if (v1__26) {
          return v1__26;
        } else {
          return false;
        }
      } else {
        return false;
      }
    } else if (_$e_(false, v1__25)) {
      if (record_$q_(data)) {
        let v1__27 = some_$q_(get(rule, _kwd12["proto"])) ? invoke_method("matches?")(get(rule, _kwd12["proto"]), data) : true;
        if (v1__27) {
          return v1__27;
        } else {
          return false;
        }
      } else {
        return false;
      }
    } else {
      return v1__25;
    }
  }())) {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__28 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__28)) {
        return _$n_str_$o_concat("expects a record, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__28;
      }
    }());
  } else if (exact_keys_$q_) {
    if (seq_equal(existed_keys, wanted_keys)) {
      return check_values();
    } else {
      return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], nil_$q_(default_message) ? function __fn__() {
        let extra_keys = seq_difference(existed_keys, wanted_keys);
        let missing_keys = seq_difference(wanted_keys, existed_keys);
        if (not(empty_$q_(extra_keys))) {
          return _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, ""))));
        } else {
          return _$n_str_$o_concat("missing record keys ", _$n_str_$o_concat(missing_keys, _$n_str_$o_concat(" of ", _$n_str_$o_concat(wanted_keys, ""))));
        }
      }() : default_message);
    }
  } else if (check_keys_$q_) {
    let extra_keys = seq_difference(existed_keys, wanted_keys);
    if (empty_$q_(extra_keys)) {
      return check_values();
    } else {
      return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], nil_$q_(default_message) ? _$n_str_$o_concat("unexpected record keys ", _$n_str_$o_concat(extra_keys, _$n_str_$o_concat(" for ", _$n_str_$o_concat(wanted_keys, "")))) : default_message);
    }
  } else {
    return check_values();
  }
}
function validate_pick_type(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let dict = get(rule, _kwd12["dict"]);
  let next_coord = append2(coord, new CalcitSymbol("pick-type"));
  let type_field = get(rule, _kwd12["type-field"]);
  let data_type = get(data, type_field);
  if (nil_$q_(get(dict, data_type))) {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], data, _kwd12["message"], function __fn__() {
      let v1__46 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__46)) {
        return _$n_str_$o_concat("found no matched type in pick-type: ", _$n_str_$o_concat(data_type, ""));
      } else {
        return v1__46;
      }
    }());
  } else {
    let next_rule = get(dict, data_type);
    let result = validate_lilac(data, next_rule, next_coord);
    if (get(result, _kwd12["ok?"])) {
      return result;
    } else {
      return _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], data, _kwd12["message"], function __fn__() {
        let v1__47 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
        if (nil_$q_(v1__47)) {
          return _$n_str_$o_concat("failed to match in pick-type", "");
        } else {
          return v1__47;
        }
      }(), _kwd12["next"], result);
    }
  }
}
function validate_or(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, _kwd12["items"]);
  let next_coord = append2(coord, new CalcitSymbol("or"));
  return apply(function generated_loop(xs, branches) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let times_AUTO_15 = 0;
    while (true) {
      let ret_AUTO_14 = null;
      if (times_AUTO_15 > 1e5)
        throw new Error("tail recursion not stopping");
      if (empty_$q_(xs)) {
        ret_AUTO_14 = _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], data, _kwd12["message"], function __fn__() {
          let v1__34 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
          if (nil_$q_(v1__34)) {
            return 'found no matched case in "or"';
          } else {
            return v1__34;
          }
        }(), _kwd12["branches"], branches, _kwd12["next"], last(branches));
      } else {
        let r0 = first2(xs);
        let result = validate_lilac(data, r0, next_coord);
        if (get(result, _kwd12["ok?"])) {
          ret_AUTO_14 = result;
        } else {
          ret_AUTO_14 = recur(rest2(xs), append2(branches, result));
        }
      }
      if (ret_AUTO_14 instanceof CalcitRecur) {
        if (ret_AUTO_14.args.length !== 2)
          throw new Error("argument sizes do not match");
        [xs, branches] = ret_AUTO_14.args;
        times_AUTO_15 += 1;
        continue;
      } else {
        return ret_AUTO_14;
      }
    }
  }, _$L_(items, _$L_()));
}
function validate_optional(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item = get(rule, _kwd12["item"]);
  let coord = append2(base_coord, new CalcitSymbol("optional"));
  if (nil_$q_(data)) {
    return ok_result;
  } else {
    return validate_lilac(data, item, coord);
  }
}
function validate_not(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let coord = append2(base_coord, new CalcitSymbol("not"));
  let item = get(rule, _kwd12["item"]);
  let result = validate_lilac(data, item, coord);
  if (get(result, _kwd12["ok?"])) {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__33 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__33)) {
        return 'expects a inverted value in "not"';
      } else {
        return v1__33;
      }
    }(), _kwd12["next"], result);
  } else {
    return ok_result;
  }
}
function validate_map(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let key_rule = get(rule, _kwd12["key-shape"]);
  let item_rule = get(rule, _kwd12["item"]);
  let coord = append2(base_coord, new CalcitSymbol("map"));
  if (map_$q_(data)) {
    return apply(function generated_loop(xs) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let times_AUTO_18 = 0;
      while (true) {
        let ret_AUTO_17 = null;
        if (times_AUTO_18 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_17 = ok_result;
        } else {
          let x0 = first2(xs);
          let k = first2(x0);
          let v = last(x0);
          let child_coord = append2(coord, k);
          let k_result = validate_lilac(k, key_rule, child_coord);
          let result = validate_lilac(v, item_rule, child_coord);
          if (get(k_result, _kwd12["ok?"])) {
            if (get(result, _kwd12["ok?"])) {
              ret_AUTO_17 = recur(rest2(xs));
            } else {
              ret_AUTO_17 = result;
            }
          } else {
            ret_AUTO_17 = k_result;
          }
        }
        if (ret_AUTO_17 instanceof CalcitRecur) {
          if (ret_AUTO_17.args.length !== 1)
            throw new Error("argument sizes do not match");
          [xs] = ret_AUTO_17.args;
          times_AUTO_18 += 1;
          continue;
        } else {
          return ret_AUTO_17;
        }
      }
    }, _$L_(to_pairs(data)));
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__30 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__30)) {
        return _$n_str_$o_concat("expects a map, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__30;
      }
    }());
  }
}
function validate_list(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let item_rule = get(rule, _kwd12["item"]);
  let coord = append2(base_coord, new CalcitSymbol("list"));
  if (list_$q_(data)) {
    return apply(function generated_loop(xs, idx) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      let times_AUTO_21 = 0;
      while (true) {
        let ret_AUTO_20 = null;
        if (times_AUTO_21 > 1e5)
          throw new Error("tail recursion not stopping");
        if (empty_$q_(xs)) {
          ret_AUTO_20 = ok_result;
        } else {
          let x0 = first2(xs);
          let child_coord = append2(coord, idx);
          let result = validate_lilac(x0, item_rule, child_coord);
          if (get(result, _kwd12["ok?"])) {
            ret_AUTO_20 = recur(rest2(xs), inc(idx));
          } else {
            ret_AUTO_20 = result;
          }
        }
        if (ret_AUTO_20 instanceof CalcitRecur) {
          if (ret_AUTO_20.args.length !== 2)
            throw new Error("argument sizes do not match");
          [xs, idx] = ret_AUTO_20.args;
          times_AUTO_21 += 1;
          continue;
        } else {
          return ret_AUTO_20;
        }
      }
    }, _$L_(data, 0));
  } else {
    return _$n__$M_(_kwd12["ok?"], false, _kwd12["data"], data, _kwd12["rule"], rule, _kwd12["coord"], coord, _kwd12["message"], function __fn__() {
      let v1__31 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
      if (nil_$q_(v1__31)) {
        return _$n_str_$o_concat("expects a list, got ", _$n_str_$o_concat(preview_data(data), ""));
      } else {
        return v1__31;
      }
    }());
  }
}
function validate_lilac(data, rule, arg) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  let coord = nil_$q_(arg) ? _$L_() : arg;
  let kind = get(rule, _kwd12["lilac-type"]);
  let method = get(core_methods, kind);
  let user_method = get(deref(_$s_custom_methods), kind);
  let result = function __fn__() {
    if (fn_$q_(method)) {
      return method(data, rule, coord);
    } else if (fn_$q_(user_method)) {
      return user_method(data, rule, coord);
    } else {
      console.log(printable("Unknown method:", kind, "of", rule));
      return quit_$x_(1);
    }
  }();
  if (get(result, _kwd12["ok?"])) {
    return result;
  } else {
    return assoc(result, _kwd12["formatted-message"], format_message("", result));
  }
}
function validate_component(data, rule, coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let lazy_fn = get(rule, _kwd12["fn"]);
  let next_coord = append2(coord, turn_symbol(get(rule, _kwd12["name"])));
  let next_rule = apply(lazy_fn, get(rule, _kwd12["args"]));
  return validate_lilac(data, next_rule, next_coord);
}
function validate_and(data, rule, base_coord) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  let items = get(rule, _kwd12["items"]);
  let next_coord = append2(base_coord, new CalcitSymbol("and"));
  return apply(function generated_loop(xs) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let times_AUTO_24 = 0;
    while (true) {
      let ret_AUTO_23 = null;
      if (times_AUTO_24 > 1e5)
        throw new Error("tail recursion not stopping");
      if (empty_$q_(xs)) {
        ret_AUTO_23 = ok_result;
      } else {
        let r0 = first2(xs);
        let result = validate_lilac(data, r0, next_coord);
        if (get(result, _kwd12["ok?"])) {
          ret_AUTO_23 = recur(rest2(xs));
        } else {
          ret_AUTO_23 = _$n__$M_(_kwd12["ok?"], false, _kwd12["coord"], next_coord, _kwd12["rule"], rule, _kwd12["data"], data, _kwd12["message"], function __fn__() {
            let v1__35 = get_in(rule, _$L_(_kwd12["options"], _kwd12["message"]));
            if (nil_$q_(v1__35)) {
              return 'failed validating in "and"';
            } else {
              return v1__35;
            }
          }(), _kwd12["next"], result);
        }
      }
      if (ret_AUTO_23 instanceof CalcitRecur) {
        if (ret_AUTO_23.args.length !== 1)
          throw new Error("argument sizes do not match");
        [xs] = ret_AUTO_23.args;
        times_AUTO_24 += 1;
        continue;
      } else {
        return ret_AUTO_23;
      }
    }
  }, _$L_(items));
}
var dev_check = () => {
};
dev_check.isMacro = true;
function keyword_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["keyword"], _kwd12["options"], options);
}
function map_ADD_(key_shape, item, arg) {
  if (arguments.length < 2)
    throw new Error("too few arguments");
  if (arguments.length > 3)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["map"], _kwd12["key-shape"], key_shape, _kwd12["item"], item, _kwd12["options"], options);
}
function nil_ADD_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["nil"]);
}
function number_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  check_keys("checking number+", options, _$L_(_kwd12["max"], _kwd12["min"]));
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["number"], _kwd12["max"], get(options, _kwd12["max"]), _kwd12["min"], get(options, _kwd12["min"]), _kwd12["options"], options);
}
function optional_ADD_(item, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["optional"], _kwd12["item"], item, _kwd12["options"], options);
}
function or_ADD_(items, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  (function __fn__() {
    not(string_$q_("expects items of or+ in vector")) ? function __fn__2() {
      let err_AUTO_25 = new Error("expects 1st argument to be string");
      err_AUTO_25.data = null;
      throw err_AUTO_25;
    }() : null;
    if (list_$q_(items)) {
      return null;
    } else {
      console.log(printable("Failed assertion:", format_to_lisp(new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("items")]))));
      let err_AUTO_26 = new Error("expects items of or+ in vector (list? items)");
      err_AUTO_26.data = null;
      throw err_AUTO_26;
    }
  })();
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["or"], _kwd12["items"], items, _kwd12["options"], options);
}
function record_ADD_(pairs, arg) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  check_keys("checking record+", options, _$L_(_kwd12["exact-keys?"], _kwd12["check-keys?"], _kwd12["all-optional?"], _kwd12["proto"]));
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["record"], _kwd12["pairs"], pairs, _kwd12["options"], options, _kwd12["exact-keys?"], function __fn__() {
    let v1__48 = get(options, _kwd12["exact-keys?"]);
    if (nil_$q_(v1__48)) {
      return false;
    } else {
      return v1__48;
    }
  }(), _kwd12["check-keys?"], function __fn__() {
    let v1__49 = get(options, _kwd12["check-keys?"]);
    if (nil_$q_(v1__49)) {
      return false;
    } else {
      return v1__49;
    }
  }(), _kwd12["all-optional?"], function __fn__() {
    let v1__50 = get(options, _kwd12["all-optional?"]);
    if (nil_$q_(v1__50)) {
      return false;
    } else {
      return v1__50;
    }
  }(), _kwd12["proto"], get(options, _kwd12["proto"]));
}
function string_ADD_(arg) {
  if (arguments.length < 0)
    throw new Error("too few arguments");
  if (arguments.length > 1)
    throw new Error("too many arguments");
  let options = nil_$q_(arg) ? _$n__$M_() : arg;
  check_keys("checking string+", options, _$L_(_kwd12["nonblank?"], _kwd12["re"]));
  return _$n__$M_(_kwd12["lilac-type"], _kwd12["string"], _kwd12["re"], get(options, _kwd12["re"]), _kwd12["nonblank?"], get(options, _kwd12["nonblank?"]), _kwd12["options"], options);
}
var _$s_custom_methods = peekDefatom("lilac.core/*custom-methods") ?? defatom("lilac.core/*custom-methods", _$n__$M_());
var _$s_in_dev_$q_ = peekDefatom("lilac.core/*in-dev?") ?? defatom("lilac.core/*in-dev?", true);
var ok_result = _$n__$M_(_kwd12["ok?"], true);
var core_methods = _$n__$M_(_kwd12["boolean"], validate_boolean, _kwd12["string"], validate_string, _kwd12["nil"], validate_nil, _kwd12["fn"], validate_fn, _kwd12["keyword"], validate_keyword, _kwd12["symbol"], validate_symbol, _kwd12["number"], validate_number, _kwd12["record"], validate_record, _kwd12["map"], validate_map, _kwd12["list"], validate_list, _kwd12["set"], validate_set, _kwd12["not"], validate_not, _kwd12["or"], validate_or, _kwd12["and"], validate_and, _kwd12["custom"], validate_custom, _kwd12["component"], validate_component, _kwd12["is"], validate_is, _kwd12["optional"], validate_optional, _kwd12["tuple"], validate_tuple, _kwd12["any"], validate_any, _kwd12["enum"], validate_enum, _kwd12["pick-type"], validate_pick_type);

// server-out/skir.core.js
var $http = __toESM(require("http"));

// server-out/skir.util.js
var _kwd13 = {};
[].forEach((x) => {
  _kwd13[x] = kwd(x);
});
function key__GT_str(v) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (keyword_$q_(v)) {
    return turn_string(v);
  } else if (string_$q_(v)) {
    return v;
  } else if (list_$q_(v)) {
    return pr_str(v);
  } else if (map_$q_(v)) {
    return pr_str(v);
  } else {
    return _$n_str_$o_concat(v, "");
  }
}
function promise_$q_(x) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  if (fn_$q_(x.then)) {
    let v1__51 = _$e_(x, Promise.resolve(x));
    if (v1__51) {
      return v1__51;
    } else {
      return false;
    }
  } else {
    return false;
  }
}

// server-out/skir.core.js
var _kwd14 = {};
["port", "after-start", "port", "host", "code", "message", "headers", "body", "check-keys?", "method", "get", "head", "post", "put", "delete", "connect", "options", "trace", "patch", "url", "headers", "body", "original-request", "ok?", "formatted-message", "code", "message", "headers", "body", "effect", "port", "host", "after-start"].forEach((x) => {
  _kwd14[x] = kwd(x);
});
function req__GT_edn(req) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return _$n__$M_(_kwd14["method"], function __fn__() {
    let v__6 = req.method;
    if (_$n__$e_(v__6, "GET")) {
      return _kwd14["get"];
    } else if (_$n__$e_(v__6, "HEAD")) {
      return _kwd14["head"];
    } else if (_$n__$e_(v__6, "POST")) {
      return _kwd14["post"];
    } else if (_$n__$e_(v__6, "PUT")) {
      return _kwd14["put"];
    } else if (_$n__$e_(v__6, "DELETE")) {
      return _kwd14["delete"];
    } else if (_$n__$e_(v__6, "CONNECT")) {
      return _kwd14["connect"];
    } else if (_$n__$e_(v__6, "OPTIONS")) {
      return _kwd14["options"];
    } else if (_$n__$e_(v__6, "TRACE")) {
      return _kwd14["trace"];
    } else if (_$n__$e_(v__6, "PATCH")) {
      return _kwd14["patch"];
    } else {
      return req.method;
    }
  }(), _kwd14["url"], req.url, _kwd14["headers"], to_calcit_data(req.headers), _kwd14["body"], null, _kwd14["original-request"], req);
}
function write_response_$x_(res, edn_res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  deref(_$s_in_dev_$q_) ? function __fn__() {
    let result__7 = validate_lilac(edn_res, lilac_response);
    if (not(get(result__7, _kwd14["ok?"]))) {
      console.log(printable(get(result__7, _kwd14["formatted-message"]), "\n", _$n_str_$o_concat("(dev-check ", _$n_str_$o_concat(new CalcitSymbol("edn-res"), _$n_str_$o_concat(" ", _$n_str_$o_concat(new CalcitSymbol("lilac-response"), _$n_str_$o_concat("), where props is: ", _$n_str_$o_concat(edn_res, ""))))))));
    } else {
      return null;
    }
  }() : null;
  res.statusCode = get(edn_res, _kwd14["code"]);
  res.statusMessage = get(edn_res, _kwd14["message"]);
  foldl(get(edn_res, _kwd14["headers"]), null, function doseq_fn_PCT_(_acc, pair) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let k = _$n_list_$o_nth(pair, 0);
    let v = _$n_list_$o_nth(pair, 1);
    return res.setHeader(key__GT_str(k), key__GT_str(v));
  });
  return res.end(function __fn__() {
    let body2 = get(edn_res, _kwd14["body"]);
    if (list_$q_(body2)) {
      return format_cirru_edn(body2);
    } else if (map_$q_(body2)) {
      return format_cirru_edn(body2);
    } else if (nil_$q_(body2)) {
      return "";
    } else if (string_$q_(body2)) {
      return body2;
    } else if (Array.isArray(body2)) {
      return JSON.stringify(body2);
    } else {
      return JSON.stringify(body2);
    }
  }());
}
function handle_request_$x_(req, res, handler) {
  if (arguments.length !== 3)
    throw new Error("argument sizes do not match");
  try {
    let edn_req = req__GT_edn(req);
    let response = handler(edn_req, res);
    if (map_$q_(response)) {
      return write_response_$x_(res, response);
    } else if (fn_$q_(response)) {
      return response(function f_PCT_2(response_data) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return write_response_$x_(res, response_data);
      });
    } else if (promise_$q_(response)) {
      return response.then(function f_PCT_2(result) {
        if (arguments.length !== 1)
          throw new Error("argument sizes do not match");
        return write_response_$x_(res, result);
      });
    } else if (_$e_(response, _kwd14["effect"])) {
      return null;
    } else {
      console.log(printable("Response:", response));
      let err_AUTO_1 = new Error("Unknown response!");
      err_AUTO_1.data = null;
      throw err_AUTO_1;
    }
  } catch (errMsg_AUTO_2) {
    return function f_PCT_2(err) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      console.error(err);
      res.statusCode = 500;
      res.statusMessage = "Server Error";
      return res.end(_$n_str_$o_concat(pr_str(err), _$n_str_$o_concat("\n", _$n_str_$o_concat("\n", _$n_str_$o_concat(err.stack, "")))));
    }(errMsg_AUTO_2.toString());
  }
}
function create_server_$x_(handler, user_options) {
  if (arguments.length < 1)
    throw new Error("too few arguments");
  if (arguments.length > 2)
    throw new Error("too many arguments");
  reset_$x_(_$s_req_handler, handler);
  let options = merge(default_options, user_options);
  let server = $http.createServer(function f_PCT_2(req, res) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return handle_request_$x_(req, res, deref(_$s_req_handler));
  });
  return server.listen(get(options, _kwd14["port"]), get(options, _kwd14["host"]), function f_PCT_2() {
    if (arguments.length !== 0)
      throw new Error("argument sizes do not match");
    return get(options, _kwd14["after-start"])(options);
  });
}
var _$s_req_handler = peekDefatom("skir.core/*req-handler") ?? defatom("skir.core/*req-handler", null);
var default_options = _$n__$M_(_kwd14["port"], 4e3, _kwd14["after-start"], function f_PCT_(options) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  console.log(printable(_$n_str_$o_concat("Server listening on ", _$n_str_$o_concat(get(options, _kwd14["port"]), ""))));
}, _kwd14["host"], "0.0.0.0");
var lilac_response = record_ADD_(_$n__$M_(_kwd14["code"], number_ADD_(), _kwd14["message"], optional_ADD_(string_ADD_()), _kwd14["headers"], optional_ADD_(map_ADD_(or_ADD_(_$L_(keyword_ADD_(), string_ADD_())), or_ADD_(_$L_(keyword_ADD_(), string_ADD_(), boolean_ADD_(), nil_ADD_())))), _kwd14["body"], any_ADD_()), _$n__$M_(_kwd14["check-keys?"], true));

// server-out/app.server.js
var _kwd15 = {};
["name", "size", "created-time", "effect", "meta", "content", "name", "meta", "charset", "rel", "href", "style", "padding", "font-family", "color", "font-size", "font-weight", "style", "padding", "created-time", "style", "line-height", "href", "name", "inner-text", "name", "style", "text-decoration", "none", "font-family", "font-size", "max-width", "overflow", "hidden", "text-overflow", "ellipsis", "size", "font-family", "color", "font-size", "created-time", "font-family", "color", "font-size", "code", "headers", "body", "effect", "code", "headers", "message", "code", "body", "code", "body", "code", "body", "original-request", "port", "after-start", "small"].forEach((x) => {
  _kwd15[x] = kwd(x);
});
async function check_version_$x_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  let pkg = invoke_method("parse")(JSON, $fs.readFileSync($path.join(__dirname, "../package.json")));
  let version = pkg.version;
  let npm_version = await latestVersion(pkg.name);
  if (_$e_(npm_version, version)) {
    console.log(printable("Running latest version", version));
  } else {
    console.log(printable($chalk.yellow(_$n_str_$o_concat("New version ", _$n_str_$o_concat(npm_version, _$n_str_$o_concat(" available, current one is ", _$n_str_$o_concat(version, _$n_str_$o_concat(" . Please upgrade!", _$n_str_$o_concat("\n\nyarn global add file-sucker\n", "")))))))));
  }
}
async function load_stats_$x_(xs) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  let tasks = js_array();
  foldl(xs, null, function doseq_fn_PCT_(_acc, x) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return tasks.push(new Promise(function f_PCT_2(resolve, reject) {
      if (arguments.length !== 2)
        throw new Error("argument sizes do not match");
      return $fs.stat(x, function f_PCT_3(err, stat2) {
        if (arguments.length !== 2)
          throw new Error("argument sizes do not match");
        return resolve(_$n__$M_(_kwd15["name"], x, _kwd15["size"], stat2.size, _kwd15["created-time"], stat2.ctime));
      });
    }));
  });
  return Promise.all(tasks);
}
function on_download_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  req.url = invoke_method("replace")(req.url, "/files/", "/");
  console.log(printable("url", req.url));
  serve_files_$x_(req, res, (0, import_finalhandler.default)(req, res));
  return _kwd15["effect"];
}
function turn_list(arr) {
  if (arguments.length !== 1)
    throw new Error("argument sizes do not match");
  return function f_PCT_2(xs, as) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    let times_AUTO_3 = 0;
    while (true) {
      let ret_AUTO_2 = null;
      if (times_AUTO_3 > 1e5)
        throw new Error("tail recursion not stopping");
      if (_$e_(0, as.length)) {
        ret_AUTO_2 = xs;
      } else {
        ret_AUTO_2 = recur(conj(xs, as[0]), as.slice(1));
      }
      if (ret_AUTO_2 instanceof CalcitRecur) {
        if (ret_AUTO_2.args.length !== 2)
          throw new Error("argument sizes do not match");
        [xs, as] = ret_AUTO_2.args;
        times_AUTO_3 += 1;
        continue;
      } else {
        return ret_AUTO_2;
      }
    }
  }(_$L_(), arr);
}
async function on_file_indexed_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let filenames = filter(to_calcit_data($fs.readdirSync(".")), function f_PCT_2(filename) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return invoke_method("isFile")($fs.lstatSync(filename));
  });
  let files_info = await load_stats_$x_(filenames);
  let result = make_string(html(_$n__$M_(), head(_$n__$M_(), create_element(_kwd15["meta"], _$n__$M_(_kwd15["content"], "width=device-width, initial-scale=1, maximum-scale=1.0, user-scalable=no", _kwd15["name"], "viewport")), create_element(_kwd15["meta"], _$n__$M_(_kwd15["charset"], "utf8")), link(_$n__$M_(_kwd15["rel"], "stylesheet", _kwd15["href"], "http://cdn.tiye.me/favored-fonts/josefin-sans.css"))), body(_$n__$M_(), div(_$n__$M_(), empty_$q_(filenames) ? div(_$n__$M_(_kwd15["style"], merge(center, _$n__$M_(_kwd15["padding"], 80))), _LT__GT_("No files", _$n__$M_(_kwd15["font-family"], font_fancy, _kwd15["color"], hsl(0, 0, 80), _kwd15["font-size"], 40, _kwd15["font-weight"], 300))) : null, list__GT_(_$n__$M_(_kwd15["style"], _$n__$M_(_kwd15["padding"], "24px 8px")), map_indexed(invoke_method("sort-by")(turn_list(files_info), function f_PCT_2(x) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    return negate(get(x, _kwd15["created-time"]));
  }), function f_PCT_2(idx, file) {
    if (arguments.length !== 2)
      throw new Error("argument sizes do not match");
    return _$L_(idx, div(_$n__$M_(_kwd15["style"], merge(row, _$n__$M_(_kwd15["line-height"], "40px"))), a(_$n__$M_(_kwd15["href"], _$n_str_$o_concat("/files/", _$n_str_$o_concat(get(file, _kwd15["name"]), "")), _kwd15["inner-text"], get(file, _kwd15["name"]), _kwd15["style"], _$n__$M_(_kwd15["text-decoration"], _kwd15["none"], _kwd15["font-family"], font_fancy, _kwd15["font-size"], 16, _kwd15["max-width"], "50vw", _kwd15["overflow"], _kwd15["hidden"], _kwd15["text-overflow"], _kwd15["ellipsis"]))), _$e__LT_(16, null), _LT__GT_((0, import_prettysize.default)(get(file, _kwd15["size"])), _$n__$M_(_kwd15["font-family"], font_fancy, _kwd15["color"], hsl(0, 0, 70), _kwd15["font-size"], 12)), _$e__LT_(16, null), _LT__GT_(invoke_method("format")((0, import_dayjs.default)(get(file, _kwd15["created-time"])), "MM-DD HH:mm"), _$n__$M_(_kwd15["font-family"], font_fancy, _kwd15["color"], hsl(0, 0, 70), _kwd15["font-size"], 12))));
  }))))));
  return _$n__$M_(_kwd15["code"], 200, _kwd15["headers"], _$n__$M_("Content-Type", "text/html"), _kwd15["body"], result);
}
function on_page_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  serve(req, res, (0, import_finalhandler.default)(req, res));
  return _kwd15["effect"];
}
function on_upload_$x_(req, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  res.setHeader("Access-Control-Allow-Origin", req.headers.origin);
  res.setHeader("Access-Control-Allow-Methods", "POST,GET,OPTIONS");
  let v__52 = req.method;
  if (_$n__$e_(v__52, "POST")) {
    return function f_PCT_2(send_$x_) {
      if (arguments.length !== 1)
        throw new Error("argument sizes do not match");
      let form = new $formidable.IncomingForm();
      let size_limit = _$s_(4, 1024, 1024, 1024);
      console.log(printable("New request of file transferring..."));
      form.maxFieldsSize = size_limit;
      form.maxFileSize = size_limit;
      return form.parse(req, function f_PCT_3(error, fields, files) {
        if (arguments.length !== 3)
          throw new Error("argument sizes do not match");
        some_$q_(error) ? function __fn__() {
          let err_AUTO_4 = new Error(error);
          err_AUTO_4.data = null;
          throw err_AUTO_4;
        }() : null;
        let file = files.file;
        console.log(printable("Received file:", file.name));
        return $fs.rename(file.path, $path.join(process.env.PWD, file.name), function f_PCT_4(rename_error) {
          if (arguments.length !== 1)
            throw new Error("argument sizes do not match");
          some_$q_(rename_error) ? function __fn__() {
            let err_AUTO_5 = new Error(rename_error);
            err_AUTO_5.data = null;
            throw err_AUTO_5;
          }() : null;
          return send_$x_(_$n__$M_(_kwd15["code"], 200, _kwd15["headers"], _$n__$M_(), _kwd15["message"], "Uploaded"));
        });
      });
    };
  } else if (_$n__$e_(v__52, "GET")) {
    return _$n__$M_(_kwd15["code"], 200, _kwd15["body"], "use POST");
  } else if (_$n__$e_(v__52, "OPTIONS")) {
    return _$n__$M_(_kwd15["code"], 200, _kwd15["body"], "ok");
  } else {
    return _$n__$M_(_kwd15["code"], 404, _kwd15["body"], "method not supported");
  }
}
function on_request_$x_(req_edn, res) {
  if (arguments.length !== 2)
    throw new Error("argument sizes do not match");
  let req = get(req_edn, _kwd15["original-request"]);
  if (_$e_("/upload", req.url)) {
    return on_upload_$x_(req, res);
  } else if (function __fn__() {
    let v1__53 = _$e_(req.url, "/files");
    if (nil_$q_(v1__53)) {
      return _$e_(req.url, "/files/");
    } else if (_$e_(false, v1__53)) {
      return _$e_(req.url, "/files/");
    } else {
      return v1__53;
    }
  }()) {
    return on_file_indexed_$x_(req, res);
  } else if (invoke_method("starts-with?")(req.url, "/files/")) {
    return on_download_$x_(req, res);
  } else {
    return on_page_$x_(req, res);
  }
}
function main_$x_() {
  if (arguments.length !== 0)
    throw new Error("argument sizes do not match");
  let port = function __fn__() {
    if (nil_$q_(process.env.PORT)) {
      if (nil_$q_(process.env.port)) {
        return 4e3;
      } else if (_$e_(false, process.env.port)) {
        return 4e3;
      } else {
        return process.env.port;
      }
    } else if (_$e_(false, process.env.PORT)) {
      if (nil_$q_(process.env.port)) {
        return 4e3;
      } else if (_$e_(false, process.env.port)) {
        return 4e3;
      } else {
        return process.env.port;
      }
    } else {
      return process.env.PORT;
    }
  }();
  return create_server_$x_(function _PCT__BSL_(_PCT_, _PCT_2) {
    if (arguments.length < 0)
      throw new Error("too few arguments");
    if (arguments.length > 2)
      throw new Error("too many arguments");
    return on_request_$x_(_PCT_, _PCT_2);
  }, _$n__$M_(_kwd15["port"], port, _kwd15["after-start"], function f_PCT_2(options) {
    if (arguments.length !== 1)
      throw new Error("argument sizes do not match");
    let address2 = _$n_str_$o_concat("\n", _$n_str_$o_concat("http://", _$n_str_$o_concat($ip.address(), _$n_str_$o_concat(":", _$n_str_$o_concat(port, _$n_str_$o_concat("\n", ""))))));
    console.log(printable("Open page on your phone and send file:", "\n", address2));
    $qrcode.generate(address2, _$n_js_object(_kwd15["small"], true), console.log);
    return check_version_$x_();
  }));
}
var serve_files_$x_ = (0, import_serve_static.default)(process.env.PWD, _$n_js_object("index", js_array()));
var serve = (0, import_serve_static.default)($path.join(__dirname, "../dist"), _$n_js_object("index", js_array("index.html")));

// server.js
var import_meta = {};
main_$x_();
if (import_meta.hot) {
  import_meta.hot.accept("./server-out/app.server.js", (main) => {
    main.reload_$x_();
  });
}
/*!
 * @description Recursive object extending
 * @author Viacheslav Lotsmanov <lotsmanov89@gmail.com>
 * @license MIT
 *
 * The MIT License (MIT)
 *
 * Copyright (c) 2013-2018 Viacheslav Lotsmanov
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy of
 * this software and associated documentation files (the "Software"), to deal in
 * the Software without restriction, including without limitation the rights to
 * use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
 * the Software, and to permit persons to whom the Software is furnished to do so,
 * subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
 * COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
 * IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */
/*!
 * depd
 * Copyright(c) 2014 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2014-2015 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * depd
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * destroy
 * Copyright(c) 2014 Jonathan Ong
 * MIT Licensed
 */
/*!
 * ee-first
 * Copyright(c) 2014 Jonathan Ong
 * MIT Licensed
 */
/*!
 * encodeurl
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * escape-html
 * Copyright(c) 2012-2013 TJ Holowaychuk
 * Copyright(c) 2015 Andreas Lubbe
 * Copyright(c) 2015 Tiancheng "Timothy" Gu
 * MIT Licensed
 */
/*!
 * etag
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * finalhandler
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * fresh
 * Copyright(c) 2012 TJ Holowaychuk
 * Copyright(c) 2016-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * http-errors
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * on-finished
 * Copyright(c) 2013 Jonathan Ong
 * Copyright(c) 2014 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * parseurl
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2014-2017 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * range-parser
 * Copyright(c) 2012-2014 TJ Holowaychuk
 * Copyright(c) 2015-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * send
 * Copyright(c) 2012 TJ Holowaychuk
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * serve-static
 * Copyright(c) 2010 Sencha Inc.
 * Copyright(c) 2011 TJ Holowaychuk
 * Copyright(c) 2014-2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * statuses
 * Copyright(c) 2014 Jonathan Ong
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * toidentifier
 * Copyright(c) 2016 Douglas Christopher Wilson
 * MIT Licensed
 */
/*!
 * unpipe
 * Copyright(c) 2015 Douglas Christopher Wilson
 * MIT Licensed
 */
